// BatchDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "BatchDlg.h"

#include "FluxAnalysisToolDlg.h"
#include "FluxPartitioningDlg.h"
#include "QcQaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CBatchDlg _CAO
BOOL CBatchDlg::m_bAbnormalTermination = FALSE;

CBatchDlg::CBatchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBatchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBatchDlg)
	m_strBatchFile = _T("");
	//}}AFX_DATA_INIT
	m_pThread = NULL;
	m_bIsThread = FALSE;
}


void CBatchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBatchDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Text(pDX, IDC_EDIT_BATCH_FILE, m_strBatchFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBatchDlg, CDialog)
	//{{AFX_MSG_MAP(CBatchDlg)
	ON_EN_KILLFOCUS(IDC_EDIT_BATCH_FILE, OnKillfocus)
	ON_BN_CLICKED(IDC_BUTTON_IN_FILE, OnButtonInFile)
	ON_BN_CLICKED(IDC_BTN_BATCH_START, OnBtnBatchStart)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBatchDlg bZ[W nh

void CBatchDlg::OnKillfocus() 
{
	UpdateData(TRUE);
}

void CBatchDlg::OnButtonInFile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"txt  t@C   (*.txt)|*.txt|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strBatchFile = dlg.GetPathName();

		UpdateData(FALSE);
	}
}

void CBatchDlg::OnBtnBatchStart() 
{
	// ***************************************************************
	// error check
	// ***************************************************************
	if(m_strBatchFile == ""){
		AfxMessageBox("Please specify the input butch file.");
		return;
	}

	// ***************************************************************
	// search exec num
	// ***************************************************************
	int iExecNum = SearchExecNum(m_strBatchFile);
	if(iExecNum == 0){
		return;
	}

	// **************************************************
	// vOXo[̏
	// **************************************************
	m_ctlProgress.SetRange(0, iExecNum);	// Inisilize Progress bar
	m_ctlProgress.SetPos(0);

	// ***************************************************************
	// Excec batch
	// ***************************************************************
	BOOL bIsDebug = FALSE;
	#ifdef _DEBUG
	bIsDebug = TRUE;
	#endif
	if(bIsDebug){
		OnExecBatch();
	}
	else{
		// Using Malti Thread
		if(!m_bAbnormalTermination){
			if(!m_bIsThread){
				m_pThread = AfxBeginThread(ComuputeBatchThread,(LPVOID)this);
				m_pThread->m_bAutoDelete = FALSE;
				m_pThread->ResumeThread();
			}
			else{
				AfxMessageBox("Error : Thread is busy !");
			}
		}
		else{
			AfxMessageBox(_T("Please restart the Flux Calculater.exe [Abnormal Termination Error]"));
		}
	}
}

UINT CBatchDlg::ComuputeBatchThread(LPVOID pParam)
{
	CBatchDlg* pBatch = static_cast<CBatchDlg*>(pParam);

 	pBatch->m_bIsThread = TRUE;
	pBatch->OnExecBatch();

	pBatch->m_bIsThread = FALSE;

	return 0;
}

void CBatchDlg::OnExecBatch()
{
	// ***************************************************************
	// analyze the batch file
	// ***************************************************************
	try{
		CStdioFile InFile(m_strBatchFile, CFile::modeRead | CFile::shareDenyWrite);

		int iLine = 0;
		BOOL bError = FALSE;
		int iState = 0;		// InDIR (1), OutFile (2), IniFile (3)
		CString strLine;
		CString strError;
		CString strPathName;
		CString strViewFileName = "Exec File Name : " ;
		int iExec = 0;
		int i = 0;

		// Kvȕϐ̒`
		CString strIniFile, strIniUsterFile;
		CString strInputFile;
		CString strOutputDir;
		CString strInputFixedFile;
		CString strFileGPP;
		CString strFileRE;

		while(InFile.ReadString(strLine)){
			// wb_[̏
			iLine++;

			if(strLine == "" || strLine.Left(2) == "//") continue;
			strLine.TrimLeft();
			strLine.TrimRight();
			if(strLine == "" || strLine.Left(2) == "//") continue;

			if(strLine.Find("IniFile") != -1){
				strIniFile = strLine.Mid(strLine.Find('"') + 1);
				strIniFile = strIniFile.Left(strIniFile.Find('"'));
				continue;
			}

			if(strLine.Find("IniUsterFile") != -1){
				strIniUsterFile = strLine.Mid(strLine.Find('"') + 1);
				strIniUsterFile = strIniUsterFile.Left(strIniUsterFile.Find('"'));
				continue;
			}

			if(strLine.Find("InputFile") != -1){
				strInputFile = strLine.Mid(strLine.Find('"') + 1);
				strInputFile = strInputFile.Left(strInputFile.Find('"'));

				// get file name
				strLine = strInputFile.Mid(strInputFile.ReverseFind('\\') + 1);
				//strViewFileName = "Exec File Name : " + strLine;
				GetDlgItem(IDC_STATIC_FILE)->SetWindowText(strLine);
				UpdateData(FALSE);
				continue;
			}

			if(strLine.Find("OutputDir") != -1){
				strOutputDir = strLine.Mid(strLine.Find('"') + 1);
				strOutputDir = strOutputDir.Left(strOutputDir.Find('"'));
				continue;
			}

			if(strLine.Find("InputFixedFile") != -1){
				strInputFixedFile = strLine.Mid(strLine.Find('"') + 1);
				strInputFixedFile = strInputFixedFile.Left(strInputFixedFile.Find('"'));
				continue;
			}

			if(strLine.Find("FileGPP") != -1){
				strFileGPP = strLine.Mid(strLine.Find('"') + 1);
				strFileGPP = strFileGPP.Left(strFileGPP.Find('"'));
				continue;
			}

			if(strLine.Find("FileRE") != -1){
				strFileRE = strLine.Mid(strLine.Find('"') + 1);
				strFileRE = strFileRE.Left(strFileRE.Find('"'));
				continue;
			}

			if(strLine.Find("EXEC_Determine") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Determine Parameters...");
				m_pdlgFATDlg->m_dlgFluxPartitioning->SetForBatchSetting(strIniFile, strInputFile, strOutputDir, strInputFixedFile, strFileGPP, strFileRE, strIniUsterFile);
				m_pdlgFATDlg->m_dlgFluxPartitioning->Determine_Photosynthesis_Respiration_Parameters(strError);

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}

			if(strLine.Find("EXEC_Application") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Applying Gap-filling...");
				m_pdlgFATDlg->m_dlgFluxPartitioning->SetForBatchSetting(strIniFile, strInputFile, strOutputDir, strInputFixedFile, strFileGPP, strFileRE, strIniUsterFile);
				m_pdlgFATDlg->m_dlgFluxPartitioning->Gap_Filling_Carbon_Energy_Fluxes(strError);

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}

			if(strLine.Find("EXEC_MDV") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Applying Mean Diurnal Variation method...");
				m_pdlgFATDlg->m_dlgMDV->SetForBatchSetting(strIniFile, strInputFile, strOutputDir);
				m_pdlgFATDlg->m_dlgMDV->OnMeanDiurnalVariation(strError);

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}

			if(strLine.Find("EXEC_LUT") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Applying Look up table method...");
				m_pdlgFATDlg->m_dlgLookUpTable->SetForBatchSetting(strIniFile, strInputFile, strOutputDir);
				m_pdlgFATDlg->m_dlgLookUpTable->OnLookUpTable(strError);

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}

			if(strLine.Find("EXEC_USTAR") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Determing u* threshold...");
				m_pdlgFATDlg->m_dlgUstarFiltering->SetForBatchSetting(strIniFile, strInputFile, strOutputDir);
				m_pdlgFATDlg->m_dlgUstarFiltering->public_OnButtonDetermine();

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}

			if(strLine.Find("EXEC_QC") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Applying QC/QC ...");
				m_pdlgFATDlg->m_dlgQcQa->SetForBatchSetting(strIniFile, strInputFile, strOutputDir);
				m_pdlgFATDlg->m_dlgQcQa->public_OnBtnApply(strError);

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}

			if(strLine.Find("EXEC_UNCERTAINTIES") != -1){
				GetDlgItem(IDC_STATIC_STATUS)->SetWindowText("Applying Uncertainties analysis ...");
				m_pdlgFATDlg->m_dlgFluxPartitioning->SetForBatchSetting(strIniFile, strInputFile, strOutputDir, strInputFixedFile, strFileGPP, strFileRE, strIniUsterFile);
				m_pdlgFATDlg->m_dlgFluxPartitioning->Determine_uncertainties_bootstraping(strError);

				// vOXo[̍XV
				if(m_ctlProgress.m_hWnd){
					m_ctlProgress.SetPos(i = i + 1);
				}
				continue;
			}
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}

	if(m_pdlgFATDlg->m_dlgFluxPartitioning != NULL){
		m_pdlgFATDlg->m_dlgFluxPartitioning->EnableWindow(TRUE);
	}
	if(m_pdlgFATDlg->m_dlgMDV != NULL){
		m_pdlgFATDlg->m_dlgMDV->EnableWindow(TRUE);
	}
	if(m_pdlgFATDlg->m_dlgLookUpTable != NULL){
		m_pdlgFATDlg->m_dlgLookUpTable->EnableWindow(TRUE);
	}
	if(m_pdlgFATDlg->m_dlgUstarFiltering != NULL){
		m_pdlgFATDlg->m_dlgUstarFiltering->EnableWindow(TRUE);
	}
	if(m_pdlgFATDlg->m_dlgQcQa != NULL){
		m_pdlgFATDlg->m_dlgQcQa->EnableWindow(TRUE);
	}

	AfxMessageBox("End batch calculation!");
}

int CBatchDlg::SearchExecNum(const CString& strBatchFile)
{
	int iExecNum = 0;
	CString strLine;

	try{
		CStdioFile InFile(m_strBatchFile, CFile::modeRead | CFile::shareDenyWrite);

		while(InFile.ReadString(strLine)){

			if(strLine == "" || strLine.Left(2) == "//") continue;
			strLine.TrimLeft();
			strLine.TrimRight();
			if(strLine == "" || strLine.Left(2) == "//") continue;

			if(strLine.Find("EXEC_Determine") != -1){
				m_pdlgFATDlg->public_OnMenuFluxPartitioning() ;
				m_pdlgFATDlg->m_dlgFluxPartitioning->EnableWindow(FALSE);
			}
			if(strLine.Find("EXEC_Application") != -1){
				m_pdlgFATDlg->public_OnMenuFluxPartitioning() ;
				m_pdlgFATDlg->m_dlgFluxPartitioning->EnableWindow(FALSE);
			}
			if(strLine.Find("EXEC_MDV") != -1){
				m_pdlgFATDlg->public_OnMenuMeanDiurnalVariation() ;
				m_pdlgFATDlg->m_dlgMDV->EnableWindow(FALSE);
			}
			if(strLine.Find("EXEC_LUT") != -1){
				m_pdlgFATDlg->public_OnMenuLookUpTable() ;
				m_pdlgFATDlg->m_dlgLookUpTable->EnableWindow(FALSE);
			}
			if(strLine.Find("EXEC_USTAR") != -1){
				m_pdlgFATDlg->public_OnMenuUstarFiltering() ;
				m_pdlgFATDlg->m_dlgUstarFiltering->EnableWindow(FALSE);
			}
			if(strLine.Find("EXEC_QC") != -1){
				m_pdlgFATDlg->public_OnMenuQC() ;
				m_pdlgFATDlg->m_dlgQcQa->EnableWindow(FALSE);
			}
			if(strLine.Find("EXEC_UNCERTAINTIES") != -1){
				m_pdlgFATDlg->public_OnMenuFluxPartitioning() ;
				m_pdlgFATDlg->m_dlgFluxPartitioning->EnableWindow(FALSE);
			}

			if(strLine.Find("EXEC") != -1){
				iExecNum++;
				continue;
			}
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}

	// m_pdlgFATDlg->SetActiveWindow();
	SetActiveWindow();

	return iExecNum;
}

void CBatchDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
}

void CBatchDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	if( m_bIsThread ){
		if(AfxMessageBox("Although flux calculation is been operated, do you terminate the process?", MB_OKCANCEL) == IDCANCEL){
			return;
		}

		if ( ::WaitForSingleObject(m_pThread->m_hThread, 2000) ==  WAIT_TIMEOUT ){
			TerminateThread(m_pThread->m_hThread, 1);			
		}
		m_bAbnormalTermination = TRUE;
		AfxMessageBox(_T("Abnormal termination! : Please restart the Flux Calculater.exe"));
		delete m_pThread;
		m_pThread = NULL;
	}

/*	if(m_pdlgFATDlg->m_dlgFluxPartitioning != NULL){
		m_pdlgFATDlg->m_dlgFluxPartitioning->DestroyWindow();
		m_pdlgFATDlg->m_dlgFluxPartitioning = NULL;
	}
	if(m_pdlgFATDlg->m_dlgMDV != NULL){
		m_pdlgFATDlg->m_dlgMDV->DestroyWindow();
		m_pdlgFATDlg->m_dlgMDV = NULL;
	}
	if(m_pdlgFATDlg->m_dlgLookUpTable != NULL){
		m_pdlgFATDlg->m_dlgLookUpTable->DestroyWindow();
		m_pdlgFATDlg->m_dlgLookUpTable = NULL;
	}*/

	CDialog::OnCancel();
}

BOOL CBatchDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDI_BATCH );
	SetIcon(hFile, TRUE);	
	SetIcon(hFile, FALSE);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
