// BrowseFolderDialog.cpp: CBrowseFolderDialog NX̃Cve[V
//
//		Reference : http://homepage2.nifty.com/soga/
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BrowseFolderDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

BEGIN_MESSAGE_MAP(CBrowseFolderDialog, CWnd)
	//{{AFX_MSG_MAP(CBrowseFolderDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

char CBrowseFolderDialog::m_szText[MAX_PATH];

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CBrowseFolderDialog::CBrowseFolderDialog(UINT ulFlags, LPCTSTR lpTitle,int iRootFolder)
{
	// ulFlags : _CAO{bNX̃IvVtOw肵܂B
	// lpTitle : _CAO{bNX̃c[r[̏㕔ɕ\镶̃AhXw肵܂B
	// iRootFolder : [gtH_\ACe ID Xgւ̃|C^iPIDLjw肵܂B

	Init();

	memset(m_szTitle,0,sizeof(m_szTitle));

	m_ulFlags     = ulFlags;
	m_iRootFolder = iRootFolder;

	if( lpTitle != NULL )
	{
		strcpy(m_szTitle,lpTitle);
	}
}

CBrowseFolderDialog::~CBrowseFolderDialog()
{

}

void CBrowseFolderDialog::Init()
{
	m_rootPidl   = NULL;
	m_iSelectFolder = 0;
	memset(m_szSelectedPath,0,sizeof(m_szSelectedPath));	
	memset(m_szFirstPath,0,sizeof(m_szFirstPath));	
	memset(m_szDisplayName,0,sizeof(m_szDisplayName));
}

/*****************************************************************************
*	֐	:	_CAO\
*****************************************************************************/
int CBrowseFolderDialog::DoModal()
{
	Init();

	return Modal();
}

/*****************************************************************************
*	֐	:	_CAO\(tH_pXw)
*****************************************************************************/
int CBrowseFolderDialog::DoModal(LPCTSTR lpSelect)
{	
	Init();

	if( lpSelect != NULL )
	{
		strcpy(m_szFirstPath,lpSelect);
	}

	return Modal();
}

/*****************************************************************************
*	֐	:	_CAO\(tH_w)
*****************************************************************************/
int CBrowseFolderDialog::DoModal(int iSelectFolder)
{	
	Init();

	m_iSelectFolder = iSelectFolder;

	return Modal();
}

int CBrowseFolderDialog::Modal()
{
	//@tH_I_CAO̕\
	// [g擾
	if( GetPIDL(m_iRootFolder,&m_rootPidl) == FALSE )
	{
		return -1;
	}

	// I擾
	if( GetPIDL(m_iSelectFolder,&m_selectPidl) == FALSE )
	{
		return -1;
	}

	BROWSEINFO stBInfo;
	ZeroMemory(&stBInfo,sizeof(stBInfo));

	//@\̂܂B
	stBInfo.hwndOwner	= AfxGetMainWnd()->GetSafeHwnd();	// eEBhẼnh
	stBInfo.pidlRoot	= m_rootPidl;						// [gtH_	
	stBInfo.pszDisplayName = m_szDisplayName;				// tH_󂯂Ƃ
	stBInfo.lpszTitle	= m_szTitle;						// ̕
	stBInfo.ulFlags		= m_ulFlags;						// \tO
	stBInfo.lpfn		= CallBackFunc;						// R[obN֐
	stBInfo.lParam		= (LPARAM)this;		//vV[Wɑp[^[

	//@_CAO{bNX\
	LPITEMIDLIST pidlRetFolder = ::SHBrowseForFolder( &stBInfo );

	if( pidlRetFolder != NULL )
	{
		//@tpX擾܂B
		::SHGetPathFromIDList( pidlRetFolder, m_szSelectedPath );
		FreePIDL(pidlRetFolder );

		return IDOK;
	}

	FreePIDL(pidlRetFolder );
	return IDCANCEL;
}

int CALLBACK CBrowseFolderDialog::CallBackFunc(HWND hWnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
	//  ̃tH_I
	CBrowseFolderDialog *dlg = (CBrowseFolderDialog*)lpData;

	switch( uMsg ){
		case BFFM_INITIALIZED :    // 
			if( dlg->m_szFirstPath[0] != NULL )
			{
				::SendMessage(hWnd, BFFM_SETSELECTION, TRUE, (LPARAM)dlg->m_szFirstPath);
			}
			else if( dlg->m_selectPidl != NULL )
			{
				::SendMessage(hWnd, BFFM_SETSELECTION, FALSE, (LPARAM)dlg->m_selectPidl);
			}

			dlg->SubclassWindow( hWnd );
			dlg->OnInitDialog();
			break;
		case BFFM_SELCHANGED:     // I
			if(m_szText[0] != NULL)
				strcpy(dlg->m_szFirstPath, m_szText);
			
			::SHGetPathFromIDList( (LPITEMIDLIST)lParam, m_szText );			

			dlg->OnChangedSel(hWnd,(LPITEMIDLIST)lParam);
			break;
		case BFFM_VALIDATEFAILED: // s͎
			dlg->OnFailedValidate((LPCTSTR)lParam);
			break;
	}

	return 0;
}

/****************************************************************
*  ֐  F   tH_PIDL擾
****************************************************************/
BOOL CBrowseFolderDialog::GetPIDL(int nFolder,LPITEMIDLIST *pidl)
{
	if( nFolder == 0 )
	{
		*pidl = NULL;
		return TRUE;
	}

	// PIDL 擾
	LPITEMIDLIST pidlTmp;
	if( SHGetSpecialFolderLocation(AfxGetMainWnd()->GetSafeHwnd(),nFolder,&pidlTmp) == NOERROR )
	{
		*pidl = pidlTmp;
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

/****************************************************************
*  ֐  F   PIDLJ
****************************************************************/
void CBrowseFolderDialog::FreePIDL(LPITEMIDLIST pidl)
{
	::CoTaskMemFree(pidl);
	::CoTaskMemFree(m_rootPidl);
	::CoTaskMemFree(m_selectPidl);
}

LPITEMIDLIST CBrowseFolderDialog::GetItemIDList( CString p_cFileStr )
{
	// Reference : http://www.kab-studio.biz/Programing/Codian/
	if( p_cFileStr.IsEmpty() )
		return NULL;

	LPITEMIDLIST pIDL;
	LPSHELLFOLDER pDesktopFolder; 

	if( ::SHGetDesktopFolder( &pDesktopFolder ) != NOERROR )
		return NULL;

	OLECHAR       ochPath[MAX_PATH];
	ULONG         chEaten;			//̃TCY󂯎܂B
	ULONG         dwAttributes;		//󂯎܂B
	HRESULT       hRes;

	//@ȂƃC^[tFCX̓_Ȃ̂łB
	::MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, p_cFileStr, -1, ochPath, MAX_PATH );

	//@ۂITEMIDLIST擾܂B
	hRes = pDesktopFolder->ParseDisplayName( NULL, NULL, ochPath, &chEaten, &pIDL, &dwAttributes);
    
	if( hRes != NOERROR )
		pIDL = NULL;

	pDesktopFolder->Release();

	return pIDL;
}

void CBrowseFolderDialog::OnChangedSel(HWND hwnd,LPITEMIDLIST pList)
{
}

CString CBrowseFolderDialog::GetPathName( ) const
{
	return static_cast<CString>(m_szSelectedPath);
}

CString CBrowseFolderDialog::GetDirectoryName( ) const
{
	return static_cast<CString>(m_szDisplayName);
}
