// Dataset.cpp: CDataset NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
// #include "MeanDiurnalVariation.h"
#include "Dataset.h"

#include <math.h>
#include <algorithm>
using namespace std;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const double CDataset::s_dErrorValue = -99999;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDataset::CDataset()
{

}

CDataset::CDataset(std::vector<double> aryContinuousDataset)
{
	for(int i = 0; i < aryContinuousDataset.size(); i++){
		m_aryContinuousDataset.push_back(aryContinuousDataset[i]);
	}
}

CDataset::CDataset(std::vector< std::vector<double> > aryDataset_bs)
{
	for(int i = 0; i < aryDataset_bs.size(); i++){
		m_aryDataset_bs.push_back(aryDataset_bs[i]);
	}
}

CDataset::~CDataset()
{
	typedef vector<double> *Vec;
	map<int, Vec>::iterator p;

	for(p = m_mapDiurnalPattern.begin(); p != m_mapDiurnalPattern.end(); p++){
		delete p->second;
	}
}

void CDataset::SetContinuousDataset(CString strTime, double dDataset)
{
	m_aryContinuousDataset.push_back(dDataset);
	m_aryContinuousDate.push_back(strTime);
	m_aryIsComplement.push_back(NONE_COMPLEMENT);
	m_aryRadiationComplemetFactor.push_back(1);
}

//////////////////////////////////////////////////////////
// }⊮
//////////////////////////////////////////////////////////
void CDataset::InterpolateDataset(int iLimtSeqLoss)
{
	// f[^̓}⊮
	int iSeqLoss = 0, iLoopCount = 0;
	double dBeforeData = s_dErrorValue;
	double dSlop = 0;
	BOOL bIsFrontNull = FALSE;
	m_aryInterporateDataset.resize(m_aryContinuousDataset.size());

	for(int i = 0; i < m_aryContinuousDataset.size(); i++){
		if(m_aryContinuousDataset[i] == s_dErrorValue){
			iSeqLoss++;
			if(i == 0){	//@擪sZero ̏ꍇ́A㑱sɊւĂ}͏oȂB
				bIsFrontNull = TRUE;
			}
		}else{
			if((iSeqLoss <= iLimtSeqLoss) && iSeqLoss > 0){
				if(i != 0 && bIsFrontNull == FALSE){	// 擪sɂ͕⊮sȂB
					// ⊮
					dSlop = (m_aryContinuousDataset[i] - dBeforeData)/(iSeqLoss + 1);	// X
					for(int j = iSeqLoss; j > 0; j--){
						iLoopCount++;
						m_aryInterporateDataset[i-j] = dSlop * iLoopCount + dBeforeData;	// ؕЂ
						m_aryIsComplement[i-j] = INTERPOLATE_COMPLEMENT;				// }⊮Flag 1 𗧂ĂB
					}
					iLoopCount = 0;
				}
				bIsFrontNull = FALSE;
			}
			dBeforeData = m_aryContinuousDataset[i];
			iSeqLoss = 0;
		}
	}
}

void CDataset::Update_InterpolateDataset(BOOL bMovingAverage, const CString& strCurrent)
{
	// }⊮ꂽf[^𕽋ϓω@E\@ɂ⊮ꂽf[^ɔfB
	int iRunOfDay_MDV = m_aryMDV_Dataset.size();
	int iRunOfDay_LT = m_aryLT_Filled_Dataset.size();

	if(bMovingAverage){
		// ړσEBhȄꍇ
		int iCurrentDate = get_current_date(strCurrent);
		int iRunOfDay;
		if(iRunOfDay_MDV > iRunOfDay_LT){
			iRunOfDay = iRunOfDay_MDV;
		}
		else{
			iRunOfDay = iRunOfDay_LT;
		}
		if(iRunOfDay == 0) return;

		int iCount = 0;
		for(int i = iCurrentDate; i < iCurrentDate + iRunOfDay; i++){
			if(m_aryIsComplement[i] == INTERPOLATE_COMPLEMENT){
				if(iRunOfDay_MDV != 0) m_aryMDV_Dataset[iCount] = m_aryInterporateDataset[i];
				if(iRunOfDay_LT != 0) m_aryLT_Filled_Dataset[iCount] = m_aryInterporateDataset[i];
			}
			iCount++;
		}
	}
	else{
		// ubNσEBhȄꍇ
		for(int i = 0; i < m_aryInterporateDataset.size(); i++){
			if(m_aryIsComplement[i] == INTERPOLATE_COMPLEMENT){
				if(iRunOfDay_MDV != 0) m_aryMDV_Dataset[i] = m_aryInterporateDataset[i];
				if(iRunOfDay_LT != 0) m_aryLT_Filled_Dataset[i] = m_aryInterporateDataset[i];
			}
		}
	}
}

//////////////////////////////////////////////////////////
// ϓω@
//////////////////////////////////////////////////////////
void CDataset::SetDiurnalVariation(int iRunOfDay, int iBoostrapNum /*= 1*/, BOOL bBootstrap /*= FALSE*/)
{
	int iTimeSequence = 0;
	typedef vector<double> *Vec;
	map<int, Vec>::iterator mapIte;

	// nf[^Aeɐ
	for(int i = 0; i < m_aryContinuousDataset.size(); i++){
		iTimeSequence++;

		// o^ĂȂԂo^
		if(m_mapDiurnalPattern.find(iTimeSequence) == m_mapDiurnalPattern.end()){
			Vec aryTimeVaule = new vector<double>;
			m_mapDiurnalPattern.insert(make_pair(iTimeSequence, aryTimeVaule));
		}

		if(m_aryContinuousDataset[i] != s_dErrorValue){	
			mapIte = m_mapDiurnalPattern.find(iTimeSequence);
			mapIte->second->push_back(m_aryContinuousDataset[i]);
		}

		if(iTimeSequence == iRunOfDay){
			iTimeSequence = 0;
		}
	}

	// ɐꂽf[^ADiurnal Variation 쐬
	for(i = 1; i < m_mapDiurnalPattern.size() + 1; i++){
		mapIte = m_mapDiurnalPattern.find(i);
		m_aryDiurnalAverage.push_back(AverageDouble(*(mapIte->second)));
		m_aryDiurnalStdev.push_back(StdevDouble(*(mapIte->second)));
		m_aryDiurnalNumbers.push_back(NumDouble(*(mapIte->second)));
	}

	if(bBootstrap == TRUE){
		for(i = 1; i < m_mapDiurnalPattern.size() + 1; i++){
			mapIte = m_mapDiurnalPattern.find(i);
			vector<double> aryDataBootstrap = AverageDouble_bootstrap(*(mapIte->second), iBoostrapNum);
			m_aryDiurnalAverage[i-1] = (AverageDouble(aryDataBootstrap));
			m_aryDiurnalStdev[i-1] = (StdevDouble(aryDataBootstrap));

			// u[gXgbv̕ϓωp^[̐
			m_aryBootstrapDiurnalVariation.push_back(aryDataBootstrap);

			// calculate upper and lower confidence interval 90%
			std::sort(aryDataBootstrap.begin(),aryDataBootstrap.end());//\[g
			m_aryDiurnalUpperConfidence90_bootstrap.push_back(aryDataBootstrap[iBoostrapNum * 0.1]);
			m_aryDiurnalLowerConfidence90_bootstrap.push_back(aryDataBootstrap[iBoostrapNum * 0.9]);
		}
	}
}

void CDataset::ExecMeanDiurnalVariationMethod()
{
	// f[^̕⊮
	int iDiurnalNumberCounter = 0;
	int iDiurnalNumber = m_aryDiurnalAverage.size();
	m_aryMDV_Dataset.resize(m_aryContinuousDataset.size());

	for(int i = 0; i < m_aryContinuousDataset.size(); i++){
		if(m_aryContinuousDataset[i] == s_dErrorValue){
			m_aryMDV_Dataset[i] = m_aryDiurnalAverage[iDiurnalNumberCounter];
			m_aryIsComplement[i] = MDVM_COMPLEMENT;	// Diurnal Variation ⊮ Flag 1 𗧂ĂB
			if(m_aryDiurnalAverage[iDiurnalNumberCounter] == s_dErrorValue){
				m_aryIsComplement[i] = s_dErrorValue;
			}
		}
		else{
			m_aryMDV_Dataset[i] = m_aryContinuousDataset[i];
		}
		iDiurnalNumberCounter++;

		if(iDiurnalNumberCounter == iDiurnalNumber){
			iDiurnalNumberCounter = 0;
		}
	}
}

void CDataset::ExecMeanDiurnalVariationMethod_moving_av(const CString& strCurrentDate)
{
	// f[^̕⊮
	int iDiurnalNumberCounter = 0;
	int iDiurnalNumber = m_aryDiurnalAverage.size();
	int iCurrentDate;

	// Current Date ̃X^[g
	iCurrentDate = get_current_date(strCurrentDate);
	
	m_aryMDV_Dataset.resize(m_aryDiurnalAverage.size());
	m_aryIsComplement.resize(m_aryDiurnalAverage.size());

	for(int i = iCurrentDate; i < (iCurrentDate + m_aryDiurnalAverage.size()); i++){
		if(m_aryContinuousDataset[i] == s_dErrorValue){
			m_aryMDV_Dataset[iDiurnalNumberCounter] = m_aryDiurnalAverage[iDiurnalNumberCounter];
			m_aryIsComplement[iDiurnalNumberCounter] = MDVM_COMPLEMENT;	// Diurnal Variation ⊮ Flag 1 𗧂ĂB
		}
		else{
			m_aryMDV_Dataset[iDiurnalNumberCounter] = m_aryContinuousDataset[i];
		}
		iDiurnalNumberCounter++;

		if(iDiurnalNumberCounter == iDiurnalNumber){
			iDiurnalNumberCounter = 0;
		}
	}
}

void CDataset::ExecMeanDiurnalVariationMethod_bootstrap(int iBootstrapNum)
{
	// bootstrap (ubNς̏ꍇ́A@ABړς̏ꍇ͇Â݂B)
	BOOL bIsBootstrap = TRUE;
	int iDiurnalNumber = m_aryDiurnalAverage.size();
	const int iPrecision = 1; //10;

	if(bIsBootstrap == TRUE){
		int iNum = 0;
		long double dAverage = s_dErrorValue;
		for(int iB = 0; iB < iBootstrapNum; iB++){
			dAverage = 0.0;
			iNum = 0;
			for(int i = 0; i < m_aryContinuousDataset.size(); i++){
				if(m_aryContinuousDataset[i] != s_dErrorValue){
					dAverage += m_aryContinuousDataset[i] * iPrecision;
					iNum++;
				}
				if(m_aryContinuousDataset[i] == s_dErrorValue && m_aryBootstrapDiurnalVariation[i % iDiurnalNumber][iB] != s_dErrorValue){
					if(m_aryIsComplement[i] == INTERPOLATE_COMPLEMENT){
						dAverage += m_aryMDV_Dataset[i] * iPrecision;
					}
					else{
						dAverage += m_aryBootstrapDiurnalVariation[i % iDiurnalNumber][iB] * iPrecision;
					}
					iNum++;
				}
			}

			if(iNum != 0){
				dAverage /= iNum;
				dAverage /= iPrecision;
			}
			else{
				dAverage = s_dErrorValue;
			}
			m_aryBootstrapAverage.push_back(dAverage);
		}
	}
}

// ˗ʕ␳WMDVM ŕ⊮lɔfB
void CDataset::ApplyRadiationFactor_DirunalVariation(const CString& strCurrentDate, BOOL bMovingAverage)
{
	if(bMovingAverage){
		int iCurrentDate = get_current_date(strCurrentDate);

		int iCount = 0;
		for(int i = iCurrentDate; i < (iCurrentDate + m_aryDiurnalAverage.size()); i++){
			if(m_aryIsComplement[i] == MDVM_COMPLEMENT && iCount < m_aryMDV_Dataset.size()/* && m_aryContinuousDataset[i] > 0*/){
				m_aryMDV_Dataset[iCount] *= m_aryRadiationComplemetFactor[i];
			}
			iCount++;
		}
	}
	else{
		for(int i = 0; i < m_aryContinuousDataset.size(); i++){
			if(m_aryIsComplement[i] == MDVM_COMPLEMENT/* && m_aryContinuousDataset[i] > 0*/){
				m_aryMDV_Dataset[i] *= m_aryRadiationComplemetFactor[i];
			}
		}
	}
}

int CDataset::get_current_date(const CString& strCurrentDate)
{
	int iCurrentDate;
	for(int i = 0; i < m_aryContinuousDate.size(); i++){
		if(m_aryContinuousDate[i] == strCurrentDate){
			iCurrentDate = i;
			break;
		}
	}
	return iCurrentDate;
}

void CDataset::SetConvertRate(const std::vector<double>& aryRadiationDataset, double dRadiationAverage, int iDayOfRun, int iAverageNumber)
{
	vector<double> aryOneDayData;
	vector<double> aryConvertRate;
	int iDayCount = 0;

	// Ԃ̓˗ʂ̕ϒlZero ̏ꍇ́Aϊ1 ƂB
	if(dRadiationAverage == 0){
		return;
	}else{
		m_aryRadiationComplemetFactor.clear();
	}

	// ̕˗ʕϊvZ
	for(int i = 0; i < aryRadiationDataset.size(); i++){
		if(iDayCount < iDayOfRun){
			aryOneDayData.push_back(aryRadiationDataset[i]);
		}else{
			aryConvertRate.push_back(GetAverage(aryOneDayData, iAverageNumber) / dRadiationAverage);
			aryOneDayData.clear();
			iDayCount = -1;
		}
		iDayCount++;
	}

	// ̕ϊeɔf
	for(int j = 0; j < aryConvertRate.size(); j++){
		for(i = 0; i < iDayOfRun; i++){
			m_aryRadiationComplemetFactor.push_back(aryConvertRate[j]);
		}
	}
}

double CDataset::GetDiurnalAverage(int iAverageNum)
{
	vector<double> aryDiurnalAverage;

	for(int i = 0; i < m_aryDiurnalAverage.size(); i++){
		aryDiurnalAverage.push_back(m_aryDiurnalAverage[i]);
	}

	return GetAverage(aryDiurnalAverage, iAverageNum);
}

double CDataset::GetAverage(std::vector<double> aryOneDayData, int iAverageNum)
{	
	double dSum = 0;
	sort(aryOneDayData.begin(), aryOneDayData.end());

	for(int i = aryOneDayData.size() - 1; i > (aryOneDayData.size() - 1 - iAverageNum); i--){
		dSum += aryOneDayData[i];
	}

	if(iAverageNum == 0){		// Zero Ŋ鎖ɊւO
		return s_dErrorValue;
	}

	return dSum / iAverageNum;
}

//////////////////////////////////////////////////////////
// t@C̏o̓tH[}bg쐬
//////////////////////////////////////////////////////////

BOOL CDataset::GetOutputPatternFormat(int iRunNum, CString& strLine, BOOL bIsBootstrap)
{
	if(iRunNum >= m_aryDiurnalAverage.size()){
		return FALSE;
	}

	if(bIsBootstrap == FALSE){
		strLine.Format("%d,%lf,%lf,%d\n", 
			iRunNum, m_aryDiurnalAverage[iRunNum], m_aryDiurnalStdev[iRunNum], m_aryDiurnalNumbers[iRunNum]);
	}
	else{
		strLine.Format("%d,%lf,%lf,%d,%lf,%lf\n", 
			iRunNum, m_aryDiurnalAverage[iRunNum], m_aryDiurnalStdev[iRunNum], m_aryDiurnalNumbers[iRunNum], m_aryDiurnalUpperConfidence90_bootstrap[iRunNum], m_aryDiurnalLowerConfidence90_bootstrap[iRunNum]);
	}
	return TRUE;
}

BOOL CDataset::GetDiurnalAverage(int iRunNum, CString& strLine)
{
	if(iRunNum >= m_aryDiurnalAverage.size()){
		return FALSE;
	}

	strLine.Format("%lf", m_aryDiurnalAverage[iRunNum]);
	return TRUE;
}


void CDataset::GetContinuousData(std::vector<CString>& aryResultLine, BOOL bIsFrontColumn)
{
	CString strLine;

	if(bIsFrontColumn){		
		for(int i = 0; i < m_aryContinuousDataset.size(); i++){
			strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryContinuousDataset[i]);
			aryResultLine.push_back(strLine);
		}
	}else{
		for(int i = 0; i < aryResultLine.size(); i++){
			strLine.Format(",%lf", m_aryContinuousDataset[i]);
			aryResultLine[i] = aryResultLine[i] + strLine;
		}
	}
}

void CDataset::GetFilledData(std::vector<CString>& aryResultLine, int iDataType, const CString& strCurrentDate, BOOL bIsFrontColumn, BOOL bMovingAverage)
{
	CString strLine;
	int iCurrentDate = get_current_date(strCurrentDate);
	int iCount = 0;
	int iSize = m_aryDiurnalAverage.size();
	if(iSize < m_aryTable_Dataset.size()) iSize = m_aryTable_Dataset.size();

	// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4, flag : 5)
	if(bMovingAverage){
		for(int i = iCurrentDate; i < (iCurrentDate + iSize); i++){
			if(i > m_aryContinuousDate.size() - 1){		// added at 2010.07.18 by Ueyama
				break;
			}
			if(bIsFrontColumn){	
				if(iDataType == 0)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryContinuousDataset[i]);
				if(iDataType == 1)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryMDV_Dataset[iCount]);
				if(iDataType == 2)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryLT_Filled_Dataset[iCount]);
				if(iDataType == 3)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryDiurnalAverage[iCount]);
				if(iDataType == 4)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryTable_Dataset[iCount]);
				if(iDataType == 5)	strLine.Format("%s,%d", m_aryContinuousDate[i], m_aryIsComplement[iCount]);
				aryResultLine.push_back(strLine);
			}
			else{
				if(iDataType == 0)	strLine.Format(",%lf", m_aryContinuousDataset[i]);
				if(iDataType == 1)	strLine.Format(",%lf", m_aryMDV_Dataset[iCount]);
				if(iDataType == 2)	strLine.Format(",%lf", m_aryLT_Filled_Dataset[iCount]);
				if(iDataType == 3)	strLine.Format(",%lf", m_aryDiurnalAverage[iCount]);
				if(iDataType == 4)	strLine.Format(",%lf", m_aryTable_Dataset[iCount]);
				if(iDataType == 5)	strLine.Format(",%d", m_aryIsComplement[iCount]);

				aryResultLine[iCount] = aryResultLine[iCount] + strLine;
			}
			iCount++;
		}
	}
	else{
		int iRunPerDay = m_aryDiurnalAverage.size();
		for(int i = 0; i < m_aryContinuousDataset.size(); i++){
			if(i > m_aryContinuousDate.size() - 1){		// added at 2010.07.18 by Ueyama
				break;
			}
			if(bIsFrontColumn){	
				if(iDataType == 0)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryContinuousDataset[i]);
				if(iDataType == 1)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryMDV_Dataset[i]);
				if(iDataType == 2)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryLT_Filled_Dataset[i]);
				if(iDataType == 3)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryDiurnalAverage[i % iRunPerDay]);
				if(iDataType == 4)	strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryTable_Dataset[i]);
				if(iDataType == 5)	strLine.Format("%s,%d", m_aryContinuousDate[i], m_aryIsComplement[i]);
				aryResultLine.push_back(strLine);
			}
			else{
				if(iDataType == 0)	strLine.Format(",%lf", m_aryContinuousDataset[i]);
				if(iDataType == 1)	strLine.Format(",%lf", m_aryMDV_Dataset[i]);
				if(iDataType == 2)	strLine.Format(",%lf", m_aryLT_Filled_Dataset[i]);
				if(iDataType == 3)	strLine.Format(",%lf", m_aryDiurnalAverage[i % iRunPerDay]);
				if(iDataType == 4)	strLine.Format(",%lf", m_aryTable_Dataset[i]);
				if(iDataType == 5)	strLine.Format(",%d", m_aryIsComplement[i]);

				aryResultLine[i] = aryResultLine[i] + strLine;
			}
		}
	}
}

void CDataset::GetFlagData(std::vector<CString>& aryResultLine, BOOL bIsFrontColumn)
{
	CString strLine;

	if(bIsFrontColumn){		
		for(int i = 0; i < m_aryIsComplement.size(); i++){
			strLine.Format("%s,%d", m_aryContinuousDate[i], m_aryIsComplement[i]);
			aryResultLine.push_back(strLine);
		}
	}else{
		for(int i = 0; i < aryResultLine.size(); i++){
			strLine.Format(",%d", m_aryIsComplement[i]);
			aryResultLine[i] = aryResultLine[i] + strLine;
		}
	}
}

void CDataset::GetBootstrapMean(std::vector<CString>& aryResultLine, BOOL bIsFrontColumn)
{
	CString strLine;

	if(bIsFrontColumn){		
		for(int i = 0; i < m_aryBootstrapAverage.size(); i++){
			strLine.Format("%d,%lf", i, m_aryBootstrapAverage[i]);
			aryResultLine.push_back(strLine);
		}
	}else{
		for(int i = 0; i < aryResultLine.size(); i++){
			strLine.Format(",%lf", m_aryBootstrapAverage[i]);
			aryResultLine[i] = aryResultLine[i] + strLine;
		}
	}
}

void CDataset::GetQCFlagData(std::vector<CString>& aryFlagLine, std::vector<CString>& aryResultLine, const CString& strCurrentDate, int iRunPerDay, BOOL bIsFrontColumn, BOOL bMovingAverage)
{
	CString strLine;
	int iCurrentDate = get_current_date(strCurrentDate);
	int iCount = 0;

	if(bMovingAverage){
		if(bIsFrontColumn){		
			for(int i = iCurrentDate; i < (iCurrentDate + iRunPerDay); i++){
				if(m_aryContinuousDate.size() <= i || m_aryQC_flg.size() <= i){
					strLine.Format("Error,%lf", s_dErrorValue);
					aryFlagLine.push_back(strLine);
					aryResultLine.push_back(strLine);
					return;
				}

				// output for flag
				strLine.Format("%s,%d", m_aryContinuousDate[i], m_aryQC_flg[i]);
				aryFlagLine.push_back(strLine);

				// output of results
				if(m_aryQC_flg[i] == 0){
					strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryContinuousDataset[i]);
				}
				else{

					strLine.Format("%s,%lf", m_aryContinuousDate[i], s_dErrorValue);
				}			
				aryResultLine.push_back(strLine);
			}
		}else{
			for(int i = iCurrentDate; i < (iCurrentDate + iRunPerDay); i++){
				if(m_aryContinuousDate.size() <= i || m_aryQC_flg.size() <= i){
					strLine.Format(",%lf", s_dErrorValue);					
					aryFlagLine[iCount] = aryFlagLine[iCount] + strLine;
					aryResultLine[iCount] = aryResultLine[iCount] + strLine;
					return;
				}

				// output for flag
				strLine.Format(",%d", m_aryQC_flg[i]);
				aryFlagLine[iCount] = aryFlagLine[iCount] + strLine;

				// output of results
				if(m_aryQC_flg[i] == 0){
					strLine.Format(",%lf", m_aryContinuousDataset[i]);
				}
				else{
					strLine.Format(",%lf", s_dErrorValue);
				}
				aryResultLine[iCount] = aryResultLine[iCount] + strLine;
				iCount++;
			}
		}
	}
	else{
		if(bIsFrontColumn){		
			for(int i = 0; i < m_aryIsComplement.size(); i++){
				// output for flag
				strLine.Format("%s,%d", m_aryContinuousDate[i], m_aryQC_flg[i]);
				aryFlagLine.push_back(strLine);

				// output of results
				if(m_aryQC_flg[i] == 0){
					strLine.Format("%s,%lf", m_aryContinuousDate[i], m_aryContinuousDataset[i]);
				}
				else{
					strLine.Format("%s,%lf", m_aryContinuousDate[i], s_dErrorValue);
				}			
				aryResultLine.push_back(strLine);
			}
		}else{
			for(int i = 0; i < aryResultLine.size(); i++){
				// output for flag
				strLine.Format(",%d", m_aryQC_flg[i]);
				aryFlagLine[i] = aryFlagLine[i] + strLine;

				// output of results
				if(m_aryQC_flg[i] == 0){
					strLine.Format(",%lf", m_aryContinuousDataset[i]);
				}
				else{
					strLine.Format(",%lf", s_dErrorValue);
				}
				aryResultLine[i] = aryResultLine[i] + strLine;
			}
		}
	}
}


//////////////////////////////////////////////////////////
// Quality Control by using MAD (Papale et al., 2006; Biogeosciences)
//////////////////////////////////////////////////////////
void CDataset::QualityControl_MAD(const double& dZvalue, BOOL bIsDayNightDiv, const double& dNighttimeRadiation, const std::vector<int>& aryNighttimeFlag)
{
	// lǂݔ΂f[^Zbg쐬
	vector<double> aryNoGapData;
	vector<double> aryNoGapDataDay;
	vector<double> aryNoGapDataNight;
	for(int i = 0; i < m_aryContinuousDataset.size(); i++){
		if(m_aryContinuousDataset[i] != s_dErrorValue){
			aryNoGapData.push_back(m_aryContinuousDataset[i]);
			if(bIsDayNightDiv){
				if(aryNighttimeFlag[i] == 1){
					aryNoGapDataNight.push_back(m_aryContinuousDataset[i]);
				}
				else{
					aryNoGapDataDay.push_back(m_aryContinuousDataset[i]);
				}
			}
		}
	}

	// MAD KpāAtO쐬
	vector<int> aryQC_flag;
	vector<int> aryQC_flag_day;
	vector<int> aryQC_flag_night;
	if(bIsDayNightDiv){
		if(aryNoGapDataDay.size() != 0) MedianOfAbsoluteDeviation(aryNoGapDataDay, aryQC_flag_day, dZvalue);
		if(aryNoGapDataNight.size() != 0) MedianOfAbsoluteDeviation(aryNoGapDataNight, aryQC_flag_night, dZvalue);
	}
	else{
		if(aryNoGapData.size() != 0) MedianOfAbsoluteDeviation(aryNoGapData, aryQC_flag, dZvalue);
	}

	// l̂f[^ɃtO𔽉f
	int iAll = 0, iDay = 0, iNight = 0, bLoopNum = 0;
	if(m_aryQC_flg.size() != 0) bLoopNum = 1;
	for(i = 0; i < m_aryContinuousDataset.size(); i++){
		if(m_aryContinuousDataset[i] != s_dErrorValue){
			if(bLoopNum == 0){
				if(bIsDayNightDiv && aryNighttimeFlag[i] == 0){
					m_aryQC_flg.push_back(aryQC_flag_day[iDay]);
					iDay++;
				}
				else if(bIsDayNightDiv && aryNighttimeFlag[i] == 1){
					m_aryQC_flg.push_back(aryQC_flag_night[iNight]);
					iNight++;
				}
				else{
					m_aryQC_flg.push_back(aryQC_flag[iAll]);
					iAll++;
				}
			}
			else{
				if(bIsDayNightDiv && aryNighttimeFlag[i] == 0){
					if(m_aryQC_flg[i] == 0) m_aryQC_flg[i] = aryQC_flag_day[iDay];
					iDay++;
				}
				else if(bIsDayNightDiv && aryNighttimeFlag[i] == 1){
					if(m_aryQC_flg[i] == 0) m_aryQC_flg[i] = aryQC_flag_night[iNight];
					iNight++;
				}
				else{
					if(m_aryQC_flg[i] == 0) m_aryQC_flg[i] = aryQC_flag[iAll];
					iAll++;
				}
			}
		}
		else{
			if(bLoopNum == 0){
				m_aryQC_flg.push_back(-1);			// Ƃƌ̏ꍇ́Au-1v}
			}
		}
	}
}

void CDataset::MedianOfAbsoluteDeviation(const std::vector<double>& aryNoGapData, std::vector<int>& aryQC_flag, const double& dZvalue)
{
	vector<double> aryDvalue;
	for(int i = 0; i < aryNoGapData.size(); i++){
		if(i == 0 || i == (aryNoGapData.size() - 1) ){
			aryDvalue.push_back(0.0);
			continue;
		}

		// equation 1 for Papale et al., 2006
		aryDvalue.push_back( (aryNoGapData[i] - aryNoGapData[i - 1]) - (aryNoGapData[i + 1] - aryNoGapData[i]));
	}

	// equation 4 for Papale et al., 2006
	double Md = Median(aryDvalue);
	vector<double> aryAbsD_Md;

	for(i = 0; i < aryNoGapData.size(); i++){
		aryAbsD_Md.push_back(fabs(aryDvalue[i] - Md));
		double MAD = Median(aryAbsD_Md);

		if(aryDvalue[i] < Md - (dZvalue * MAD / 0.6745)  ||  aryDvalue[i] > Md + (dZvalue * MAD / 0.6745) ){
			aryQC_flag.push_back(1);
		}
		else{
			aryQC_flag.push_back(0);
		}
	}

	// for first and last data cannot be applied this method, and then simply set NO-Error flag.
	aryQC_flag[0] = 0;
	aryQC_flag[aryNoGapData.size() - 1] = 0;
}

void CDataset::ApplyQualityControl()
{
	for(int i = 0; i < m_aryContinuousDataset.size(); i++){
		if(m_aryQC_flg[i] != 0 ){
			m_aryContinuousDataset[i] = s_dErrorValue;
		}
	}
}

//////////////////////////////////////////////////////////
// Bootstrap
//////////////////////////////////////////////////////////
void CDataset::Average_Stdev_BootstrapData_daily(int iStart, int iEnd, double& dAverage, double& dStdev)
{
	double dTx = 0.0;
	double dDayTx = 0.0, dDayTxx = 0.0;
	int iNum = 0, iNumDay = 0;
	dAverage = s_dErrorValue;
	dStdev = s_dErrorValue;

	for(int iBootstrap = 0; iBootstrap < m_aryDataset_final_bs.size(); iBootstrap++){
		for(int i = iStart; i < iEnd; i++){
			if(m_aryDataset_final_bs[iBootstrap][i] != s_dErrorValue){
				dTx += m_aryDataset_final_bs[iBootstrap][i];
				iNum++;
			}
		}
		if(iNum != 0){
			dDayTx += (dTx / iNum);
			dDayTxx += (dTx / iNum) * (dTx / iNum);
			iNumDay++;
		}
		dTx = 0.0;
		iNum = 0;
	}

	if(iNumDay != 0){
		dAverage = dDayTx / iNumDay;
		dStdev = (dDayTxx - dDayTx * dDayTx / iNumDay) / iNumDay;
	}
}

//////////////////////////////////////////////////////////
// Calculate statistics
//////////////////////////////////////////////////////////

double CDataset::AverageDouble(const std::vector<double> &aryDouble)
{
	double dSum = 0.0;

	if(aryDouble.size() == 0){
		return s_dErrorValue;
	}

	for(int i = 0; i < aryDouble.size(); i++){
		dSum += aryDouble[i];
	}

	return dSum / aryDouble.size();
}

std::vector<double> CDataset::AverageDouble_bootstrap(const std::vector<double> &aryDouble, int iBootstrapNum)
{
	double dSum = 0.0;
	vector<double> aryAverage;

	if(aryDouble.size() == 0){
		aryAverage.push_back(s_dErrorValue);
		// return aryAverage;
	}

	// boot strap @
	for(int iB = 0; iB < iBootstrapNum; iB++){
		vector<double> aryDouble_bs;
		int iSizeArrya = aryDouble.size();

		for(int i = 0; i < iSizeArrya; i++){
			aryDouble_bs.push_back(aryDouble[rand() % iSizeArrya]);
		}

		for(i = 0; i < aryDouble_bs.size(); i++){
			dSum += aryDouble_bs[i];
		}
		if(aryDouble.size() == 0){
			dSum = s_dErrorValue;
		}
		else{
			dSum /= aryDouble_bs.size();
		}
		aryAverage.push_back(dSum);
		dSum = 0.0;
	}
	// std::sort(aryAverage.begin(),aryAverage.end());//\[g

	return aryAverage;
}

double CDataset::StdevDouble(const std::vector<double> &aryDouble)
{
    double Ty =0 ,Tyy = 0;
	double n = aryDouble.size();

	if(aryDouble.size() == 0){
		return s_dErrorValue;
	}

    for(int i = 0; i < n; i++){
    	Ty += aryDouble[i];
        Tyy += aryDouble[i] * aryDouble[i];
    }
    double S = (Tyy - Ty * Ty / n) / n;
    return sqrt(S);
}

int CDataset::NumDouble(const std::vector<double> &aryDouble)
{
    return aryDouble.size();
}

double CDataset::Median(std::vector<double> aryDouble)
{
	double median = s_dErrorValue;
	std::sort(aryDouble.begin(),aryDouble.end());		//\[g

	 // WA߂
    if(aryDouble.size() % 2 == 1)  // f[^̏ꍇ
    {
        median = aryDouble[(aryDouble.size() - 1) / 2];  // WA
    }
    else  // f[^̏ꍇ
    {
        median = (aryDouble[(aryDouble.size() / 2) - 1] + aryDouble[aryDouble.size() / 2]) / 2.0;  // WA
	}

	return median;
}
