// Dataset.h: CDataset NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATASET_H__AF4A195D_EDF1_4353_8CE0_E6309217064B__INCLUDED_)
#define AFX_DATASET_H__AF4A195D_EDF1_4353_8CE0_E6309217064B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning( disable : 4786 )
#include <vector>
#include <string>
#include <map>

class CPhotosynthesisParameters {
public:
	CPhotosynthesisParameters() {
		m_iFixed_Pmax_B = FALSE;
		m_iFixed_R0 = FALSE;
	};

	double m_dMaximumPhotosynthesis;
	double m_dB;
	double m_dR0;
	double m_dRMSE;	
	double m_dCoefficientCorrelation;
	int m_iCount;
	int m_iDataNum;
	int m_iFixed_Pmax_B;
	int m_iFixed_R0;

	double m_dMaximumPhotosynthesis_stdev;	// for bootstraping
	double m_dB_stdev;						// for bootstraping
	double m_dR0_stdev;						// for bootstraping
};

class CRespirationParameters{
public:
	CRespirationParameters() {
		m_iFixed_Rref = FALSE;
		m_iFixed_Q10 = FALSE;
	};

	double m_dQ10;
	double m_dR0;
	double m_dTref;
	double m_dRMSE;	
	double m_dCoefficientCorrelation;
	int m_iCount;
	int m_iDataNum;
	int m_iFixed_Rref;
	int m_iFixed_Q10;
	int m_iFixed_Tref;

	double m_dQ10_stdev;				// for bootstraping
	double m_dR0_stdev;					// for bootstraping
	double m_dTref_stdev;				// for bootstraping
};

class CDataset  
{
public:
	enum{ NONE_COMPLEMENT, INTERPOLATE_COMPLEMENT, LUTM_COMPLEMENT, NLRM_COMPLEMENT, MDVM_COMPLEMENT};

	CDataset();
	CDataset(std::vector<double> aryContinuousDataset);
	CDataset(std::vector< std::vector<double> > aryDataset_bs);
	virtual ~CDataset();

	void SetContinuousDataset(CString strTime, double dDataset);

	std::vector<double>* GetContinuousDataset(){return &m_aryContinuousDataset;}
	double GetData(int iDateNum) {return m_aryContinuousDataset[iDateNum];}
	CString GetDate(int iDateNum) {return m_aryContinuousDate[iDateNum];}
	double GetErrorValue() {return s_dErrorValue;}

	// }⊮
	void InterpolateDataset(int iLimtSeqLoss);
	void Update_InterpolateDataset(BOOL bMovingAverage, const CString& strCurrent);

	// ϓω@
	void ExecMeanDiurnalVariationMethod();
	void ExecMeanDiurnalVariationMethod_moving_av(const CString& strCurrentDate);
	void ExecMeanDiurnalVariationMethod_bootstrap(int iBootstrapNum);
	void ApplyRadiationFactor_DirunalVariation(const CString& strCurrentDate, BOOL bMovingAverage = FALSE);
	void SetDiurnalVariation(int iRunOfDay, int iBoostrapNum = 1, BOOL bBootstrap = FALSE);

	double GetFlagData(int iNumber){return m_aryIsComplement[iNumber];}

	// bootstrap
	void Average_Stdev_BootstrapData_daily(int iStart, int iEnd, double& dAverage, double& dStdev);

	void SetHeaderName(const CString& strHeaderName){m_strHeaderName = strHeaderName;}
	BOOL GetOutputPatternFormat(int iRunNum, CString& strLine, BOOL bIsBootstrap);
	BOOL GetDiurnalAverage(int iRunNum, CString& strLine);
	int  GetDiurnalNum(){return m_aryDiurnalAverage.size();};
	void GetContinuousData(std::vector<CString>& aryResultLine, BOOL bIsFrontColumn);
	void GetFlagData(std::vector<CString>& aryResultLine, BOOL bIsFrontColumn);
	void GetBootstrapMean(std::vector<CString>& aryResultLine, BOOL bIsFrontColumn);
	void SetConvertRate(const std::vector<double>& aryRadiationDataset, double dRadiationAverage, int iDayOfRun, int iAverageNumber);
	std::string GetHeaderName(){return m_strHeaderName;}
	double GetDiurnalAverage(int iAverageNum);

	void GetFilledData(std::vector<CString>& aryResultLine, int iDataType, const CString& strCurrentDate, BOOL bIsFrontColumn, BOOL bMovingAverage);
	int get_current_date(const CString& strCurrentDate);

	int size() {return m_aryContinuousDataset.size();};

	static const double s_dErrorValue;
	std::vector<std::vector<std::vector<double> > > m_aryLookUpTable;
	std::vector<std::vector<std::vector<double> > > m_aryLookUpTable1;
	std::vector<std::vector<std::vector<double> > > m_aryLookUpTable2;
	// double m_aryLookUpTable[36][36][36];
	
	std::vector<CString> m_aryContinuousDate;				// n̎f[^i[
	std::vector<double> m_aryInterporateDataset;			// }⊮ꂽf[^
	std::vector<double> m_aryMDV_Dataset;					// ϓω@ɂ⊮ꂽf[^
	std::vector<double> m_aryLT_Filled_Dataset;				// \@ɂ⊮ꂽf[^
	std::vector<double> m_aryTable_Dataset;					// \@ɂ⊮ꂽf[^
	std::vector<int> m_aryIsComplement;						// ⊮Ȃ:0, }⊮:1, MDVN:4
	std::vector<double> m_aryRE_lut;						// Look up table ɂ

	// bootstrap variables
	std::vector< std::vector<double> > m_aryTable_Dataset_bs;		// bootstrap @ɂ萶ꂽ\@ɂ⊮ꂽf[^
	std::vector< std::vector<double> > m_aryDataset_bs;				// bootstrap @ɂ萶ꂽ\@ɂ⊮ꂽf[^
	std::vector< std::vector<double> > m_aryDataset_final_bs;		// bootstrap @ɂ萶ꂽ⊮ꂽf[^
	std::vector<double> m_aryAverage_Final_Dataset;					// bootstrap @ɂ萶ꂽ⊮ꂽf[^ (Final ̕)
	std::vector<double> m_aryStdev_Final_Dataset;					// bootstrap @ɂ萶ꂽ⊮ꂽf[^ (Final ̕W΍)


	// quality control
	void MedianOfAbsoluteDeviation(const std::vector<double>& aryNoGapData, std::vector<int>& aryQC_flag, const double& dZvalue);
	void QualityControl_MAD(const double& dZvalue, BOOL bIsDayNightDiv, const double& dNighttimeRadiation, const std::vector<int>& aryNighttimeFlag);
	void GetQCFlagData(std::vector<CString>& aryFlagLine, std::vector<CString>& aryResultLine, const CString& strCurrentDate, int iRunPerDay, BOOL bIsFrontColumn, BOOL bMovingAverage);
	void ApplyQualityControl();

	std::vector<double> m_aryDiurnalAverage;
	std::vector<double> m_aryDiurnalStdev;
	std::vector<int> m_aryDiurnalNumbers;

	// bootstrap variables
	std::vector<double> m_aryDiurnalUpperConfidence90_bootstrap;
	std::vector<double> m_aryDiurnalLowerConfidence90_bootstrap;
	std::vector< std::vector<double> > m_aryBootstrapDiurnalVariation;
	std::vector<double> m_aryBootstrapAverage;
private:
	std::vector<double> m_aryContinuousDataset;				// nf[^i[
	std::vector<double> m_aryRadiationComplemetFactor;		//  
	std::map<int, std::vector<double>*> m_mapDiurnalPattern;// ϓω쐬邽߂̎̃f[^
	std::map<int, double> m_mapDiurnalAverage;				// ϓωi[

	// quality control flag
	std::vector<int> m_aryQC_flg;

	double AverageDouble(const std::vector<double> &aryDouble);
	std::vector<double> CDataset::AverageDouble_bootstrap(const std::vector<double> &aryDouble, int iBootstrapNum);
	double StdevDouble(const std::vector<double> &aryDouble);
	int NumDouble(const std::vector<double> &aryDouble);
	double GetAverage(std::vector<double> aryOneDayData, int iAverageNum);
	double Median(std::vector<double> aryDouble);
	std::string m_strHeaderName;
};

#endif // !defined(AFX_DATASET_H__AF4A195D_EDF1_4353_8CE0_E6309217064B__INCLUDED_)
