// LightPhotosynthesisDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "LightPhotosynthesisDlg.h"

#include "BrowseFolderDialog.h"
#include "MeanTerm.h"

#include <vector>

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLightPhotosynthesisDlg _CAO


CLightPhotosynthesisDlg::CLightPhotosynthesisDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLightPhotosynthesisDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLightPhotosynthesisDlg)
	m_iDaysOfTerm = 14;
	m_strInputFile = _T("");
	m_strOutputFile = _T("");
	m_iRunPerDay = 48;
	m_bSetMaximumB = FALSE;
	m_dMaximumB = 0.005;
	m_bCalculateR0 = FALSE;
	m_bUseNegativeValues = FALSE;
	m_bUseNonRectangular = FALSE;
	m_dConvexity = 0.9;
	m_strInputFile1 = _T("");
	m_strInputFile2 = _T("");
	m_strOutputApplicationFile = _T("");
	//}}AFX_DATA_INIT
}

CLightPhotosynthesisDlg::~CLightPhotosynthesisDlg()
{

}

void CLightPhotosynthesisDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLightPhotosynthesisDlg)
	DDX_Text(pDX, IDC_EDIT_ANALYITICAL_TERM, m_iDaysOfTerm);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_FILE, m_strOutputFile);
	DDX_Text(pDX, IDC_EDIT_RUN_PER_DAY, m_iRunPerDay);
	DDX_Check(pDX, IDC_CHECK_MAX_B, m_bSetMaximumB);
	DDX_Text(pDX, IDC_EDIT_MAX_B, m_dMaximumB);
	DDX_Check(pDX, IDC_CHECK_CALC_R0, m_bCalculateR0);
	DDX_Check(pDX, IDC_CHECK_NEGATIVE_VALUE, m_bUseNegativeValues);
	DDX_Check(pDX, IDC_CHECK_NON_RECTANGULAR, m_bUseNonRectangular);
	DDX_Text(pDX, IDC_EDIT_CONVEXITY, m_dConvexity);
	DDV_MinMaxDouble(pDX, m_dConvexity, 0., 1.);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE1, m_strInputFile1);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE2, m_strInputFile2);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_APPLICATION, m_strOutputApplicationFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLightPhotosynthesisDlg, CDialog)
	//{{AFX_MSG_MAP(CLightPhotosynthesisDlg)
	ON_BN_CLICKED(IDOK, OnExec)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE, OnButtonInputFile)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUT_FILE, OnButtonOutputFile)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE, OnKillfocusEdit)
	ON_BN_CLICKED(IDC_CHECK_MAX_B, OnCheckMaxB)
	ON_BN_CLICKED(IDC_CHECK_CALC_R0, OnCheckCalcR0)
	ON_BN_CLICKED(IDC_CHECK_NEGATIVE_VALUE, OnCheckNegativeValue)
	ON_BN_CLICKED(IDC_CHECK_NON_RECTANGULAR, OnCheckNonRectangular)
	ON_EN_KILLFOCUS(IDC_EDIT_CONVEXITY, OnKillfocus)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE1, OnButtonInputFile1)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE2, OnButtonInputFile2)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUT_APPLICATION, OnButtonOutputApplication)
	ON_BN_CLICKED(IDC_BUTTON_EXEC, OnExec)
	ON_EN_KILLFOCUS(IDC_EDIT_OUTPUT_FILE, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_RUN_PER_DAY, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_ANALYITICAL_TERM, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE1, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE2, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_OUTPUT_APPLICATION, OnKillfocusEdit)
	ON_BN_CLICKED(IDC_BUTTON_EXEC_APPLICATION, OnButtonExecApplication)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLightPhotosynthesisDlg bZ[W nh

BOOL CLightPhotosynthesisDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	GetDlgItem(IDC_EDIT_MAX_B)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_NON_RECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_CONVEXITY)->EnableWindow(FALSE);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CLightPhotosynthesisDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_dConvexity = 0.9;
}

void CLightPhotosynthesisDlg::OnButtonInputFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile = dlg.GetPathName();
		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputFile == ""){
			m_strOutputFile = m_strInputFile.Mid(0, m_strInputFile.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CLightPhotosynthesisDlg::OnButtonOutputFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputFile = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CLightPhotosynthesisDlg::OnButtonInputFile1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile1 = dlg.GetPathName();
		if(m_strOutputApplicationFile == ""){
			m_strOutputApplicationFile = m_strInputFile1.Mid(0, m_strInputFile1.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
	
}

void CLightPhotosynthesisDlg::OnButtonInputFile2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile2 = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CLightPhotosynthesisDlg::OnButtonOutputApplication() 
{
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputApplicationFile = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CLightPhotosynthesisDlg::OnKillfocusEdit() 
{
	UpdateData(TRUE);
}

void CLightPhotosynthesisDlg::OnKillfocus() 
{
	UpdateData(TRUE);
}

void CLightPhotosynthesisDlg::OnCheckCalcR0() 
{
	UpdateData(TRUE);
}

void CLightPhotosynthesisDlg::OnCheckNegativeValue() 
{
	UpdateData(TRUE);
}

void CLightPhotosynthesisDlg::OnExec() 
{
	BOOL bExistHeader = TRUE;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);

	BeginWaitCursor();

	///////////////////////////////////////////
	// eLXg{bNX̓͂̃`FbN
	///////////////////////////////////////////
	if(m_strInputFile == ""){
		AfxMessageBox ("̓t@Cw肵ĂB");
		return;
	}
	if(m_strOutputFile == ""){
		AfxMessageBox ("o̓t@Cw肵ĂB");
		return;
	}
	if(m_iRunPerDay <= 0){
		AfxMessageBox ("Run per Day ͐̐ɂĉB");
		return;
	}
	if(m_iDaysOfTerm <= 0){
		AfxMessageBox ("Analytical Term ͐̐ɂĉB");
		return;
	}
	if(m_bSetMaximumB == TRUE && m_dMaximumB <= 0.0){
		AfxMessageBox ("Analytical Term ͐̐ɂĉB");
		return;
	}
	if(m_bUseNonRectangular == TRUE && m_dConvexity <= 0.0 || m_dConvexity > 1.0){
		AfxMessageBox ("Convexity  0`1 ̂ɂĉB");
		return;
	}
	
	///////////////////////////////////////////
	// ̓t@C̓ǂݍ
	///////////////////////////////////////////	
	vector<CMeanTerm*> m_aryMeanTerm;
	CString strHeaderLine;
	if(ReadFileByMeanTerm(m_strInputFile, m_aryMeanTerm, m_iRunPerDay, m_iDaysOfTerm, strHeaderLine) == FALSE){
		AfxMessageBox ("̓t@C̓ǂݍ݂Ɏs܂B");
		return;
	}

	///////////////////////////////////////////
	// Œp^̓ǂݍ
	///////////////////////////////////////////	
	m_aryFixedPhotosynthesisParameters.clear();
	CPhotosynthesisParameters tempPrm;
//	tempPrm.m_iFixed = FALSE;

	///////////////////////////////////////////
	// ŏ@ɂ[Ȑ̍쐬
	///////////////////////////////////////////	
	int iRadiationColumn = 0;
	int iPhotosynthesisColumn = 1;
	double dTempMax = -99999, dTempMin = -99999, dTempAve = -99999;
	double dNighttimeRadiation = 0.0;
	for(int i = 0; i < m_aryMeanTerm.size(); i++){
		// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
		CString strTemp = strHeaderLine;
		if(m_aryMeanTerm[i]->SetDataset(strTemp.Replace(',','@')) == FALSE){
			return;
		}
		m_aryMeanTerm[i]->SetHeader(strHeaderLine);

		// poȐ̌
		if(m_aryMeanTerm[i]->DetermineLightPhotosynthesisCurve(m_bSetMaximumB, m_dMaximumB, m_dConvexity, dNighttimeRadiation, m_bCalculateR0, m_bUseNegativeValues, m_bUseNonRectangular, iRadiationColumn, iPhotosynthesisColumn, FALSE, tempPrm) == FALSE){
			return;
		}
	}

	///////////////////////////////////////////
	// t@CEtH_쐬Aʂۑ
	///////////////////////////////////////////	
	CString strOutputFileName;
	m_strInputTitle = m_strInputFile.Mid(m_strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));
	if(m_bUseNonRectangular == 0){
		strOutputFileName.Format("%s\\%s_L-P-curve.csv", m_strOutputFile, m_strInputTitle);
	}
	else{
		strOutputFileName.Format("%s\\%s_nL-P-curve_%.2lf.csv", m_strOutputFile, m_strInputTitle, m_dConvexity);
	}

	try{
		CStdioFile file(strOutputFileName, CFile::modeCreate | CFile::modeWrite);

		// sڂɗLq
		CString strLine;
		strLine.Format("Date, Amax, b, R0, RMSE, R, Data Number, iCount, Negative Values:%d, Non Rectangular:%d, Convexity:%lf\n", m_bUseNegativeValues, m_bUseNonRectangular, m_dConvexity);
		file.WriteString(strLine);

		for(int i = 0; i < m_aryMeanTerm.size(); i++){
			strLine = m_aryMeanTerm[i]->GetOutputLine_LightPhotosynthesis(m_bUseNegativeValues, dTempMax, dTempMin, dTempAve);
			file.WriteString(strLine);
		}

		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}

	///////////////////////////////////////////
	// mۂ̈̊J
	///////////////////////////////////////////
	for(i = 0; i < m_aryMeanTerm.size(); i++){
		delete m_aryMeanTerm[i];
	}
	m_aryMeanTerm.clear();
}

BOOL CLightPhotosynthesisDlg::ReadFileByMeanTerm(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iDaysOfTerm, CString& strHeaderLine, BOOL bExistHeader)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	BOOL bIsOK = FALSE;
	CString strTemp;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		if(bExistHeader == TRUE){	//  sڂɃwb_[LڂĂꍇ
			InFile.ReadString(strHeaderLine);
		}

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}

			if(iCountOfRun == 0){
				CMeanTerm* MeanTerm = new CMeanTerm(iTermNum);
				aryMeanTerm.push_back(MeanTerm);
				iTermNum++;

				// ̏擾
				strTemp = strLine.Left(strLine.Find(','));
				(aryMeanTerm.back())->SetCurrentDate(strTemp);
			}
			if(iCountOfRun < iRunPerDay * iDaysOfTerm){
				(aryMeanTerm.back())->SetLine(strLine);
				iCountOfRun++;
			}
			if(iCountOfRun == iRunPerDay * iDaysOfTerm){
				iCountOfRun = 0;
			}
		}
		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}
	bIsOK = TRUE;
	return bIsOK;
}

void CLightPhotosynthesisDlg::OnCheckMaxB() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);

	if(m_bSetMaximumB == TRUE){		
		GetDlgItem(IDC_EDIT_MAX_B)->EnableWindow(TRUE);

	}else{
		GetDlgItem(IDC_EDIT_MAX_B)->EnableWindow(FALSE);
	}	
	UpdateData(FALSE);
}

void CLightPhotosynthesisDlg::OnCheckNonRectangular() 
{
	UpdateData(TRUE);

	if(m_bUseNonRectangular == TRUE){		
		GetDlgItem(IDC_STATIC_NON_RECT)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_CONVEXITY)->EnableWindow(TRUE);

	}else{
		GetDlgItem(IDC_STATIC_NON_RECT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_CONVEXITY)->EnableWindow(FALSE);
	}	
	UpdateData(FALSE);
}

void CLightPhotosynthesisDlg::OnButtonExecApplication() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ	
	CString strLine, strTemp;
	BOOL bUseNegativeValues;
	BOOL bUseNonRectangular;
	double dDate;
	double dConvexity;
	double dAmax;
	double dB;
	double dR0;
	vector<CMeanTerm*> aryMeanTerm;

	UpdateData(TRUE);
	BeginWaitCursor();
	
	///////////////////////////////////////////
	// eLXg{bNX̓͂̃`FbN
	///////////////////////////////////////////
	if(m_strInputFile1 == ""){
		AfxMessageBox ("̓t@Cw肵ĂB");
		return;
	}
	if(m_strInputFile2 == ""){
		AfxMessageBox ("̓p^t@Cw肵ĂB");
		return;
	}
	if(m_strOutputApplicationFile == ""){
		AfxMessageBox ("o̓t@Cw肵ĂB");
		return;
	}

	///////////////////////////////////////////
	// ̓p^t@C̓ǂݍ
	///////////////////////////////////////////	
	try{
		CStdioFile file(m_strInputFile2, CFile::modeRead | CFile::shareDenyWrite);

		// sڂɗLq
		int iCount = 0;

		while(file.ReadString(strLine)){			
			if(strLine == ","){
				continue;
			}
			iCount++; 

			// Get Header data
			if(iCount == 1){
				// Get bUseNegativeValues
				if(strLine.Find("Negative Values:") == -1){
					AfxMessageBox ("p^t@CtH[}bg܂B");
					return;
				}
				strTemp = strLine.Mid(strLine.Find("Negative Values:"));
				strTemp = strTemp.Mid(0, strTemp.Find(","));
				strTemp = strTemp.Mid(strTemp.Find(":") + 1);
				bUseNegativeValues = atoi(strTemp);

				// Get bUseNonRectangular
				if(strLine.Find("Non Rectangular:") == -1){
					AfxMessageBox ("p^t@CtH[}bg܂B");
					return;
				}
				strTemp = strLine.Mid(strLine.Find("Non Rectangular:"));
				strTemp = strTemp.Mid(0, strTemp.Find(","));
				strTemp = strTemp.Mid(strTemp.Find(":") + 1);
				bUseNonRectangular = atoi(strTemp);

				// Get dConvexity
				if(strLine.Find("Convexity:") == -1){
					AfxMessageBox ("p^t@CtH[}bg܂B");
					return;
				}
				strTemp = strLine.Mid(strLine.Find("Convexity:"));
				strTemp = strTemp.Mid(strTemp.Find(":") + 1);
				dConvexity = atof(strTemp);

				continue;
			}

			// Header ȊÕf[^̓ǂݍ
			CMeanTerm* MeanTerm = new CMeanTerm(iCount - 2);
			if(iCount == 2) MeanTerm->SetPhotosynthesisConstant(bUseNegativeValues, bUseNonRectangular, dConvexity);
			// Get Date
			strTemp = strLine.Mid(0, strLine.Find(","));
			dDate = atof(strTemp);
			// Get dAmax
			strLine = strLine.Mid(strLine.Find(",") + 1);
			strTemp = strLine.Mid(0, strLine.Find(","));
			dAmax = atof(strTemp);
			// Get dB
			strLine = strLine.Mid(strLine.Find(",") + 1);
			strTemp = strLine.Mid(0, strLine.Find(","));
			dB = atof(strTemp);
			// Get dR0
			strLine = strLine.Mid(strLine.Find(",") + 1);
			strTemp = strLine.Mid(0, strLine.Find(","));
			dR0 = atof(strTemp);
			if(bUseNegativeValues == TRUE && dR0 != CDataset::s_dErrorValue) dR0 = - dR0;
			// Set Parameters
			MeanTerm->SetParametersGPP(dDate, dAmax, dB, dR0);
			aryMeanTerm.push_back(MeanTerm);
		}

		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}

	///////////////////////////////////////////
	// ͘At@C̓ǂݍ
	///////////////////////////////////////////	
	int iCountOfRun = 0;
	CString strHeader;
	try{
		CStdioFile file(m_strInputFile1, CFile::modeRead | CFile::shareDenyWrite);
		int iCount = 0;

		while(file.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			iCount++; 

			// wb_[ǂݔ΂
			if(iCount == 1){
				strHeader = strLine;
				continue;
			}

			// Get Date
			strTemp = strLine.Mid(0, strLine.Find(","));
			dDate = atof(strTemp);

			if(iCountOfRun == aryMeanTerm.size() - 1){
				aryMeanTerm[iCountOfRun]->SetLine(strLine);
			}
			else{
				if(dDate < aryMeanTerm[iCountOfRun + 1]->GetStartDay()){
					aryMeanTerm[iCountOfRun]->SetLine(strLine);
				}
				else{
					iCountOfRun++;
					aryMeanTerm[iCountOfRun]->SetLine(strLine);
				}
			}
		}
		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return;
	}

	///////////////////////////////////////////
	// poȐxvZ
	///////////////////////////////////////////
	int iRadiationColumn = 0;
	for(int i = 0; i < aryMeanTerm.size(); i++){
		aryMeanTerm[i]->ApplyLightPhotosynthesisCurve(strHeader, iRadiationColumn);
	}

	///////////////////////////////////////////
	// ʃt@C̏o
	///////////////////////////////////////////
	CString strInputTitle = m_strInputFile1.Mid(m_strInputFile1.ReverseFind('\\') + 1);
	strInputTitle = strInputTitle.Mid(0, strInputTitle.ReverseFind('.'));
	try{
		// ⊮̎nt@CSĂ̊Ԃɂ킽ďo͂邽߂̃t@C̃CX^X
		CString strOutPass;
		if(!bUseNonRectangular){
			strOutPass = m_strOutputApplicationFile + "\\" + strInputTitle + "_result01.csv";
		}
		else{
			strOutPass = m_strOutputApplicationFile + "\\" + strInputTitle + "_result02.csv";
		}
		CStdioFile file(strOutPass, CFile::modeCreate | CFile::modeWrite);

		// All result & flag file ̃wb_Lq
		if(!bUseNonRectangular){
			strLine = "Date, Radiation, Flux, Flux_rectangle\n";
		}
		else{
			strLine = "Date, Radiation, Flux, Flux_non-rectangle\n";
		}
		file.WriteString(strLine);

		// t@CEtH_쐬Aʂۑ	
		for(i = 0; i < aryMeanTerm.size(); i++){
			aryMeanTerm[i]->WriteDataset(file, 0, FALSE);
		}
		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}

	///////////////////////////////////////////
	// mۂ̈̊J
	///////////////////////////////////////////
	for(i = 0; i < aryMeanTerm.size(); i++){
		delete aryMeanTerm[i];
	}
	aryMeanTerm.clear();
}
