// LookUpTableDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "LookUpTableDlg.h"

#include "BrowseFolderDialog.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLookUpTableDlg _CAO


CLookUpTableDlg::CLookUpTableDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLookUpTableDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLookUpTableDlg)
	m_iGapFillingTerm = 15;
	m_iRunPerDay = 48;
	m_strInputFile = _T("");
	m_strOutputFile = _T("");
	m_bUseLinearRegression = TRUE;
	m_iMaximumForLinearRegression = 3;
	m_bUsePeriod = FALSE;
	m_bMovingAverage = TRUE;
	m_iCalibrationColmun1 = 5;
	m_iCalibrationColmun2 = 6;
	m_iCalibrationColmun3 = 7;
	m_iApplicationColmun1 = 8;
	m_iApplicationColmun2 = 9;
	m_iApplicationColmun3 = 10;
	m_iDivide1 = 36;
	m_iDivide2 = 36;
	m_iDivide3 = 36;
	m_dMax1 = 3400.0;
	m_dMax2 = 60.0;
	m_dMax3 = 17.5;
	m_dMin1 = 10.0;
	m_dMin2 = -25.0;
	m_dMin3 = 0.0;
	//}}AFX_DATA_INIT
}


void CLookUpTableDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLookUpTableDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Text(pDX, IDC_EDIT_GAP_TERM, m_iGapFillingTerm);
	DDV_MinMaxUInt(pDX, m_iGapFillingTerm, 1, 100000);
	DDX_Text(pDX, IDC_EDIT_RUN_PER_DAY, m_iRunPerDay);
	DDV_MinMaxUInt(pDX, m_iRunPerDay, 1, 100000);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDX_Text(pDX, IDC_EDIT_OUT_DIR, m_strOutputFile);
	DDX_Check(pDX, IDC_CHECK_USE_REGRESSION, m_bUseLinearRegression);
	DDX_Text(pDX, IDC_EDIT_MAXIMUM_REGRESSION, m_iMaximumForLinearRegression);
	DDV_MinMaxUInt(pDX, m_iMaximumForLinearRegression, 1, 100000);
	DDX_Check(pDX, IDC_CHECK_PERIOD, m_bUsePeriod);
	DDX_Check(pDX, IDC_CHECK_MOVING_WD, m_bMovingAverage);
	DDX_Text(pDX, IDC_EDIT_CAL1, m_iCalibrationColmun1);
	DDV_MinMaxUInt(pDX, m_iCalibrationColmun1, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_CAL2, m_iCalibrationColmun2);
	DDV_MinMaxUInt(pDX, m_iCalibrationColmun2, 1, 10000);
	DDX_Text(pDX, IDC_EDIT_CAL3, m_iCalibrationColmun3);
	DDV_MinMaxUInt(pDX, m_iCalibrationColmun3, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_APLLY1, m_iApplicationColmun1);
	DDV_MinMaxUInt(pDX, m_iApplicationColmun1, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_APLLY2, m_iApplicationColmun2);
	DDV_MinMaxUInt(pDX, m_iApplicationColmun2, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_APLLY3, m_iApplicationColmun3);
	DDV_MinMaxUInt(pDX, m_iApplicationColmun3, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_DIV1, m_iDivide1);
	DDV_MinMaxUInt(pDX, m_iDivide1, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_DIV2, m_iDivide2);
	DDV_MinMaxUInt(pDX, m_iDivide2, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_DIV3, m_iDivide3);
	DDV_MinMaxUInt(pDX, m_iDivide3, 1, 1000);
	DDX_Text(pDX, IDC_EDIT_MAX1, m_dMax1);
	DDX_Text(pDX, IDC_EDIT_MAX2, m_dMax2);
	DDX_Text(pDX, IDC_EDIT_MAX3, m_dMax3);
	DDX_Text(pDX, IDC_EDIT_MIN1, m_dMin1);
	DDX_Text(pDX, IDC_EDIT_MIN2, m_dMin2);
	DDX_Text(pDX, IDC_EDIT_MIN3, m_dMin3);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLookUpTableDlg, CDialog)
	//{{AFX_MSG_MAP(CLookUpTableDlg)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE, OnKillfocus)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE, OnButtonInputFile)
	ON_BN_CLICKED(IDC_BUTTON_OUT_DIR, OnButtonOutDir)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnButtonApply)
	ON_BN_CLICKED(IDC_CHECK_USE_REGRESSION, OnCheckUseRegression)
	ON_BN_CLICKED(IDC_CHECK_PERIOD, OnCheckPeriod)
	ON_BN_CLICKED(IDC_CHECK_MOVING_WD, OnCheckMovingWd)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_EN_KILLFOCUS(IDC_EDIT_OUT_DIR, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_GAP_TERM, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_RUN_PER_DAY, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MAXIMUM_REGRESSION, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_CAL1, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_APLLY1, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_DIV1, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MAX1, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MIN1, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_CAL2, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_APLLY2, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_DIV2, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MAX2, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MIN2, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_CAL3, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_APLLY3, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_DIV3, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MAX3, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MIN3, OnKillfocus)
	ON_BN_CLICKED(IDC_BTN_LAOD, OnBtnLaod)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLookUpTableDlg bZ[W nh
BOOL CLookUpTableDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDI_LUT );
	SetIcon(hFile, TRUE);	
	SetIcon(hFile, FALSE);	
	m_bIsThread = FALSE;
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CLookUpTableDlg::OnKillfocus() 
{
	UpdateData(TRUE);
}

void CLookUpTableDlg::OnCheckUseRegression() 
{
	UpdateData(TRUE);

	if(m_bUseLinearRegression == TRUE){
		GetDlgItem(IDC_EDIT_MAXIMUM_REGRESSION)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_EDIT_MAXIMUM_REGRESSION)->EnableWindow(FALSE);
	}
}

void CLookUpTableDlg::OnCheckPeriod() 
{
	UpdateData(TRUE);	
}

void CLookUpTableDlg::OnCheckMovingWd() 
{
	UpdateData(TRUE);
}

void CLookUpTableDlg::OnButtonInputFile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile = dlg.GetPathName();
		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputFile == ""){
			m_strOutputFile = m_strInputFile.Mid(0, m_strInputFile.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CLookUpTableDlg::OnButtonOutDir() 
{
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputFile = dlg.GetPathName();
		UpdateData(FALSE);
	}
}
void CLookUpTableDlg::OnButtonApply() 
{
	BOOL bIsDebug = FALSE;
	#ifdef _DEBUG
	bIsDebug = TRUE;
	#endif

	CString strErrorMessage;
	if(bIsDebug){
		if(OnLookUpTable(strErrorMessage) == TRUE){
			AfxMessageBox("The calculation has been successfully done !");
		}
		else{
			AfxMessageBox(strErrorMessage);
		}
	}
	else{
		// Using Malti Thread
		if(!m_bIsThread){
			m_pThread = AfxBeginThread(OnLookUpTableThread,(LPVOID)this);
			m_pThread->m_bAutoDelete = FALSE;
			m_pThread->ResumeThread();
		}
		else{
			AfxMessageBox("Error : Thread is busy !");
		}
	}
}

UINT CLookUpTableDlg::OnLookUpTableThread(LPVOID pParam)
{
	CLookUpTableDlg* pDlg = static_cast<CLookUpTableDlg*>(pParam);

 	pDlg->m_bIsThread = TRUE;
	if(pDlg->OnLookUpTable(pDlg->m_strErrorMessageForThread) == TRUE){
		AfxMessageBox("The calculation has been successfully done !");
	}
	else{
		if(pDlg->m_strErrorMessageForThread != ""){
			AfxMessageBox(pDlg->m_strErrorMessageForThread);
		}
	}

	pDlg->m_bIsThread = FALSE;
	return 0;
}

BOOL CLookUpTableDlg::OnLookUpTable(CString& strErrorMessage) 
{
	CWaitCursor wait;
	UpdateData(TRUE);

	// ***************************************************************
	// t@CE^Cg̍XV
	// ***************************************************************
	m_strInputTitle = m_strInputFile.Mid(m_strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));

	// ***************************************************************
	// ݒt@C̏o
	// ***************************************************************
	CString strOutSettingFile = m_strInputFile;
	strOutSettingFile = strOutSettingFile.Left(strOutSettingFile.ReverseFind('.')) + ".lut.set.txt";
	strOutSettingFile = m_strOutputFile + "\\" + strOutSettingFile.Mid(strOutSettingFile.ReverseFind('\\') + 1);
	SaveSetting(strOutSettingFile);

	// **************************************************
	// vOXo[̏
	// **************************************************
	int iProgressRange = 1100;
	m_ctlProgress.SetRange(0, iProgressRange);	// Inisilize Progress bar
	m_ctlProgress.SetPos(100);

	if(ErrorCheck(strErrorMessage) == FALSE){
		return FALSE;
	}

	vector<CMeanTerm*> aryMeanTerm;
	CString strHeader;

	// ̓f[^̓ǂݍ
	if(m_bMovingAverage){
		ReadFile_with_MovingWindow(m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iGapFillingTerm, strHeader);
	}
	else{
		ReadFile_with_BlockWindow (m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iGapFillingTerm, strHeader);
	}

	if(LookUpTable(m_strOutputFile, aryMeanTerm, strHeader, m_bMovingAverage, m_ctlProgress) == FALSE){
		// mۂ̈̊J
		for(int i = 0; i < aryMeanTerm.size(); i++){
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];
		}
		return FALSE;
	}
	
	return TRUE;
}

BOOL CLookUpTableDlg::ErrorCheck(CString& strErrorMessage)
{
	if(m_strInputFile == ""){
		strErrorMessage = "Please select the input file.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_INPUT_FILE));
		return FALSE;
	}
	if(m_strOutputFile == ""){
		strErrorMessage = "Please select the output directory.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_OUT_DIR));
		return FALSE;
	}
	if(m_iRunPerDay <= 0){
		strErrorMessage = "The Run per day should be positive value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_RUN_PER_DAY));
		return FALSE;
	}
	if(m_iGapFillingTerm < 1){
		strErrorMessage = "The gap filling term should be greater than 1.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_GAP_TERM));
		return FALSE;
	}
	if(m_bMovingAverage && m_iGapFillingTerm % 2 == 0){
		strErrorMessage = "The respiration term should be odd number.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_GAP_TERM));
		return FALSE;
	}

	// check inputs for the explaing variable
	if(m_dMax1 <= m_dMin1){
		strErrorMessage = "The maximum value for explaining varialbe 1 should be greater than the minimum value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_MAX1));
		return FALSE;
	}
	if(m_dMax2 <= m_dMin2){
		strErrorMessage = "The maximum value for explaining varialbe 2 should be greater than the minimum value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_MAX2));
		return FALSE;
	}
	if(m_dMax3 <= m_dMin3){
		strErrorMessage = "The maximum value for explaining varialbe 3 should be greater than the minimum value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_MAX3));
		return FALSE;
	}

	return TRUE;
}

BOOL CLookUpTableDlg::ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strHeaderLine);	//	 1s
		InFile.ReadString(strLine);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[@ipj
	for(int i = 0; i < aryLines.size(); i++){
		if(i % iRunPerDay == 0 ){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i - (iPhotosynthesisTerm - 1) / 2 * m_iRunPerDay;
			int iEnd   = i + (iPhotosynthesisTerm - 1) / 2 * m_iRunPerDay;
			if(iStart < 0) iStart = 0;
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j <= iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));  // commented out at 2010.01.27  at 2011.01.01

				// ǂݍݓr period ςƂ 
				// added at 2011.2.1 for moving window 
				if(m_bUsePeriod && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					continue;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

BOOL CLookUpTableDlg::ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strHeaderLine);	//	 1s
		InFile.ReadString(strLine);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[j
	BOOL bPeriodChange = FALSE;
	for(int i = 0; i < aryLines.size(); i++){
		if(i % (iRunPerDay * iPhotosynthesisTerm) == 0 || bPeriodChange == TRUE){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;
			bPeriodChange = FALSE;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i;
			int iEnd   = i + (iPhotosynthesisTerm * m_iRunPerDay);
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j < iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));

				// ǂݍݓr period ςƂ
				if(m_bUsePeriod && j != iStart && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					bPeriodChange = TRUE;
					i = j - 1;
					break;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

BOOL CLookUpTableDlg::LookUpTable(const CString& strOutDir, std::vector<CMeanTerm*>& aryMeanTerm, CString& strHeaderLine, BOOL bMovingAverage, CProgressCtrl& ctlProgress)
{
	int iDataType = 2;	// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4)

	try{
		// ⊮̎nt@CSĂ̊Ԃɂ킽ďo͂邽߂̃t@C̃CX^X
		CString strResult, strFlag, strTable;
		if(bMovingAverage == FALSE){
			strResult.Format("%s\\%s_bw%d_lut_results.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strFlag.Format("%s\\%s_bw%d_lut_flags.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strTable.Format("%s\\%s_bw%d_lut_tables.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
		}
		else{
			strResult.Format("%s\\%s_mw%d_lut_results.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strFlag.Format("%s\\%s_mw%d_lut_flags.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strTable.Format("%s\\%s_mw%d_lut_tables.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
		}

		CStdioFile fileAllResult(strResult, CFile::modeCreate | CFile::modeWrite);
		CStdioFile fileAllFlag(strFlag, CFile::modeCreate | CFile::modeWrite);
		CStdioFile fileAllTable(strTable, CFile::modeCreate | CFile::modeWrite);;

		// All result & flag file ̃wb_Lq
		fileAllResult.WriteString(strHeaderLine + "\n");
		fileAllFlag.WriteString(strHeaderLine + "\n");
		fileAllTable.WriteString(strHeaderLine + "\n");

		// t@CEtH_쐬Aʂۑ	
		CString strDirPath;
		double dProgressSize = 1000.0 / aryMeanTerm.size();
		for(int i = 0; i < aryMeanTerm.size(); i++){
			// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
			CString strTemp = strHeaderLine;
			if(aryMeanTerm[i]->SetDataset(strTemp.Replace(',','@')) == FALSE){
				return FALSE;
			}
			aryMeanTerm[i]->SetHeader(strHeaderLine);

			if(aryMeanTerm[i]->LookUpTableMethod(m_iCalibrationColmun1-1, m_iCalibrationColmun2-1, m_iCalibrationColmun3-1,
				m_iApplicationColmun1-1, m_iApplicationColmun2-1, m_iApplicationColmun3-1, m_iDivide1, m_iDivide2, m_iDivide3,
				m_dMax1, m_dMax2, m_dMax3, m_dMin1, m_dMin2, m_dMin3, m_iRunPerDay, bMovingAverage) == FALSE){
				return FALSE;
			}

			// `⊮
			if(m_bUseLinearRegression){
				if(aryMeanTerm[i]->LinearInterpolation(m_iMaximumForLinearRegression, bMovingAverage) == FALSE){
					return FALSE;
				}
			}

			// o
			// ⊮̎nt@CSĂ̊Ԃɂ킽ďo
			aryMeanTerm[i]->CompleteResultsAndFlagFile_LT(fileAllResult, fileAllFlag, fileAllTable, bMovingAverage);

			// mۂ̈̊J
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];

			// vOXo[̍XV
			m_ctlProgress.SetPos(100 + dProgressSize * i);
		}
		fileAllResult.Close();
		fileAllFlag.Close();
		fileAllTable.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return FALSE;
	}

	return TRUE;
}

void CLookUpTableDlg::OnBtnSave() 
{
	CFileDialog dlg(FALSE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"Setting  File   (*.lut.set.txt)|*.lut.set.txt|",
		NULL);

	CString strFilePass, strLine;
	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	if(strFilePass != "" && strFilePass.Right(12) != ".lut.set.txt"){
		strFilePass += ".lut.set.txt";
	}

	SaveSetting(strFilePass);
}

void CLookUpTableDlg::OnBtnLaod() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"Setting  File   (*.lut.set.txt)|*.lut.set.txt|",
		NULL);

	CString strFilePass;
	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	SetParameterFromFile(strFilePass);
}

void CLookUpTableDlg::SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir)
{
	m_strInputFile = strInputFile;
	m_strOutputFile = strOutputDir;

	SetParameterFromFile(strIniFile);
	UpdateData(FALSE);
}

void CLookUpTableDlg::SaveSetting(const CString& strFilePass)
{
	CString strLine;

	try{
		CStdioFile out(strFilePass, CFile::modeCreate | CFile::modeWrite);

		// Write Setting of Nono-Linear Regression Function parameters
		strLine.Format("GapFillingTerm:%d\n", m_iGapFillingTerm);
		out.WriteString(strLine);

		strLine.Format("RunPerDay:%d\n", m_iRunPerDay);
		out.WriteString(strLine);

		strLine.Format("UseLinearRegression:%d\n", m_bUseLinearRegression);
		out.WriteString(strLine);

		strLine.Format("MaximumForLinearRegression:%d\n", m_iMaximumForLinearRegression);
		out.WriteString(strLine);

		strLine.Format("UsePeriod:%d\n", m_bUsePeriod);
		out.WriteString(strLine);

		strLine.Format("MovingAverage:%d\n", m_bMovingAverage);
		out.WriteString(strLine);

		// Calibration variable 1
		strLine.Format("CalibrationColmun1:%d\n", m_iCalibrationColmun1);
		out.WriteString(strLine);

		strLine.Format("ApplicationColmun1:%d\n", m_iApplicationColmun1);
		out.WriteString(strLine);

		strLine.Format("Divide1:%d\n", m_iDivide1);
		out.WriteString(strLine);

		strLine.Format("Max1:%lf\n", m_dMax1);
		out.WriteString(strLine);

		strLine.Format("Min1:%lf\n", m_dMin1);
		out.WriteString(strLine);

		// Calibration variable 2
		strLine.Format("CalibrationColmun2:%d\n", m_iCalibrationColmun2);
		out.WriteString(strLine);

		strLine.Format("ApplicationColmun2:%d\n", m_iApplicationColmun2);
		out.WriteString(strLine);

		strLine.Format("Divide2:%d\n", m_iDivide2);
		out.WriteString(strLine);

		strLine.Format("Max2:%lf\n", m_dMax2);
		out.WriteString(strLine);

		strLine.Format("Min2:%lf\n", m_dMin2);
		out.WriteString(strLine);

		// Calibration variable 3
		strLine.Format("CalibrationColmun3:%d\n", m_iCalibrationColmun3);
		out.WriteString(strLine);

		strLine.Format("ApplicationColmun3:%d\n", m_iApplicationColmun3);
		out.WriteString(strLine);

		strLine.Format("Divide3:%d\n", m_iDivide3);
		out.WriteString(strLine);

		strLine.Format("Max3:%lf\n", m_dMax3);
		out.WriteString(strLine);

		strLine.Format("Min3:%lf\n", m_dMin3);
		out.WriteString(strLine);

		out.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

BOOL CLookUpTableDlg::SetParameterFromFile(CString strFilePass)
{
	BOOL bOK = TRUE;
	try{
		CStdioFile in(strFilePass, CFile::modeRead | CFile::shareDenyWrite);
		CString strLine, strTemp;
		double dTemp;
		int iTemp;

		while(in.ReadString(strLine)){
			strTemp = strLine.Left(strLine.Find(':'));

			if(strTemp == "GapFillingTerm"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iGapFillingTerm = iTemp;
				continue;
			}

			if(strTemp == "RunPerDay"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iRunPerDay = iTemp;
				continue;
			}

			if(strTemp == "UseLinearRegression"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUseLinearRegression = iTemp;
				continue;
			}

			if(strTemp == "MaximumForLinearRegression"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iMaximumForLinearRegression = iTemp;
				continue;
			}

			if(strTemp == "UsePeriod"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUsePeriod = iTemp;
				continue;
			}

			if(strTemp == "MovingAverage"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bMovingAverage = iTemp;
				continue;
			}

			// Calibration variable 1
			if(strTemp == "CalibrationColmun1"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iCalibrationColmun1 = iTemp;
				continue;
			}

			if(strTemp == "ApplicationColmun1"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iApplicationColmun1 = iTemp;
				continue;
			}

			if(strTemp == "Divide1"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iDivide1 = iTemp;
				continue;
			}

			if(strTemp == "Max1"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dMax1 = dTemp;
				continue;
			}

			if(strTemp == "Min1"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dMin1 = dTemp;
				continue;
			}

			// Calibration variable 2
			if(strTemp == "CalibrationColmun2"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iCalibrationColmun2 = iTemp;
				continue;
			}

			if(strTemp == "ApplicationColmun2"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iApplicationColmun2 = iTemp;
				continue;
			}

			if(strTemp == "Divide2"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iDivide2 = iTemp;
				continue;
			}

			if(strTemp == "Max2"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dMax2 = dTemp;
				continue;
			}

			if(strTemp == "Min2"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dMin2 = dTemp;
				continue;
			}

			// Calibration variable 3
			if(strTemp == "CalibrationColmun3"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iCalibrationColmun3 = iTemp;
				continue;
			}

			if(strTemp == "ApplicationColmun3"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iApplicationColmun3 = iTemp;
				continue;
			}

			if(strTemp == "Divide3"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iDivide3 = iTemp;
				continue;
			}

			if(strTemp == "Max3"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dMax3 = dTemp;
				continue;
			}

			if(strTemp == "Min3"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dMin3 = dTemp;
				continue;
			}
		}

		UpdateData(FALSE);
		OnCheckUseRegression();

		in.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bOK = FALSE;
	}

	return bOK;
}
