// MeanTerm.h: CMeanTerm NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEANTERM_H__99E414A8_873D_4045_B202_B4608BB22636__INCLUDED_)
#define AFX_MEANTERM_H__99E414A8_873D_4045_B202_B4608BB22636__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning( disable : 4786 )
#include<vector>
#include<string>
#include "Dataset.h"

class CMeanTerm  
{
public:
	CMeanTerm(int iTermNumber);
	void ReleaseDataset();
	virtual ~CMeanTerm();
	void SetLine(const CString& strLine);
	void SetLine(const CString& strLine, int iPeriod);
	void SetCurrentPeriod(const int& iPeriod) {m_iPeriod = iPeriod;};
	int  GetCurrentPeriod() { return m_iPeriod;};
	int GetSizeOfDataset() {return m_aryDataset.size();};
	void SetRunPerDay(const int& iRunPerDay){m_iRunPerDay = iRunPerDay;};
	CDataset* GetDataset(int iDataNum) {return m_aryDataset[iDataNum];};

	// Ustar filering
	BOOL Ustar_filtering(std::vector<int>& aryColumnNum, double dNighttimeRadiation, double dUstar_threshold, 
							int iUstarColumn, int iRadiationColumn);
	BOOL Eliminate_nighttime_negative(std::vector<int>& aryColumnNum, double dNighttimeRadiation, int iNEEColumn, int iRadiationColumn);

	// data screening by van Gorsel et al. (2007; 2008) 
	BOOL VanGorsel_filtering(double dNighttimeRadiation, int iSunsetRunVanGorsel, int iNEEColumn, int iRadiationColumn);

	// ϓω@ɂ錇⊮Ɏgp֐
	void CreatePatternFiles(const CString& strDirPath, int iTermNum, BOOL bIsBootstrap);
	void WriteGapFilledData(const CString& strDirPath, int iTermNum, int iDataType, BOOL bMovingAverage);
	void WriteFlagFile(const CString& strDirPath, int iTermNum);
	void WriteBootstrapAverage(const CString& strDirPath, int iTermNum);
	void CompleteResultsAndFlagFile(CStdioFile &fileAllResult, CStdioFile &fileAllFlag, BOOL bMovingAverage);
	void WriteBootstrapAllAverageFile(CStdioFile &fileAllBootstrap);
	void WriteDataset(CStdioFile &fileAllResult, int iDataType, BOOL bMovingAverage);
	BOOL MeanDiurnalVariation(int iRunPerDay, int iRadiationColumn, int iAverageNumber, BOOL bMovingAverage, BOOL m_bUseRadiation, BOOL bBootstrap, int iBootstrapNum);
	BOOL LinearInterpolation(int iMaximumForLinearRegression, BOOL bMovingAverage);
	BOOL LinearInterpolation_NoneLinearRegression(int iMaximumForLinearRegression, int iNEE_raw, int iNEE_nlr1, int iNEE_nlr2);
	void SetBootstrapMeanALL_mdv(int iTotalLineNum, BOOL bMovingAverage);
	void ClearBootstrapMeanAll_mdv(){m_aryBootstrapMeanAll_mdv.clear();};

	//Look up table ɕKvȃp^̌Ɏgp֐
	BOOL LookUpTableMethod(const int& iCalibrationColmun1, const int& iCalibrationColmun2, const int& iCalibrationColmun3,
				const int& iApplicationColmun1, const int& iApplicationColmun2, const int& iApplicationColmun3, 
				const int& iDivide1, const int& iDivide2, const int& iDivide3,
				const int& dMax1, const int& dMax2, const int& dMax3, const int& dMin1, const int& dMin2, const int& dMin3, 
				const int& iRunPerDay, BOOL bMovingAverage);
	BOOL LookUpTable(int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, 
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage);
	BOOL LookUpTable_bootstrap(int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, 
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage, int iBootstrapNum);
	void Create_LookUpTable_flux(CDataset* aryHeatFlux, CDataset* aryLatentFlux, CDataset* aryNEE, CDataset* aryRadiation, CDataset* aryTemperature, CDataset* aryVPD, 
			int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, int& iRad, int& iTemp, int& iVPD,
			std::vector<std::vector<std::vector<double> > >& aryLookUp2_H, std::vector<std::vector<std::vector<double> > >& aryLookUp2_lE, std::vector<std::vector<std::vector<double> > >& aryLookUp2_NEE, std::vector<std::vector<std::vector<double> > >& aryLookUp3_H, std::vector<std::vector<std::vector<double> > >& aryLookUp3_lE,
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage);
	void Create_LookUpTable_flux_bootstrap(CDataset* aryHeatFlux, CDataset* aryLatentFlux, CDataset* aryNEE, CDataset* aryRadiation, CDataset* aryTemperature, CDataset* aryVPD, 
			int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, int& iRad, int& iTemp, int& iVPD,
			std::vector<std::vector<std::vector<double> > >& aryLookUp2_H, std::vector<std::vector<std::vector<double> > >& aryLookUp2_lE, std::vector<std::vector<std::vector<double> > >& aryLookUp2_NEE, std::vector<std::vector<std::vector<double> > >& aryLookUp3_H, std::vector<std::vector<std::vector<double> > >& aryLookUp3_lE,
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage);
	int LookUpTable_respiration(int iNEE, int iRadiationColumn, int iTemperatureColumn, 
		int iRadiationFilledColumn, int iTemperatureFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage);
	void GetIndex_LookUpTable(double& dValue, int& iIndex, const int& iDivide, const double& dMax, const double& dMin);
	void GetIndex_LookUpTable(double& dRadiation, double&dTemperature, double&dVPD, int& iRad, int& iTemp, int& iVPD, const double& dUpplerNighttimeRadiation);
	void WriteGapFilledCarbonFlux_mdv_lt(CStdioFile &fileAllResult, std::vector<int>& aryOutColumnNum, BOOL bMovingAverage, BOOL bBootstrap);
	void CompleteResultsAndFlagFile_LT(CStdioFile &fileResult, CStdioFile &fileFlag, CStdioFile &fileTable, BOOL bMovingAverage);

	// [ȐɕKvȃp^̌Ɏgp֐
	BOOL DetermineLightPhotosynthesisCurve(BOOL bSetMaximumB, const double& dMaximumB, const double& dC, const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParameters& FixedPrm);
	BOOL DetermineLightPhotosynthesisCurve_bootstrap(BOOL bSetMaximumB, const double& dMaximumB, const double& dC, const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParameters& FixedPrm, int iBootstrapNum);
	void DetermineLightPhotosynthesisCurve(std::vector<double>* aryRadiation, std::vector<double>* aryPhotosynthesis, BOOL bSetMaximumB, const double& dMaximumB, const double& dC, const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParameters& FixedPrm, double& dB, double& dAmax, double& dR0, double& dRMSE, double& dCoefficientCorrelation, int& iCount, int& iLoopCount);
	double GetMaxValue(const std::vector<double>* aryValue);
	double GetDaytimeMaxValue(const std::vector<double>* aryValue, const std::vector<double>* aryRadiation);
	double CalculateR0(const std::vector<double>* aryRadiation, const std::vector<double>* aryPhotosynthesis, const double& dNighttimeRadiation, const double& dErrorValue);
	double CalculateLightPhotosynthesisCurve(const double& dRadiation, const double& dPhotosynthesis, const double& dAmax, const double& dB, const double& dR0, const double& dC, BOOL bUseNonRectangular);
	CString GetOutputLine_LightPhotosynthesis(BOOL bUseNegativeValues, const double& dMaximum, const double& dMinimum, const double& dAverage);
	CString GetOutputLine_LightPhotosynthesis_bootstrap(BOOL bUseNegativeValues, const CPhotosynthesisParameters& cPhoto);
	void SetParametersGPP(const double& dDate, const double& dAmax, const double& dB, const double& dR0);
	double GetStartDay(){return m_dStartDate;};
	int GetNumberOfDays(int iRunPerDay) {return m_aryDataset[0]->size() / iRunPerDay;};
	int ApplyLightPhotosynthesisCurve(const CString& strHeader, const int iRadiationColumn);
	int ApplyLightPhotosynthesisCurve_bootstrap(const int iRadiationColumn);
	void SetPhotosynthesisConstant(BOOL bUseNegativeValues, BOOL bUseNonRectangular, double dConvexity);
	int QC_PhotosynthesisData(double dThresholdSigma,BOOL bUseNegativeValues, const int& iRadiationColumn, const int& iPhotosynthesisColumn);
	int QC_RespirationData(double dThresholdSigma,BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dUpplerNighttimeRadiation,  const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn,  int iRespirationColumn, int iUstarColumn) ;
	CPhotosynthesisParameters Average_stdev_bootstrap_parameters_photosynthesis();
	void SetBootstrapPhosynthesisParameters(std::vector<CPhotosynthesisParameters>& aryPhotosynthesisParametersBootstrap, const CPhotosynthesisParameters& cAveragePhotoParameters);
	void GetBootstrapPhotsynthesisParameters(std::vector<CPhotosynthesisParameters>& cPhoto);
	BOOL SetBootstrapNonLinearParameters(const std::vector<CPhotosynthesisParameters>& aryBootstrapPhoto, const std::vector<CRespirationParameters>& aryBootstrapResp);

	BOOL DetermineRespirationCurve(double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParameters& FixedPrm, BOOL bAnnual);
	BOOL DetermineRespirationCurve_bootstrap(double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParameters& FixedPrm, BOOL bAnnual, int iBootstrapNum);
	void DetermineRespirationCurve(std::vector<double>* aryTemperatureP, std::vector<double>* aryRadiationP, std::vector<double>* aryRespirationP, std::vector<double>* aryUstarP, 
		double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParameters& FixedPrm, BOOL bAnnual,
		double& dQ10, double& dR0, double& dReferenceTemperature, double& dRMSE, double& dCoefficientCorrelation, int& iDataSize, int& iCount, int& iDataNum);
	double CalculateRespirationCurve(double dTemperature, double dRespiration, double dR0, double dQ10, double dTk, double dT0, double dTref, BOOL bUseLloyd_Taylor);
	double CalculateRespirationCurve_log_transform(double dTemperature, double dRespiration, double dR0, double dQ10, double dTk, double dT0, double dTref, BOOL bUseLloyd_Taylor);
	CString GetOutputLine_RespirationCurve(const double& dTmax, const double&dTmin, const double&dTave);
	CString GetOutputLine_RespirationCurve_bootstrap(const CRespirationParameters& cResp);
	int ApplyRespirationCurve(const int iTemperatureColumn);
	int ApplyRespirationCurve_bootstrap(const int iTemperatureColumn);
	void SetRespirationConstant(BOOL bUseNegativeValues, BOOL bUseLT_Equation, double dUstar_threshold, double dNighttimeRadiation);
	void SetParametersRE(const double& dDate, const double& dR0, const double& dQ10, const double& dTref);
	void UpdateParametersRE(const double& dR0_annual, const double& dQ10_annual, const double& dTref_annual, const double& dErrorValue);
	CRespirationParameters Average_stdev_bootstrap_parameters_respiration();
	void SetBootstrapRespirationParameters(std::vector<CRespirationParameters>& aryRespirationParametersBootstrap, const CRespirationParameters& cAverageRespirationParameters, const double& dMaximumQ10);
	void GetBootstrapRespirationParameters(std::vector<CRespirationParameters>& cResp);

	int GapFill_NEE_NonLinearRegression(const int iNEEraw, const int iUstar, const int iRadiation, const int iNEE_model_nlr);
	int GapFill_NEE_NonLinearRegression(const int iNEEraw, const int iUstar, const int iRadiation, const int iNEE_model_nlr, const int iRE);
	int GapFill_NEE_NonLinearRegression_bootstrap(const int iNEEraw, const int iUstar, const int iRadiation, const int iNEE_model_nlr, const int iRE, int iBootstrapNum);
	int Estimate_NEE_NonLinearRegression(const int iRadiation, const int iNEE_model_nlr, const int iRE);
	int Estimate_NEE_NonLinearRegression_bootstrap(const int iRadiation, const int iNEE_model_nlr, const int iRE, int iBootstrapNum);
	int Estimate_GPP(const int iNEE_nlr2, const int iRE);
	int Estimate_GPP_bootstrap(const int iNEE_nlr2, const int iRE, int iBootstrapNum);
	int SetObservedGPP(const int iNEEraw, const int iGPP);
	int Adjust_GPP_RE(const int iGPP,  const int iRE, int& iGPP2, int& iRE2);
	int Adjust_GPP_RE_bootstrap(const int iGPP,  const int iRE, int& iGPP2, int& iRE2, int iBootstrapNum);
	void Calculate_GPP_bootstrap(CDataset* pDataset_nee, CDataset* pDataset_re, CDataset* pDataset_gpp, int iBootstrapNum, BOOL bMovingAverage);
	void WriteGapFilledCarbonFlux(CStdioFile &fileAllResult, std::vector<int>& aryOutColumnNum);

	// u* 臒ľ
	BOOL determin_u_star_threshold(int iUstarColumn, int iNEEColumn, int iRadiationColumn, int iTemperatureColumn, double dNighttimeRadiation,
	 std::vector<std::string>& aryCurrentDate, std::vector<double>& aryMaximumT, std::vector<double>& aryMinimumT, std::vector<double>& aryCorrelationCoefficient, 
	 std::vector<double>& aryUpperClassUstar, std::vector<double>& aryUstarThreshold, std::vector<int>& aryUstarThretholdClass, std::vector<int>& aryDataSize, double& dUstarThreshold);

	BOOL determin_u_star_threshold2(int iUstarColumn, int iNEEColumn, int iRadiationColumn, int iTemperatureColumn, double dNighttimeRadiation,
	 std::vector<std::string>& aryCurrentDate, std::vector<double>& aryMaximumT, std::vector<double>& aryMinimumT, std::vector<double>& aryCorrelationCoefficient, 
	 std::vector<double>& aryUpperClassUstar, std::vector<double>& aryUstarThreshold, std::vector<int>& aryUstarThretholdClass, std::vector<int>& aryDataSize, double& dUstarThreshold, const double& dPvalue);

	// Quality control by using MAD
	BOOL QualityControl_MAD(const double& dZvalue, BOOL bIsDayNightDiv, const double& dNighttimeRadiation, const int& iRadiationColumn);
	BOOL ApplyQualityControl(int bIsDayNightDiv, const int& iRadiationColumn);
	void WriteQualityFlag(CStdioFile& fileFlag, CStdioFile& fileResult, BOOL bMovingAverage);

	void Set_Final_Gap_Filled_Data(CMeanTerm& cMeanTermNLR, std::vector<CString>& aryDate, 
		std::vector<double>& aryFinalH, std::vector<double>& aryFinallE, std::vector<double>& aryFinalNEE,
	    std::vector<int>& aryFlagH, std::vector<int>& aryFlaglE, std::vector<int>& aryFlagNEE, std::vector<double>& aryFinalGPP, std::vector<double>& aryFinalRE);
	void set_gap_fill_priority(CMeanTerm& cMeanTermNLR, const CMeanTerm* cMeanTermMDV, double& dData, int& iFlag,
				int raw_mdv, int lut_mdv, int nlr2, int mdv_mdv, int table_mdv, int i, BOOL bUseNLR);

	void Final_Priority_bootstrap(int iColumnNum, int iBootstrapNum, int iLimtSeqLoss,  BOOL bMovingAverage, BOOL bIsNEE, CDataset* pDataset_nlr = NULL);
	BOOL WriteStringBoostrapFinal(CStdioFile& outFile, int iHeatFlux, int iLatentFlux, int iNEEraw, int iGPP2, int iRE2, BOOL bMovingAverage);
	BOOL WriteStringUncertaintyDay(CStdioFile& outFile, int iHeatFlux, int iLatentFlux, int iNEEraw, int iGPP2, int iRE2, BOOL bMovingAverage);
	void ForBootstrapAnnualMeanStdev(const int iData, double& dTx, int& iNum, int iBootstrap);

	void GetMaximumMinimuAverage(const int& iColumn, double& dMaximum, double& dMinimum, double& dAverage);

	void SetCurrentDate(const CString& strCurrentDate) {m_strCurrentDate = strCurrentDate;};
	void SetHeader(const CString& strHeader);		// Header i[
	void ClearHeader(){s_aryHeader.clear();};		// Header 폜
	BOOL SetDataset(int iDataSize);					// 񂩂f[^Zbg𔲂oACDataset Ɋi[

	static const double s_dErrorValue;

	// [ȐɕKvȃp^̌Ɏgp֐
	CPhotosynthesisParameters m_PhotosynthesisParameters;
	CRespirationParameters m_RespirationParameters;
	std::vector<CPhotosynthesisParameters> m_aryPhotosynthesisParameters_bootstrap;
	std::vector<CRespirationParameters> m_aryRespirationParameters_bootstrap;
	
	// Look up table bootstrap ̕W΍
	std::vector<double> m_aryStdev_Table_Dataset_H_bs;
	std::vector<double> m_aryStdev_Table_Dataset_LE_bs;
	std::vector<double> m_aryStdev_Table_Dataset_NEE_bs;
private:
	int m_iTermNumber;								// 擪牽Ԗڂ̋敪̊Ԃł邩̏i[ (0 ` XX)
	int m_iPeriod;
	int m_iRunPerDay;
	CString m_strHeader;
	CString m_strCurrentDate;
	std::vector<std::string> m_aryLine;
	std::vector<CDataset*> m_aryDataset;
	static std::vector<std::string> s_aryHeader;
	double m_dStartDate;
	static std::vector< std::vector<double> > m_aryBootstrapMeanAll_mdv;

	static int s_iDatasetNum;
	static const double s_dR;
	static BOOL s_bUseNegativeValues;
	static BOOL s_bUseNonRectangular;
	static double s_dConvexity;
	static BOOL s_bUseLT_Equation;
	static double s_dUstar_threshold;
	static double s_dNighttimeRadiation;

	BOOL IsZeroValue(CString strValue);
	void ReplaceImpossibleChara(CString& strString);
	double coefficient_correlation(const std::vector<double>& x, const std::vector<double>& y);

};

#endif // !defined(AFX_MEANTERM_H__99E414A8_873D_4045_B202_B4608BB22636__INCLUDED_)
