// MenuMeanDiurnalVariationDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "MenuMeanDiurnalVariationDlg.h"

#include "BrowseFolderDialog.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMenuMeanDiurnalVariationDlg _CAO


CMenuMeanDiurnalVariationDlg::CMenuMeanDiurnalVariationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMenuMeanDiurnalVariationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMenuMeanDiurnalVariationDlg)
	m_strInputFile = _T("");
	m_strOutputFile = _T("");
	m_iGapFillingTerm = 15;
	m_iRunPerDay = 48;
	m_iMaximumForLinearRegression = 3;
	m_bUsePeriod = FALSE;
	m_bMovingAverage = TRUE;
	m_bUseLinearRegression = TRUE;
	m_bIsBootstrap = FALSE;
	m_iBootstrapNum = 1000;
	//}}AFX_DATA_INIT
	m_iLineNum = 0;
}


void CMenuMeanDiurnalVariationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMenuMeanDiurnalVariationDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDX_Text(pDX, IDC_EDIT_OUT_DIR, m_strOutputFile);
	DDX_Text(pDX, IDC_EDIT_GAP_TERM, m_iGapFillingTerm);
	DDV_MinMaxUInt(pDX, m_iGapFillingTerm, 1, 1000000);
	DDX_Text(pDX, IDC_EDIT_RUN_PER_DAY, m_iRunPerDay);
	DDV_MinMaxUInt(pDX, m_iRunPerDay, 1, 1000000);
	DDX_Text(pDX, IDC_EDIT_MAXIMUM_REGRESSION, m_iMaximumForLinearRegression);
	DDV_MinMaxUInt(pDX, m_iMaximumForLinearRegression, 1, 1000000);
	DDX_Check(pDX, IDC_CHECK_PERIOD, m_bUsePeriod);
	DDX_Check(pDX, IDC_CHECK_MOVING_WD, m_bMovingAverage);
	DDX_Check(pDX, IDC_CHECK_USE_REGRESSION, m_bUseLinearRegression);
	DDX_Check(pDX, IDC_CHECK_BOOTSTRAP, m_bIsBootstrap);
	DDX_Text(pDX, IDC_EDIT_BOOTSTRUP, m_iBootstrapNum);
	DDV_MinMaxUInt(pDX, m_iBootstrapNum, 1, 10000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMenuMeanDiurnalVariationDlg, CDialog)
	//{{AFX_MSG_MAP(CMenuMeanDiurnalVariationDlg)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE, OnKillfocus)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE, OnButtonInputFile)
	ON_BN_CLICKED(IDC_BUTTON_FIXED_DATA, OnButtonFixedData)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnButtonApply)
	ON_BN_CLICKED(IDC_CHECK_USE_REGRESSION, OnCheckUseRegression)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_BN_CLICKED(IDC_BTN_LAOD, OnBtnLaod)
	ON_EN_KILLFOCUS(IDC_EDIT_OUT_DIR, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_GAP_TERM, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_RUN_PER_DAY, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_MAXIMUM_REGRESSION, OnKillfocus)
	ON_BN_CLICKED(IDC_CHECK_BOOTSTRAP, OnCheckBootstrap)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMenuMeanDiurnalVariationDlg bZ[W nh
BOOL CMenuMeanDiurnalVariationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDI_MDV );
	SetIcon(hFile, TRUE);	
	SetIcon(hFile, FALSE);	
	GetDlgItem(IDC_EDIT_BOOTSTRUP)->EnableWindow(FALSE);
	m_bIsThread = FALSE;
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CMenuMeanDiurnalVariationDlg::OnCheckUseRegression() 
{
	UpdateData(TRUE);

	if(m_bUseLinearRegression == TRUE){
		GetDlgItem(IDC_EDIT_MAXIMUM_REGRESSION)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_EDIT_MAXIMUM_REGRESSION)->EnableWindow(FALSE);
	}
}

void CMenuMeanDiurnalVariationDlg::OnKillfocus() 
{
	UpdateData(TRUE);
}

void CMenuMeanDiurnalVariationDlg::OnButtonInputFile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile = dlg.GetPathName();
		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputFile == ""){
			m_strOutputFile = m_strInputFile.Mid(0, m_strInputFile.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CMenuMeanDiurnalVariationDlg::OnButtonFixedData() 
{
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputFile = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CMenuMeanDiurnalVariationDlg::OnCheckBootstrap() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData(TRUE);

	if(m_bIsBootstrap == TRUE){		
		GetDlgItem(IDC_EDIT_BOOTSTRUP)->EnableWindow(TRUE);

	}else{
		GetDlgItem(IDC_EDIT_BOOTSTRUP)->EnableWindow(FALSE);
	}	
	UpdateData(FALSE);
}

void CMenuMeanDiurnalVariationDlg::OnButtonApply() 
{
	BOOL bIsDebug = FALSE;
	#ifdef _DEBUG
	bIsDebug = TRUE;
	#endif

	CString strErrorMessage;
	if(bIsDebug){
		if(OnMeanDiurnalVariation(strErrorMessage) == TRUE){
			AfxMessageBox("The calculation has been successfully done !");
		}
		else{
			AfxMessageBox(strErrorMessage);
		}
	}
	else{
		// Using Malti Thread
		if(!m_bIsThread){
			m_pThread = AfxBeginThread(OnMeanDiurnalVariationThread,(LPVOID)this);
			m_pThread->m_bAutoDelete = FALSE;
			m_pThread->ResumeThread();
		}
		else{
			AfxMessageBox("Error : Thread is busy !");
		}
	}
}

UINT CMenuMeanDiurnalVariationDlg::OnMeanDiurnalVariationThread(LPVOID pParam)
{
	CMenuMeanDiurnalVariationDlg* pDlg = static_cast<CMenuMeanDiurnalVariationDlg*>(pParam);

 	pDlg->m_bIsThread = TRUE;
	if(pDlg->OnMeanDiurnalVariation(pDlg->m_strErrorMessageForThread) == TRUE){
		AfxMessageBox("The calculation has been successfully done !");
	}
	else{
		if(pDlg->m_strErrorMessageForThread != ""){
			AfxMessageBox(pDlg->m_strErrorMessageForThread);
		}
	}

	pDlg->m_bIsThread = FALSE;
	return 0;
}

BOOL CMenuMeanDiurnalVariationDlg::OnMeanDiurnalVariation(CString& strErrorMessage) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CWaitCursor wait;
	UpdateData(TRUE);

	if(ErrorCheck(strErrorMessage) == FALSE){
		return FALSE;
	}

	// ***************************************************************
	// t@CE^Cg̍XV
	// ***************************************************************
	m_strInputTitle = m_strInputFile.Mid(m_strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));

	// ***************************************************************
	// ݒt@C̏o
	// ***************************************************************
	CString strOutSettingFile = m_strInputFile;
	strOutSettingFile = strOutSettingFile.Left(strOutSettingFile.ReverseFind('.')) + ".mdv.set.txt";
	strOutSettingFile = m_strOutputFile + "\\" + strOutSettingFile.Mid(strOutSettingFile.ReverseFind('\\') + 1);
	SaveSetting(strOutSettingFile);

	// **************************************************
	// vOXo[̏
	// **************************************************
	int iProgressRange = 1100;
	m_ctlProgress.SetRange(0, iProgressRange);	// Inisilize Progress bar
	m_ctlProgress.SetPos(100);

	vector<CMeanTerm*> aryMeanTerm;
	CString strHeader;

	// ̓f[^̓ǂݍ
	if(m_bMovingAverage){
		ReadFile_with_MovingWindow(m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iGapFillingTerm, strHeader);
	}
	else{
		ReadFile_with_BlockWindow (m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iGapFillingTerm, strHeader);
	}

	if(MeanDiurnalVariation(m_strOutputFile, aryMeanTerm, strHeader, m_bMovingAverage, m_ctlProgress) == FALSE){
		// mۂ̈̊J
		for(int i = 0; i < aryMeanTerm.size(); i++){
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];
		}
		return FALSE;
	}

	return TRUE;	
}

BOOL CMenuMeanDiurnalVariationDlg::ErrorCheck(CString& strErrorMessage)
{
	if(m_strInputFile == ""){
		strErrorMessage = "Please select the input file.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_INPUT_FILE));
		return FALSE;
	}
	if(m_strOutputFile == ""){
		strErrorMessage = "Please select the output directory.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_OUT_DIR));
		return FALSE;
	}
	if(m_iRunPerDay <= 0){
		strErrorMessage = "The Run per day should be positive value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_RUN_PER_DAY));
		return FALSE;
	}
	if(m_iGapFillingTerm < 1){
		strErrorMessage = "The gap filling term should be greater than 1.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_GAP_TERM));
		return FALSE;
	}
	if(m_bMovingAverage && m_iGapFillingTerm % 2 == 0){
		strErrorMessage = "The respiration term should be odd number.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_GAP_TERM));
		return FALSE;
	}

	return TRUE;
}

BOOL CMenuMeanDiurnalVariationDlg::ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;
	m_iLineNum = 0;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strHeaderLine);	//	 1s
		InFile.ReadString(strLine);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
			m_iLineNum++;
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[@ipj
	for(int i = 0; i < aryLines.size(); i++){
		if(i % iRunPerDay == 0 ){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i - (iPhotosynthesisTerm - 1) / 2 * m_iRunPerDay;
			int iEnd   = i + (iPhotosynthesisTerm - 1) / 2 * m_iRunPerDay;
			if(iStart < 0) iStart = 0;
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j <= iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));  // commented out at 2010.01.27  at 2011.01.01

				// ǂݍݓr period ςƂ 
				// added at 2011.2.1 for moving window 
				if(m_bUsePeriod && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					continue;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

BOOL CMenuMeanDiurnalVariationDlg::ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;
	m_iLineNum = 0;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strHeaderLine);	//	 1s
		InFile.ReadString(strLine);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
			m_iLineNum++;
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[j
	BOOL bPeriodChange = FALSE;
	for(int i = 0; i < aryLines.size(); i++){
		if(i % (iRunPerDay * iPhotosynthesisTerm) == 0 || bPeriodChange == TRUE){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;
			bPeriodChange = FALSE;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i;
			int iEnd   = i + (iPhotosynthesisTerm * m_iRunPerDay);
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j < iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));

				// ǂݍݓr period ςƂ
				if(m_bUsePeriod && j != iStart && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					bPeriodChange = TRUE;
					i = j - 1;
					break;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

BOOL CMenuMeanDiurnalVariationDlg::MeanDiurnalVariation(const CString& strOutDir, std::vector<CMeanTerm*>& aryMeanTerm, CString& strHeaderLine, BOOL bMovingAverage, CProgressCtrl& ctlProgress)
{
	BOOL bUseRadiation = FALSE;
	int iNumOfSampleRadiation = -1;
	int iRadiationColumn = -1;
	int iDataType = 1;	// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4)
	vector<double> aryBootstrapAverageAll;

	try{
		// ⊮̎nt@CSĂ̊Ԃɂ킽ďo͂邽߂̃t@C̃CX^X
		CString strAllResult, strAllFlag, strPatternMv, strBootstrapAll;
		if(bMovingAverage == FALSE){
			strAllResult.Format("%s\\%s_bw%d_mdv_results.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strAllFlag.Format("%s\\%s_bw%d_mdv_flags.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			if(m_bIsBootstrap == TRUE) strBootstrapAll.Format("%s\\%s_bw%d_mdv_bs_mean.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
		}
		else{
			strAllResult.Format("%s\\%s_mw%d_mdv_results.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strAllFlag.Format("%s\\%s_mw%d_mdv_flags.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			strPatternMv.Format("%s\\%s_mw%d_mdv_pattern.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			if(m_bIsBootstrap == TRUE) strBootstrapAll.Format("%s\\%s_mw%d_mdv_bs_mean.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
		}

		CStdioFile fileAllResult(strAllResult, CFile::modeCreate | CFile::modeWrite);
		CStdioFile fileAllFlag(strAllFlag, CFile::modeCreate | CFile::modeWrite);
		CStdioFile fileAllPatternMv;
		CStdioFile fileAllBootstrap;
		if(bMovingAverage) fileAllPatternMv.Open(strPatternMv, CFile::modeCreate | CFile::modeWrite);
		if(m_bIsBootstrap == TRUE) fileAllBootstrap.Open(strBootstrapAll, CFile::modeCreate | CFile::modeWrite);

		// All result & flag file ̃wb_Lq
		fileAllResult.WriteString(strHeaderLine + "\n");
		fileAllFlag.WriteString(strHeaderLine + "\n");
		if(bMovingAverage) fileAllPatternMv.WriteString(strHeaderLine + "\n");
		if(m_bIsBootstrap == TRUE) fileAllBootstrap.WriteString(strHeaderLine + "\n");

		// t@CEtH_쐬Aʂۑ	
		CString strDirPath;
		double dProgressSize = 1000.0 / aryMeanTerm.size();
		for(int i = 0; i < aryMeanTerm.size(); i++){
			// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
			CString strTemp = strHeaderLine;
			if(aryMeanTerm[i]->SetDataset(strTemp.Replace(',','@')) == FALSE){
				return FALSE;
			}
			aryMeanTerm[i]->SetHeader(strHeaderLine);
			aryMeanTerm[i]->SetRunPerDay(m_iRunPerDay);

			if(aryMeanTerm[i]->MeanDiurnalVariation(m_iRunPerDay, iRadiationColumn, iNumOfSampleRadiation, bMovingAverage, bUseRadiation, m_bIsBootstrap, m_iBootstrapNum) == FALSE){
				return FALSE;
			}
			// `⊮
			if(m_bUseLinearRegression){
				if(aryMeanTerm[i]->LinearInterpolation(m_iMaximumForLinearRegression, bMovingAverage) == FALSE){
					return FALSE;
				}
			}

			// o
			if(bMovingAverage == FALSE){
				// ubN
				if( i < 9){
					strDirPath.Format("%s\\Term-0%d",strOutDir, i + 1);
				}else{
					strDirPath.Format("%s\\Term-%d",strOutDir, i + 1);
				}

				// p^[t@C쐬fBNg̍쐬
				if(GetFileAttributes(strDirPath) == 0xFFFFFFFF){	
					CreateDirectory(strDirPath, NULL);
				}
				// p^[t@C̏o
				aryMeanTerm[i]->CreatePatternFiles(strDirPath, i + 1, m_bIsBootstrap);

				// ⊮̎nt@C̏o
				aryMeanTerm[i]->WriteGapFilledData(strDirPath, i + 1, iDataType, bMovingAverage);

				// ⊮̗LLqFlag t@C̏o
				aryMeanTerm[i]->WriteFlagFile(strDirPath, i + 1);

				// Bootstrap ̑SĂ̊ԕϒlʂ̏o
				if(m_bIsBootstrap == TRUE) aryMeanTerm[i]->WriteBootstrapAverage(strDirPath, i + 1);
			}
			else{
				// ړ
				// p^[t@C̍쐬
				aryMeanTerm[i]->WriteDataset(fileAllPatternMv, 3, bMovingAverage);
			}
			// ⊮̎nt@CSĂ̊Ԃɂ킽ďo
			aryMeanTerm[i]->CompleteResultsAndFlagFile(fileAllResult, fileAllFlag, bMovingAverage);

			// SԂʂBootstrap ϒlo͑O
			if(m_bIsBootstrap == TRUE){
				aryMeanTerm[i]->SetBootstrapMeanALL_mdv(m_iLineNum, bMovingAverage);
			}

			// mۂ̈̊J
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];

			// vOXo[̍XV
			m_ctlProgress.SetPos(100 + dProgressSize * i);
		}

		// SԂʂBootstrap ϒlo
		if(m_bIsBootstrap == TRUE){
			aryMeanTerm[0]->WriteBootstrapAllAverageFile(fileAllBootstrap);
			aryMeanTerm[0]->ClearBootstrapMeanAll_mdv();
		}

		fileAllResult.Close();
		fileAllFlag.Close();
		if(m_bIsBootstrap == TRUE) fileAllBootstrap.Close();
		if(bMovingAverage) fileAllPatternMv.Close();

		// p^[t@Č
		int iLine = 0;
		CString strFileName, strLine, strLine2;
		if(bMovingAverage == FALSE){			
			strPatternMv.Format("%s\\%s_bw%d_mdv_pattern.csv", strOutDir, m_strInputTitle, m_iGapFillingTerm);
			CStdioFile filePatternAll(strPatternMv, CFile::modeCreate | CFile::modeWrite);

			for(int i = 0; i < aryMeanTerm.size(); i++){
				if(i + 1 < 10){
					strFileName.Format("%s\\Term-0%d\\XX-Pattern-%d-ALL.csv", strOutDir, i + 1, i + 1);
				}
				else{
					strFileName.Format("%s\\Term-%d\\XX-Pattern-%d-ALL.csv", strOutDir, i + 1, i + 1);
				}
				CStdioFile infile(strFileName, CFile::modeRead | CFile::shareDenyWrite);

				iLine = 0;
				while(infile.ReadString(strLine)){
					if(i == 0 && iLine == 0){
						filePatternAll.WriteString("Term," + strLine + "\n");
					}
					if(iLine != 0){
						strLine2.Format("%d, %s\n", i + 1, strLine);
						filePatternAll.WriteString(strLine2);
					}
					iLine++;
				}

				infile.Close();
			}

			filePatternAll.Close();
		}
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return FALSE;
	}

	return TRUE;
}

void CMenuMeanDiurnalVariationDlg::OnBtnSave() 
{
	CFileDialog dlg(FALSE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"Setting  File   (*.lut.set.txt)|*.mdv.set.txt|",
		NULL);

	CString strFilePass, strLine;
	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	if(strFilePass != "" && strFilePass.Right(12) != ".mdv.set.txt"){
		strFilePass += ".mdv.set.txt";
	}

	SaveSetting(strFilePass);
}

void CMenuMeanDiurnalVariationDlg::OnBtnLaod() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"Setting  File   (*.mdv.set.txt)|*.mdv.set.txt|",
		NULL);

	CString strFilePass;
	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	SetParameterFromFile(strFilePass);
	
}

void CMenuMeanDiurnalVariationDlg::SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir)
{
	m_strInputFile = strInputFile;
	m_strOutputFile = strOutputDir;

	SetParameterFromFile(strIniFile);
	UpdateData(FALSE);
}

void CMenuMeanDiurnalVariationDlg::SaveSetting(const CString& strFilePass)
{
	CString strLine;

	try{
		CStdioFile out(strFilePass, CFile::modeCreate | CFile::modeWrite);

		// Write Setting of Nono-Linear Regression Function parameters
		strLine.Format("GapFillingTerm:%d\n", m_iGapFillingTerm);
		out.WriteString(strLine);

		strLine.Format("RunPerDay:%d\n", m_iRunPerDay);
		out.WriteString(strLine);

		strLine.Format("UseLinearRegression:%d\n", m_bUseLinearRegression);
		out.WriteString(strLine);

		strLine.Format("MaximumForLinearRegression:%d\n", m_iMaximumForLinearRegression);
		out.WriteString(strLine);

		strLine.Format("UsePeriod:%d\n", m_bUsePeriod);
		out.WriteString(strLine);

		strLine.Format("MovingAverage:%d\n", m_bMovingAverage);
		out.WriteString(strLine);

		out.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

BOOL CMenuMeanDiurnalVariationDlg::SetParameterFromFile(CString strFilePass)
{
	BOOL bOK = TRUE;
	try{
		CStdioFile in(strFilePass, CFile::modeRead | CFile::shareDenyWrite);
		CString strLine, strTemp;
		int iTemp;

		while(in.ReadString(strLine)){
			strTemp = strLine.Left(strLine.Find(':'));

			if(strTemp == "GapFillingTerm"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iGapFillingTerm = iTemp;
				continue;
			}

			if(strTemp == "RunPerDay"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iRunPerDay = iTemp;
				continue;
			}

			if(strTemp == "UseLinearRegression"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUseLinearRegression = iTemp;
				continue;
			}

			if(strTemp == "MaximumForLinearRegression"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iMaximumForLinearRegression = iTemp;
				continue;
			}

			if(strTemp == "UsePeriod"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUsePeriod = iTemp;
				continue;
			}

			if(strTemp == "MovingAverage"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bMovingAverage = iTemp;
				continue;
			}

		}

		UpdateData(FALSE);
		OnCheckUseRegression();

		in.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bOK = FALSE;
	}

	return bOK;
}
