// QcQaDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "QcQaDlg.h"

#include "BrowseFolderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;
/////////////////////////////////////////////////////////////////////////////
// CQcQaDlg _CAO


CQcQaDlg::CQcQaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CQcQaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CQcQaDlg)
	m_strInputFile = _T("");
	m_strOutputDir = _T("");
	m_dZvalue = 4.0;
	m_bUsePeriod = FALSE;
	m_iWindowSize = 13;
	m_dNighttimeRadiation = 10.0;
	m_bIsDayNightDiv = TRUE;
	m_iRadiationColumn = 9;
	m_iRunPerDay = 48;
	m_bMovingAverage = TRUE;
	m_bIs2ndZvalue = TRUE;
	m_d2ndZvalue = 20.0;
	m_bIsFluxPartitioningFile = FALSE;
	//}}AFX_DATA_INIT
}


void CQcQaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQcQaDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDX_Text(pDX, IDC_EDIT_OUT_DIR, m_strOutputDir);
	DDX_Text(pDX, IDC_EDIT_Z_VALUE, m_dZvalue);
	DDV_MinMaxDouble(pDX, m_dZvalue, 0.1, 20.);
	DDX_Check(pDX, IDC_CHECK_PERIOD, m_bUsePeriod);
	DDX_Text(pDX, IDC_EDIT_WINDOW, m_iWindowSize);
	DDV_MinMaxInt(pDX, m_iWindowSize, 1, 18000);
	DDX_Text(pDX, IDC_EDIT_NIGHT_RADIATION, m_dNighttimeRadiation);
	DDX_Check(pDX, IDC_CHECK_DIV_NIGHT, m_bIsDayNightDiv);
	DDX_Text(pDX, IDC_EDIT_RADIATION_COLUMN, m_iRadiationColumn);
	DDV_MinMaxInt(pDX, m_iRadiationColumn, 1, 100);
	DDX_Text(pDX, IDC_EDIT_RUN_PER_DAY, m_iRunPerDay);
	DDV_MinMaxInt(pDX, m_iRunPerDay, 1, 18000);
	DDX_Check(pDX, IDC_CHECK_MOVING_WD, m_bMovingAverage);
	DDX_Check(pDX, IDC_CHECK_2ND_Z_VALUE, m_bIs2ndZvalue);
	DDX_Text(pDX, IDC_EDIT_2ND_Z_VALUE, m_d2ndZvalue);
	DDV_MinMaxDouble(pDX, m_d2ndZvalue, 0.1, 50.);
	DDX_Check(pDX, IDC_CHECK_FLUX_INPUT, m_bIsFluxPartitioningFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CQcQaDlg, CDialog)
	//{{AFX_MSG_MAP(CQcQaDlg)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE, OnKillfocus)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE, OnButtonInputFile)
	ON_BN_CLICKED(IDC_BUTTON_FIXED_DATA, OnButtonFixedData)
	ON_BN_CLICKED(IDC_BTN_APPLY, OnBtnApply)
	ON_BN_CLICKED(IDC_CHECK_DIV_NIGHT, OnCheckDivNight)
	ON_BN_CLICKED(IDC_CHECK_2ND_Z_VALUE, OnCheck2ndZValue)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_BN_CLICKED(IDC_BTN_LAOD, OnBtnLaod)
	ON_EN_KILLFOCUS(IDC_EDIT_OUT_DIR, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_Z_VALUE, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_WINDOW, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_RADIATION_COLUMN, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_RUN_PER_DAY, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_2ND_Z_VALUE, OnKillfocus)
	ON_BN_CLICKED(IDC_CHECK_FLUX_INPUT, OnCheckFluxInput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQcQaDlg bZ[W nh


BOOL CQcQaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDI_QC );
	SetIcon(hFile, TRUE);	
	SetIcon(hFile, FALSE);	
	m_bIsThread = FALSE;
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CQcQaDlg::OnKillfocus() 
{
	UpdateData(TRUE);
}

void CQcQaDlg::OnButtonInputFile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile = dlg.GetPathName();
		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputDir == ""){
			m_strOutputDir = m_strInputFile.Mid(0, m_strInputFile.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CQcQaDlg::OnButtonFixedData() 
{
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputDir = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CQcQaDlg::OnCheckDivNight() 
{
	UpdateData(TRUE);

	if(m_bIsDayNightDiv == TRUE){
		GetDlgItem(IDC_EDIT_NIGHT_RADIATION)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_NIGHT_RAD)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_RAD_COLUMN)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_RADIATION_COLUMN)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_EDIT_NIGHT_RADIATION)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_NIGHT_RAD)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_RAD_COLUMN)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_RADIATION_COLUMN)->EnableWindow(FALSE);
	}
	
}

void CQcQaDlg::OnCheckFluxInput() 
{
	UpdateData(TRUE);

	if(m_bIsFluxPartitioningFile == TRUE){
		GetDlgItem(IDC_EDIT_RADIATION_COLUMN)->EnableWindow(FALSE);
		m_iRadiationColumn = 9;
	}
	else{
		GetDlgItem(IDC_EDIT_RADIATION_COLUMN)->EnableWindow(TRUE);
	}	
	UpdateData(FALSE);
}

void CQcQaDlg::OnCheck2ndZValue() 
{
	UpdateData(TRUE);

	if(m_bIs2ndZvalue == TRUE){
		GetDlgItem(IDC_EDIT_2ND_Z_VALUE)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_EDIT_2ND_Z_VALUE)->EnableWindow(FALSE);
	}
}

void CQcQaDlg::OnBtnApply() 
{
	BOOL bIsDebug = FALSE;
	#ifdef _DEBUG
	bIsDebug = TRUE;
	#endif

	CString strErrorMessage;
	if(bIsDebug){
		if(ApplyQualityControl(strErrorMessage) == TRUE){
			AfxMessageBox("The calculation has been successfully done !");
		}
		else{
			AfxMessageBox(strErrorMessage);
		}
	}
	else{
		// Using Malti Thread
		if(!m_bIsThread){
			m_pThread = AfxBeginThread(ApplyQualityControlThread,(LPVOID)this);
			m_pThread->m_bAutoDelete = FALSE;
			m_pThread->ResumeThread();
		}
		else{
			AfxMessageBox("Error : Thread is busy !");
		}
	}
}

UINT CQcQaDlg::ApplyQualityControlThread(LPVOID pParam)
{
	CQcQaDlg* pDlg = static_cast<CQcQaDlg*>(pParam);

 	pDlg->m_bIsThread = TRUE;
	if(pDlg->ApplyQualityControl(pDlg->m_strErrorMessageForThread) == TRUE){
		AfxMessageBox("The calculation has been successfully done !");
	}
	else{
		if(pDlg->m_strErrorMessageForThread != ""){
			AfxMessageBox(pDlg->m_strErrorMessageForThread);
		}
	}

	pDlg->m_bIsThread = FALSE;
	return 0;
}

BOOL CQcQaDlg::ApplyQualityControl(CString& strErrorMessage) 
{
	UpdateData(TRUE);

	if(ErrorCheck(strErrorMessage) == FALSE){
		return FALSE;
	}

	// ***************************************************************
	// t@CE^Cg̍XV
	// ***************************************************************
	m_strInputTitle = m_strInputFile.Mid(m_strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));

	// ***************************************************************
	// ݒt@C̏o
	// ***************************************************************
	CString strOutSettingFile = m_strInputFile;
	strOutSettingFile = strOutSettingFile.Left(strOutSettingFile.ReverseFind('.')) + ".qc.set.txt";
	strOutSettingFile = m_strOutputDir + "\\" + strOutSettingFile.Mid(strOutSettingFile.ReverseFind('\\') + 1);
	SaveSetting(strOutSettingFile);

	// **************************************************
	// vOXo[̏
	// **************************************************
	int iProgressRange = 1100;
	m_ctlProgress.SetRange(0, iProgressRange);	// Inisilize Progress bar
	m_ctlProgress.SetPos(100);

	vector<CMeanTerm*> aryMeanTerm;

	// ̓f[^̓ǂݍ
	m_bUsePeriod = FALSE;

	if(m_bMovingAverage){
		ReadFile_with_MovingWindow(m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iWindowSize);
	}
	else{
		ReadFile_with_BlockWindow (m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iWindowSize);
	}

	if(QalityControl(m_strOutputDir, aryMeanTerm, m_ctlProgress) == FALSE){
		// mۂ̈̊J
		for(int i = 0; i < aryMeanTerm.size(); i++){
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];
		}
		return FALSE;
	}

	return TRUE;	
}

BOOL CQcQaDlg::QalityControl(const CString& strOutDir, std::vector<CMeanTerm*>& aryMeanTerm, CProgressCtrl& ctlProgress)
{
	int iRadiationColumn = m_iRadiationColumn - 2;

	try{
		// ⊮̎nt@CSĂ̊Ԃɂ킽ďo͂邽߂̃t@C̃CX^X
		CString strResult, strFlag, strFluxPartitionQC, strTable, strDayNight = "all";
		if(m_bIsDayNightDiv){
			strDayNight = "dn";
		}
		if(m_bMovingAverage == FALSE){
			strResult.Format("%s\\%s_bw%d_%.1lf_%s_qc_results.csv", strOutDir, m_strInputTitle, m_iWindowSize, m_dZvalue, strDayNight);
			strFlag.Format("%s\\%s_bw%d_%.1lf_%s_qc_flags.csv", strOutDir, m_strInputTitle, m_iWindowSize, m_dZvalue, strDayNight);
		}
		else{
			strResult.Format("%s\\%s_mw%d_%.1lf_%s_qc_results.csv", strOutDir, m_strInputTitle, m_iWindowSize, m_dZvalue, strDayNight);
			strFlag.Format("%s\\%s_mw%d_%.1lf_%s_qc_flags.csv", strOutDir, m_strInputTitle, m_iWindowSize, m_dZvalue, strDayNight);
		}

		CStdioFile fileAllResult(strResult, CFile::modeCreate | CFile::modeWrite);
		CStdioFile fileAllFlag(strFlag, CFile::modeCreate | CFile::modeWrite);
		CStdioFile fileFluxPartitionQC;

		// All result & flag file ̃wb_Lq
		fileAllResult.WriteString(m_strHeader + "\n");
		fileAllResult.WriteString(m_strHeader2 + "\n");
		fileAllFlag.WriteString(m_strHeader + "\n");
		fileAllFlag.WriteString(m_strHeader2 + "\n");

		// t@CEtH_쐬Aʂۑ	
		CString strDirPath;
		double dProgressSize = 1000.0 / aryMeanTerm.size();
		for(int i = 0; i < aryMeanTerm.size(); i++){
			// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
			CString strTemp = m_strHeader;
			if(aryMeanTerm[i]->SetDataset(strTemp.Replace(',','@')) == FALSE){
				return FALSE;
			}
			aryMeanTerm[i]->SetHeader(m_strHeader);
			aryMeanTerm[i]->SetRunPerDay(m_iRunPerDay);

			if(aryMeanTerm[i]->QualityControl_MAD(m_dZvalue, m_bIsDayNightDiv, m_dNighttimeRadiation, iRadiationColumn) == FALSE){
				return FALSE;
			}

			if(m_bIs2ndZvalue){
				aryMeanTerm[i]->ApplyQualityControl(m_bIsDayNightDiv, iRadiationColumn);
				if(aryMeanTerm[i]->QualityControl_MAD(m_d2ndZvalue, m_bIsDayNightDiv, m_dNighttimeRadiation, iRadiationColumn) == FALSE){
					return FALSE;
				}
			}

			// o
			aryMeanTerm[i]->WriteQualityFlag(fileAllFlag, fileAllResult, m_bMovingAverage);


			// mۂ̈̊J
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];

			// vOXo[̍XV
			m_ctlProgress.SetPos(100 + dProgressSize * i);
		}
		fileAllResult.Close();
		fileAllFlag.Close();

		if(m_bIsFluxPartitioningFile){
			WriteFluxPartitioningInputQC(m_strInputFile, strResult);
		}
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return FALSE;
	}

	return TRUE;
}

BOOL CQcQaDlg::ErrorCheck(CString& strErrorMessage)
{
	if(m_strInputFile == ""){
		strErrorMessage = "Please select the input file.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_INPUT_FILE));
		return FALSE;
	}
	if(m_strOutputDir == ""){
		strErrorMessage = "Please select the output directory.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_OUT_DIR));
		return FALSE;
	}
	if(m_dZvalue <= 0){
		strErrorMessage = "Z value should be positive value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_Z_VALUE));
		return FALSE;
	}
	if(m_iWindowSize < 0){
		strErrorMessage = "Windows size should be positive value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_Z_VALUE));
		return FALSE;
	}
	if(m_iRunPerDay <= 0){
		strErrorMessage = "The Run per day should be positive value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_RUN_PER_DAY));
		return FALSE;
	}
	if(m_bMovingAverage && m_iWindowSize % 2 == 0){
		strErrorMessage = "The window size term should be odd number.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_WINDOW));
		return FALSE;
	}

	return TRUE;
}

BOOL CQcQaDlg::ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(m_strHeader);				//	 1s
		InFile.ReadString(m_strHeader2);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[j
	BOOL bPeriodChange = FALSE;
	for(int i = 0; i < aryLines.size(); i++){
		if(i % (iRunPerDay * iPhotosynthesisTerm) == 0 || bPeriodChange == TRUE){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;
			bPeriodChange = FALSE;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i;
			int iEnd   = i + (iPhotosynthesisTerm * iRunPerDay);
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j < iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));

				// ǂݍݓr period ςƂ
				if(m_bUsePeriod && j != iStart && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					bPeriodChange = TRUE;
					i = j - 1;
					break;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

BOOL CQcQaDlg::ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(m_strHeader);				//	 1s
		InFile.ReadString(m_strHeader2);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[@ipj
	for(int i = 0; i < aryLines.size(); i++){
		if(i % iRunPerDay == 0 ){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i - (iPhotosynthesisTerm - 1) / 2 * m_iRunPerDay;
			int iEnd   = i + (iPhotosynthesisTerm - 1) / 2 * m_iRunPerDay;
			if(iStart < 0) iStart = 0;
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j <= iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));  // commented out at 2010.01.27  at 2011.01.01

				// ǂݍݓr period ςƂ 
				// added at 2011.2.1 for moving window 
				if(m_bUsePeriod && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					continue;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

void CQcQaDlg::OnBtnSave() 
{
	CString strFilePass;
	CFileDialog dlg(FALSE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.qc.set.txt)|*.qc.set.txt|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	if(strFilePass != "" && strFilePass.Right(11) != ".qc.set.txt"){
		strFilePass += ".qc.set.txt";
	}

	SaveSetting(strFilePass);
}

void CQcQaDlg::OnBtnLaod() 
{
	CString strFilePass;
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.qc.set.txt)|*.qc.set.txt|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	SetParameterFromFile(strFilePass);
}

void CQcQaDlg::SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir)
{
	m_strInputFile = strInputFile;
	m_strOutputDir = strOutputDir;
	m_strInputTitle = strInputFile.Mid(strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));

	if(strIniFile != "") SetParameterFromFile(strIniFile);
	UpdateData(FALSE);
}

void CQcQaDlg::SaveSetting(const CString& strFilePass)
{
	CString strLine;

	try{
		CStdioFile out(strFilePass, CFile::modeCreate | CFile::modeWrite);

		// Write Setting
		strLine.Format("dZvalue:%lf\n", m_dZvalue);
		out.WriteString(strLine);

		strLine.Format("d2ndZvalue:%lf\n", m_d2ndZvalue);
		out.WriteString(strLine);

		strLine.Format("bIs2ndZvalue:%d\n", m_bIs2ndZvalue);
		out.WriteString(strLine);

		strLine.Format("bUsePeriod_qc:%d\n", m_bUsePeriod);
		out.WriteString(strLine);

		strLine.Format("iWindowSize_qc:%d\n", m_iWindowSize);
		out.WriteString(strLine);

		strLine.Format("iRunPerDay_qc:%d\n", m_iRunPerDay);
		out.WriteString(strLine);

		strLine.Format("bMovingAverage_qc:%d\n", m_bMovingAverage);
		out.WriteString(strLine);

		strLine.Format("dNighttimeRadiation_qc:%lf\n", m_dNighttimeRadiation);
		out.WriteString(strLine);

		strLine.Format("bIsDayNightDiv_qc:%d\n", m_bIsDayNightDiv);
		out.WriteString(strLine);

		strLine.Format("iRadiationColumn_qc:%d\n", m_iRadiationColumn);
		out.WriteString(strLine);

		strLine.Format("bIsFluxPartitioningFile:%d\n", m_bIsFluxPartitioningFile);
		out.WriteString(strLine);

		out.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

BOOL CQcQaDlg::SetParameterFromFile(CString strFilePass)
{
	BOOL bOK = TRUE;
	try{
		CStdioFile in(strFilePass, CFile::modeRead | CFile::shareDenyWrite);
		CString strLine, strTemp;
		double dTemp;
		int iTemp;

		while(in.ReadString(strLine)){
			strTemp = strLine.Left(strLine.Find(':'));

			if(strTemp == "dZvalue"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dZvalue = dTemp;
				continue;
			}

			if(strTemp == "d2ndZvalue"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_d2ndZvalue = dTemp;
				continue;
			}

			if(strTemp == "bIs2ndZvalue"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bIs2ndZvalue = iTemp;
				continue;
			}

			if(strTemp == "bUsePeriod_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUsePeriod = iTemp;
				continue;
			}

			if(strTemp == "iWindowSize_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iWindowSize = iTemp;
				continue;
			}

			if(strTemp == "iRunPerDay_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iRunPerDay = iTemp;
				continue;
			}

			if(strTemp == "bMovingAverage_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bMovingAverage = iTemp;
				continue;
			}

			if(strTemp == "dNighttimeRadiation_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dNighttimeRadiation = dTemp;
				continue;
			}

			if(strTemp == "bIsDayNightDiv_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bIsDayNightDiv = iTemp;
				continue;
			}

			if(strTemp == "iRadiationColumn_qc"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iRadiationColumn = iTemp;
				continue;
			}

			if(strTemp == "bIsFluxPartitioningFile"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bIsFluxPartitioningFile = iTemp;
				continue;
			}
		}

		UpdateData(FALSE);

		in.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bOK = FALSE;
	}

	return bOK;
}

BOOL CQcQaDlg::WriteFluxPartitioningInputQC(const CString& strInputFile, const CString& strResultFile)
{
	BOOL bOK = FALSE;
	vector< vector<double> > aryInput, aryResult;
	vector<CString> aryDateString1, aryDateString2, aryHeaderString1, aryHeaderString2;
	const int iMaxFluxColumn = 3;


	// ̓t@C̓ǂݍ
	if(ReadPartitioningFile(strInputFile, aryInput, aryDateString1, aryHeaderString1) == FALSE){
		bOK = FALSE;
		return bOK;
	}

	// QC/QA o̓t@C̓ǂݍ
	if(ReadPartitioningFile(strResultFile, aryResult, aryDateString2, aryHeaderString2) == FALSE){
		bOK = FALSE;
		return bOK;
	}

	// Flux Partitioning File ͗p QC/QA f[^̏o
	CString strOutFile, strLine, strLine2;
	strOutFile.Format("%s\\%s.qc.csv", m_strOutputDir, m_strInputTitle);

	try{
		CStdioFile OutFile(strOutFile, CFile::modeCreate | CFile::modeWrite);

		OutFile.WriteString(aryHeaderString1[0]);
		OutFile.WriteString(aryHeaderString1[1]);

		for(int i = 0; i < aryDateString1.size(); i++){
			for(int j = 0; j < aryInput[i].size(); j++){
				if(j == 0){
					if(j > iMaxFluxColumn){
						strLine.Format("%s, %lf", aryDateString1[i], aryInput[i][j]);
					}
					else{
						strLine.Format("%s, %lf", aryDateString1[i], aryResult[i][j]);
					}
				}
				else{
					if(j > iMaxFluxColumn){
						strLine2.Format(",%lf", aryInput[i][j]);
					}
					else{
						strLine2.Format(",%lf", aryResult[i][j]);
					}
					strLine = strLine + strLine2;
				}
			}
			strLine = strLine + "\n";
			OutFile.WriteString(strLine);
		}

		OutFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bOK;
	}

	// ̊J
//	for(int i = 0; i < aryInput.size(); i++){
//		delete aryInput[i];
//		delete aryResult[i];
//	}

	return TRUE;
}

BOOL CQcQaDlg::ReadPartitioningFile(const CString& strFileName, std::vector< std::vector<double> >& aryData, std::vector<CString>& aryDate, std::vector<CString>& aryHeaderString)
{
	BOOL bIsOK = FALSE;
	CString strLine, strTemp, strTemp2, strString, strTime;
	double dTemp;
	int iDataSize = 0;
	vector<CString> aryLines;

	try{
		CStdioFile InFile(strFileName, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strLine);			//	 1s
		aryHeaderString.push_back(strLine + "\n");
		InFile.ReadString(strLine);			//   2s
		aryHeaderString.push_back(strLine + "\n");

		iDataSize = strLine.Replace(',','@') - 1;

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// CSV t@C̓Iǂݍ
	int iColmunNumber, iColmunPosition;
	for(int i = 0; i < aryLines.size(); i++){
		strTemp = aryLines[i];
		iColmunNumber = 0;
		vector<double> aryDataLine;

		// ̎擾
		iColmunPosition = strTemp.Find(",");
		if(iColmunPosition != -1){
			strString = aryLines[i];
			strTime = strString.Left(iColmunPosition);
			strTemp = strString.Mid(iColmunPosition + 1);
		}else{
			strTime = strTemp;
			strTemp.Format("%lf",CDataset::s_dErrorValue);
		}
		if(strTemp == ""){
			strTemp.Format("%lf",CDataset::s_dErrorValue);
		}
		aryDate.push_back(strTime);

		while((iColmunPosition = strTemp.Find(",")) != -1){
			iColmunNumber++;	// JJEg

			strTemp2 = strTemp.Left(iColmunPosition);				
			dTemp = atof(strTemp2);
			if(strTemp2 == ""){
				dTemp = CDataset::s_dErrorValue;
			}
			if(dTemp == 0){		// atof ́AlȊOƎ0Ԃ߁Al0Ȃ̂mF
				if(!(IsZeroValue(strTemp2)))
					dTemp = CDataset::s_dErrorValue;
			}
			aryDataLine.push_back(dTemp);

			strTemp = strTemp.Mid(iColmunPosition + 1);
		}

		// ŏIJɎ^f[^Zbg̎o
		// f[^ZbgECX^X̍쐬
		dTemp = atof(strTemp);
		if(strTemp == ""){
				dTemp = CDataset::s_dErrorValue;
			}
		if(dTemp == 0){		// atof ́AlȊOƎ0Ԃ߁Al0Ȃ̂mF
			if(!(IsZeroValue(strTemp)))
				dTemp = CDataset::s_dErrorValue;
		}
		// add at 2011.03.09 : Excel -10000ɂȂ錏ɑΉ
		if(dTemp < CDataset::s_dErrorValue){
			dTemp = CDataset::s_dErrorValue;
		}
		
		aryDataLine.push_back(dTemp);
		iColmunNumber++; // ŏIJJEg

		// 󔒃J̃R}ȗĂt@CɊւ鏈(EXCELt@CɕKvȏ)
		while(iDataSize > iColmunNumber){
			iColmunNumber ++;
			aryDataLine.push_back(CDataset::s_dErrorValue);				
		}

		aryData.push_back(aryDataLine);
	}

	return TRUE;

}

BOOL CQcQaDlg::IsZeroValue(CString strValue)
{
	strValue.Remove('0');
	strValue.Remove('.');
	strValue.Remove('-');	// For windows vista 
	strValue.TrimLeft();
	if(strValue == ""){
		return TRUE;
	}else{
		return FALSE;
	}
}
