// SelfCorrelationDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "SelfCorrelationDlg.h"

#include "BrowseFolderDialog.h"
#include <math.h>
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CSelfCorrelationDlg _CAO
double CSelfCorrelationDlg::s_dErrorValue = -99999;

CSelfCorrelationDlg::CSelfCorrelationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelfCorrelationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelfCorrelationDlg)
	m_strInputFile = _T("");
	m_strInputFlux = _T("");
	m_strOutputDir = _T("");
	m_iIteration = 1000;
	m_iRunPerDay = 48;
	m_bUseDaytimeOnly = FALSE;
	m_dNighttimeRadiation = 10.0;
	//}}AFX_DATA_INIT
}


void CSelfCorrelationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelfCorrelationDlg)
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDX_Text(pDX, IDC_EDIT_INPUT_FLUX, m_strInputFlux);
	DDX_Text(pDX, IDC_EDIT_OUT_DIR, m_strOutputDir);
	DDX_Text(pDX, IDC_EDIT_ITERATION, m_iIteration);
	DDV_MinMaxUInt(pDX, m_iIteration, 0, 10000);
	DDX_Text(pDX, IDC_EDIT_RUN_PER_DAY, m_iRunPerDay);
	DDV_MinMaxUInt(pDX, m_iRunPerDay, 1, 480);
	DDX_Check(pDX, IDC_CHECK_DAYTIME, m_bUseDaytimeOnly);
	DDX_Text(pDX, IDC_EDIT_NIGHT_RADIATION, m_dNighttimeRadiation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelfCorrelationDlg, CDialog)
	//{{AFX_MSG_MAP(CSelfCorrelationDlg)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE, OnButtonInputFile)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FLUX, OnButtonInputFlux)
	ON_BN_CLICKED(IDC_BUTTON_OUT_DIR, OnButtonOutputDirecotry)
	ON_BN_CLICKED(IDC_BUTTON_DETERMINE, OnButtonDetermine)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE, OnKillfocus)
	ON_BN_CLICKED(IDC_CHECK_DAYTIME, OnCheckDaytime)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FLUX, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_OUT_DIR, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_ITERATION, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_RUN_PER_DAY, OnKillfocus)
	ON_BN_CLICKED(IDC_BTN_LAOD, OnBtnLaod)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelfCorrelationDlg bZ[W nh

BOOL CSelfCorrelationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	GetDlgItem(IDC_EDIT_NIGHT_RADIATION)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_INPUT_FILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_INPUT_FILE)->EnableWindow(FALSE);

	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDI_CORREL );
	SetIcon(hFile, TRUE);	
	SetIcon(hFile, FALSE);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSelfCorrelationDlg::OnKillfocus() 
{
	UpdateData(TRUE);	
}

void CSelfCorrelationDlg::OnCheckDaytime() 
{
	UpdateData(TRUE);

	if(m_bUseDaytimeOnly == TRUE){		
		GetDlgItem(IDC_EDIT_NIGHT_RADIATION)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_INPUT_FILE)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_INPUT_FILE)->EnableWindow(TRUE);

	}else{
		GetDlgItem(IDC_EDIT_NIGHT_RADIATION)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_INPUT_FILE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_INPUT_FILE)->EnableWindow(FALSE);
	}	
	UpdateData(FALSE);
}

void CSelfCorrelationDlg::OnButtonInputFile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile = dlg.GetPathName();
//		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputDir == ""){
			m_strOutputDir = m_strInputFile.Mid(0, m_strInputFile.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CSelfCorrelationDlg::OnButtonInputFlux() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFlux = dlg.GetPathName();
		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputDir == ""){
			m_strOutputDir = m_strInputFlux.Mid(0, m_strInputFlux.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CSelfCorrelationDlg::OnButtonOutputDirecotry() 
{
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputDir = dlg.GetPathName();
		UpdateData(FALSE);
	}	
}

void CSelfCorrelationDlg::OnButtonDetermine() 
{
	UpdateData(TRUE);

	BeginWaitCursor();
	srand( (unsigned)time( NULL ) );

	vector<double> aryR_obs_day, aryR_obs_week, aryR_obs_month, aryR_obs_annual;
	vector<double> aryR_sc_day, aryR_sc_week, aryR_sc_month, aryR_sc_annual;
	vector<double> aryR_real_day, aryR_real_week, aryR_real_month, aryR_real_annual;

	///////////////////////////////////////////
	// eLXg{bNX̓͂̃`FbN
	///////////////////////////////////////////
	CString strErrorMessage;
	if(ErrorCheck(strErrorMessage) == FALSE){
		AfxMessageBox(strErrorMessage);
		return ;
	}

	// ***************************************************************
	// ݒt@C̏o
	// ***************************************************************
	CString strOutSettingFile = m_strInputFlux;
	strOutSettingFile = strOutSettingFile.Left(strOutSettingFile.ReverseFind('.')) + ".correlation.set.txt";
	strOutSettingFile = m_strOutputDir + "\\" + strOutSettingFile.Mid(strOutSettingFile.ReverseFind('\\') + 1);
	SaveSetting(strOutSettingFile);

	//////////////////////////////////////////////////////
	// ̓t@C̓ǂݍ
	//////////////////////////////////////////////////////
	vector<CString> aryLinesInput;
	if(m_bUseDaytimeOnly) ReadFile_with_BlockWindow(m_strInputFile, aryLinesInput);

	vector<CString> aryLinesInputFlux;
	ReadFile_with_BlockWindow(m_strInputFlux, aryLinesInputFlux);

	//////////////////////////////////////////////////////
	// ǂݍ񂾃f[^NEE, RE, GPP, PPFD 𔲂o
	//////////////////////////////////////////////////////
	vector<double> aryNEE, aryRE, aryGPP, aryPPFD;
	const int iNEE = 4, iGPP = 5, iRE = 6, iPPFD = 9;
	GetDataFromLines(aryLinesInputFlux, aryNEE, iNEE, s_dErrorValue);
	GetDataFromLines(aryLinesInputFlux, aryRE, iRE, s_dErrorValue);
	GetDataFromLines(aryLinesInputFlux, aryGPP, iGPP, s_dErrorValue);
	if(m_bUseDaytimeOnly) GetDataFromLines(aryLinesInput, aryPPFD, iPPFD, s_dErrorValue);

	//////////////////////////////////////////////////////
	// ݂̂̃f[^gpꍇ
	//////////////////////////////////////////////////////
	if(m_bUseDaytimeOnly){
		if(select_daytime_data(aryNEE, aryRE, aryGPP, aryPPFD, m_dNighttimeRadiation) == FALSE){
			AfxMessageBox("Record number for PPFD and fluxes should be consistent.");
			return;
		}
	}

	//////////////////////////////////////////////////////
	// ւ̌vZ
	//////////////////////////////////////////////////////
	double dR = 0.0;

	// daily
	vector<double> aryNEE_day, aryRE_day, aryGPP_day;
	average_array(aryNEE, aryRE, aryGPP, aryNEE_day, aryRE_day, aryGPP_day, m_iRunPerDay);

	// weekly
	vector<double> aryNEE_week, aryRE_week, aryGPP_week;
	average_array(aryNEE, aryRE, aryGPP, aryNEE_week, aryRE_week, aryGPP_week, m_iRunPerDay * 7);

	// monthly
	vector<double> aryNEE_month, aryRE_month, aryGPP_month;
	average_array(aryNEE, aryRE, aryGPP, aryNEE_month, aryRE_month, aryGPP_month, m_iRunPerDay * 30);

	// annual
	vector<double> aryNEE_annual, aryRE_annual, aryGPP_annual;
	average_array(aryNEE, aryRE, aryGPP, aryNEE_annual, aryRE_annual, aryGPP_annual, m_iRunPerDay * 365);

	// ϑl̑֌W̕sm̓u[gXgbv@ŏoB
	for(int i = 0; i < m_iIteration; i++){
		vector<double> aryRandomNEE, aryRandomRE, aryRandomGPP;
		// daily
		make_bootstrap_array(aryNEE_day, aryRE_day, aryGPP_day, aryRandomNEE, aryRandomRE, aryRandomGPP);
		caluculate_correlation_coefficient(aryRandomRE, aryRandomGPP, dR);
		aryR_obs_day.push_back(dR);
		aryRandomNEE.clear();
		aryRandomRE.clear();
		aryRandomGPP.clear();

		// weekly
		make_bootstrap_array(aryNEE_week, aryRE_week, aryGPP_week, aryRandomNEE, aryRandomRE, aryRandomGPP);
		caluculate_correlation_coefficient(aryRandomRE, aryRandomGPP, dR);
		aryR_obs_week.push_back(dR);
		aryRandomNEE.clear();
		aryRandomRE.clear();
		aryRandomGPP.clear();

		// monthly
		make_bootstrap_array(aryNEE_month, aryRE_month, aryGPP_month, aryRandomNEE, aryRandomRE, aryRandomGPP);
		caluculate_correlation_coefficient(aryRandomRE, aryRandomGPP, dR);
		aryR_obs_month.push_back(dR);
		aryRandomNEE.clear();
		aryRandomRE.clear();
		aryRandomGPP.clear();

		// annual
		make_bootstrap_array(aryNEE_annual, aryRE_annual, aryGPP_annual, aryRandomNEE, aryRandomRE, aryRandomGPP);
		caluculate_correlation_coefficient(aryRandomRE, aryRandomGPP, dR);
		aryR_obs_annual.push_back(dR);
		aryRandomNEE.clear();
		aryRandomRE.clear();
		aryRandomGPP.clear();
	}

	//////////////////////////////////////////////////////
	// Uւ̌vZ
	//////////////////////////////////////////////////////
	for(i = 0; i < m_iIteration; i++){
		vector<double> aryRondamNEE, aryRondamRE, aryRondamGPP;
		make_randam_array(aryNEE, aryRondamNEE);
		make_randam_array(aryRE, aryRondamRE);
		calculate_GPP(aryRondamNEE, aryRondamRE, aryRondamGPP);

		// daily
		vector<double> aryNEE_day, aryRE_day, aryGPP_day;
		average_array(aryRondamNEE, aryRondamRE, aryRondamGPP, aryNEE_day, aryRE_day, aryGPP_day, m_iRunPerDay);
		caluculate_correlation_coefficient(aryRE_day, aryGPP_day, dR);
		aryR_sc_day.push_back(dR);

		// weekly
		vector<double> aryNEE_week, aryRE_week, aryGPP_week;
		average_array(aryRondamNEE, aryRondamRE, aryRondamGPP, aryNEE_week, aryRE_week, aryGPP_week, m_iRunPerDay * 7);
		caluculate_correlation_coefficient(aryRE_week, aryGPP_week, dR);
		aryR_sc_week.push_back(dR);

		// monthly
		vector<double> aryNEE_month, aryRE_month, aryGPP_month;
		average_array(aryRondamNEE, aryRondamRE, aryRondamGPP, aryNEE_month, aryRE_month, aryGPP_month, m_iRunPerDay * 30);
		caluculate_correlation_coefficient(aryRE_month, aryGPP_month, dR);
		aryR_sc_month.push_back(dR);

		// annual
		vector<double> aryNEE_annual, aryRE_annual, aryGPP_annual;
		average_array(aryRondamNEE, aryRondamRE, aryRondamGPP, aryNEE_annual, aryRE_annual, aryGPP_annual, m_iRunPerDay * 365);
		caluculate_correlation_coefficient(aryRE_annual, aryGPP_annual, dR);
		aryR_sc_annual.push_back(dR);
	}

	//////////////////////////////////////////////////////
	// ^ւ̌vZ
	//////////////////////////////////////////////////////
	for(i = 0; i < m_iIteration; i++){
		dR = aryR_obs_day[i] - aryR_sc_day[i];
		if(aryR_obs_day[i] == s_dErrorValue || aryR_sc_day[i] == s_dErrorValue) dR = s_dErrorValue;
		aryR_real_day.push_back(dR);

		dR = aryR_obs_week[i] - aryR_sc_week[i];
		if(aryR_obs_week[i] == s_dErrorValue || aryR_sc_week[i] == s_dErrorValue) dR = s_dErrorValue;
		aryR_real_week.push_back(dR);

		dR = aryR_obs_month[i] - aryR_sc_month[i];
		if(aryR_obs_month[i] == s_dErrorValue || aryR_sc_month[i] == s_dErrorValue) dR = s_dErrorValue;
		aryR_real_month.push_back(dR);

		dR = aryR_obs_annual[i] - aryR_sc_annual[i];
		if(aryR_obs_annual[i] == s_dErrorValue || aryR_sc_annual[i] == s_dErrorValue) dR = s_dErrorValue;
		aryR_real_annual.push_back(dR);
	}

	//////////////////////////////////////////////////////
	// ϕW΍
	//////////////////////////////////////////////////////
	double Robs_day, Robs_day_stdev, Rsc_day, Rsc_day_stdev, Rreal_day, Rreal_day_stdev;
	caluculate_average_stdev(aryR_obs_day, Robs_day, Robs_day_stdev);
	caluculate_average_stdev(aryR_sc_day, Rsc_day, Rsc_day_stdev);
	caluculate_average_stdev(aryR_real_day, Rreal_day, Rreal_day_stdev);

	double Robs_week, Robs_week_stdev, Rsc_week, Rsc_week_stdev, Rreal_week, Rreal_week_stdev;
	caluculate_average_stdev(aryR_obs_week, Robs_week, Robs_week_stdev);
	caluculate_average_stdev(aryR_sc_week, Rsc_week, Rsc_week_stdev);
	caluculate_average_stdev(aryR_real_week, Rreal_week, Rreal_week_stdev);

	double Robs_month, Robs_month_stdev, Rsc_month, Rsc_month_stdev, Rreal_month, Rreal_month_stdev;
	caluculate_average_stdev(aryR_obs_month, Robs_month, Robs_month_stdev);
	caluculate_average_stdev(aryR_sc_month, Rsc_month, Rsc_month_stdev);
	caluculate_average_stdev(aryR_real_month, Rreal_month, Rreal_month_stdev);

	double Robs_annual, Robs_annual_stdev, Rsc_annual, Rsc_annual_stdev, Rreal_annual, Rreal_annual_stdev;
	caluculate_average_stdev(aryR_obs_annual, Robs_annual, Robs_annual_stdev);
	caluculate_average_stdev(aryR_sc_annual, Rsc_annual, Rsc_annual_stdev);
	caluculate_average_stdev(aryR_real_annual, Rreal_annual, Rreal_annual_stdev);

	//////////////////////////////////////////////////////
	// ʂ̏o
	//////////////////////////////////////////////////////
	CString strOutFile;
	if(m_bUseDaytimeOnly){
		strOutFile = m_strOutputDir + "\\" + m_strInputTitle + ".Correlation.Daytime.csv";
	}
	else{
		strOutFile = m_strOutputDir + "\\" + m_strInputTitle + ".Correlation.csv";
	}
	CString strLine;
	try{
		CStdioFile OutFile(strOutFile, CFile::modeCreate | CFile::modeWrite);

		OutFile.WriteString("Timescale, N, R_obs, R_obs_stdev, R_sc, R_sc_stdev, R_real, R_real_stdev\n");

		strLine.Format("day, %d, %lf, %lf, %lf, %lf, %lf, %lf\n", aryNEE_day.size(), Robs_day, Robs_day_stdev, Rsc_day, Rsc_day_stdev, Rreal_day, Rreal_day_stdev);
		OutFile.WriteString(strLine);
		strLine.Format("week, %d, %lf, %lf, %lf, %lf, %lf, %lf\n", aryNEE_week.size(), Robs_week, Robs_week_stdev, Rsc_week, Rsc_week_stdev, Rreal_week, Rreal_week_stdev);
		OutFile.WriteString(strLine);
		strLine.Format("month, %d, %lf, %lf, %lf, %lf, %lf, %lf\n", aryNEE_month.size(), Robs_month, Robs_month_stdev, Rsc_month, Rsc_month_stdev, Rreal_month, Rreal_month_stdev);
		OutFile.WriteString(strLine);
		strLine.Format("annual, %d, %lf, %lf, %lf, %lf, %lf, %lf\n", aryNEE_annual.size(), Robs_annual, Robs_annual_stdev, Rsc_annual, Rsc_annual_stdev, Rreal_annual, Rreal_annual_stdev);
		OutFile.WriteString(strLine);

		OutFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}

}

BOOL CSelfCorrelationDlg::ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CString>& aryLines)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	CString strHeader;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strHeader);				//	 1s
		InFile.ReadString(strHeader);				//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	return bIsOK;
}

void CSelfCorrelationDlg::GetDataFromLines(std::vector<CString>& aryLines, std::vector<double>& aryData, const int& iColumn, const double& dError)
{
	int iColmunPosition, iColmunNumber;
	CString strTemp, strTemp2;
	double dTemp;

	// CSV t@C̓Iǂݍ
	for(int i = 0; i < aryLines.size(); i++){
		strTemp = aryLines[i];
		iColmunNumber = 0;

		while((iColmunPosition = strTemp.Find(",")) != -1){
			iColmunNumber++;	// JJEg

			strTemp2 = strTemp.Left(iColmunPosition);				
			dTemp = atof(strTemp2);
			if(strTemp2 == ""){
				dTemp = dError;
			}
			if(dTemp == 0){		// atof ́AlȊOƎ0Ԃ߁Al0Ȃ̂mF
				if(!(IsZeroValue(strTemp2)))
					dTemp = dError;
			}
			if(iColmunNumber == iColumn){
				aryData.push_back(dTemp);
			}

			strTemp = strTemp.Mid(iColmunPosition + 1);
		}
	}
}

BOOL CSelfCorrelationDlg::IsZeroValue(CString strValue)
{
	strValue.Remove('0');
	strValue.Remove('.');
	strValue.Remove('-');	// For windows vista 
	strValue.TrimLeft();
	if(strValue == ""){
		return TRUE;
	}else{
		return FALSE;
	}
}

void CSelfCorrelationDlg::caluculate_correlation_coefficient(const std::vector<double>& x, const std::vector<double>& y, double& dR)
{
	double stdev1, stdev2, covariance;
	double Tx = 0.0;
	double Txx = 0.0;
	double Tyy = 0.0;
	double Txy = 0.0;
	double Ty = 0.0;
	const int iSize = x.size();
	dR = s_dErrorValue;

	if(iSize == 0){
		return;
	}

    for(int i = 0; i < iSize; i++)
    {
    	Tx += x[i];
		Ty += y[i];
        Txx += x[i] * x[i];
		Tyy += y[i] * y[i];		
        Txy += x[i] * y[i];    
    }
    stdev1 = sqrt((Txx - Tx * Tx / iSize) / iSize);
	stdev2 = sqrt((Tyy - Ty * Ty / iSize) / iSize);
	covariance = (Txy - Tx * Ty / iSize) / iSize;

	if(Txx - Tx * Tx / iSize < 0){
		stdev1 = s_dErrorValue;
	}
	if(Tyy - Ty * Ty / iSize < 0){
		stdev2 = s_dErrorValue;
	}

	if(stdev1 != 0 && stdev2 != 0){
		dR = covariance / stdev1 / stdev2;
	}
}

void CSelfCorrelationDlg::caluculate_average_stdev(const std::vector<double>& x, double& average, double& stdev)
{
	double Tx = 0.0;
	double Txx = 0.0;
	const int iSize = x.size();
	int iCount = 0;

    for(int i = 0; i < iSize; i++)
    {
		if(x[i] == s_dErrorValue){
			continue;
		}
		iCount++;

    	Tx += x[i];
        Txx += x[i] * x[i]; 
    }

	if(iCount == 0){
		stdev = s_dErrorValue;
		average = s_dErrorValue;
	}
	else{
		stdev = sqrt((Txx - Tx * Tx / iCount) / iCount);
		average = Tx / iCount;
	}
}

void CSelfCorrelationDlg::average_array(const std::vector<double>& aryIn1, const std::vector<double>& aryIn2, const std::vector<double>& aryIn3, 
	std::vector<double>& aryAverage1, std::vector<double>& aryAverage2, std::vector<double>& aryAverage3, const int& iAverageTerm)
{
	int iCount = 0;
	double dAverage1 = 0.0, dAverage2 = 0.0, dAverage3 = 0.0;
	int iSize = aryIn1.size();

	if(iSize > aryIn2.size()){
		iSize = aryIn2.size();
	}
	if(iSize > aryIn3.size()){
		iSize = aryIn3.size();
	}

	for(int i = 0; i < iSize; i++){
		if(aryIn1[i] == s_dErrorValue || aryIn2[i] == s_dErrorValue || aryIn3[i] == s_dErrorValue){
			continue;
		}

		if(iCount < iAverageTerm){
			dAverage1 += aryIn1[i];
			dAverage2 += aryIn2[i];
			dAverage3 += aryIn3[i];
			iCount++;
		}
		else{
			aryAverage1.push_back(dAverage1 /iCount);
			dAverage1 = 0.0;
			aryAverage2.push_back(dAverage2 /iCount);
			dAverage2 = 0.0;
			aryAverage3.push_back(dAverage3 /iCount);
			dAverage3 = 0.0;
			iCount = 0;
		}
	}
}

void CSelfCorrelationDlg::make_randam_array(const std::vector<double>& aryIn, std::vector<double>& aryRondam)
{	
	int iSize = aryIn.size();

	for(int i = 0; i < iSize; i++){
		aryRondam.push_back(aryIn[rand() % (iSize - 1)]);
	}
}

void CSelfCorrelationDlg::make_bootstrap_array(const std::vector<double>& aryIn1, const std::vector<double>& aryIn2, const std::vector<double>& aryIn3, 
	std::vector<double>& aryInBootstrap1, std::vector<double>& aryInBootstrap2, std::vector<double>& aryInBootstrap3)
{
	int iSize = aryIn1.size();
	int iRandom;

	if(iSize > aryIn2.size()){
		iSize = aryIn2.size();
	}
	if(iSize > aryIn3.size()){
		iSize = aryIn3.size();
	}

	if(iSize <= 1){
		return;
	}

	for(int i = 0; i < iSize; i++){
		iRandom = rand() % (iSize - 1);
		aryInBootstrap1.push_back(aryIn1[iRandom]);
		aryInBootstrap2.push_back(aryIn2[iRandom]);
		aryInBootstrap3.push_back(aryIn3[iRandom]);
	}
}

void CSelfCorrelationDlg::calculate_GPP(const std::vector<double>& aryNEE, const std::vector<double>& aryRE, std::vector<double>& aryGPP)
{
	for(int i = 0; i < aryNEE.size(); i++){
		if(aryNEE[i] == s_dErrorValue || aryRE[i] == s_dErrorValue){
			aryGPP.push_back(s_dErrorValue);
		}
		else{
			aryGPP.push_back(aryRE[i] - aryNEE[i]);
		}
	}
}

BOOL CSelfCorrelationDlg::select_daytime_data(std::vector<double>& aryNEE, std::vector<double>& aryRE, std::vector<double>& aryGPP, std::vector<double>& aryPPFD, const double& dNighttimeRadiation)
{
	vector<double> _aryNEE, _aryRE, _aryGPP;

	if(aryNEE.size() != aryPPFD.size()){
		return FALSE;
	}

	for(int i = 0; i < aryPPFD.size(); i++){
		if(aryPPFD[i] > dNighttimeRadiation){
			_aryNEE.push_back(aryNEE[i]);
			_aryRE.push_back(aryRE[i]);
			_aryGPP.push_back(aryGPP[i]);
		}
	}
	aryNEE.clear();
	aryRE.clear();
	aryGPP.clear();

	for(i = 0; i < _aryNEE.size(); i++){
		aryNEE.push_back(_aryNEE[i]);
		aryRE.push_back(_aryRE[i]);
		aryGPP.push_back(_aryGPP[i]);
	}
	return TRUE;
}

void CSelfCorrelationDlg::OnBtnLaod() 
{
	CString strFilePass;
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.correlation.set.txt)|*.correlation.set.txt|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	SetParameterFromFile(strFilePass);
}

BOOL CSelfCorrelationDlg::SetParameterFromFile(CString strFilePass)
{
	BOOL bOK = TRUE;
	try{
		CStdioFile in(strFilePass, CFile::modeRead | CFile::shareDenyWrite);
		CString strLine, strTemp;
		double dTemp;
		int iTemp;

		while(in.ReadString(strLine)){
			strTemp = strLine.Left(strLine.Find(':'));

			if(strTemp == "Iteration"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iIteration = iTemp;
				continue;
			}

			if(strTemp == "RunPerDay"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iRunPerDay = iTemp;
				continue;
			}

			if(strTemp == "NighttimeRadiation"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dNighttimeRadiation = dTemp;
				continue;
			}

			if(strTemp == "UseDaytimeOnly"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUseDaytimeOnly = iTemp;
				continue;
			}
		}

		UpdateData(FALSE);

		in.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bOK = FALSE;
	}

	return bOK;
}

void CSelfCorrelationDlg::SaveSetting(const CString& strFilePass) 
{
	CString strLine;

	try{
		CStdioFile out(strFilePass, CFile::modeCreate | CFile::modeWrite);

		// Write Setting of Nono-Linear Regression Function parameters
		strLine.Format("Iteration:%d\n", m_iIteration);
		out.WriteString(strLine);

		strLine.Format("RunPerDay:%d\n", m_iRunPerDay);
		out.WriteString(strLine);

		strLine.Format("NighttimeRadiation:%lf\n", m_dNighttimeRadiation);
		out.WriteString(strLine);

		strLine.Format("UseDaytimeOnly:%lf\n", m_bUseDaytimeOnly);
		out.WriteString(strLine);

		out.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

BOOL CSelfCorrelationDlg::ErrorCheck(CString& strErrorMessage)
{
	if(m_bUseDaytimeOnly == TRUE && m_strInputFile == ""){
		strErrorMessage = "Please select the input PPFD file.";
		return FALSE;
	}
	if(m_strInputFlux == ""){
		strErrorMessage = "Please select the input flux file.";
		return FALSE;
	}
	if(m_strOutputDir == ""){
		strErrorMessage = "Please select the output directory.";
		return FALSE;
	}

	return TRUE;
}