// UstarFilteringDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "UstarFilteringDlg.h"

#include "BrowseFolderDialog.h"
#include <math.h>

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUstarFilteringDlg _CAO


CUstarFilteringDlg::CUstarFilteringDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUstarFilteringDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUstarFilteringDlg)
	m_strInputFile = _T("");
	m_strOutputDir = _T("");
	m_iTerm = 95;
	m_iRunPerDay = 48;
	m_bUsePeriod = FALSE;
	m_dNighttimeRadiation = 10.0;
	m_dPvalue = 0.005;
	m_iBootstrapNum = 1000;
	m_dUstarThres = 0.0;
	//}}AFX_DATA_INIT
}


void CUstarFilteringDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUstarFilteringDlg)
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDX_Text(pDX, IDC_EDIT_OUT_DIR, m_strOutputDir);
	DDX_Text(pDX, IDC_EDIT_TERM, m_iTerm);
	DDV_MinMaxUInt(pDX, m_iTerm, 1, 1000000);
	DDX_Text(pDX, IDC_EDIT_RUN_PER_DAY, m_iRunPerDay);
	DDV_MinMaxUInt(pDX, m_iRunPerDay, 1, 1000000);
	DDX_Check(pDX, IDC_CHECK_PERIOD, m_bUsePeriod);
	DDX_Text(pDX, IDC_EDIT_NIGHT_RADIATION, m_dNighttimeRadiation);
	DDX_Text(pDX, IDC_EDIT_P, m_dPvalue);
	DDV_MinMaxDouble(pDX, m_dPvalue, 0., 1.);
	DDX_Text(pDX, IDC_EDIT_BOOTSTRAP, m_iBootstrapNum);
	DDV_MinMaxUInt(pDX, m_iBootstrapNum, 1, 10000);
	DDX_Text(pDX, IDC_EDIT_U_STAR_THES, m_dUstarThres);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUstarFilteringDlg, CDialog)
	//{{AFX_MSG_MAP(CUstarFilteringDlg)
	ON_EN_KILLFOCUS(IDC_EDIT_INPUT_FILE, OnKillfocus)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_FILE, OnButtonInputFile)
	ON_BN_CLICKED(IDC_BUTTON_FIXED_DATA, OnButtonFixedData)
	ON_BN_CLICKED(IDC_BUTTON_DETERMINE, OnButtonDetermine)
	ON_EN_KILLFOCUS(IDC_EDIT_OUT_DIR, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_GAP_TERM, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_RUN_PER_DAY, OnKillfocus)
	ON_EN_KILLFOCUS(IDC_EDIT_NIGHT_RADIATION, OnKillfocus)
	ON_BN_CLICKED(IDC_BTN_LAOD, OnBtnLaod)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUstarFilteringDlg bZ[W nh
BOOL CUstarFilteringDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDI_U_STAR );
	SetIcon(hFile, TRUE);	
	SetIcon(hFile, FALSE);	
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CUstarFilteringDlg::OnKillfocus() 
{
	UpdateData(TRUE);
}

void CUstarFilteringDlg::OnButtonInputFile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"csv  t@C   (*.csv)|*.csv|"
		"SĂ t@C   (*.*)|*.*|",
		NULL);

	if(dlg.DoModal() == IDOK){
		m_strInputFile = dlg.GetPathName();
		m_strInputTitle = dlg.GetFileTitle();
		if(m_strOutputDir == ""){
			m_strOutputDir = m_strInputFile.Mid(0, m_strInputFile.ReverseFind('\\'));
		}
		UpdateData(FALSE);
	}
}

void CUstarFilteringDlg::OnButtonFixedData() 
{
	CBrowseFolderDialog dlg;
	UpdateData(TRUE);
	
	if(dlg.DoModal() == IDOK){
		m_strOutputDir = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CUstarFilteringDlg::SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir)
{
	m_strInputFile = strInputFile;
	m_strOutputDir = strOutputDir;
	m_strInputTitle = strInputFile.Mid(strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));

	if(strIniFile != "") SetParameterFromFile(strIniFile);
	UpdateData(FALSE);
}

void CUstarFilteringDlg::OnButtonDetermine() 
{
	CWaitCursor wait;
	UpdateData(TRUE);

	CString strErrorMessage;

	if(ErrorCheck(strErrorMessage) == FALSE){
		return;
	}

	// ***************************************************************
	// t@CE^Cg̍XV
	// ***************************************************************
	m_strInputTitle = m_strInputFile.Mid(m_strInputFile.ReverseFind('\\') + 1);
	m_strInputTitle = m_strInputTitle.Mid(0, m_strInputTitle.ReverseFind('.'));

	// ***************************************************************
	// ̓f[^̓ǂݍ
	// ***************************************************************
	CString strHeaderLine;
	vector<CMeanTerm*> aryMeanTerm;
	ReadFile_with_BlockWindow(m_strInputFile, aryMeanTerm, m_iRunPerDay, m_iTerm, strHeaderLine);

	vector<std::string> aryCurrentDate;			// Ώۂ̓ti[
	vector<double> aryMaximumT;					// exW̍ōC
	vector<double> aryMinimumT;					// exW̍ŒC
	vector<double> aryCorrelationCoefficient;	// exWu* ƋC̑֌W
	vector<double> aryUpperClassUstar;			// 5NXu* ̕ϒl
	vector<double> aryUstarThreshold;			// exWu* 臒l
	vector<int>    aryDataSize;					// u* 臒lɎgpf[^
	vector<int> aryUstarThretholdClass;			// u* 臒l݂NX
	double dUstarThreshold = 0.0;				// exWu*臒l̒l
	double dUstarThreshold_annual = 0.0;
	vector<double> aryUsterThreshold_an;
	double dAveUstarThreshold;
	double dStedvUstarThreshold;
	int iBootstrapNum = m_iBootstrapNum;

	int iUstarColumn = 0;
	int iNEEColumn = 3;
	int iRadiationColumn = 4;
	int iTemperatureColumn = 5;
	BOOL bError;

	try{
		// ⊮̎nt@CSĂ̊Ԃɂ킽ďo͂邽߂̃t@C̃CX^X
		CString strOutFile, strLine;
		strOutFile.Format("%s\\%s_us%d_threshold.csv", m_strOutputDir, m_strInputTitle, m_iTerm);
		CStdioFile out(strOutFile, CFile::modeCreate | CFile::modeWrite);

		strLine = "Date, Tmax, Tmin, R, u*_upper, u*_threshold, class, num\n";
		out.WriteString(strLine);

		for(int b = 0; b < iBootstrapNum; b++){
			for(int i = 0; i < aryMeanTerm.size(); i++){
				// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
				CString strTemp = strHeaderLine;
				if(b == 0){
					if(aryMeanTerm[i]->SetDataset(strTemp.Replace(',','@')) == FALSE){
						return;
					}
					aryMeanTerm[i]->SetHeader(strHeaderLine);
				}

				//aryMeanTerm[i]->determin_u_star_threshold(iUstarColumn, iNEEColumn, iRadiationColumn, iTemperatureColumn, m_dNighttimeRadiation,
				//	aryCurrentDate, aryMaximumT, aryMinimumT, aryCorrelationCoefficient, aryUpperClassUstar, aryUstarThreshold, aryUstarThretholdClass, aryDataSize, dUstarThreshold);
				bError = aryMeanTerm[i]->determin_u_star_threshold2(iUstarColumn, iNEEColumn, iRadiationColumn, iTemperatureColumn, m_dNighttimeRadiation,
					aryCurrentDate, aryMaximumT, aryMinimumT, aryCorrelationCoefficient, aryUpperClassUstar, aryUstarThreshold, aryUstarThretholdClass, aryDataSize, dUstarThreshold, m_dPvalue);

				for(int j = 0; j < aryCurrentDate.size(); j++){
					// double test = aryUstarThretholdClass[j]; 
					if(bError == TRUE){
						int iError = aryUpperClassUstar.size() - 1 ;
						if(iError < j){
							aryUpperClassUstar.push_back(aryMeanTerm[0]->s_dErrorValue);
						}
						iError = aryUstarThretholdClass.size() - 1 ;
						if(iError - 1 < j){
							aryUstarThretholdClass.push_back(aryMeanTerm[0]->s_dErrorValue);
						}

						strLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %d, %d\n", 
							aryCurrentDate[j].c_str(), aryMaximumT[j], aryMinimumT[j], aryCorrelationCoefficient[j], aryUpperClassUstar[j], aryUstarThreshold[j], aryUstarThretholdClass[j], aryDataSize[j]);
						out.WriteString(strLine);
					}
				}
				if(aryCurrentDate.size() != 0) strLine.Format("%s, u* threshold :, %lf\n", aryCurrentDate[0].c_str(), dUstarThreshold);
				out.WriteString(strLine);
				if(dUstarThreshold > dUstarThreshold_annual) dUstarThreshold_annual = dUstarThreshold;

				aryCurrentDate.clear();
				aryMaximumT.clear();
				aryMinimumT.clear();
				aryCorrelationCoefficient.clear();
				aryUpperClassUstar.clear();
				aryUstarThreshold.clear();
				aryUstarThretholdClass.clear();
				aryDataSize.clear();

				// mۂ̈̊J
				// aryMeanTerm[i]->ReleaseDataset();
				// delete aryMeanTerm[i];
			}
			aryUsterThreshold_an.push_back(dUstarThreshold_annual);
			dUstarThreshold_annual = 0.0;

		}
		
		// mۂ̈̊J
		for(int i = 0; i < aryMeanTerm.size(); i++){
			aryMeanTerm[i]->ReleaseDataset();
			delete aryMeanTerm[i];
		}

		// calculate average and stdev
		average_stdev(aryUsterThreshold_an, dAveUstarThreshold, dStedvUstarThreshold);
		strLine.Format("average , %lf, stdev , %lf\n", dAveUstarThreshold, dStedvUstarThreshold);
		// AfxMessageBox(strLine);

		// output final Data
		CString strOutFinalFile;
		strOutFinalFile.Format("%s\\%s_final_us%d_threshold.csv", m_strOutputDir, m_strInputTitle, m_iTerm);
		CStdioFile out_final(strOutFinalFile, CFile::modeCreate | CFile::modeWrite);
		out_final.WriteString(strLine);
		out_final.Close();

		// show test box
		m_dUstarThres = dAveUstarThreshold;
		UpdateData(FALSE);

		out.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return;
	}

	// ***************************************************************
	// ݒt@C̏o
	// ***************************************************************
	CString strOutSettingFile = m_strInputFile;
	strOutSettingFile = strOutSettingFile.Left(strOutSettingFile.ReverseFind('.')) + ".ust.set.txt";
	strOutSettingFile = m_strOutputDir + "\\" + strOutSettingFile.Mid(strOutSettingFile.ReverseFind('\\') + 1);
	SaveSetting(strOutSettingFile);
	
}

void CUstarFilteringDlg::average_stdev(const std::vector<double>& x, double& average, double& stdev)
{   
	/* ρEW΍ */
    double S = 0;
	double Tx = 0;
	double Txx = 0;

    for(int i = 0; i < x.size(); i++)
    {
    	Tx += x[i];
        Txx += x[i] * x[i];
    }
	average = Tx / x.size();
    stdev = sqrt( (Txx - Tx * Tx / x.size()) / x.size() );
}

BOOL CUstarFilteringDlg::ErrorCheck(CString& strErrorMessage)
{
	if(m_strInputFile == ""){
		strErrorMessage = "Please select the input file.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_INPUT_FILE));
		return FALSE;
	}
	if(m_strOutputDir == ""){
		strErrorMessage = "Please select the output directory.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_OUT_DIR));
		return FALSE;
	}
	if(m_iRunPerDay <= 0){
		strErrorMessage = "The Run per day should be positive value.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_RUN_PER_DAY));
		return FALSE;
	}
	if(m_iTerm < 1){
		strErrorMessage = "The gap filling term should be greater than 1.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_TERM));
		return FALSE;
	}
	if(m_iBootstrapNum < 1){
		strErrorMessage = "The bootstrap number should be greater than 1.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_BOOTSTRAP));
		return FALSE;
	}
	if(m_dPvalue < 0){
		strErrorMessage = "The p value should be greater than 0.";
		(this)->GotoDlgCtrl(GetDlgItem(IDC_EDIT_P));
		return FALSE;
	}

	return TRUE;
}

BOOL CUstarFilteringDlg::ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine)
{
	//  ̓t@Cǂݍ݁Aw肳ꂽԖɐ؂蕪
	CString strLine;
	int iCountOfRun = 0;
	int iTermNum = 0;
	int iPeriod = 0;
	CString strTemp;
	BOOL bIsOK = FALSE;
	vector <CString> aryLines;

	try{
		CStdioFile InFile(strInputFile, CFile::modeRead | CFile::shareDenyWrite);

		// wb_[ǂݔ΂
		InFile.ReadString(strHeaderLine);	//	 1s
		InFile.ReadString(strLine);			//   2s

		while(InFile.ReadString(strLine)){
			if(strLine == ","){
				continue;
			}
			aryLines.push_back(strLine);
		}

		InFile.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		return bIsOK;
	}

	// EBhEړăf[^i[@ipj
	BOOL bPeriodChange = FALSE;
	for(int i = 0; i < aryLines.size(); i++){
		if(i % (iRunPerDay * iPhotosynthesisTerm) == 0 || bPeriodChange == TRUE){
			CMeanTerm* PhotosynthesisTerm = new CMeanTerm(iTermNum);
			aryMeanTerm.push_back(PhotosynthesisTerm);
			iTermNum++;
			bPeriodChange = FALSE;

			// ̏擾
			if(m_bUsePeriod == TRUE){
				strTemp = aryLines[i].Mid(aryLines[i].ReverseFind(',') + 1);
				iPeriod = atoi(strTemp);
				(aryMeanTerm.back())->SetCurrentPeriod(iPeriod);
			}
			strTemp = aryLines[i].Left(aryLines[i].Find(','));
			(aryMeanTerm.back())->SetCurrentDate(strTemp);

			int iStart = i;
			int iEnd   = i + (iPhotosynthesisTerm * m_iRunPerDay);
			if(iEnd > (aryLines.size() - 1)) iEnd = aryLines.size() - 1;

			for(int j = iStart; j < iEnd; j++){
				iPeriod = atoi(aryLines[j].Mid(aryLines[j].ReverseFind(',') + 1));

				// ǂݍݓr period ςƂ
				if(m_bUsePeriod && j != iStart && iPeriod != (aryMeanTerm.back())->GetCurrentPeriod()){
					bPeriodChange = TRUE;
					i = j - 1;
					break;
				}

				if(m_bUsePeriod){
					(aryMeanTerm.back())->SetLine(aryLines[j], iPeriod);
				}
				else{
					(aryMeanTerm.back())->SetLine(aryLines[j]);
				}
			}
		}
	}

	bIsOK = TRUE;
	return bIsOK;
}

void CUstarFilteringDlg::OnBtnLaod() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY| OFN_LONGNAMES,
		"Setting  File   (*.ust.set.txt)|*.ust.set.txt|",
		NULL);

	CString strFilePass;
	if(dlg.DoModal() == IDOK){
		strFilePass = dlg.GetPathName();
	}
	else{
		return;
	}

	SetParameterFromFile(strFilePass);
}

void CUstarFilteringDlg::SaveSetting(const CString& strFilePass)
{
	CString strLine;

	try{
		CStdioFile out(strFilePass, CFile::modeCreate | CFile::modeWrite);

		// Write Setting of Nono-Linear Regression Function parameters
		strLine.Format("Term:%d\n", m_iTerm);
		out.WriteString(strLine);

		strLine.Format("RunPerDay:%d\n", m_iRunPerDay);
		out.WriteString(strLine);

		strLine.Format("UsePeriod_Ustar:%d\n", m_bUsePeriod);
		out.WriteString(strLine);

		strLine.Format("NighttimeRadiation:%lf\n", m_dNighttimeRadiation);
		out.WriteString(strLine);

		strLine.Format("BootstrapNum:%d\n", m_iBootstrapNum);
		out.WriteString(strLine);

		strLine.Format("Pvalue:%lf\n", m_dPvalue);
		out.WriteString(strLine);

		strLine.Format("Ustar_threshold:%lf\n", m_dUstarThres);
		out.WriteString(strLine);

		out.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

BOOL CUstarFilteringDlg::SetParameterFromFile(CString strFilePass)
{
	BOOL bOK = TRUE;
	try{
		CStdioFile in(strFilePass, CFile::modeRead | CFile::shareDenyWrite);
		CString strLine, strTemp;
		int iTemp;
		double dTemp;

		while(in.ReadString(strLine)){
			strTemp = strLine.Left(strLine.Find(':'));

			if(strTemp == "Term"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iTerm = iTemp;
				continue;
			}

			if(strTemp == "RunPerDay"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iRunPerDay = iTemp;
				continue;
			}

			if(strTemp == "UsePeriod_Ustar"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_bUsePeriod = iTemp;
				continue;
			}

			if(strTemp == "NighttimeRadiation"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dNighttimeRadiation = dTemp;
				continue;
			}

			if(strTemp == "BootstrapNum"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				iTemp = atoi(strLine);
				m_iBootstrapNum = iTemp;
				continue;
			}

			if(strTemp == "Pvalue"){
				strLine = strLine.Mid(strLine.Find(':') + 1);
				dTemp = atof(strLine);
				m_dPvalue = dTemp;
				continue;
			}

		}

		UpdateData(FALSE);

		in.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bOK = FALSE;
	}

	return bOK;
}
