#if !defined(AFX_FLUXPARTITIONING_H__233A85A4_73A9_48EC_ADB6_A37E25D66DBD__INCLUDED_)
#define AFX_FLUXPARTITIONING_H__233A85A4_73A9_48EC_ADB6_A37E25D66DBD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FluxPartitioningDlg.h : wb_[ t@C
//
#include "MeanTerm.h"
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// CFluxPartitioning _CAO

class CFluxPartitioningDlg : public CDialog
{
// RXgNV
public:
	CFluxPartitioningDlg(CWnd* pParent = NULL);   // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CFluxPartitioningDlg)
	enum { IDD = IDD_DLG_FLUX_PARTITION };
	CProgressCtrl	m_ctlProgress;
	CString	m_strInputFile;
	CString	m_strOutputFile;
	UINT	m_iRunPerDay;
	UINT	m_iRespirationTerm;
	UINT	m_iPhotosynthesisTerm;
	double	m_dUstar_threshold;
	BOOL	m_bSetMaximumB;
	double	m_dMaximumB;
	double	m_dConvexity;
	BOOL	m_bUseNonRectangular;
	double	m_dNighttimeRadiation;
	BOOL	m_bUseLT_Equation;
	BOOL	m_bUseFixedData;
	CString	m_strFixedDataFile;
	BOOL	m_bUsePeriod;
	CString	m_strInputFileApply;
	CString	m_strOutputFileApply;
	UINT	m_iMaximumForLinearRegression;
	CString	m_strInputRE;
	CString	m_strInputGPP;
	BOOL	m_bUseLinearRegression;
	UINT	m_iGapFillingTerm;
	BOOL	m_bMeanDiurnalVariation;
	BOOL	m_bNonLinearRegression;
	BOOL	m_bMovingAverage;
	BOOL	m_bPhotosynthesis;
	BOOL	m_bRespiration;
	int		m_iQCMaximumLoop;
	double	m_dQCThresholdSigma;
	double	m_dMaximumQ10;
	double	m_dReferenceT_RE;
	int		m_iBootstrapNum;
	BOOL	m_bUseVanGorsel;
	UINT	m_iSunsetRunVanGorsel;
	BOOL	m_bEliminateNegativeNEE;
	//}}AFX_DATA
	CString m_strIniUsterFile;

	BOOL m_bIsThread;

	// void OnBtnDetermine_public(){OnBtnDetermine();}
	BOOL Determine_Photosynthesis_Respiration_Parameters(CString& strErrorMessage) ;
	BOOL Gap_Filling_Carbon_Energy_Fluxes(CString& strErrorMessage);
	BOOL Determine_uncertainties_bootstraping(CString& strErrorMessage);

	// Interface to other dialog
	void SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir, const CString& strFixedFile, const CString& strFileGPP, const CString& strFileRE, const CString& strIniUsterFile);
	

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CFluxPartitioningDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CString m_strInputTitle;
	CString m_strInputTitleApply;
	BOOL m_bBootstraping;

	// Non linear regression parameters by bootstrapping
	std::vector<CPhotosynthesisParameters> m_aryPhotosynthesisParametersBootstrap;
	std::vector<CRespirationParameters> m_aryRespirationParametersBootstrap;

	// Œp^
	std::vector<CPhotosynthesisParameters> m_aryFixedPhotosynthesisParameters;
	std::vector<CRespirationParameters> m_aryFixedRespirationParameters;

	BOOL ErrorCheck(CString& strErrorMessage);
	void DeterminePhotosynthesisParameters(std::vector<CMeanTerm*>& aryMeanTermGPP, const CString& strHeaderLine, CProgressCtrl& ctlProgress);
	void DetermineRespirationParameters(std::vector<CMeanTerm*>& aryMeanTermRE, const CString& strHeaderLine, CProgressCtrl& ctlProgress);
	void Determine_GPP_Parameters(CString& strOutPass, std::vector<CMeanTerm*>& aryMeanTermGPP, CString& strHeaderLine, CProgressCtrl& ctlProgress);
	BOOL ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTermGPP, std::vector<CMeanTerm*>& aryMeanTermRE, int iRunPerDay, int iPhotosynthesisTerm, int iRespirationTerm, CString& strHeaderLine);
	BOOL ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);
	BOOL ReadFixedParamterFile();
	BOOL ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTermGPP, std::vector<CMeanTerm*>& aryMeanTermRE, int iRunPerDay, int iPhotosynthesisTerm, int iRespirationTerm, CString& strHeaderLine);
	BOOL ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);

	BOOL ErrorCheckApply(CString& strErrorMessage);
	BOOL Read_GPP_Parameter(std::vector<CMeanTerm*>& aryMeanTerm);
	BOOL Read_RE_Parameter(std::vector<CMeanTerm*>& aryMeanTerm);
	BOOL ReadContinuousFile_for_EachTerm(const CString strFileName, std::vector<CMeanTerm*>& aryMeanTerm, CString& strHeader, int iHeaderNum);

	BOOL GapFill_mdv_lt(const CString& strHeaderLine, std::vector<CMeanTerm*>& aryMeanTermGPP, BOOL bMovingAverage, CProgressCtrl& ctlProgress);
	void LinearRegression_NonLinearRegression(const CString& strOutPass, std::vector<CMeanTerm*>& aryMeanTerm, CString& strHeader);
	BOOL Final_Priority(std::vector<CMeanTerm*>& aryMeanTermGPP, const CString& strInputTitle);

	CWinThread* m_pThread;
	static UINT OnDetermineThread(LPVOID pParam);
	static UINT OnApplyThread(LPVOID pParam);
	static UINT OnBtnUncertainThread(LPVOID pParam);
	BOOL IsActiveThread() { return m_bIsThread; }
	CString m_strErrorMessageForThread;

	// Setting file
	void SaveSetting(const CString& strFilePass);
	BOOL SetParameterFromFile(CString strFilePass);
	void UpdateGraphics();

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CFluxPartitioningDlg)
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonOutputFile();
	afx_msg void OnKillfocus();
	afx_msg void OnBtnDetermine();
	afx_msg void OnCheckNonRectangular();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckMaxB();
	afx_msg void OnCheckFixedData();
	afx_msg void OnButtonFixedData();
	afx_msg void OnButtonInputApply();
	afx_msg void OnCheckLtEquation();
	afx_msg void OnCheckPeriod();
	afx_msg void OnCheckUseRegression();
	afx_msg void OnButtonOutputApply();
	afx_msg void OnButtonInputGpp();
	afx_msg void OnButtonInputRe();
	afx_msg void OnBtnApply();
	afx_msg void OnCheckMdv();
	afx_msg void OnCheckNlr();
	afx_msg void OnCheckRespiration();
	afx_msg void OnCheckPhotosynthesis();
	afx_msg void OnCheckMovingWd();
	afx_msg void OnClose();
	afx_msg void OnBtnLaod();
	afx_msg void OnBtnSave();
	afx_msg void OnBtnUncertain();
	afx_msg void OnCheckVanGorsel();
	afx_msg void OnCheckOmitNegativeNee();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_FLUXPARTITIONING_H__233A85A4_73A9_48EC_ADB6_A37E25D66DBD__INCLUDED_)
