// MeanTerm.cpp: CMeanTerm NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "math.h"
#include "MeanTerm.h"
#include "Dataset.h"

#include <algorithm>
#include <math.h>

using namespace std;
#pragma warning( disable : 4786 )
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const double CMeanTerm::s_dErrorValue = CDataset::s_dErrorValue;
const double CMeanTerm::s_dR = 8.314472;		// ideal gas constant (8.314472 J K-1 J-1)
BOOL CMeanTerm::s_bUseNegativeValues;
BOOL CMeanTerm::s_bUseNonRectangular;
double CMeanTerm::s_dConvexity;
BOOL CMeanTerm::s_bUseLT_Equation;
double CMeanTerm::s_dUstar_threshold;
double CMeanTerm::s_dNighttimeRadiation;
std::vector< std::vector<double> > CMeanTerm::m_aryBootstrapMeanAll_mdv;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

int CMeanTerm::s_iDatasetNum;
std::vector<std::string> CMeanTerm::s_aryHeader;

CMeanTerm::CMeanTerm(int iTermNumber):m_iTermNumber(iTermNumber), m_iPeriod(0)
{
	if(iTermNumber == 0){
		s_iDatasetNum = 0;
	}
}

CMeanTerm::~CMeanTerm()
{
	// s_aryHeader.clear();
	ReleaseDataset();
}

void CMeanTerm::ReleaseDataset()
{
	for(int i = 0; i < m_aryDataset.size(); i++){
		delete m_aryDataset[i];
	}
	m_aryDataset.clear();
}

void CMeanTerm::SetPhotosynthesisConstant(BOOL bUseNegativeValues, BOOL bUseNonRectangular, double dConvexity)
{
	s_bUseNegativeValues = bUseNegativeValues;
	s_bUseNonRectangular = bUseNonRectangular;
	s_dConvexity = dConvexity;
}

void CMeanTerm::SetRespirationConstant(BOOL bUseNegativeValues, BOOL bUseLT_Equation, double dUstar_threshold, double dNighttimeRadiation)
{
	s_bUseNegativeValues = bUseNegativeValues;
	s_bUseLT_Equation = bUseLT_Equation;
	s_dUstar_threshold = dUstar_threshold;
	s_dNighttimeRadiation = dNighttimeRadiation;
}

void CMeanTerm::SetLine(const CString& strLine)
{
	m_aryLine.push_back((LPCTSTR)strLine);
}

void CMeanTerm::SetLine(const CString& strLine, int iPeriod)
{
	if(m_iPeriod == iPeriod){
		m_aryLine.push_back((LPCTSTR)strLine);
	}
}

BOOL CMeanTerm::SetDataset(int iDataSize)
{
	CString strTemp, strTemp2, strTime, strString;
	int iColmunPosition = 0;
	int iColmunNumber = 0;
	double dTemp = 0;

	ReleaseDataset();

	// f[^ZbgECX^X̍쐬 (C 2005.07/21)
	for(int i = 0; i < iDataSize; i++){
		CDataset* Dataset = new CDataset();
		m_aryDataset.push_back(Dataset);
	}

	// CSV t@C̓Iǂݍ
	for(i = 0; i < m_aryLine.size(); i++){
		strTemp = m_aryLine[i].c_str();
		iColmunNumber = 0;

		// ̎擾
		iColmunPosition = strTemp.Find(",");
		if(iColmunPosition != -1){
			strString = m_aryLine[i].c_str();
			strTime = strString.Left(iColmunPosition);
			strTemp = strString.Mid(iColmunPosition + 1);
		}else{
			strTime = strTemp;
			strTemp.Format("%lf",CDataset::s_dErrorValue);
		}
		if(strTemp == ""){
			strTemp.Format("%lf",CDataset::s_dErrorValue);
		}

		while((iColmunPosition = strTemp.Find(",")) != -1){
			iColmunNumber++;	// JJEg

			strTemp2 = strTemp.Left(iColmunPosition);				
			dTemp = atof(strTemp2);
			if(strTemp2 == ""){
				dTemp = CDataset::s_dErrorValue;
			}
			if(dTemp == 0){		// atof ́AlȊOƎ0Ԃ߁Al0Ȃ̂mF
				if(!(IsZeroValue(strTemp2)))
					dTemp = CDataset::s_dErrorValue;
			}
			if((iColmunNumber-1) < m_aryDataset.size()){
				m_aryDataset[iColmunNumber-1]->SetContinuousDataset(strTime, dTemp);
			}else{
				CString strErrorMsg;
				strErrorMsg.Format("csv t@C̃JrŕύXĂ܂BőJ́A%d łB", s_iDatasetNum + 1);
				AfxMessageBox(strErrorMsg);
				return FALSE;
			}
			strTemp = strTemp.Mid(iColmunPosition + 1);
		}

		// ŏIJɎ^f[^Zbg̎o
		// f[^ZbgECX^X̍쐬
		dTemp = atof(strTemp);
		if(strTemp == ""){
				dTemp = CDataset::s_dErrorValue;
			}
		if(dTemp == 0){		// atof ́AlȊOƎ0Ԃ߁Al0Ȃ̂mF
			if(!(IsZeroValue(strTemp)))
				dTemp = CDataset::s_dErrorValue;
		}
		// add at 2011.03.09 : Excel -10000ɂȂ錏ɑΉ
		if(dTemp < CDataset::s_dErrorValue){
			dTemp = CDataset::s_dErrorValue;
		}
		
		if(iColmunNumber <  m_aryDataset.size()){
			m_aryDataset[iColmunNumber]->SetContinuousDataset(strTime, dTemp);
		}else{
			CString strErrorMsg;
			strErrorMsg.Format("csv t@C̃JrŕύXĂ܂BőJ́A%d łB", s_iDatasetNum + 1);
			AfxMessageBox(strErrorMsg);
			return FALSE;
		}
		iColmunNumber++; // ŏIJJEg

		// 󔒃J̃R}ȗĂt@CɊւ鏈(EXCELt@CɕKvȏ)
		while(iDataSize > iColmunNumber){
			iColmunNumber ++;
			m_aryDataset[iColmunNumber-1]->SetContinuousDataset(strTime, CDataset::s_dErrorValue);				
		}
	}
	return TRUE;
}

BOOL CMeanTerm::IsZeroValue(CString strValue)
{
	strValue.Remove('0');
	strValue.Remove('.');
	strValue.Remove('-');	// For windows vista 
	strValue.TrimLeft();
	if(strValue == ""){
		return TRUE;
	}else{
		return FALSE;
	}
}

void CMeanTerm::SetHeader(const CString& strHeader)
{
	CString strTemp = strHeader, strTemp2;
	m_strHeader = strHeader;
	int iColmunPosition = 0;
	int iColmunNumber = 0;

	if(m_iTermNumber == 0){
		s_iDatasetNum = 0;
		s_aryHeader.clear();

		while((iColmunPosition = strTemp.Find(",")) != -1){
			iColmunNumber++;
				
			if(iColmunNumber > 1){ // 1  ́Adl㎞ĂB
				strTemp2 = strTemp.Left(iColmunPosition);
				
				s_aryHeader.push_back((LPCTSTR)strTemp2);
				s_iDatasetNum++;
			}
			strTemp = strTemp.Mid(iColmunPosition + 1);
		}
		if(strTemp != ""){	// ŏIJɎ^f[^Zbg̎o
			s_aryHeader.push_back((LPCTSTR)strTemp);
		}else{
			strTemp = "HeaderError";
			s_aryHeader.push_back((LPCTSTR)strTemp);
		}

		// CDataset NX̃CX^XɁAwb_[t^
		//for(int i = 0; i < s_iDatasetNum /*m_aryHeader.size()*/; i++){
		//	m_aryDataset[i]->SetHeaderName(s_aryHeader[i]);
		//}
	}

	// CDataset NX̃CX^XɁAwb_[t^
	for(int i = 0; i < s_iDatasetNum; i++){
		m_aryDataset[i]->SetHeaderName(s_aryHeader[i].c_str());
	}

}

BOOL CMeanTerm::MeanDiurnalVariation(int iRunPerDay, int iRadiationColumn, int iAverageNumber, BOOL bMovingAverage, BOOL m_bUseRadiation, BOOL bBootstrap, int iBootstrapNum)
{
	// ϓω@ɂ⊮
	for(int i = 0; i < m_aryDataset.size(); i++){
		// Diurnal Variation 쐬
		m_aryDataset[i]->SetDiurnalVariation(iRunPerDay, iBootstrapNum, bBootstrap);

		// }⊮̑IĂꍇA}⊮{ <- Ōɒuǂ
		// if(bIsInterpolate) m_aryDataset[i]->InterpolateDataset(iMaxInterpolateData);

		// Mean Diurnal Variation @Ńf[^⊮
		
		if(bMovingAverage){
			m_aryDataset[i]->ExecMeanDiurnalVariationMethod_moving_av(m_strCurrentDate);
		}
		else{
			m_aryDataset[i]->ExecMeanDiurnalVariationMethod();
		}
		if(bBootstrap == TRUE){
			m_aryDataset[i]->ExecMeanDiurnalVariationMethod_bootstrap(iBootstrapNum);
		}
	}

	if(m_bUseRadiation){
		// ˗ʂDiurnal Pattern A˗ʂ̑\lvZ
		double dRadiationAverage = m_aryDataset[iRadiationColumn]->GetDiurnalAverage(iAverageNumber);
		const std::vector<double>* paryRadiationDatset = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
		for(int i = 0; i < m_aryDataset.size(); i++){
			m_aryDataset[i]->SetConvertRate(*paryRadiationDatset, dRadiationAverage, iRunPerDay, iAverageNumber);
			m_aryDataset[i]->ApplyRadiationFactor_DirunalVariation(m_strCurrentDate, bMovingAverage);
		}
	}

	return TRUE;
}

void CMeanTerm::SetBootstrapMeanALL_mdv(int iTotalLineNum, BOOL bMovingAverage)
{
	vector<double> aryAve;
	int iTermSize = m_aryLine.size();

	for(int i = 0; i < m_aryDataset.size(); i++){
		for(int j = 0; j < m_aryDataset[i]->m_aryBootstrapAverage.size(); j++ ){
			if(bMovingAverage){
				aryAve.push_back(m_aryDataset[i]->m_aryBootstrapAverage[j] * m_iRunPerDay / iTotalLineNum);
			}
			else{
				aryAve.push_back(m_aryDataset[i]->m_aryBootstrapAverage[j] * iTermSize / iTotalLineNum);
			}
		}

		if(m_iTermNumber == 0){
			m_aryBootstrapMeanAll_mdv.push_back(aryAve);
		}
		else{
			for(int j = 0; j < m_aryDataset[i]->m_aryBootstrapAverage.size(); j++ ){
				m_aryBootstrapMeanAll_mdv[i][j] += aryAve[j];
			}
		}
		aryAve.clear();
	}
}

BOOL CMeanTerm::LinearInterpolation(int iMaximumForLinearRegression, BOOL bMovingAverage)
{
	// }⊮ 
	// ̊֐́Aϓω@A\@ɂ⊮sȂɎs邱
	// łȂƁAωp^[Look-up-table }⊮̃f[^ō쐬Ă܂B

	for(int i = 0; i < m_aryDataset.size(); i++){
		// }⊮̑IĂꍇA}⊮{
		m_aryDataset[i]->InterpolateDataset(iMaximumForLinearRegression);
	}

	for(i = 0; i < m_aryDataset.size(); i++){
		// }⊮̃f[^𕽋ϓω@E\@ɂ⊮ꂽlɔf
		m_aryDataset[i]->Update_InterpolateDataset(bMovingAverage, m_strCurrentDate);
	}

	return TRUE;
}

BOOL CMeanTerm::LinearInterpolation_NoneLinearRegression(int iMaximumForLinearRegression, int iNEE_raw, int iNEE_nlr1, int iNEE_nlr2)
{
	m_aryDataset[iNEE_raw]->InterpolateDataset(iMaximumForLinearRegression);

	for(int i = 0; i < m_aryDataset[iNEE_raw]->m_aryInterporateDataset.size(); i++){
		if(m_aryDataset[iNEE_raw]->m_aryIsComplement[i] == m_aryDataset[iNEE_raw]->INTERPOLATE_COMPLEMENT){
			(m_aryDataset[iNEE_nlr1]->GetContinuousDataset())->operator[](i) = m_aryDataset[iNEE_raw]->m_aryInterporateDataset[i];
			(m_aryDataset[iNEE_nlr2]->GetContinuousDataset())->operator[](i) = m_aryDataset[iNEE_raw]->m_aryInterporateDataset[i];
		}
	}
	return TRUE;
}

BOOL CMeanTerm::LookUpTableMethod(const int& iCalibrationColmun1, const int& iCalibrationColmun2, const int& iCalibrationColmun3,
				const int& iApplicationColmun1, const int& iApplicationColmun2, const int& iApplicationColmun3, 
				const int& iDivide1, const int& iDivide2, const int& iDivide3,
				const int& dMax1, const int& dMax2, const int& dMax3, const int& dMin1, const int& dMin2, const int& dMin3, 
				const int& iRunPerDay, BOOL bMovingAverage)
{
	std::vector<std::vector<std::vector<std::vector<double> > > > aryLookUpCount3, aryLookUpCount2, aryLookUpCount1;
	int iSize = m_aryDataset.size();
	aryLookUpCount3.resize(iSize, vector<vector<vector<double> > >( iDivide1, vector<vector<double> >(iDivide2 , vector<double>(iDivide3)))); // 3 ϐ
	aryLookUpCount2.resize(iSize, vector<vector<vector<double> > >( iDivide1, vector<vector<double> >(iDivide2 , vector<double>(iDivide3)))); // 2 ϐ
	aryLookUpCount1.resize(iSize, vector<vector<vector<double> > >( iDivide1, vector<vector<double> >(iDivide2 , vector<double>(iDivide3)))); // 1 ϐ

	// look up table ̏
	for(int i = 0; i < iSize; i++){
		m_aryDataset[i]->m_aryLookUpTable.resize( iDivide1, vector<vector<double> >(iDivide2 , vector<double>(iDivide3)));
		m_aryDataset[i]->m_aryLookUpTable1.resize( iDivide1, vector<vector<double> >(iDivide2 , vector<double>(iDivide3)));
		m_aryDataset[i]->m_aryLookUpTable2.resize( iDivide1, vector<vector<double> >(iDivide2 , vector<double>(iDivide3)));
	}

	// Look up table ̍쐬
	int i1, i2, i3, iColumn;
	double d1, d2, d3, dDummy = s_dErrorValue;

	for(i = 0; i < (m_aryDataset[iCalibrationColmun1]->GetContinuousDataset())->size(); i++){
		d1 = (m_aryDataset[iCalibrationColmun1]->GetContinuousDataset())->operator[](i);
		d2 = (m_aryDataset[iCalibrationColmun2]->GetContinuousDataset())->operator[](i);
		d3 = (m_aryDataset[iCalibrationColmun3]->GetContinuousDataset())->operator[](i);
		if(d1 == s_dErrorValue) continue;

		// 1ϐLook up table փf[^i[
		GetIndex_LookUpTable(d1, i1, iDivide1, dMax1, dMin1);
		GetIndex_LookUpTable(dDummy, i2, iDivide2, dMax2, dMin2);
		GetIndex_LookUpTable(dDummy, i3, iDivide3, dMax3, dMin3);
		for(iColumn = 0; iColumn < iSize; iColumn++){
			if((m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i) != s_dErrorValue){
				m_aryDataset[iColumn]->m_aryLookUpTable1[i1][i2][i3] += (m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i);
				aryLookUpCount1[iColumn][i1][i2][i3] += 1;
			}
		}

		
		if(d2 == s_dErrorValue) continue;

		// 2ϐLook up table փf[^i[
		GetIndex_LookUpTable(d1, i1, iDivide1, dMax1, dMin1);
		GetIndex_LookUpTable(d2, i2, iDivide2, dMax2, dMin2);
		GetIndex_LookUpTable(dDummy, i3, iDivide3, dMax3, dMin3);
		for(iColumn = 0; iColumn < iSize; iColumn++){
			if((m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i) != s_dErrorValue){
				m_aryDataset[iColumn]->m_aryLookUpTable2[i1][i2][i3] += (m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i);
				aryLookUpCount2[iColumn][i1][i2][i3] += 1;
			}
		}

		if(d3 == s_dErrorValue) continue;

		// 3ϐLook up table փf[^i[
		GetIndex_LookUpTable(d1, i1, iDivide1, dMax1, dMin1);
		GetIndex_LookUpTable(d2, i2, iDivide2, dMax2, dMin2);
		GetIndex_LookUpTable(d3, i3, iDivide3, dMax3, dMin3);	
		for(iColumn = 0; iColumn < iSize; iColumn++){
			if((m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i) != s_dErrorValue){
				m_aryDataset[iColumn]->m_aryLookUpTable[i1][i2][i3] += (m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i);
				aryLookUpCount3[iColumn][i1][i2][i3] += 1;
			}
		}
	}

	// ϒl̍쐬
	for(iColumn = 0; iColumn < iSize; iColumn++){
		for(i = 0; i < iDivide1; i++){
			for(int j = 0; j < iDivide2; j++){
				for(int k = 0; k < iDivide3; k++){
					// 3ϐLook up table
					if(aryLookUpCount3[iColumn][i][j][k] == 0.0){
						m_aryDataset[iColumn]->m_aryLookUpTable[i][j][k] = s_dErrorValue;
					}
					else{
						m_aryDataset[iColumn]->m_aryLookUpTable[i][j][k] /= aryLookUpCount3[iColumn][i][j][k];
					}

					// 2ϐLook up table
					if(aryLookUpCount2[iColumn][i][j][k] == 0.0){
						m_aryDataset[iColumn]->m_aryLookUpTable2[i][j][k] = s_dErrorValue;
					}
					else{
						m_aryDataset[iColumn]->m_aryLookUpTable2[i][j][k] /= aryLookUpCount2[iColumn][i][j][k];
					}

					// 1ϐLook up table
					if(aryLookUpCount1[iColumn][i][j][k] == 0.0){
						m_aryDataset[iColumn]->m_aryLookUpTable1[i][j][k] = s_dErrorValue;
					}
					else{
						m_aryDataset[iColumn]->m_aryLookUpTable1[i][j][k] /= aryLookUpCount1[iColumn][i][j][k];
					}
				}
			}
		}
	}

	// Current Date ̃X^[g
	int iCurrentDate = m_aryDataset[0]->get_current_date(m_strCurrentDate);

	// Look up table găf[^⊮
	double dValue;
	int i3_2, i2_1;
	int iStart = 0;
	int iEnd = (m_aryDataset[iApplicationColmun1]->GetContinuousDataset())->size(); 
	if(bMovingAverage){
		iStart = iCurrentDate;
		iEnd = iStart + iRunPerDay;
	}

	for(i = iStart; i < iEnd; i++){
		d1 = (m_aryDataset[iApplicationColmun1]->GetContinuousDataset())->operator[](i);
		d2 = (m_aryDataset[iApplicationColmun2]->GetContinuousDataset())->operator[](i);
		d3 = (m_aryDataset[iApplicationColmun3]->GetContinuousDataset())->operator[](i);

		GetIndex_LookUpTable(d1, i1, iDivide1, dMax1, dMin1);
		GetIndex_LookUpTable(d2, i2, iDivide2, dMax2, dMin2);
		GetIndex_LookUpTable(d3, i3, iDivide3, dMax3, dMin3);
		d3 = s_dErrorValue;
		GetIndex_LookUpTable(d3, i3_2, iDivide3, dMax3, dMin3);
		d2 = s_dErrorValue;
		GetIndex_LookUpTable(d2, i2_1, iDivide2, dMax2, dMin2);

		for(iColumn = 0; iColumn < iSize; iColumn++){
			// 3ϐLook up table
			dValue = m_aryDataset[iColumn]->m_aryLookUpTable[i1][i2][i3];

			// 2ϐLook up table
			if(dValue == s_dErrorValue) dValue = m_aryDataset[iColumn]->m_aryLookUpTable2[i1][i2][i3_2];

			// 1ϐLook up table
			if(dValue == s_dErrorValue) dValue = m_aryDataset[iColumn]->m_aryLookUpTable1[i1][i2_1][i3_2];

			// look up table ɂ萄肳ꂽl̂݃f[^Zbg쐬
			m_aryDataset[iColumn]->m_aryTable_Dataset.push_back(dValue);

			// sensitble heat flux
			if((m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue){
				m_aryDataset[iColumn]->m_aryLT_Filled_Dataset.push_back(dValue);
				m_aryDataset[iColumn]->m_aryIsComplement[i] = (CDataset::LUTM_COMPLEMENT);
			}
			else{
				m_aryDataset[iColumn]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i));
				m_aryDataset[iColumn]->m_aryIsComplement[i] = (CDataset::NONE_COMPLEMENT);
			}
		}
	}

	return TRUE;
}

void CMeanTerm::GetIndex_LookUpTable(double& dValue, int& iIndex, const int& iDivide, const double& dMax, const double& dMin)
{
	double dCarry = 10000.0;
	if(dValue < dMin){
		iIndex = 0;
	}
	else if(dValue > dMax){
		iIndex = iDivide - 1;
	}
	else{
		iIndex = int((dValue - dMin) * dCarry) / ((dMax - dMin) / (iDivide - 2) * dCarry) + 1;
	}
}

BOOL CMeanTerm::LookUpTable(int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, 
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage)
{
	// **********************************************************************************
	// Look up table ̍쐬
	// **********************************************************************************
	// Look up table ̏
	CDataset* aryHeatFlux = m_aryDataset[iHeatFlux];
	CDataset* aryLatentFlux = m_aryDataset[iLatentFlux];
	CDataset* aryNEE = m_aryDataset[iNEE];
	CDataset* aryRadiation = m_aryDataset[iRadiationColumn];
	CDataset* aryTemperature = m_aryDataset[iTemperatureColumn];
	CDataset* aryVPD = m_aryDataset[iVPDColumn];

	// look up table 2ϐp
	std::vector<std::vector<std::vector<double> > > aryLookUp2_H;
	std::vector<std::vector<std::vector<double> > > aryLookUp2_lE;
	std::vector<std::vector<std::vector<double> > > aryLookUp2_NEE;

	// look up table 1ϐp
	std::vector<std::vector<std::vector<double> > > aryLookUp3_H;
	std::vector<std::vector<std::vector<double> > > aryLookUp3_lE;
	
	int iRad, iTemp, iVPD;
	Create_LookUpTable_flux(aryHeatFlux, aryLatentFlux, aryNEE, aryRadiation, aryTemperature, aryVPD, 
			iHeatFlux, iLatentFlux, iNEE, iRadiationColumn, iTemperatureColumn, iVPDColumn, iRad, iTemp, iVPD,
			aryLookUp2_H, aryLookUp2_lE, aryLookUp2_NEE, aryLookUp3_H, aryLookUp3_lE,
			iRadiationFilledColumn, iTemperatureFilledColumn, iVPDFilledColumn, dUpplerNighttimeRadiation, iRunPerDay, bMovingAverage);

	// Current Date ̃X^[g
	int iCurrentDate = m_aryDataset[iHeatFlux]->get_current_date(m_strCurrentDate);

	// **********************************************************************************
	// Look up table găf[^⊮
	// **********************************************************************************
	double dH_lut, dlE_lut, dNEE_lut;
	int iRad2, iTemp2, iVPD2, iRad3, iTemp3, iVPD3;
	double dRadiation, dTemperature, dVPD;
	int iStart = 0;
	int iEnd = (m_aryDataset[iRadiationFilledColumn]->GetContinuousDataset())->size(); 
	if(bMovingAverage){
		iStart = iCurrentDate;
		iEnd = iStart + iRunPerDay;
	}

	for(int i = iStart; i < iEnd; i++){
		dRadiation = (m_aryDataset[iRadiationFilledColumn]->GetContinuousDataset())->operator[](i);
		dTemperature = (m_aryDataset[iTemperatureFilledColumn]->GetContinuousDataset())->operator[](i);
		dVPD = (m_aryDataset[iVPDFilledColumn]->GetContinuousDataset())->operator[](i);

		//if(dRadiation == s_dErrorValue || dTemperature == s_dErrorValue || dVPD == s_dErrorValue){
		//	continue;
		//}

		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);
		dVPD = s_dErrorValue;
		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad2, iTemp2, iVPD2, dUpplerNighttimeRadiation);
		dTemperature = s_dErrorValue;
		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad3, iTemp3, iVPD3, dUpplerNighttimeRadiation);

		// 3ϐLook up table
		dH_lut = m_aryDataset[iHeatFlux]->m_aryLookUpTable[iRad][iTemp][iVPD];
		dlE_lut = m_aryDataset[iLatentFlux]->m_aryLookUpTable[iRad][iTemp][iVPD];
		dNEE_lut = m_aryDataset[iNEE]->m_aryLookUpTable[iRad][iTemp][iVPD];

		// 2ϐLook up table
		if(dH_lut == s_dErrorValue) dH_lut = aryLookUp2_H[iRad2][iTemp2][iVPD2];
		if(dlE_lut == s_dErrorValue) dlE_lut = aryLookUp2_lE[iRad2][iTemp2][iVPD2];
		// if(dNEE_lut == s_dErrorValue) dNEE_lut = aryLookUp2_NEE[iRad2][iTemp2][iVPD2];

		// 1ϐLook up table
		if(dH_lut == s_dErrorValue) dH_lut = aryLookUp3_H[iRad3][iTemp3][iVPD3];
		if(dlE_lut == s_dErrorValue) dlE_lut = aryLookUp3_lE[iRad3][iTemp3][iVPD3];

		// look up table ɂ萄肳ꂽl̂݃f[^Zbg쐬
		m_aryDataset[iHeatFlux]->m_aryTable_Dataset.push_back(dH_lut);
		m_aryDataset[iLatentFlux]->m_aryTable_Dataset.push_back(dlE_lut);
		m_aryDataset[iNEE]->m_aryTable_Dataset.push_back(dNEE_lut);

		// sensitble heat flux
		if((m_aryDataset[iHeatFlux]->GetContinuousDataset())->operator[](i) == s_dErrorValue){
			m_aryDataset[iHeatFlux]->m_aryLT_Filled_Dataset.push_back(dH_lut);
		}
		else{
			m_aryDataset[iHeatFlux]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iHeatFlux]->GetContinuousDataset())->operator[](i));
		}

		// latetnt heat flux
		if((m_aryDataset[iLatentFlux]->GetContinuousDataset())->operator[](i) == s_dErrorValue){
			m_aryDataset[iLatentFlux]->m_aryLT_Filled_Dataset.push_back(dlE_lut);
		}
		else{
			m_aryDataset[iLatentFlux]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iLatentFlux]->GetContinuousDataset())->operator[](i));
		}

		// NEE
		if((m_aryDataset[iNEE]->GetContinuousDataset())->operator[](i) == s_dErrorValue){
			m_aryDataset[iNEE]->m_aryLT_Filled_Dataset.push_back(dNEE_lut);
		}
		else{
			m_aryDataset[iNEE]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iNEE]->GetContinuousDataset())->operator[](i));
		}
	}

	return TRUE;
}

void CMeanTerm::Create_LookUpTable_flux(CDataset* aryHeatFlux, CDataset* aryLatentFlux, CDataset* aryNEE, CDataset* aryRadiation, CDataset* aryTemperature, CDataset* aryVPD, 
			int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, int& iRad, int& iTemp, int& iVPD,
			std::vector<std::vector<std::vector<double> > >& aryLookUp2_H, std::vector<std::vector<std::vector<double> > >& aryLookUp2_lE, std::vector<std::vector<std::vector<double> > >& aryLookUp2_NEE, std::vector<std::vector<std::vector<double> > >& aryLookUp3_H, std::vector<std::vector<std::vector<double> > >& aryLookUp3_lE,
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage)
{
	// Look up table ̏
	// 36 x 36 x 36 3z@F1FPPFD, 2: Tair, 3: VPD
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_H;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_lE;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_NEE;
	aryLookUpCount_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// look up table 2ϐp
	std::vector<std::vector<std::vector<double> > > aryLookUpCount2_H;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount2_lE;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount2_NEE;
	aryLookUp2_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUp2_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUp2_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount2_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount2_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount2_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// look up table 1ϐp
	std::vector<std::vector<std::vector<double> > > aryLookUpCount3_H;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount3_lE;
	aryLookUp3_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUp3_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount3_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount3_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	aryHeatFlux->m_aryLookUpTable.clear();
	aryLatentFlux->m_aryLookUpTable.clear();
	aryNEE->m_aryLookUpTable.clear();
	aryHeatFlux->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLatentFlux->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryNEE->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// Look up table ̍쐬
	double dRadiation, dTemperature, dVPD, dDummy = s_dErrorValue;
	for(int i = 0; i < (aryRadiation->GetContinuousDataset())->size(); i++){
		dRadiation = (aryRadiation->GetContinuousDataset())->operator[](i);
		dTemperature = (aryTemperature->GetContinuousDataset())->operator[](i);
		dVPD = (aryVPD->GetContinuousDataset())->operator[](i);
		if(dRadiation == s_dErrorValue) continue;
	
		// 1ϐLook up table փf[^i[
		GetIndex_LookUpTable(dRadiation, dDummy, dDummy, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		if((aryHeatFlux->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLookUp3_H[iRad][iTemp][iVPD] += (aryHeatFlux->GetContinuousDataset())->operator[](i);
			aryLookUpCount3_H[iRad][iTemp][iVPD] += 1;
		}

		if((aryLatentFlux->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLookUp3_lE[iRad][iTemp][iVPD] += (aryLatentFlux->GetContinuousDataset())->operator[](i);
			aryLookUpCount3_lE[iRad][iTemp][iVPD] += 1;
		}
		if(dTemperature == s_dErrorValue) continue;

		// 2ϐLook up table փf[^i[
		GetIndex_LookUpTable(dRadiation, dTemperature, dDummy, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		if((aryHeatFlux->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLookUp2_H[iRad][iTemp][iVPD] += (aryHeatFlux->GetContinuousDataset())->operator[](i);
			aryLookUpCount2_H[iRad][iTemp][iVPD] += 1;
		}

		if((aryLatentFlux->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLookUp2_lE[iRad][iTemp][iVPD] += (aryLatentFlux->GetContinuousDataset())->operator[](i);
			aryLookUpCount2_lE[iRad][iTemp][iVPD] += 1;
		}

		if((aryNEE->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLookUp2_NEE[iRad][iTemp][iVPD] += (aryNEE->GetContinuousDataset())->operator[](i);
			aryLookUpCount2_NEE[iRad][iTemp][iVPD] += 1;
		}
		if(dVPD == s_dErrorValue) continue;

		// 3ϐLook up table փf[^i[
		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		if((aryHeatFlux->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryHeatFlux->m_aryLookUpTable[iRad][iTemp][iVPD] += (aryHeatFlux->GetContinuousDataset())->operator[](i);
			aryLookUpCount_H[iRad][iTemp][iVPD] += 1;
		}
		if((aryLatentFlux->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLatentFlux->m_aryLookUpTable[iRad][iTemp][iVPD] += (aryLatentFlux->GetContinuousDataset())->operator[](i);
			aryLookUpCount_lE[iRad][iTemp][iVPD] += 1;
		}
		if((aryNEE->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryNEE->m_aryLookUpTable[iRad][iTemp][iVPD] += (aryNEE->GetContinuousDataset())->operator[](i);
			aryLookUpCount_NEE[iRad][iTemp][iVPD] += 1;
		}
	}

	// ϒl̍쐬
	for(i = 0; i < 36; i++){
		for(int j = 0; j < 36; j++){
			for(int k = 0; k < 36; k++){
				// 3ϐLook up table
				if(aryLookUpCount_H[i][j][k] == 0.0){
					aryHeatFlux->m_aryLookUpTable[i][j][k] = s_dErrorValue;
				}
				else{
					aryHeatFlux->m_aryLookUpTable[i][j][k] /= aryLookUpCount_H[i][j][k];
				}
				if(aryLookUpCount_lE[i][j][k] == 0.0){
					aryLatentFlux->m_aryLookUpTable[i][j][k] = s_dErrorValue;
				}
				else{
					aryLatentFlux->m_aryLookUpTable[i][j][k] /= aryLookUpCount_lE[i][j][k];
				}
				if(aryLookUpCount_NEE[i][j][k] == 0.0){
					aryNEE->m_aryLookUpTable[i][j][k] = s_dErrorValue;
				}
				else{
					aryNEE->m_aryLookUpTable[i][j][k] /= aryLookUpCount_NEE[i][j][k];
					// ԂCO2 flux ɂȂ́A[Ƃ
					if(aryNEE->m_aryLookUpTable[0][j][k] < 0.0 && aryNEE->m_aryLookUpTable[0][j][k] != s_dErrorValue){
						aryNEE->m_aryLookUpTable[0][j][k] = 0.0;
					}
				}

				// 2ϐLook up table
				if(aryLookUpCount2_H[i][j][k] == 0.0){
					aryLookUp2_H[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp2_H[i][j][k] /= aryLookUpCount2_H[i][j][k];
				}
				if(aryLookUpCount2_lE[i][j][k] == 0.0){
					aryLookUp2_lE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp2_lE[i][j][k] /= aryLookUpCount2_lE[i][j][k];
				}
				if(aryLookUpCount2_NEE[i][j][k] == 0.0){
					aryLookUpCount_NEE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp2_NEE[i][j][k] /= aryLookUpCount2_NEE[i][j][k];
					aryLookUp2_NEE[0][j][k] = s_dErrorValue;				// Ԃ͓ϐł͋߂Ȃ
				}

				// 1ϐLook up table
				if(aryLookUpCount3_H[i][j][k] == 0.0){
					aryLookUp3_H[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp3_H[i][j][k] /= aryLookUpCount3_H[i][j][k];
				}
				if(aryLookUpCount3_lE[i][j][k] == 0.0){
					aryLookUp3_lE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp3_lE[i][j][k] /= aryLookUpCount3_lE[i][j][k];
				}
			}
		}
	}
}

BOOL CMeanTerm::LookUpTable_bootstrap(int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, 
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage, int iBootstrapNum)
{
	// **********************************************************************************
	// Look up table ̍쐬
	// **********************************************************************************
	// Look up table ̏
	CDataset* aryHeatFlux = m_aryDataset[iHeatFlux];
	CDataset* aryLatentFlux = m_aryDataset[iLatentFlux];
	CDataset* aryNEE = m_aryDataset[iNEE];
	CDataset* aryRadiation = m_aryDataset[iRadiationColumn];
	CDataset* aryTemperature = m_aryDataset[iTemperatureColumn];
	CDataset* aryVPD = m_aryDataset[iVPDColumn];

	// Current Date ̃X^[g
	int iCurrentDate = m_aryDataset[iHeatFlux]->get_current_date(m_strCurrentDate);

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		// look up table 2ϐp
		std::vector<std::vector<std::vector<double> > > aryLookUp2_H;
		std::vector<std::vector<std::vector<double> > > aryLookUp2_lE;
		std::vector<std::vector<std::vector<double> > > aryLookUp2_NEE;

		// look up table 1ϐp
		std::vector<std::vector<std::vector<double> > > aryLookUp3_H;
		std::vector<std::vector<std::vector<double> > > aryLookUp3_lE;
		
		int iRad, iTemp, iVPD;
		Create_LookUpTable_flux_bootstrap(aryHeatFlux, aryLatentFlux, aryNEE, aryRadiation, aryTemperature, aryVPD, 
				iHeatFlux, iLatentFlux, iNEE, iRadiationColumn, iTemperatureColumn, iVPDColumn, iRad, iTemp, iVPD,
				aryLookUp2_H, aryLookUp2_lE, aryLookUp2_NEE, aryLookUp3_H, aryLookUp3_lE,
				iRadiationFilledColumn, iTemperatureFilledColumn, iVPDFilledColumn, dUpplerNighttimeRadiation, iRunPerDay, bMovingAverage);

		// **********************************************************************************
		// Look up table găf[^⊮
		// **********************************************************************************
		double dH_lut, dlE_lut, dNEE_lut;
		int iRad2, iTemp2, iVPD2, iRad3, iTemp3, iVPD3;
		double dRadiation, dTemperature, dVPD;
		int iStart = 0;
		int iEnd = (m_aryDataset[iRadiationFilledColumn]->GetContinuousDataset())->size(); 
		if(bMovingAverage){
			iStart = iCurrentDate;
			iEnd = iStart + iRunPerDay;
		}

		vector<double> aryTable_Dataset_H;
		vector<double> aryTable_Dataset_LE;
		vector<double> aryTable_Dataset_NEE;

		for(int i = iStart; i < iEnd; i++){
			dRadiation = (m_aryDataset[iRadiationFilledColumn]->GetContinuousDataset())->operator[](i);
			dTemperature = (m_aryDataset[iTemperatureFilledColumn]->GetContinuousDataset())->operator[](i);
			dVPD = (m_aryDataset[iVPDFilledColumn]->GetContinuousDataset())->operator[](i);

			//if(dRadiation == s_dErrorValue || dTemperature == s_dErrorValue || dVPD == s_dErrorValue){
			//	continue;
			//}

			GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);
			dVPD = s_dErrorValue;
			GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad2, iTemp2, iVPD2, dUpplerNighttimeRadiation);
			dTemperature = s_dErrorValue;
			GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad3, iTemp3, iVPD3, dUpplerNighttimeRadiation);

			// 3ϐLook up table
			dH_lut = m_aryDataset[iHeatFlux]->m_aryLookUpTable[iRad][iTemp][iVPD];
			dlE_lut = m_aryDataset[iLatentFlux]->m_aryLookUpTable[iRad][iTemp][iVPD];
			dNEE_lut = m_aryDataset[iNEE]->m_aryLookUpTable[iRad][iTemp][iVPD];

			// 2ϐLook up table
			if(dH_lut == s_dErrorValue) dH_lut = aryLookUp2_H[iRad2][iTemp2][iVPD2];
			if(dlE_lut == s_dErrorValue) dlE_lut = aryLookUp2_lE[iRad2][iTemp2][iVPD2];
			// if(dNEE_lut == s_dErrorValue) dNEE_lut = aryLookUp2_NEE[iRad2][iTemp2][iVPD2];

			// 1ϐLook up table
			if(dH_lut == s_dErrorValue) dH_lut = aryLookUp3_H[iRad3][iTemp3][iVPD3];
			if(dlE_lut == s_dErrorValue) dlE_lut = aryLookUp3_lE[iRad3][iTemp3][iVPD3];

			// look up table ɂ萄肳ꂽl̂݃f[^Zbg쐬
			aryTable_Dataset_H.push_back(dH_lut);
			aryTable_Dataset_LE.push_back(dlE_lut);
			aryTable_Dataset_NEE.push_back(dNEE_lut);
		}
		// look up table ɂ萄肳ꂽl̂݃f[^Zbgbootstrap zɊi[
		aryHeatFlux->m_aryTable_Dataset_bs.push_back(aryTable_Dataset_H);
		aryLatentFlux->m_aryTable_Dataset_bs.push_back(aryTable_Dataset_LE);
		aryNEE->m_aryTable_Dataset_bs.push_back(aryTable_Dataset_NEE);

		aryTable_Dataset_H.clear();
		aryTable_Dataset_LE.clear();
		aryTable_Dataset_NEE.clear();
	}

	// look up table bootstrap ̕ρEW΍vZ
	for(int iTime = 0; iTime < aryHeatFlux->m_aryTable_Dataset_bs[0].size(); iTime++){
		int iH_num = 0, iLE_num = 0, iNEE_num = 0;
		double dH_tx = 0.0, dLE_tx = 0.0, dNEE_tx = 0.0, dH_txx = 0.0, dLE_txx = 0.0, dNEE_txx = 0.0;
		for(iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
			if(aryHeatFlux->m_aryTable_Dataset_bs[iBootstrap][iTime] != s_dErrorValue){
				dH_tx += aryHeatFlux->m_aryTable_Dataset_bs[iBootstrap][iTime] ;
				dH_txx += aryHeatFlux->m_aryTable_Dataset_bs[iBootstrap][iTime]  * aryHeatFlux->m_aryTable_Dataset_bs[iBootstrap][iTime] ;
				iH_num++;
			}

			if(aryLatentFlux->m_aryTable_Dataset_bs[iBootstrap][iTime] != s_dErrorValue){
				dLE_tx += aryLatentFlux->m_aryTable_Dataset_bs[iBootstrap][iTime] ;
				dLE_txx += aryLatentFlux->m_aryTable_Dataset_bs[iBootstrap][iTime]  * aryLatentFlux->m_aryTable_Dataset_bs[iBootstrap][iTime] ;
				iLE_num++;
			}

			if(aryNEE->m_aryTable_Dataset_bs[iBootstrap][iTime] != s_dErrorValue){
				dNEE_tx += aryNEE->m_aryTable_Dataset_bs[iBootstrap][iTime] ;
				dNEE_txx += aryNEE->m_aryTable_Dataset_bs[iBootstrap][iTime]  * aryNEE->m_aryTable_Dataset_bs[iBootstrap][iTime] ;
				iNEE_num++;
			}
		}
		if(iH_num != 0){
			m_aryDataset[iHeatFlux]->m_aryTable_Dataset.push_back(dH_tx / iH_num );
			m_aryStdev_Table_Dataset_H_bs.push_back(sqrt( (dH_txx - dH_tx * dH_tx / iH_num) / iH_num ));
		}
		else{
			m_aryDataset[iHeatFlux]->m_aryTable_Dataset.push_back(s_dErrorValue);
			m_aryStdev_Table_Dataset_H_bs.push_back(s_dErrorValue);
		}

		if(iLE_num != 0){
			m_aryDataset[iLatentFlux]->m_aryTable_Dataset.push_back(dLE_tx / iLE_num );
			m_aryStdev_Table_Dataset_LE_bs.push_back(sqrt( (dLE_txx - dLE_tx * dLE_tx / iLE_num) / iLE_num ));
		}
		else{
			m_aryDataset[iLatentFlux]->m_aryTable_Dataset.push_back(s_dErrorValue);
			m_aryStdev_Table_Dataset_LE_bs.push_back(s_dErrorValue);
		}

		if(iNEE_num != 0){
			m_aryDataset[iNEE]->m_aryTable_Dataset.push_back(dNEE_tx / iNEE_num );
			m_aryStdev_Table_Dataset_NEE_bs.push_back(sqrt( (dNEE_txx - dNEE_tx * dNEE_tx / iNEE_num) / iNEE_num ));
		}
		else{
			m_aryDataset[iNEE]->m_aryTable_Dataset.push_back(s_dErrorValue);
			m_aryStdev_Table_Dataset_NEE_bs.push_back(s_dErrorValue);
		}

		// ϒlgČ⊮
		// sensitble heat flux
		if((m_aryDataset[iHeatFlux]->GetContinuousDataset())->operator[](iCurrentDate + iTime) == s_dErrorValue){
			m_aryDataset[iHeatFlux]->m_aryLT_Filled_Dataset.push_back(m_aryDataset[iHeatFlux]->m_aryTable_Dataset[iTime]);
		}
		else{
			m_aryDataset[iHeatFlux]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iHeatFlux]->GetContinuousDataset())->operator[](iCurrentDate + iTime));
		}

		// latetnt heat flux
		if((m_aryDataset[iLatentFlux]->GetContinuousDataset())->operator[](iCurrentDate + iTime) == s_dErrorValue){
			m_aryDataset[iLatentFlux]->m_aryLT_Filled_Dataset.push_back(m_aryDataset[iLatentFlux]->m_aryTable_Dataset[iTime]);
		}
		else{
			m_aryDataset[iLatentFlux]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iLatentFlux]->GetContinuousDataset())->operator[](iCurrentDate + iTime));
		}

		// NEE
		if((m_aryDataset[iNEE]->GetContinuousDataset())->operator[](iCurrentDate + iTime) == s_dErrorValue){
			m_aryDataset[iNEE]->m_aryLT_Filled_Dataset.push_back(m_aryDataset[iNEE]->m_aryTable_Dataset[iTime]);
		}
		else{
			m_aryDataset[iNEE]->m_aryLT_Filled_Dataset.push_back((m_aryDataset[iNEE]->GetContinuousDataset())->operator[](iCurrentDate + iTime));
		}
	}

	return TRUE;
}

void CMeanTerm::Create_LookUpTable_flux_bootstrap(CDataset* aryHeatFlux, CDataset* aryLatentFlux, CDataset* aryNEE, CDataset* aryRadiation, CDataset* aryTemperature, CDataset* aryVPD, 
			int iHeatFlux, int iLatentFlux, int iNEE, int iRadiationColumn, int iTemperatureColumn, int iVPDColumn, int& iRad, int& iTemp, int& iVPD,
			std::vector<std::vector<std::vector<double> > >& aryLookUp2_H, std::vector<std::vector<std::vector<double> > >& aryLookUp2_lE, std::vector<std::vector<std::vector<double> > >& aryLookUp2_NEE, std::vector<std::vector<std::vector<double> > >& aryLookUp3_H, std::vector<std::vector<std::vector<double> > >& aryLookUp3_lE,
			int iRadiationFilledColumn, int iTemperatureFilledColumn, int iVPDFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage)
{
	// Look up table ̏
	// 36 x 36 x 36 3z@F1FPPFD, 2: Tair, 3: VPD
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_H;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_lE;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_NEE;
	aryLookUpCount_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// look up table 2ϐp
	std::vector<std::vector<std::vector<double> > > aryLookUpCount2_H;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount2_lE;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount2_NEE;
	aryLookUp2_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUp2_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUp2_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount2_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount2_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount2_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// look up table 1ϐp
	std::vector<std::vector<std::vector<double> > > aryLookUpCount3_H;
	std::vector<std::vector<std::vector<double> > > aryLookUpCount3_lE;
	aryLookUp3_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUp3_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount3_H.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLookUpCount3_lE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	aryHeatFlux->m_aryLookUpTable.clear();
	aryLatentFlux->m_aryLookUpTable.clear();
	aryNEE->m_aryLookUpTable.clear();
	aryHeatFlux->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryLatentFlux->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	aryNEE->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// Look up table ̍쐬
	double dRadiation, dTemperature, dVPD, dDummy = s_dErrorValue;
	int iSize = (aryRadiation->GetContinuousDataset())->size();
	for(int i = 0; i < (aryRadiation->GetContinuousDataset())->size(); i++){
		int iRandam = rand() % iSize;
		dRadiation = (aryRadiation->GetContinuousDataset())->operator[](iRandam);
		dTemperature = (aryTemperature->GetContinuousDataset())->operator[](iRandam);
		dVPD = (aryVPD->GetContinuousDataset())->operator[](iRandam);
		if(dRadiation == s_dErrorValue) continue;
	
		// 1ϐLook up table փf[^i[
		GetIndex_LookUpTable(dRadiation, dDummy, dDummy, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		if((aryHeatFlux->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryLookUp3_H[iRad][iTemp][iVPD] += (aryHeatFlux->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount3_H[iRad][iTemp][iVPD] += 1;
		}

		if((aryLatentFlux->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryLookUp3_lE[iRad][iTemp][iVPD] += (aryLatentFlux->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount3_lE[iRad][iTemp][iVPD] += 1;
		}
		if(dTemperature == s_dErrorValue) continue;

		// 2ϐLook up table փf[^i[
		GetIndex_LookUpTable(dRadiation, dTemperature, dDummy, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		if((aryHeatFlux->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryLookUp2_H[iRad][iTemp][iVPD] += (aryHeatFlux->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount2_H[iRad][iTemp][iVPD] += 1;
		}

		if((aryLatentFlux->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryLookUp2_lE[iRad][iTemp][iVPD] += (aryLatentFlux->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount2_lE[iRad][iTemp][iVPD] += 1;
		}

		if((aryNEE->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryLookUp2_NEE[iRad][iTemp][iVPD] += (aryNEE->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount2_NEE[iRad][iTemp][iVPD] += 1;
		}
		if(dVPD == s_dErrorValue) continue;

		// 3ϐLook up table փf[^i[
		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		if((aryHeatFlux->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryHeatFlux->m_aryLookUpTable[iRad][iTemp][iVPD] += (aryHeatFlux->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount_H[iRad][iTemp][iVPD] += 1;
		}
		if((aryLatentFlux->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryLatentFlux->m_aryLookUpTable[iRad][iTemp][iVPD] += (aryLatentFlux->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount_lE[iRad][iTemp][iVPD] += 1;
		}
		if((aryNEE->GetContinuousDataset())->operator[](iRandam) != s_dErrorValue){
			aryNEE->m_aryLookUpTable[iRad][iTemp][iVPD] += (aryNEE->GetContinuousDataset())->operator[](iRandam);
			aryLookUpCount_NEE[iRad][iTemp][iVPD] += 1;
		}
	}

	// ϒl̍쐬
	for(i = 0; i < 36; i++){
		for(int j = 0; j < 36; j++){
			for(int k = 0; k < 36; k++){
				// 3ϐLook up table
				if(aryLookUpCount_H[i][j][k] == 0.0){
					aryHeatFlux->m_aryLookUpTable[i][j][k] = s_dErrorValue;
				}
				else{
					aryHeatFlux->m_aryLookUpTable[i][j][k] /= aryLookUpCount_H[i][j][k];
				}
				if(aryLookUpCount_lE[i][j][k] == 0.0){
					aryLatentFlux->m_aryLookUpTable[i][j][k] = s_dErrorValue;
				}
				else{
					aryLatentFlux->m_aryLookUpTable[i][j][k] /= aryLookUpCount_lE[i][j][k];
				}
				if(aryLookUpCount_NEE[i][j][k] == 0.0){
					aryNEE->m_aryLookUpTable[i][j][k] = s_dErrorValue;
				}
				else{
					aryNEE->m_aryLookUpTable[i][j][k] /= aryLookUpCount_NEE[i][j][k];
					// ԂCO2 flux ɂȂ́A[Ƃ
					if(aryNEE->m_aryLookUpTable[0][j][k] < 0.0) aryNEE->m_aryLookUpTable[0][j][k] = 0.0;
				}

				// 2ϐLook up table
				if(aryLookUpCount2_H[i][j][k] == 0.0){
					aryLookUp2_H[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp2_H[i][j][k] /= aryLookUpCount2_H[i][j][k];
				}
				if(aryLookUpCount2_lE[i][j][k] == 0.0){
					aryLookUp2_lE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp2_lE[i][j][k] /= aryLookUpCount2_lE[i][j][k];
				}
				if(aryLookUpCount2_NEE[i][j][k] == 0.0){
					aryLookUpCount_NEE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp2_NEE[i][j][k] /= aryLookUpCount2_NEE[i][j][k];
					aryLookUp2_NEE[0][j][k] = s_dErrorValue;				// Ԃ͓ϐł͋߂Ȃ
				}

				// 1ϐLook up table
				if(aryLookUpCount3_H[i][j][k] == 0.0){
					aryLookUp3_H[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp3_H[i][j][k] /= aryLookUpCount3_H[i][j][k];
				}
				if(aryLookUpCount3_lE[i][j][k] == 0.0){
					aryLookUp3_lE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUp3_lE[i][j][k] /= aryLookUpCount3_lE[i][j][k];
				}
			}
		}
	}
}

BOOL CMeanTerm::LookUpTable_respiration(int iNEE, int iRadiationColumn, int iTemperatureColumn, 
			int iRadiationFilledColumn, int iTemperatureFilledColumn, const double& dUpplerNighttimeRadiation, int iRunPerDay, int bMovingAverage)
{
	// Look up table ̏
	// 36 x 36 x 36 3z@F1FPPFD, 2: Tair, 3: VPD
	std::vector<std::vector<std::vector<double> > > aryLookUpCount_NEE;
	aryLookUpCount_NEE.resize( 36, vector<vector<double> >(36 , vector<double>(36)));
	double aryLookUpTableRE[36][36][36];
	for(int i = 0; i < 36; i++){
		for(int j = 0; j < 36; j++){
			for(int k = 0; k < 36; k++){
				// m_aryDataset[iNEE]->m_aryLookUpTable[i][j][k] = 0.0;
				aryLookUpCount_NEE[i][j][k] = 0.0;
				aryLookUpTableRE[i][j][k] = 0.0;
			}
		}
	}
	m_aryDataset[iNEE]->m_aryLookUpTable.resize( 36, vector<vector<double> >(36 , vector<double>(36)));

	// Look up table ̍쐬
	int iRad, iTemp, iVPD;
	double dRadiation, dTemperature;
	double dVPD = 0.0;		// ԂɂVPD ͌Ȃ̂ňl^
	for(i = 0; i < (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->size(); i++){
		dRadiation = (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i);
		dTemperature = (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i);

		if(dRadiation == s_dErrorValue || dTemperature == s_dErrorValue /*|| dVPD == s_dErrorValue*/ || dRadiation > dUpplerNighttimeRadiation){
			continue;
		}
		dRadiation = 0.0;

		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		// Look up table փf[^i[
		if((m_aryDataset[iNEE]->GetContinuousDataset())->operator[](i) != s_dErrorValue){
			aryLookUpTableRE[iRad][iTemp][iVPD] += (m_aryDataset[iNEE]->GetContinuousDataset())->operator[](i);
			aryLookUpCount_NEE[iRad][iTemp][iVPD] += 1;
		}
	}

	// ϒl̍쐬
	for(i = 0; i < 36; i++){
		for(int j = 0; j < 36; j++){
			for(int k = 0; k < 36; k++){
				if(aryLookUpCount_NEE[i][j][k] == 0.0){
					aryLookUpTableRE[i][j][k] = s_dErrorValue;
				}
				else{
					aryLookUpTableRE[i][j][k] /= aryLookUpCount_NEE[i][j][k];
				}
			}
		}
	}

	// Current Date ̃X^[g
	int iCurrentDate = m_aryDataset[iNEE]->get_current_date(m_strCurrentDate);

	// Look up table gRE 𐄒
	int iStart = 0;
	int iEnd = (m_aryDataset[iRadiationFilledColumn]->GetContinuousDataset())->size();
	if(bMovingAverage){
		iStart = iCurrentDate;
		iEnd = iStart + iRunPerDay;
	}

	// vector<double> aryRE;
	for(i = iStart; i < iEnd; i++){
		dRadiation = 0.0;
		dTemperature = (m_aryDataset[iTemperatureFilledColumn]->GetContinuousDataset())->operator[](i);
		dVPD = 0.0;

		if(dRadiation == s_dErrorValue || dTemperature == s_dErrorValue || dVPD == s_dErrorValue){
			m_aryDataset[iNEE]->m_aryRE_lut.push_back(s_dErrorValue);
			continue;
		}

		GetIndex_LookUpTable(dRadiation, dTemperature, dVPD, iRad, iTemp, iVPD, dUpplerNighttimeRadiation);

		m_aryDataset[iNEE]->m_aryRE_lut.push_back(aryLookUpTableRE[iRad][iTemp][iVPD]);
	}
	
	return TRUE;
}

void CMeanTerm::GetIndex_LookUpTable(double& dRadiation, double&dTemperature, double&dVPD, int& iRad, int& iTemp, int& iVPD, const double& dUpplerNighttimeRadiation)
{
	// radiation index
	if(dRadiation < dUpplerNighttimeRadiation){
		iRad = 0;
	}
	else if(dRadiation >= 3400.0){
		iRad = 35;
	}
	else{
		iRad = int(dRadiation) / 100 + 1;
	}
	// temperature index
	if(dTemperature < -25.0){
		iTemp = 0;
	}
	else if(dTemperature >= 60.0){
		iTemp = 35;
	}
	else{
		iTemp = (int(dTemperature * 10) + 250) / 25 + 1;
	}
	// vpd index
	if(dVPD >= 17.5){
		iVPD = 35;
	}
	else if(dVPD < 0.0){
		iVPD = 0;
	}
	else{
		iVPD = int(dVPD * 10) / 5;
	}
}

BOOL CMeanTerm::Eliminate_nighttime_negative(std::vector<int>& aryColumnNum, double dNighttimeRadiation, int iNEEColumn, int iRadiationColumn)
{
	double dRadiation, dNEE;

	for(int i = 0; i < (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->size(); i++){
		dRadiation = (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i);
		dNEE = (m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i);

		if(dRadiation == s_dErrorValue){
			continue;
		}
		// Ԃu* filtering
		if(dRadiation < dNighttimeRadiation && dNEE < 0 ){
			(m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i) = s_dErrorValue;
		}
	}

	return TRUE;
}

BOOL CMeanTerm::Ustar_filtering(std::vector<int>& aryColumnNum, double dNighttimeRadiation, double dUstar_threshold, 
								int iUstarColumn, int iRadiationColumn)
{
	double dRadiation, dUstar;
	int iTarget;

	for(int i = 0; i < (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->size(); i++){
		dRadiation = (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i);
		dUstar = (m_aryDataset[iUstarColumn]->GetContinuousDataset())->operator[](i);

		if(dRadiation == s_dErrorValue){
			continue;
		}
		// Ԃu* filtering
		if(dRadiation < dNighttimeRadiation && ( dUstar < dUstar_threshold || dUstar == s_dErrorValue)){
			for(iTarget = 0; iTarget < aryColumnNum.size(); iTarget++){
				(m_aryDataset[aryColumnNum[iTarget]]->GetContinuousDataset())->operator[](i) = s_dErrorValue;
			}
		}
	}

	return TRUE;
}

BOOL CMeanTerm::VanGorsel_filtering(double dNighttimeRadiation, int iSunsetRunVanGorsel, int iNEEColumn, int iRadiationColumn)
{
	// data screening by van Gorsel et al
	// van Gorsel, E., Leuning, R., Cleugh, H. A., and Keith, H. (2007), 
	//    Nocturnal carbon efflux: reconciliation of eddy covariance and chamber measurements using an alternative to the u*-threshold filtering technique
	//    Tellus, 59B, 397-403.
	double dRadiation, dNEE, dMaxNEE = s_dErrorValue;
	int iConsecutiveNight = 0, iMaxNEE;
	vector<int> arySunsetColumn;
	vector<double> arySunsetNEE;

	for(int i = 0; i < (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->size(); i++){
		dRadiation = (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i);
		dNEE = (m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i);

		if(dRadiation == s_dErrorValue){
			continue;
		}

		if(dRadiation < dNighttimeRadiation){
			iConsecutiveNight++;
		}

		if(dRadiation >= dNighttimeRadiation && iConsecutiveNight == 0){
			continue;
		}

		if(dRadiation >= dNighttimeRadiation && iConsecutiveNight != 0){
			// set maximum NEE
			for(int j = 0; j < arySunsetColumn.size(); j++){
				if(arySunsetNEE[j] > dMaxNEE){
					dMaxNEE = arySunsetNEE[j];
					iMaxNEE = arySunsetColumn[j];
				}
			}

			if(dMaxNEE <= 0){
				iMaxNEE = -1;
			}

			// remove NEE data except Maximum NEE
			for(j = 0; j < arySunsetColumn.size(); j++){
				if(arySunsetColumn[j] != iMaxNEE){
					(m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](arySunsetColumn[j]) = s_dErrorValue;
				}
			}

			// reset internal variables
			dMaxNEE = s_dErrorValue;
			iMaxNEE = -1;
			arySunsetColumn.clear();
			arySunsetNEE.clear();
			iConsecutiveNight = 0;
		}

		// w肳ꂽvȍ~̖ԃf[^ُ͈lƂ
		if(iConsecutiveNight > iSunsetRunVanGorsel){
			(m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i) = s_dErrorValue;
			continue;
		}

		// w肳ꂽv̖ԃf[^őlvZ
		if(iConsecutiveNight <= iSunsetRunVanGorsel && dRadiation < dNighttimeRadiation){
			arySunsetNEE.push_back( (m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i) );
			arySunsetColumn.push_back(i);
		}
	}

	return TRUE;
}

void CMeanTerm::CreatePatternFiles(const CString& strDirPath, int iTermNum, BOOL bIsBootstrap)
{
	CString strPath, strLine, strHeader;

	try{
		for(int i = 0; i < m_aryDataset.size(); i++){
			int iRunNum = 0;
			if(s_aryHeader[i] == ""){
				strHeader.Format("NoName%d",i);
			}
			strHeader = s_aryHeader[i].c_str();
			ReplaceImpossibleChara(strHeader);
			CString strID = "Pattern";
			if(bIsBootstrap == TRUE) strID = "Pattern_bs";
			if(i < 10){
				strPath.Format("%s\\0%d-%s-%d-%s.csv",strDirPath, i, strID, iTermNum, strHeader);
			}else{
				strPath.Format("%s\\%d-%s-%d-%s.csv",strDirPath, i, strID, iTermNum, strHeader);
			}

			
			CStdioFile file(strPath, CFile::modeCreate | CFile::modeWrite);

			// sڂɗLq
			if(bIsBootstrap == FALSE){
				strLine.Format("Date,%s ave,%s stdev,%s num\n",s_aryHeader[i].c_str(), s_aryHeader[i].c_str(), s_aryHeader[i].c_str());
			}
			else{
				strLine.Format("Date,%s ave,%s stdev,%s num, %s upper confidence, %s lower confidence\n",s_aryHeader[i].c_str(), s_aryHeader[i].c_str(), s_aryHeader[i].c_str(), s_aryHeader[i].c_str(), s_aryHeader[i].c_str());
			}
			file.WriteString(strLine);

			while(m_aryDataset[i]->GetOutputPatternFormat(iRunNum, strLine, bIsBootstrap)){
				file.WriteString(strLine);
				iRunNum++;
			}
			file.Close();
			
		}
		
		strPath.Format("%s\\XX-Pattern-%d-ALL.csv",strDirPath, iTermNum);
		CStdioFile file_all(strPath, CFile::modeCreate | CFile::modeWrite);

		CString strOutLine;
		strHeader = "Date,";
		for(int iRunNum = 0; iRunNum < m_aryDataset[0]->GetDiurnalNum(); iRunNum++){
			strOutLine.Format("%d,", iRunNum);

			for(i = 0; i < m_aryDataset.size(); i++ ){
				// sڂɗLq
				if(iRunNum == 0){
					strLine.Format("%s ave",s_aryHeader[i].c_str());
					if(i != m_aryDataset.size() - 1){
						strHeader += (strLine + ',');
					}
					else{
						strHeader += (strLine + '\n');
						file_all.WriteString(strHeader);
					}					
				}

				m_aryDataset[i]->GetDiurnalAverage(iRunNum, strLine);
				if(i != m_aryDataset.size() -1 ){
					strOutLine += (strLine + ',');
				}
				else{
					strOutLine += (strLine + '\n');
					file_all.WriteString(strOutLine);
				}
			}
		}

		file_all.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

void CMeanTerm::WriteGapFilledData(const CString& strDirPath, int iTermNum, int iDataType, BOOL bMovingAverage)
{
	CString strLine, strHeader, strPath;
	strLine.Format("\\Results_%d.csv", iTermNum);
	strPath = strDirPath + strLine;

	try{
		CStdioFile file(strPath, CFile::modeCreate | CFile::modeWrite);

		vector<CString> aryResultLine;

		// wb_[f[^̋Lq
		file.WriteString(m_strHeader + "\n");

		// lf[^̋Lq
		WriteDataset(file, iDataType, bMovingAverage);

		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

void CMeanTerm::WriteFlagFile(const CString& strDirPath, int iTermNum)
{
	CString strLine, strHeader, strPath;
	strLine.Format("\\Flag%d.csv", iTermNum);
	strPath = strDirPath + strLine;

	try{
		CStdioFile file(strPath, CFile::modeCreate | CFile::modeWrite);

		vector<CString> aryResultLine;

		// wb_[f[^̋Lq
		file.WriteString(m_strHeader + "\n");

		// lf[^̋Lq
		for(int i = 0; i < m_aryDataset.size(); i++){
			if(i == 0){
				m_aryDataset[i]->GetFlagData(aryResultLine, TRUE);		
			}else{
				m_aryDataset[i]->GetFlagData(aryResultLine, FALSE);
			}
		}

		for(i = 0; i < aryResultLine.size(); i++){
			file.WriteString(aryResultLine[i] + "\n");
		}

		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

void CMeanTerm::WriteBootstrapAverage(const CString& strDirPath, int iTermNum)
{
	CString strLine, strHeader, strPath;
	strLine.Format("\\Bootstrap_mean%d.csv", iTermNum);
	strPath = strDirPath + strLine;

	try{
		CStdioFile file(strPath, CFile::modeCreate | CFile::modeWrite);

		vector<CString> aryResultLine;

		// wb_[f[^̋Lq
		file.WriteString(m_strHeader + "\n");

		// lf[^̋Lq
		for(int i = 0; i < m_aryDataset.size(); i++){
			if(i == 0){
				m_aryDataset[i]->GetBootstrapMean(aryResultLine, TRUE);		
			}else{
				m_aryDataset[i]->GetBootstrapMean(aryResultLine, FALSE);
			}
		}

		for(i = 0; i < aryResultLine.size(); i++){
			file.WriteString(aryResultLine[i] + "\n");
		}

		file.Close();
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
	}
}

BOOL CMeanTerm::WriteStringBoostrapFinal(CStdioFile& outFile, int iHeatFlux, int iLatentFlux, int iNEEraw, int iGPP2, int iRE2, BOOL bMovingAverage)
{
	BOOL bIsOK = TRUE;
	CString strLine;

	int iCurrentDate = m_aryDataset[iHeatFlux]->get_current_date(m_strCurrentDate);
	int iStart = 0;
	int iEnd = m_iRunPerDay;

	if(bMovingAverage == FALSE){
		iCurrentDate = 0;
		iEnd = GetDataset(iHeatFlux)->m_aryContinuousDate.size();
	}

	try{
		for(int i = iStart; i < iEnd; i++){
			strLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf\n", 
				GetDataset(iHeatFlux)->m_aryContinuousDate[iCurrentDate + i], 
				GetDataset(iHeatFlux)->m_aryAverage_Final_Dataset[i], 
				GetDataset(iLatentFlux)->m_aryAverage_Final_Dataset[i], 
				GetDataset(iNEEraw)->m_aryAverage_Final_Dataset[i], 
				GetDataset(iGPP2)->m_aryAverage_Final_Dataset[i], 
				GetDataset(iRE2)->m_aryAverage_Final_Dataset[i], 
				GetDataset(iHeatFlux)->m_aryStdev_Final_Dataset[i], 
				GetDataset(iLatentFlux)->m_aryStdev_Final_Dataset[i], 
				GetDataset(iNEEraw)->m_aryStdev_Final_Dataset[i],
				GetDataset(iGPP2)->m_aryStdev_Final_Dataset[i],
				GetDataset(iRE2)->m_aryStdev_Final_Dataset[i]);
			outFile.WriteString(strLine);
		}
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bIsOK = FALSE;
	}
	return bIsOK;
}

BOOL CMeanTerm::WriteStringUncertaintyDay(CStdioFile& outFile, int iHeatFlux, int iLatentFlux, int iNEEraw, int iGPP2, int iRE2, BOOL bMovingAverage)
{
	BOOL bIsOK = TRUE;
	CString strLine;

	int iCurrentDate = m_aryDataset[iHeatFlux]->get_current_date(m_strCurrentDate);
	int iStart = 0;
	int iEnd = m_iRunPerDay;
	double dHeatFlux, dLatentFlux, dNEE, dGPP, dRE;
	double dHeatFlux_stdev, dLatentFlux_stdev, dNEE_stdev, dGPP_stdev, dRE_stdev;

	try{
		if(bMovingAverage == TRUE){
			GetDataset(iHeatFlux)->Average_Stdev_BootstrapData_daily(iStart, iEnd, dHeatFlux, dHeatFlux_stdev);
			GetDataset(iLatentFlux)->Average_Stdev_BootstrapData_daily(iStart, iEnd, dLatentFlux, dLatentFlux_stdev);
			GetDataset(iNEEraw)->Average_Stdev_BootstrapData_daily(iStart, iEnd, dNEE, dNEE_stdev);
			GetDataset(iGPP2)->Average_Stdev_BootstrapData_daily(iStart, iEnd, dGPP, dGPP_stdev);
			GetDataset(iRE2)->Average_Stdev_BootstrapData_daily(iStart, iEnd, dRE, dRE_stdev);

			strLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf\n", 
						m_strCurrentDate, dHeatFlux, dLatentFlux, dNEE, dGPP, dRE, 
						dHeatFlux_stdev, dLatentFlux_stdev, dNEE_stdev, dGPP_stdev, dRE_stdev);
			outFile.WriteString(strLine);
		}
		else{
			iEnd = GetDataset(iHeatFlux)->m_aryContinuousDate.size() / m_iRunPerDay;
			CString strDate;

			for(int iStart = 0; iStart < iEnd; iStart++){
				strDate = GetDataset(iHeatFlux)->m_aryContinuousDate[iStart * m_iRunPerDay];
				GetDataset(iHeatFlux)->Average_Stdev_BootstrapData_daily(iStart, iStart + m_iRunPerDay, dHeatFlux, dHeatFlux_stdev);
				GetDataset(iLatentFlux)->Average_Stdev_BootstrapData_daily(iStart, iStart + m_iRunPerDay, dLatentFlux, dLatentFlux_stdev);
				GetDataset(iNEEraw)->Average_Stdev_BootstrapData_daily(iStart, iStart + m_iRunPerDay, dNEE, dNEE_stdev);
				GetDataset(iGPP2)->Average_Stdev_BootstrapData_daily(iStart, iStart + m_iRunPerDay, dGPP, dGPP_stdev);
				GetDataset(iRE2)->Average_Stdev_BootstrapData_daily(iStart, iStart + m_iRunPerDay, dRE, dRE_stdev);

				strLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf\n", 
						strDate, dHeatFlux, dLatentFlux, dNEE, dGPP, dRE, 
						dHeatFlux_stdev, dLatentFlux_stdev, dNEE_stdev, dGPP_stdev, dRE_stdev);
				outFile.WriteString(strLine);
			}
		}
	}
	catch(CException* e){
		e->ReportError();
		e->Delete();
		bIsOK = FALSE;
	}
	return bIsOK;
}

void CMeanTerm::ForBootstrapAnnualMeanStdev(const int iData, double& dTx, int& iNum, int iBootstrap)
{
	int iStart = 0;
	int iEnd = m_iRunPerDay;

	for(int i = iStart; i < iEnd; i++){
		if(GetDataset(iData)->m_aryDataset_final_bs[iBootstrap][i] != s_dErrorValue){
			dTx += GetDataset(iData)->m_aryDataset_final_bs[iBootstrap][i];
			iNum++;
		}
	}
}

void CMeanTerm::WriteQualityFlag(CStdioFile& fileFlag, CStdioFile& fileResult, BOOL bMovingAverage)
{
	vector<CString> aryResultLine;
	vector<CString> aryFlagLine;

	// lf[^̋Lq
	for(int i = 0; i < m_aryDataset.size(); i++){
		if(i == 0){
			// JڂDate Lq
			m_aryDataset[i]->GetQCFlagData(aryFlagLine, aryResultLine, m_strCurrentDate, m_iRunPerDay, TRUE, bMovingAverage);
		}else{
			// Jȍ~Date LqȂ
			m_aryDataset[i]->GetQCFlagData(aryFlagLine, aryResultLine, m_strCurrentDate, m_iRunPerDay, FALSE, bMovingAverage);
		}
	}
	
	try{		
		for(i = 0; i < aryFlagLine.size(); i++){
			fileFlag.WriteString(aryFlagLine[i] + "\n");
			fileResult.WriteString(aryResultLine[i] + "\n");
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::CompleteResultsAndFlagFile(CStdioFile &fileAllResult, CStdioFile &fileAllFlag, BOOL bMovingAverage)
{
	vector<CString> aryResultLine, aryFlagLine;
	int iDataType = 1;
	// BOOL bMovingAverage = FALSE;

	// lf[^̋Lq
	for(int i = 0; i < m_aryDataset.size(); i++){
		if(i == 0){
			// JڂDate Lq
			// m_aryDataset[i]->GetContinuousData(aryResultLine, TRUE);
			m_aryDataset[i]->GetFilledData(aryResultLine, iDataType, m_strCurrentDate, TRUE, bMovingAverage);
			m_aryDataset[i]->GetFlagData(aryFlagLine, TRUE);
		}else{
			// Jȍ~Date LqȂ
			// m_aryDataset[i]->GetContinuousData(aryResultLine, FALSE);
			m_aryDataset[i]->GetFilledData(aryResultLine, iDataType, m_strCurrentDate, FALSE, bMovingAverage);
			m_aryDataset[i]->GetFlagData(aryFlagLine, FALSE);
		}
	}

	try{
		for(i = 0; i < aryResultLine.size(); i++){
			fileAllResult.WriteString(aryResultLine[i] + "\n");
			fileAllFlag.WriteString(aryFlagLine[i] + "\n");
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::CompleteResultsAndFlagFile_LT(CStdioFile &fileResult, CStdioFile &fileFlag, CStdioFile &fileTable, BOOL bMovingAverage)
{
	vector<CString> aryResultLine, aryFlagLine, aryTableLine;
	int iDataType_filled = 2;		// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4, flag : 5)
	int iDataType_table = 4;		// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4, flag : 5)
	int iDataType_flag = 5;			// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4, flag : 5)
	// BOOL bMovingAverage = FALSE;

	// lf[^̋Lq
	for(int i = 0; i < m_aryDataset.size(); i++){
		if(i == 0){
			// JڂDate Lq
			m_aryDataset[i]->GetFilledData(aryResultLine, iDataType_filled, m_strCurrentDate, TRUE, bMovingAverage);
			m_aryDataset[i]->GetFilledData(aryFlagLine, iDataType_flag, m_strCurrentDate, TRUE, bMovingAverage);
			m_aryDataset[i]->GetFilledData(aryTableLine, iDataType_table, m_strCurrentDate, TRUE, bMovingAverage);
		}else{
			// Jȍ~Date LqȂ
			m_aryDataset[i]->GetFilledData(aryResultLine, iDataType_filled, m_strCurrentDate, FALSE, bMovingAverage);
			m_aryDataset[i]->GetFilledData(aryFlagLine, iDataType_flag, m_strCurrentDate, FALSE, bMovingAverage);
			m_aryDataset[i]->GetFilledData(aryTableLine, iDataType_table, m_strCurrentDate, FALSE, bMovingAverage);
		}
	}

	try{
		for(i = 0; i < aryResultLine.size(); i++){
			fileResult.WriteString(aryResultLine[i] + "\n");
			fileFlag.WriteString(aryFlagLine[i] + "\n");
			fileTable.WriteString(aryTableLine[i] + "\n");
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::WriteBootstrapAllAverageFile(CStdioFile &fileAllBootstrap)
{
	vector<CString> aryResultLine;
	int iDataType = 1;
	CString strLine, strTemp;
	// int iSize = m_aryBootstrapMeanAll_mdv[j].size()

	try{
		for(int i = 0; i < m_aryBootstrapMeanAll_mdv[0].size(); i++){
			strLine.Format("%d,",i);
			for(int j = 0; j < m_aryBootstrapMeanAll_mdv.size(); j++){
				if (j != m_aryBootstrapMeanAll_mdv[j].size() - 1){
					strTemp.Format("%lf,", m_aryBootstrapMeanAll_mdv[j][i]);
				}
				else{
					strTemp.Format("%lf", m_aryBootstrapMeanAll_mdv[j][i]);
				}
				strLine += strTemp;
			}
			strLine += "\n";
			fileAllBootstrap.WriteString(strLine);
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::WriteDataset(CStdioFile &fileAllResult, int iDataType, BOOL bMovingAverage)
{
	vector<CString> aryResultLine;
	// int iDataType = 1;	// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4)

	// lf[^̋Lq
	for(int i = 0; i < m_aryDataset.size(); i++){
		if(i == 0){
			// JڂDate Lq
			// m_aryDataset[i]->GetContinuousData(aryResultLine, TRUE);
			m_aryDataset[i]->GetFilledData(aryResultLine, iDataType, m_strCurrentDate, TRUE, bMovingAverage);
		}else{
			// Jȍ~Date LqȂ
			// m_aryDataset[i]->GetContinuousData(aryResultLine, FALSE);
			m_aryDataset[i]->GetFilledData(aryResultLine, iDataType, m_strCurrentDate, FALSE, bMovingAverage);
		}
	}

	try{
		for(i = 0; i < aryResultLine.size(); i++){
			fileAllResult.WriteString(aryResultLine[i] + "\n");
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::WriteGapFilledCarbonFlux(CStdioFile &fileAllResult, std::vector<int>& aryOutColumnNum)
{
	vector<CString> aryResultLine;

	for(int i = 0; i < aryOutColumnNum.size(); i++){
		if(i == 0){
			// JڂDate Lq
			m_aryDataset[aryOutColumnNum[i]]->GetContinuousData(aryResultLine, TRUE);
		}
		else{
			// Jȍ~Date LqȂ
			m_aryDataset[aryOutColumnNum[i]]->GetContinuousData(aryResultLine, FALSE);
		}
	}

	try{
		for(i = 0; i < aryResultLine.size(); i++){
			fileAllResult.WriteString(aryResultLine[i] + "\n");
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::WriteGapFilledCarbonFlux_mdv_lt(CStdioFile &fileAllResult, std::vector<int>& aryOutColumnNum, BOOL bMovingAverage, BOOL bBootstrap)
{
	vector<CString> aryResultLine;

	// wb_[
	// "Date, H_raw, lE_raw, NEE_raw, H_mdv, lE_mdv, NEE_mdv, H_lt, lE_lt, NEE_lt, "
	//  "H_pattern, lE_pattern, NEE_parttern, H_table, lE_table, NEE_table\n"

	// iDataType (raw : 0, mdv : 1, lt : 2, pattern : 3, table : 4)
	for(int iDataType = 0; iDataType <= 4; iDataType++){
		for(int i = 0; i < aryOutColumnNum.size(); i++){		
			if(i == 0 && iDataType == 0){
				// JڂDate Lq
				m_aryDataset[aryOutColumnNum[i]]->GetFilledData(aryResultLine, iDataType, m_strCurrentDate, TRUE, bMovingAverage);
			}
			else{
				// Jȍ~Date LqȂ
				m_aryDataset[aryOutColumnNum[i]]->GetFilledData(aryResultLine, iDataType, m_strCurrentDate, FALSE, bMovingAverage);
			}
		}
	}

	// Flux partitioning ̌ʂo͂
	if(bBootstrap == FALSE){
		int iNEEColumnt = 3;
		BOOL bError = FALSE;
		if(m_aryDataset[iNEEColumnt]->m_aryRE_lut.size() != 0){
			CString strPartitioning;
			int iNEEColumnt = 3;
			double dGPP, dNEE, dRE;

			int iStart = 0;
			int iRunPerDay = m_aryDataset[iNEEColumnt]->m_aryLT_Filled_Dataset.size();
			int iEnd = (m_aryDataset[iNEEColumnt]->GetContinuousDataset())->size();

			if(bMovingAverage){
				iStart = m_aryDataset[iNEEColumnt]->get_current_date(m_strCurrentDate);
				iEnd = iStart + iRunPerDay;
			}

			for(int i = iStart; i < iEnd; i++){
				dRE  = m_aryDataset[iNEEColumnt]->m_aryRE_lut[i - iStart];
				dNEE = (m_aryDataset[iNEEColumnt]->GetContinuousDataset())->operator[](i);
				if(dNEE == s_dErrorValue) dNEE = m_aryDataset[iNEEColumnt]->m_aryLT_Filled_Dataset[i - iStart];

				dGPP = dRE - dNEE;
				
				if(dGPP < 0){
					dRE -= dGPP;
					dGPP = 0;
				}
				if(dRE < 0){
					dRE = s_dErrorValue;
					dGPP = s_dErrorValue;
				}
				if(dNEE == s_dErrorValue || dGPP == s_dErrorValue || dRE == s_dErrorValue){
					dGPP = s_dErrorValue;
					dRE  = s_dErrorValue;
				}
				
				strPartitioning.Format(",%lf,%lf", dGPP, dRE);
				if((i - iStart) < aryResultLine.size()){	// Add for 2010.09.10 from Dr. Ono-san comment
					aryResultLine[i - iStart] = aryResultLine[i - iStart] + strPartitioning;
				}
				else{
					bError = TRUE;
				}
			}
		}
		if(bError){
			AfxMessageBox("Error occured, run per day should be checked!");
		}
	}

	// C̏o
	try{
		for(int i = 0; i < aryResultLine.size(); i++){
			fileAllResult.WriteString(aryResultLine[i] + "\n");
		}
	}
	catch(CException *e){
		throw(e);
	}
}

void CMeanTerm::ReplaceImpossibleChara(CString& strString)
{
	// ṕuFD^bHv́AWindows ̃t@CƂĎgpłȂ߁ASpŒu
	strString.Replace("\\","");
	strString.Replace(":","F");
	strString.Replace(".","D");
	strString.Replace("/","^");
	strString.Replace("|","b");
	strString.Replace("<","");
	strString.Replace(">","");
	strString.Replace("*","");
	strString.Replace("?","H");
}

// ***************************************************************************************************
//  ֘Ã[`
// ***************************************************************************************************

/*BOOL CMeanTerm::DetermineLightPhotosynthesisCurve(BOOL bSetMaximumB, const double& dMaximumB, const double& dC, 
		const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParamters& FixedPrm)
{
	// f[^ 1 J : 
	// f[^ 2 J : ˗
	// f[^ 3 J :  (NEE) ƂB
	vector<double>* aryRadiation = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryPhotosynthesis = m_aryDataset[iPhotosynthesisColumn]->GetContinuousDataset();

	double dRadiation = 0.0;
	double dPhotosynthesis = 0.0;
	double dErrorValue;
	double dUpperLimitAmax = 0.0, dSclaeAmax = 0.0;
	double dUpperLimitB = 0.0, dSclaeB = 0.0;
	double dOldAmax = -9999999999, dOldB = -9999999999;
	double dB = 0.0;
	double dNewStartB = 0.0;
	double dStartB;
	double dAmax = 0.0;
	double dR0 = 0.0;
	double dStartAmax = 0.00001;
	int iNumDivide = 50;
	
	double dMinimumRMSE = 9999999999.9;
	int iMinimumRMSE;
	double dOldRMSE = 9999999999.9;
	const int iMaximumLoopCount = 20;

	double dRMSE = 0.0;
	double dCoefficientCorrelation;
	int iCount = 0, iLoopCount = 0;

	dErrorValue = m_aryDataset[0]->GetErrorValue();

	
	// Use Nagative Values
	if(bUseNegativeValues){
		for(int i = 0; i < aryPhotosynthesis->size(); i++){
			if(aryPhotosynthesis->operator[](i) != dErrorValue){
				aryPhotosynthesis->operator[](i) = (-1) * aryPhotosynthesis->operator[](i);
			}				
		}
	}

	if(bUseFixedData == FALSE || FixedPrm.m_iFixed_R0 == FALSE){
		// Calculate R0
		if(bCalculateR0){
			 dR0 = CalculateR0(aryRadiation, aryPhotosynthesis, dNighttimeRadiation, dErrorValue);
		}
	}
	else{
		dR0 = FixedPrm.m_dR0;
		if(bUseNegativeValues) dR0 = -dR0;
	}

	if(bUseFixedData == FALSE || FixedPrm.m_iFixed_Pmax_B == FALSE){
		// Determine the Upper Limit and Scale Variables
		// dUpperLimitAmax = GetMaxValue(aryPhotosynthesis);
		dUpperLimitAmax = GetDaytimeMaxValue(aryPhotosynthesis, aryRadiation);
		dUpperLimitB = GetMaxValue(aryRadiation);
		
		if(dUpperLimitAmax == dErrorValue || dUpperLimitB == dErrorValue || aryRadiation->size() == 0 || dUpperLimitB == 0){
			// SĂ̏ꍇ
			m_PhotosynthesisParameters.m_dB = dErrorValue;
			m_PhotosynthesisParameters.m_dMaximumPhotosynthesis = dErrorValue;
			m_PhotosynthesisParameters.m_dR0 = dErrorValue;
			m_PhotosynthesisParameters.m_dRMSE = dErrorValue;
			m_PhotosynthesisParameters.m_iCount = dErrorValue;
			return TRUE;
		}
		else{
			dUpperLimitB = dUpperLimitAmax / (dUpperLimitB / 10);
			dSclaeAmax = dUpperLimitAmax / iNumDivide;
			dSclaeB = dUpperLimitB / iNumDivide;
			if(bSetMaximumB && dUpperLimitB > dMaximumB){
				dUpperLimitB = dMaximumB;
				double dScaleB_new = dUpperLimitB / iNumDivide;
				if(dScaleB_new < dSclaeB){
					dSclaeB = dScaleB_new;
				}
			}
			dB = dSclaeB;
		}

		// Determine Amax and b
		while(iLoopCount < iMaximumLoopCount){
			// Determine Amax
			dRMSE = 0.0;
			dMinimumRMSE = 999999999.9;
			dAmax = 0;
			// b 1Ō܂ɂ̂ŁAxgČ߂ȂB
			if(iLoopCount == 0 && iCount == 0){
				dB = dSclaeB;;
			}
			else if(iLoopCount != 0 && iCount == 0){
				dB = dNewStartB;
			}
			else{
				dB = dB;
			}

			for(int iData = 0; iData < iNumDivide; iData++){
				dAmax = dStartAmax + iData * dSclaeAmax;
				dRMSE = 0.0;
				for(int i = 0; i < aryRadiation->size(); i++){
					dRadiation      = aryRadiation->operator[](i);
					dPhotosynthesis = aryPhotosynthesis->operator[](i);			

					if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
						continue;
					}
					dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);				
				}
				if(dMinimumRMSE > dRMSE){
					iMinimumRMSE = iData;
					dMinimumRMSE = dRMSE;
				}
			}
			dAmax = iMinimumRMSE * dSclaeAmax;


			// Determine b
			dRMSE = 0.0;
			dMinimumRMSE = 9999999999.9;
			dStartB = dB;
			for(iData = 0; iData < iNumDivide; iData++){
				if(dB < dUpperLimitB) dB = dStartB + iData * dSclaeB;
				dRMSE = 0.0;
				for(int i = 0; i < aryRadiation->size(); i++){
					dRadiation      = aryRadiation->operator[](i);
					dPhotosynthesis = aryPhotosynthesis->operator[](i);		// zvXAo}CiX	

					if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
						continue;
					}
					dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);				
				}
				if(dMinimumRMSE > dRMSE){
					iMinimumRMSE = iData;
					dMinimumRMSE = dRMSE;
				}
				if(dB >= dUpperLimitB){
					dB = dUpperLimitB;		// Add at 2008.10.10
					break;
				}	
			}
			dB = dStartB + iMinimumRMSE * dSclaeB;

			// [vh~
			iCount++;
			if(((abs(dOldAmax - dAmax) < dSclaeAmax / 2.) && (abs(dOldB - dB) < dSclaeB / 2.)) || iCount > 100 || dB > dUpperLimitB){
				// Calculate RMSE
				for(int i = 0; i < aryRadiation->size(); i++){
					dRadiation      = aryRadiation->operator[](i);
					dPhotosynthesis = aryPhotosynthesis->operator[](i);			

					if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
						continue;
					}
					dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);				
				}
				if(dOldRMSE > dRMSE && dB < dUpperLimitB){
					dOldRMSE = dRMSE;
					iCount = 0;
					dNewStartB = dB;
				}
				else{
					break;
				}
				iLoopCount++;
			}
			else{
				dOldAmax = dAmax;
				dOldB = dB;
			}
		}

		if(dB >= dUpperLimitB){
			dB = dUpperLimitB;		// Add at 2008.10.10
		}
	}
	else{
		dB = FixedPrm.m_dB;
		dAmax = FixedPrm.m_dMaximumPhotosynthesis;
	}


	// RMSE and ֌W̌vZ
	iLoopCount = iCount;
	iCount = 0;
	vector<double> aryPhotosynthesis_observation;
	vector<double> aryPhotosynthesis_Model;
	double dPhotosynthesis_model;
	for(int i = 0; i < aryRadiation->size(); i++){
		if(aryRadiation->operator[](i) != dErrorValue && aryPhotosynthesis->operator[](i) != dErrorValue){
			// ֌W
			double dPhotosynthesis_obs = aryPhotosynthesis->operator[](i);
			aryPhotosynthesis_observation.push_back(aryPhotosynthesis->operator[](i));
			if(bUseNonRectangular == 0){
				dPhotosynthesis_model = (dAmax * aryRadiation->operator[](i)) / (aryRadiation->operator[](i) + dAmax / dB) + dR0;
			}
			else{
				dPhotosynthesis_model = ((dB * aryRadiation->operator[](i) + dAmax - sqrt(pow(dB * aryRadiation->operator[](i) + dAmax, 2) - 4 * dB * aryRadiation->operator[](i) * dC * dAmax)) / (2 * dC)) + dR0;
			}
			aryPhotosynthesis_Model.push_back(dPhotosynthesis_model);

			// RMSE
			dRadiation      = aryRadiation->operator[](i);
			dPhotosynthesis = aryPhotosynthesis->operator[](i);	
			dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);
			iCount++;
		}
	}
	dCoefficientCorrelation = coefficient_correlation(aryPhotosynthesis_observation, aryPhotosynthesis_Model);
	dRMSE = sqrt(dRMSE / iCount);

	// f[^̍XV
	m_PhotosynthesisParameters.m_dB = dB;
	m_PhotosynthesisParameters.m_dMaximumPhotosynthesis = dAmax;
	m_PhotosynthesisParameters.m_dR0 = dR0;
	m_PhotosynthesisParameters.m_dRMSE = dRMSE;
	m_PhotosynthesisParameters.m_dCoefficientCorrelation = dErrorValue;
	m_PhotosynthesisParameters.m_iDataNum = iCount;
	m_PhotosynthesisParameters.m_dCoefficientCorrelation = dCoefficientCorrelation;
	if(iLoopCount >= iMaximumLoopCount){
		m_PhotosynthesisParameters.m_iCount = dErrorValue;
	}
	else{
		m_PhotosynthesisParameters.m_iCount = iLoopCount;
	}

	return TRUE;
}*/

BOOL CMeanTerm::DetermineLightPhotosynthesisCurve(BOOL bSetMaximumB, const double& dMaximumB, const double& dC, 
		const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParameters& FixedPrm)
{
	// f[^ 1 J : 
	// f[^ 2 J : ˗
	// f[^ 3 J :  (NEE) ƂB
	vector<double>* aryRadiation = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryPhotosynthesis = m_aryDataset[iPhotosynthesisColumn]->GetContinuousDataset();

	double dB = 0.0;
	double dAmax = 0.0;
	double dR0 = 0.0;
	double dRMSE = 0.0;
	double dCoefficientCorrelation;
	int iCount = 0, iLoopCount = 0;
	const int iMaximumLoopCount = 20;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();

	DetermineLightPhotosynthesisCurve(aryRadiation, aryPhotosynthesis,
        bSetMaximumB, dMaximumB, dC, dNighttimeRadiation, bCalculateR0, bUseNegativeValues, bUseNonRectangular, iRadiationColumn, iPhotosynthesisColumn, bUseFixedData, FixedPrm, dB, dAmax, dR0, dRMSE, dCoefficientCorrelation, iCount, iLoopCount);

	// f[^̍XV
	m_PhotosynthesisParameters.m_dB = dB;
	m_PhotosynthesisParameters.m_dMaximumPhotosynthesis = dAmax;
	m_PhotosynthesisParameters.m_dR0 = dR0;
	m_PhotosynthesisParameters.m_dRMSE = dRMSE;
	m_PhotosynthesisParameters.m_iDataNum = iCount;
	m_PhotosynthesisParameters.m_dCoefficientCorrelation = dCoefficientCorrelation;
	if(iLoopCount >= iMaximumLoopCount){
		m_PhotosynthesisParameters.m_iCount = dErrorValue;
	}
	else{
		m_PhotosynthesisParameters.m_iCount = iLoopCount;
	}

	return TRUE;
}

BOOL CMeanTerm::DetermineLightPhotosynthesisCurve_bootstrap(BOOL bSetMaximumB, const double& dMaximumB, const double& dC, 
		const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParameters& FixedPrm, int iBootstrapNum)
{
	// f[^ 1 J : 
	// f[^ 2 J : ˗
	// f[^ 3 J :  (NEE) ƂB
	vector<double>* aryRadiation = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryPhotosynthesis = m_aryDataset[iPhotosynthesisColumn]->GetContinuousDataset();

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		double dB = 0.0;
		double dAmax = 0.0;
		double dR0 = 0.0;
		double dRMSE = 0.0;
		double dCoefficientCorrelation;
		int iCount = 0, iLoopCount = 0;
		const int iMaximumLoopCount = 20;
		double dErrorValue = m_aryDataset[0]->GetErrorValue();

		// boot strap @
		vector<double> aryRadiationBootstrap;
		vector<double> aryPhotosynthesisBootstrap;
		int iSize = aryRadiation->size();
		int iRandam;
		for(int i = 0; i < iSize; i++){
			iRandam = rand() % iSize;
			aryRadiationBootstrap.push_back((*aryRadiation)[iRandam]);
			aryPhotosynthesisBootstrap.push_back((*aryPhotosynthesis)[iRandam]);
			double Radiation = (*aryRadiation)[iRandam];
			double NEE = (*aryPhotosynthesis)[iRandam];
		}

		DetermineLightPhotosynthesisCurve(&aryRadiationBootstrap, &aryPhotosynthesisBootstrap,
			bSetMaximumB, dMaximumB, dC, dNighttimeRadiation, bCalculateR0, bUseNegativeValues, bUseNonRectangular, iRadiationColumn, iPhotosynthesisColumn, bUseFixedData, FixedPrm, dB, dAmax, dR0, dRMSE, dCoefficientCorrelation, iCount, iLoopCount);

		// f[^̍XV
		CPhotosynthesisParameters cPhotosynthesisParameters;
		cPhotosynthesisParameters.m_dMaximumPhotosynthesis = dAmax;
		cPhotosynthesisParameters.m_dB = dB;
		cPhotosynthesisParameters.m_dR0 = dR0;
		cPhotosynthesisParameters.m_dRMSE = dRMSE;
		cPhotosynthesisParameters.m_iDataNum = iCount;
		cPhotosynthesisParameters.m_dCoefficientCorrelation = dCoefficientCorrelation;
		if(iLoopCount >= iMaximumLoopCount){
			cPhotosynthesisParameters.m_iCount = dErrorValue;
		}
		else{
			cPhotosynthesisParameters.m_iCount = iLoopCount;
		}

		m_aryPhotosynthesisParameters_bootstrap.push_back(cPhotosynthesisParameters);
	}

	return TRUE;
}

void CMeanTerm::DetermineLightPhotosynthesisCurve(std::vector<double>* aryRadiation, std::vector<double>* aryPhotosynthesis,
        BOOL bSetMaximumB, const double& dMaximumB, const double& dC, 
		const double& dNighttimeRadiation, BOOL bCalculateR0, BOOL bUseNegativeValues, BOOL bUseNonRectangular, 
		int iRadiationColumn, int iPhotosynthesisColumn, BOOL bUseFixedData, const CPhotosynthesisParameters& FixedPrm,
		double& dB, double& dAmax, double& dR0, double& dRMSE, double& dCoefficientCorrelation, int& iCount, int& iLoopCount)
{
	double dRadiation = 0.0;
	double dPhotosynthesis = 0.0;
	double dErrorValue;
	double dUpperLimitAmax = 0.0, dSclaeAmax = 0.0;
	double dUpperLimitB = 0.0, dSclaeB = 0.0;
	double dOldAmax = -9999999999, dOldB = -9999999999;
	double dNewStartB = 0.0;
	double dStartB;
	double dStartAmax = 0.00001;
	int iNumDivide = 50;
	
	double dMinimumRMSE = 9999999999.9;
	int iMinimumRMSE;
	double dOldRMSE = 9999999999.9;
	const int iMaximumLoopCount = 20;

	dErrorValue = m_aryDataset[0]->GetErrorValue();

	// Use Nagative Values
	if(bUseNegativeValues){
		for(int i = 0; i < aryPhotosynthesis->size(); i++){
			if(aryPhotosynthesis->operator[](i) != dErrorValue){
				aryPhotosynthesis->operator[](i) = (-1) * aryPhotosynthesis->operator[](i);
			}				
		}
	}

	if(bUseFixedData == FALSE || FixedPrm.m_iFixed_R0 == FALSE){
		// Calculate R0
		if(bCalculateR0){
			 dR0 = CalculateR0(aryRadiation, aryPhotosynthesis, dNighttimeRadiation, dErrorValue);
		}
	}
	else{
		dR0 = FixedPrm.m_dR0;
		if(bUseNegativeValues) dR0 = -dR0;
	}

	if(bUseFixedData == FALSE || FixedPrm.m_iFixed_Pmax_B == FALSE){
		// Determine the Upper Limit and Scale Variables
		// dUpperLimitAmax = GetMaxValue(aryPhotosynthesis);
		dUpperLimitAmax = GetDaytimeMaxValue(aryPhotosynthesis, aryRadiation);
		dUpperLimitB = GetMaxValue(aryRadiation);
		
		if(dUpperLimitAmax == dErrorValue || dUpperLimitB == dErrorValue || aryRadiation->size() == 0 || dUpperLimitB == 0){
			// SĂ̏ꍇ
			dB = dErrorValue;
			dAmax = dErrorValue;
			dR0 = dErrorValue;
			dRMSE = dErrorValue;
			iCount = dErrorValue;
			return;
		}
		else{
			dUpperLimitB = dUpperLimitAmax / (dUpperLimitB / 10);
			dSclaeAmax = dUpperLimitAmax / iNumDivide;
			dSclaeB = dUpperLimitB / iNumDivide;
			if(bSetMaximumB && dUpperLimitB > dMaximumB){
				dUpperLimitB = dMaximumB;
				double dScaleB_new = dUpperLimitB / iNumDivide;
				if(dScaleB_new < dSclaeB){
					dSclaeB = dScaleB_new;
				}
			}
			dB = dSclaeB;
		}

		// Determine Amax and b
		while(iLoopCount < iMaximumLoopCount){
			// Determine Amax
			dRMSE = 0.0;
			dMinimumRMSE = 999999999.9;
			dAmax = 0;
			// b 1Ō܂ɂ̂ŁAxgČ߂ȂB
			if(iLoopCount == 0 && iCount == 0){
				dB = dSclaeB;;
			}
			else if(iLoopCount != 0 && iCount == 0){
				dB = dNewStartB;
			}
			else{
				dB = dB;
			}

			for(int iData = 0; iData < iNumDivide; iData++){
				dAmax = dStartAmax + iData * dSclaeAmax;
				dRMSE = 0.0;
				for(int i = 0; i < aryRadiation->size(); i++){
					dRadiation      = aryRadiation->operator[](i);
					dPhotosynthesis = aryPhotosynthesis->operator[](i);			

					if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
						continue;
					}
					dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);				
				}
				if(dMinimumRMSE > dRMSE){
					iMinimumRMSE = iData;
					dMinimumRMSE = dRMSE;
				}
			}
			dAmax = iMinimumRMSE * dSclaeAmax;


			// Determine b
			dRMSE = 0.0;
			dMinimumRMSE = 9999999999.9;
			dStartB = dB;
			for(iData = 0; iData < iNumDivide; iData++){
				if(dB < dUpperLimitB) dB = dStartB + iData * dSclaeB;
				dRMSE = 0.0;
				for(int i = 0; i < aryRadiation->size(); i++){
					dRadiation      = aryRadiation->operator[](i);
					dPhotosynthesis = aryPhotosynthesis->operator[](i);		// zvXAo}CiX	

					if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
						continue;
					}
					dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);				
				}
				if(dMinimumRMSE > dRMSE){
					iMinimumRMSE = iData;
					dMinimumRMSE = dRMSE;
				}
				if(dB >= dUpperLimitB){
					dB = dUpperLimitB;		// Add at 2008.10.10
					break;
				}	
			}
			dB = dStartB + iMinimumRMSE * dSclaeB;

			// [vh~
			iCount++;
			if(((abs(dOldAmax - dAmax) < dSclaeAmax / 2.) && (abs(dOldB - dB) < dSclaeB / 2.)) || iCount > 100 || dB > dUpperLimitB){
				// Calculate RMSE
				for(int i = 0; i < aryRadiation->size(); i++){
					dRadiation      = aryRadiation->operator[](i);
					dPhotosynthesis = aryPhotosynthesis->operator[](i);			

					if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
						continue;
					}
					dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);				
				}
				if(dOldRMSE > dRMSE && dB < dUpperLimitB){
					dOldRMSE = dRMSE;
					iCount = 0;
					dNewStartB = dB;
				}
				else{
					break;
				}
				iLoopCount++;
			}
			else{
				dOldAmax = dAmax;
				dOldB = dB;
			}
		}

		if(dB >= dUpperLimitB){
			dB = dUpperLimitB;		// Add at 2008.10.10
		}
	}
	else{
		dB = FixedPrm.m_dB;
		dAmax = FixedPrm.m_dMaximumPhotosynthesis;
	}


	// RMSE and ֌W̌vZ
	iLoopCount = iCount;
	iCount = 0;
	vector<double> aryPhotosynthesis_observation;
	vector<double> aryPhotosynthesis_Model;
	double dPhotosynthesis_model;
	for(int i = 0; i < aryRadiation->size(); i++){
		if(aryRadiation->operator[](i) != dErrorValue && aryPhotosynthesis->operator[](i) != dErrorValue){
			// ֌W
			double dPhotosynthesis_obs = aryPhotosynthesis->operator[](i);
			aryPhotosynthesis_observation.push_back(aryPhotosynthesis->operator[](i));
			if(bUseNonRectangular == 0){
				dPhotosynthesis_model = (dAmax * aryRadiation->operator[](i)) / (aryRadiation->operator[](i) + dAmax / dB) + dR0;
			}
			else{
				dPhotosynthesis_model = ((dB * aryRadiation->operator[](i) + dAmax - sqrt(pow(dB * aryRadiation->operator[](i) + dAmax, 2) - 4 * dB * aryRadiation->operator[](i) * dC * dAmax)) / (2 * dC)) + dR0;
			}
			aryPhotosynthesis_Model.push_back(dPhotosynthesis_model);

			// RMSE
			dRadiation      = aryRadiation->operator[](i);
			dPhotosynthesis = aryPhotosynthesis->operator[](i);	
			dRMSE += CalculateLightPhotosynthesisCurve(dRadiation, dPhotosynthesis, dAmax, dB, dR0, dC, bUseNonRectangular);
			iCount++;
		}
	}
	dCoefficientCorrelation = coefficient_correlation(aryPhotosynthesis_observation, aryPhotosynthesis_Model);
	dRMSE = sqrt(dRMSE / iCount);
}

double CMeanTerm::CalculateLightPhotosynthesisCurve(const double& dRadiation, const double& dPhotosynthesis, const double& dAmax, const double& dB, const double& dR0, const double& dC, BOOL bUseNonRectangular)
{
	double dRMSE = 0.0;
	double dSimPhoto = 0.0;
	// double dC = 0.9;     // the convexity of the light-response curve and daytime respiration

	if(bUseNonRectangular == 0){
		dSimPhoto = - (dAmax * dRadiation) / (dRadiation + dAmax / dB) - dR0;
		dRMSE = pow(dPhotosynthesis + dSimPhoto, 2);
		// dRMSE = pow(dPhotosynthesis - (dAmax * dRadiation) / (dRadiation + dAmax / dB) + dR0, 2);
	}
	else{
		dSimPhoto = (- dB * dRadiation - dAmax + sqrt(pow(dB * dRadiation + dAmax, 2) - 4.0 * dB * dRadiation * dC * dAmax)) / (2.0 * dC) - dR0;
		dRMSE = pow(dPhotosynthesis + dSimPhoto, 2);
		// dRMSE = pow(dPhotosynthesis - ((dB * dRadiation + dAmax - sqrt(pow(dB * dRadiation + dAmax, 2) - 4 * dB * dRadiation * dC * dAmax)) / (2 * dC)) + dR0,2);
	}

	return dRMSE;
}
CString CMeanTerm::GetOutputLine_LightPhotosynthesis(BOOL bUseNegativeValues, const double& dMaximum, const double& dMinimum, const double& dAverage)
{
	CString strOutLine;
	double dR0 = m_PhotosynthesisParameters.m_dR0;
	if(bUseNegativeValues == TRUE && dR0 != CDataset::s_dErrorValue) dR0 = -dR0;

	strOutLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %d, %d\n", 
		m_strCurrentDate,
		m_PhotosynthesisParameters.m_dMaximumPhotosynthesis,
		m_PhotosynthesisParameters.m_dB,
		dR0,
		m_PhotosynthesisParameters.m_dRMSE,
		m_PhotosynthesisParameters.m_dCoefficientCorrelation,
		dMaximum, dMinimum, dAverage,
		m_PhotosynthesisParameters.m_iDataNum,
		m_PhotosynthesisParameters.m_iCount);

	return strOutLine;
}

CString CMeanTerm::GetOutputLine_LightPhotosynthesis_bootstrap(BOOL bUseNegativeValues, const CPhotosynthesisParameters& cPhoto)
{
	CString strOutLine;
	double dR0 = cPhoto.m_dR0;
	if(bUseNegativeValues == TRUE && dR0 != CDataset::s_dErrorValue) dR0 = -dR0;

	strOutLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf\n", 
		m_strCurrentDate,
		cPhoto.m_dMaximumPhotosynthesis,
		cPhoto.m_dB,
		dR0,
		cPhoto.m_dMaximumPhotosynthesis_stdev,
		cPhoto.m_dB_stdev,
		cPhoto.m_dR0_stdev);

	return strOutLine;
}

double CMeanTerm::CalculateR0(const std::vector<double>* aryRadiation, const std::vector<double>* aryPhotosynthesis, const double& dNighttimeRadiation, const double& dErrorValue)
{
	double R0 = 0.0;
	double dSumPhotosynthesis = 0.0;
	int iCount = 0;

	for(int i = 0; i < aryRadiation->size(); i++){
		if(aryRadiation->operator[](i) == dErrorValue || aryPhotosynthesis->operator[](i)== dErrorValue){
			continue;
		}
		if(aryRadiation->operator[](i) <= dNighttimeRadiation){
			dSumPhotosynthesis += aryPhotosynthesis->operator[](i);
			iCount++;
		}
	}

	if(iCount == 0 || dSumPhotosynthesis > 0.0){
		R0 = 0.0;
	}
	else{
		R0 = dSumPhotosynthesis / iCount;
	}

	return R0;
}

void CMeanTerm::SetParametersGPP(const double& dDate, const double& dAmax, const double& dB, const double& dR0)
{
	m_PhotosynthesisParameters.m_dMaximumPhotosynthesis = dAmax;
	m_PhotosynthesisParameters.m_dB = dB;
	m_PhotosynthesisParameters.m_dR0 = dR0;
	m_dStartDate = dDate;
}

void CMeanTerm::SetParametersRE(const double& dDate, const double& dR0, const double& dQ10, const double& dTref)
{
	m_RespirationParameters.m_dR0 = dR0;
	m_RespirationParameters.m_dQ10 = dQ10;
	m_RespirationParameters.m_dTref = dTref;
	m_dStartDate = dDate;
}

void CMeanTerm::UpdateParametersRE(const double& dR0_annual, const double& dQ10_annual, const double& dTref_annual, const double& dErrorValue)
{
	if(m_RespirationParameters.m_dR0 == dErrorValue || m_RespirationParameters.m_dQ10 == dErrorValue){
		m_RespirationParameters.m_dR0 = dR0_annual;
		m_RespirationParameters.m_dQ10 = dQ10_annual;
		m_RespirationParameters.m_dTref = dTref_annual;
	}
}

void CMeanTerm::GetMaximumMinimuAverage(const int& iColumn, double& dMaximum, double& dMinimum, double& dAverage)
{
	double dData;
	int iCount = 0;
	dMaximum = s_dErrorValue;
	dMinimum = -s_dErrorValue;
	dAverage = 0.0;

	for(int i = 0; i < (m_aryDataset[iColumn]->GetContinuousDataset())->size(); i++){
		dData = (m_aryDataset[iColumn]->GetContinuousDataset())->operator[](i);
		if(dData == s_dErrorValue){
			continue;
		}

		dAverage += dData;
		iCount++;
		if(dData > dMaximum)	dMaximum = dData;
		if(dData < dMinimum)	dMinimum = dData;
	}
	if(dMinimum == -s_dErrorValue)	dMinimum = s_dErrorValue;
	if(iCount != 0){
		dAverage /= iCount;
	}
	else{
		dAverage = s_dErrorValue;
	}
}


int CMeanTerm::ApplyLightPhotosynthesisCurve(const CString& strHeader, const int iRadiationColumn)
{
	// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
	CString strTemp = strHeader;
	int iNEE_model_nlr1 = -1;
	if(SetDataset(strTemp.Replace(',','@')) == FALSE){
		return iNEE_model_nlr1;
	}
	SetHeader(strHeader);

	vector<double> aryPhotosynthesisRate;
	double dPhotosynthesisRate = 0.0;
	double dRadiation = 0.0;
	double dErrorValue = m_aryDataset[iRadiationColumn]->GetErrorValue();

	for(int i = 0; i < (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->size(); i++){
		dRadiation = (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i);
		if(dRadiation != dErrorValue && m_PhotosynthesisParameters.m_dMaximumPhotosynthesis != dErrorValue){
			if(!s_bUseNonRectangular){
				dPhotosynthesisRate = (m_PhotosynthesisParameters.m_dMaximumPhotosynthesis * dRadiation) / (dRadiation + m_PhotosynthesisParameters.m_dMaximumPhotosynthesis / m_PhotosynthesisParameters.m_dB) + m_PhotosynthesisParameters.m_dR0;
			}
			else{
				dPhotosynthesisRate = ((m_PhotosynthesisParameters.m_dB * dRadiation + m_PhotosynthesisParameters.m_dMaximumPhotosynthesis - sqrt(pow(m_PhotosynthesisParameters.m_dB * dRadiation + m_PhotosynthesisParameters.m_dMaximumPhotosynthesis, 2) - 4 * m_PhotosynthesisParameters.m_dB * dRadiation * s_dConvexity * m_PhotosynthesisParameters.m_dMaximumPhotosynthesis)) / (2 * s_dConvexity)) + m_PhotosynthesisParameters.m_dR0;
			}
			if(s_bUseNegativeValues){
				dPhotosynthesisRate *= -1;
			}
		}
		else{
			// ˗ʂG[
			dPhotosynthesisRate = dErrorValue;
		}
		aryPhotosynthesisRate.push_back(dPhotosynthesisRate);
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryPhotosynthesisRate);
	m_aryDataset.push_back(Dataset);
	iNEE_model_nlr1 = GetSizeOfDataset();

	return iNEE_model_nlr1;
}

int CMeanTerm::ApplyLightPhotosynthesisCurve_bootstrap(const int iRadiationColumn)
{
	int iNEE_model_nlr1 = -1;

	vector< vector<double> > aryPhotosynthesisRateBootstrap;
	double dPhotosynthesisRate = 0.0;
	double dRadiation = 0.0;
	double dErrorValue = m_aryDataset[iRadiationColumn]->GetErrorValue();

	for(int iBootstrap = 0; iBootstrap < m_aryPhotosynthesisParameters_bootstrap.size(); iBootstrap++){
		vector<double> aryPhotosynthesisRate;
		for(int i = 0; i < (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->size(); i++){
			dRadiation = (m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i);
			if(dRadiation != dErrorValue && m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dMaximumPhotosynthesis >= 0.0 && m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dB  >= 0.0 && m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dR0  != dErrorValue){
				if(!s_bUseNonRectangular){
					dPhotosynthesisRate = (m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dMaximumPhotosynthesis * dRadiation) / (dRadiation + m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dMaximumPhotosynthesis / m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dB) + m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dR0;
				}
				else{
					dPhotosynthesisRate = ((m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dB * dRadiation + m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dMaximumPhotosynthesis - sqrt(pow(m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dB * dRadiation + m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dMaximumPhotosynthesis, 2) - 4 * m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dB * dRadiation * s_dConvexity * m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dMaximumPhotosynthesis)) / (2 * s_dConvexity)) + m_aryPhotosynthesisParameters_bootstrap[iBootstrap].m_dR0;
				}
				if(s_bUseNegativeValues){
					dPhotosynthesisRate *= -1;
				}
			}
			else{
				// ˗ʂG[
				dPhotosynthesisRate = dErrorValue;
			}
			aryPhotosynthesisRate.push_back(dPhotosynthesisRate);
		}
		aryPhotosynthesisRateBootstrap.push_back(aryPhotosynthesisRate);
		aryPhotosynthesisRate.clear();
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryPhotosynthesisRateBootstrap);
	m_aryDataset.push_back(Dataset);
	iNEE_model_nlr1 = GetSizeOfDataset();

	return iNEE_model_nlr1;
}

int CMeanTerm::QC_PhotosynthesisData(double dThresholdSigma,BOOL bUseNegativeValues, const int& iRadiationColumn, const int& iPhotosynthesisColumn)
{
	// Ԃ̌ċzf[^ɊւāA莮ƊϑlrA
	// ̍Aw肵W΍̔{ (dThresholdSigma) ȏ̃f[^B
	vector<double>* aryRadiation = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryPhotosynthesis = m_aryDataset[iPhotosynthesisColumn]->GetContinuousDataset();
	vector<double> aryDifference;
	vector<int> aryIndex;

	double dErrorValue = m_aryDataset[0]->GetErrorValue();
	double dRadiation, dPhotosynthesis, dNEEmodel;
	double dTx = 0.0, dTxx = 0.0, dStandardDev;
	int iCount = 0;
	int iOutlinerCount = 0;

	if(m_PhotosynthesisParameters.m_dMaximumPhotosynthesis == dErrorValue|| (m_PhotosynthesisParameters.m_iFixed_Pmax_B == TRUE && m_PhotosynthesisParameters.m_iFixed_R0 == TRUE)){
		return iOutlinerCount;
	}

	// fƎ̕W덷vZ
	for(int i = 0; i < aryRadiation->size(); i++){
		dRadiation      = aryRadiation->operator[](i);
		dPhotosynthesis = aryPhotosynthesis->operator[](i);			

		if(dRadiation == dErrorValue || dPhotosynthesis == dErrorValue){
			continue;
		}

		if(!s_bUseNonRectangular){
			dNEEmodel = (m_PhotosynthesisParameters.m_dMaximumPhotosynthesis * dRadiation) / (dRadiation + m_PhotosynthesisParameters.m_dMaximumPhotosynthesis / m_PhotosynthesisParameters.m_dB) + m_PhotosynthesisParameters.m_dR0;
		}
		else{
			dNEEmodel = ((m_PhotosynthesisParameters.m_dB * dRadiation + m_PhotosynthesisParameters.m_dMaximumPhotosynthesis - sqrt(pow(m_PhotosynthesisParameters.m_dB * dRadiation + m_PhotosynthesisParameters.m_dMaximumPhotosynthesis, 2) - 4 * m_PhotosynthesisParameters.m_dB * dRadiation * s_dConvexity * m_PhotosynthesisParameters.m_dMaximumPhotosynthesis)) / (2 * s_dConvexity)) + m_PhotosynthesisParameters.m_dR0;
		}
		if(s_bUseNegativeValues){
			dNEEmodel *= -1;
		}

		dTx = fabs(dPhotosynthesis - dNEEmodel) / fabs(aryPhotosynthesis->operator[](i));
		dTxx = pow(fabs(dPhotosynthesis - dNEEmodel) / fabs(aryPhotosynthesis->operator[](i)), 2);
		iCount ++;

		aryDifference.push_back(fabs(aryPhotosynthesis->operator[](i) - dNEEmodel) / fabs(aryPhotosynthesis->operator[](i)));
		aryIndex.push_back(i);
	}
	dStandardDev = sqrt( (dTxx - dTx * dTx / iCount) / iCount );

	double test;
	for(i = 0; i < aryDifference.size(); i++){
		if(aryDifference[i] > dStandardDev * dThresholdSigma){
			test = aryPhotosynthesis->operator[](aryIndex[i]);
			aryPhotosynthesis->operator[](aryIndex[i]) = dErrorValue;
			iOutlinerCount++;
		}
	}
	return iOutlinerCount;
	
}

double CMeanTerm::GetMaxValue(const std::vector<double>* aryValue)
{
	double dMax;
	for(int i = 0; i < aryValue->size(); i++){
		if(i == 0){
			dMax = aryValue->operator[](i);
		}
		else{
			if(dMax < aryValue->operator[](i)){
				dMax = aryValue->operator[](i);
			}
		}
	}
	return dMax;
}

double CMeanTerm::GetDaytimeMaxValue(const std::vector<double>* aryValue, const std::vector<double>* aryRadiation)
{
	double dMax;
	int iCount = 0;
	for(int i = 0; i < aryValue->size(); i++){
		if(aryRadiation->operator[](i) > 0){
			if(iCount == 0){
				dMax = aryValue->operator[](i);
				iCount++;
			}
			else{
				if(dMax < aryValue->operator[](i)){
					dMax = aryValue->operator[](i);
				}
			}
		}
	}
	return dMax;
}

// ***************************************************************************************************
//  ċz֘Ã[`
// ***************************************************************************************************
/*BOOL CMeanTerm::DetermineRespirationCurve(double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParamters& FixedPrm, BOOL bAnnual)
{
	BOOL bUseLogTransformation = FALSE;
	vector<double>* aryTemperatureP = m_aryDataset[iTemperatureColumn]->GetContinuousDataset();
	vector<double>* aryRadiationP = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryRespirationP = m_aryDataset[iRespirationColumn]->GetContinuousDataset();
	vector<double>* aryUstarP = m_aryDataset[iUstarColumn]->GetContinuousDataset();
	vector<double> aryTemperature;
	vector<double> aryRespiration;

	double dTemperature = 0.0;
	double dRespiration = 0.0;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();
	const double const_dUpperQ10 = 5.0;
	double dUpperQ10 = dMaximumQ10, dStartQ10 = 1.0, dSclaeQ10 = 0.0, dQ10 = 1.0;
	double dUpperR0 = 0.0,  dStartR0 = 0.0,  dSclaeR0 = 0.0,  dR0 = 0.0;
	double dOldQ10 = -9999, dOldR0 = -9999.;
	double dNewStartQ10 = 0.0;
	double dReferenceTemperature = 0.0, dReferenceTemperature_LT = 10.0;
	double dTk = 273.15, dT0 = 227.13;
	int iNumDivideQ10 = pow(2, 9);
	int iNumDivideR0 = 50;
	
	double dMinimumRMSE = 99999.9;
	int iMinimumRMSE_R0, iMinimumRMSE_Q10;
	double dOldRMSE = 99999.9, dOldRMSE2 = 99999.9;
	const int iMaximumLoopCount = 20;
	double dRMSE = 0.0;
	double dCoefficientCorrelation;


	if(bUseLloyd_Taylor){
		dReferenceTemperature = dReferenceTemperature_LT;
		dReferenceTemperature = dTref;						// add 2012.02.27
		// dUpperQ10 = 450 * s_dR;		// according to Reichsterin et al., (2005) [maximum E0 should be 450K]
		if(bAnnual) dUpperQ10 *= 2.0;
		dStartQ10 = 0.0;
	}

	// ̃f[^݂̂𒊏o
	double dTemperatureAve = 0.0, dRespirationAve = 0.0;
	dTmax = dErrorValue, dTmin = -dErrorValue;
	for(int i = 0; i < aryRadiationP->size(); i++){
		if(aryRadiationP->operator[](i) <= dUpplerNighttimeRadiation && aryRadiationP->operator[](i) != dErrorValue &&
			aryUstarP->operator[](i) >= dUstarThreshold && aryUstarP->operator[](i) != dErrorValue){
			if(aryTemperatureP->operator[](i) != dErrorValue && aryRespirationP->operator[](i) != dErrorValue){
				aryTemperature.push_back(aryTemperatureP->operator[](i));
				if(bUseNegativeValues){
					aryRespiration.push_back(aryRespirationP->operator[](i));
				}
				else{
					aryRespiration.push_back((-1) * aryRespirationP->operator[](i));
				}
				dTemperatureAve += aryTemperatureP->operator[](i);
				dRespirationAve += aryRespirationP->operator[](i);

				if(dTmax < aryTemperatureP->operator[](i)) dTmax = aryTemperatureP->operator[](i);
				if(dTmin > aryTemperatureP->operator[](i)) dTmin = aryTemperatureP->operator[](i);
			}
		}
	}
	if(aryTemperature.size() != 0){
		dTemperatureAve /= aryTemperature.size();
	}
	else{
		dTemperatureAve = 0.0;
	}
	if(aryRespiration.size() != 0){
		dRespirationAve /= aryRespiration.size();
	}
	else{
		dRespirationAve = 0.0;
	}
	if(dRespirationAve <= 0) dRespirationAve = 0.01;

	if(aryTemperature.size() != 0){
		dTave = dTemperatureAve;
	}
	else{
		dTave = dErrorValue;
	}
	if(dTmin == -dErrorValue)dTmin = dErrorValue;

	if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Tref == TRUE){
		dReferenceTemperature = FixedPrm.m_dTref;
	}

	if(bUseFixedData == FALSE || (FixedPrm.m_iFixed_Rref == FALSE || FixedPrm.m_iFixed_Q10 == FALSE)){
		if(aryTemperature.size() == 0){
			// SĂ̏ꍇ
			m_RespirationParameters.m_dQ10 = dErrorValue;
			m_RespirationParameters.m_dR0 = dErrorValue;
			m_RespirationParameters.m_dRMSE = dErrorValue;
			m_RespirationParameters.m_dCoefficientCorrelation = dErrorValue;
			m_RespirationParameters.m_iCount = dErrorValue;
			m_RespirationParameters.m_iDataNum = 0; // dErrorValue; changed at 2010.01.27
			return TRUE;
		}

		// Determine the Upper Limit of R0
		// Q10 5.0 ̎肵čőR0 ߂B (2{̃}[W)
		// (ċz̕ϒl * (1./5.)^((C̕ϒl - 0) / 10) ) * 2
		dUpperR0 = dRespirationAve / (exp( log(const_dUpperQ10) / 10.0 * dTemperatureAve)) * 2.0;
		if(bUseLloyd_Taylor) dUpperR0 *= const_dUpperQ10;
		dSclaeQ10 = (dUpperQ10 - dStartQ10) / iNumDivideQ10;
		dSclaeR0 = (dUpperR0 - dStartR0) / iNumDivideR0;

		// Determine Q10 and R0
		int iCount = 0;
		int iLoopCount = 0;

		int iMutiQ10 = iNumDivideQ10 / 2;
		for(int iData = 0; iData < iNumDivideR0; iData++){
			dR0 = dStartR0 + iData * dSclaeR0;
			if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Rref == TRUE){
				dR0 = FixedPrm.m_dR0;
			}
			dOldRMSE = -1. * dErrorValue;
	//		for(int jData = 0; jData < iNumDivideQ10; jData++){	
			for(int jData = 0; jData < iNumDivideQ10; jData+=iMutiQ10){	
				dRMSE = 0.0;
				dQ10 = dStartQ10 + jData * dSclaeQ10;
				if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Q10 == TRUE) dQ10 = FixedPrm.m_dQ10;
				while(jData + iMutiQ10 > iNumDivideQ10 - 1 && iMutiQ10 != 1){
					iMutiQ10 /= 2;
				}
				for(i = 0; i < aryTemperature.size(); i++){
					dTemperature = aryTemperature[i];
					dRespiration = aryRespiration[i];		

					if(bUseLogTransformation == FALSE){
						dRMSE += CalculateRespirationCurve(dTemperature, dRespiration, dR0, dQ10, dTk, dT0, dReferenceTemperature, bUseLloyd_Taylor);
					}
					else{
						dRMSE += CalculateRespirationCurve_log_transform(dTemperature, dRespiration, dR0, dQ10, dTk, dT0, dReferenceTemperature, bUseLloyd_Taylor);
					}
				}

				if((iData == 0 && jData == 0) || (dMinimumRMSE > dRMSE)){
					iMinimumRMSE_R0 = iData;
					iMinimumRMSE_Q10 = jData;
					dMinimumRMSE = dRMSE;
				}
				if(jData == 0) dOldRMSE = dRMSE;
				if(dOldRMSE < dRMSE){
					// ̂߂̏@iQ10 RMSE ɏl߂烋[v𔲂j
					if(iMutiQ10 == 1){
						break;
					}
					else{
						jData -= (iMutiQ10 * 2);
						if(jData < 0) jData = 0;
						iMutiQ10 = iMutiQ10 / 2;
						dOldRMSE =  -1. * dErrorValue;
						continue;
					}
				}
				if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Q10 == TRUE) break;
				dOldRMSE = dRMSE;
			}
			if(iData == 0){
				dOldRMSE2 = dRMSE;
			}
			else if(dOldRMSE2 < dRMSE){
				// ̂߂̏@    iR0 RMSE ɏl߂烋[v𔲂j
				break;
			}
			dOldRMSE2 = dRMSE;
			if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Rref == TRUE) break;
		}
		if(bUseFixedData == FALSE){
			dR0 = dStartR0 + iMinimumRMSE_R0 * dSclaeR0;
			dQ10 = dStartQ10 + iMinimumRMSE_Q10 * dSclaeQ10;
		}
		else{
			if(FixedPrm.m_iFixed_Rref != TRUE) dR0 = dStartR0 + iMinimumRMSE_R0 * dSclaeR0;
			if(FixedPrm.m_iFixed_Q10 != TRUE) dQ10 = dStartQ10 + iMinimumRMSE_Q10 * dSclaeQ10;
		}

		if(dQ10 >= dUpperQ10){
			dQ10 = dUpperQ10;		// Add at 2008.10.10
		}
		if(dQ10 <= 0){
			double dTest = 5.0;
		}
		
		if(aryTemperature.size() == 0){
			m_RespirationParameters.m_dRMSE = dErrorValue;
			m_RespirationParameters.m_dCoefficientCorrelation = dErrorValue;
			m_RespirationParameters.m_iCount = dErrorValue;
			m_RespirationParameters.m_iDataNum = 0; // dErrorValue; changed at 2010.01.27
			return TRUE;
		}
	}
	else{
		dR0 = FixedPrm.m_dR0;
		dQ10 = FixedPrm.m_dQ10;
	}

	// RMSE and ֌W̌vZ
	dRMSE = 0.;
	int iCount = 0;
	vector<double> aryRespiration_Model;
	double dRespiration_model;
	for(i = 0; i < aryTemperature.size(); i++){
		dTemperature = aryTemperature[i];
		dRespiration = aryRespiration[i];			

		dRMSE += CalculateRespirationCurve(dTemperature, dRespiration, dR0, dQ10, dTk, dT0, dReferenceTemperature, bUseLloyd_Taylor);
		if(bUseLloyd_Taylor == 0){
			dRespiration_model = dR0 * exp( log(dQ10) / 10.0 * dTemperature);
		}
		else{
			dRespiration_model = dR0 * exp( dQ10 / s_dR * (1.0 / (dTk + dReferenceTemperature - dT0) - 1.0 / (dTk + dTemperature - dT0)));
		}
		aryRespiration_Model.push_back(dRespiration_model);

	}
	dCoefficientCorrelation = coefficient_correlation(aryRespiration, aryRespiration_Model);
	dRMSE = sqrt(dRMSE / aryTemperature.size());

	// f[^̍XV
	m_RespirationParameters.m_dQ10 = dQ10;
	m_RespirationParameters.m_dR0 = dR0;
	if(bUseLloyd_Taylor){
		m_RespirationParameters.m_dTref = dReferenceTemperature;
	}
	else{
		m_RespirationParameters.m_dTref = 0.0;
	}
	m_RespirationParameters.m_dRMSE = dRMSE;
	m_RespirationParameters.m_dCoefficientCorrelation = dCoefficientCorrelation;
	m_RespirationParameters.m_iDataNum = aryTemperature.size(); // - 1;

	return TRUE;
}*/

BOOL CMeanTerm::DetermineRespirationCurve(double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParameters& FixedPrm, BOOL bAnnual)
{
	vector<double>* aryTemperatureP = m_aryDataset[iTemperatureColumn]->GetContinuousDataset();
	vector<double>* aryRadiationP = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryRespirationP = m_aryDataset[iRespirationColumn]->GetContinuousDataset();
	vector<double>* aryUstarP = m_aryDataset[iUstarColumn]->GetContinuousDataset();

	double dQ10 = 1.0, dR0 = 0.0, dReferenceTemperature = 0.0, dRMSE = 0.0, dCoefficientCorrelation;
	int iDataSize, iCount, iDataNum;

	DetermineRespirationCurve(aryTemperatureP, aryRadiationP, aryRespirationP, aryUstarP, 
		dTmax, dTmin, dTave, bUseNegativeValues, bUseLloyd_Taylor, dMaximumQ10, dTref, dUpplerNighttimeRadiation, dUstarThreshold, iTemperatureColumn, iRadiationColumn, iRespirationColumn, iUstarColumn, bUseFixedData, FixedPrm, bAnnual,
		dQ10, dR0, dReferenceTemperature, dRMSE, dCoefficientCorrelation, iDataSize, iCount, iDataNum);


	// f[^̍XV
	m_RespirationParameters.m_dQ10 = dQ10;
	m_RespirationParameters.m_dR0 = dR0;
	if(bUseLloyd_Taylor){
		m_RespirationParameters.m_dTref = dReferenceTemperature;
	}
	else{
		m_RespirationParameters.m_dTref = 0.0;
	}
	m_RespirationParameters.m_dRMSE = dRMSE;
	m_RespirationParameters.m_dCoefficientCorrelation = dCoefficientCorrelation;
	m_RespirationParameters.m_iDataNum = iDataSize;

	return TRUE;
}

BOOL CMeanTerm::DetermineRespirationCurve_bootstrap(double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParameters& FixedPrm, BOOL bAnnual, int iBootstrapNum)
{
	vector<double>* aryTemperatureP = m_aryDataset[iTemperatureColumn]->GetContinuousDataset();
	vector<double>* aryRadiationP = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryRespirationP = m_aryDataset[iRespirationColumn]->GetContinuousDataset();
	vector<double>* aryUstarP = m_aryDataset[iUstarColumn]->GetContinuousDataset();

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		double dQ10 = 1.0, dR0 = 0.0, dReferenceTemperature = 0.0, dRMSE = 0.0, dCoefficientCorrelation;
		int iDataSize = 0, iCount = 0, iDataNum = 0;

		// boot strap @
		vector<double> aryTemperatureBootstrap;
		vector<double> aryRadiationBootstrap;
		vector<double> aryRespirationBootstrap;
		vector<double> aryUstarBootstrap;
		int iSize = aryRadiationP->size();
		int iRandam;
		for(int i = 0; i < iSize; i++){
			iRandam = rand() % iSize;
			aryTemperatureBootstrap.push_back((*aryTemperatureP)[iRandam]);
			aryRadiationBootstrap.push_back((*aryRadiationP)[iRandam]);
			aryRespirationBootstrap.push_back((*aryRespirationP)[iRandam]);
			aryUstarBootstrap.push_back((*aryUstarP)[iRandam]);
		}

		DetermineRespirationCurve(&aryTemperatureBootstrap, &aryRadiationBootstrap, &aryRespirationBootstrap, &aryUstarBootstrap, 
			dTmax, dTmin, dTave, bUseNegativeValues, bUseLloyd_Taylor, dMaximumQ10, dTref, dUpplerNighttimeRadiation, dUstarThreshold, iTemperatureColumn, iRadiationColumn, iRespirationColumn, iUstarColumn, bUseFixedData, FixedPrm, bAnnual,
			dQ10, dR0, dReferenceTemperature, dRMSE, dCoefficientCorrelation, iDataSize, iCount, iDataNum);


		// f[^̍XV
		CRespirationParameters cRespirationParameters;
		cRespirationParameters.m_dQ10 = dQ10;
		cRespirationParameters.m_dR0 = dR0;
		if(bUseLloyd_Taylor){
			cRespirationParameters.m_dTref = dReferenceTemperature;
		}
		else{
			cRespirationParameters.m_dTref = 0.0;
		}
		cRespirationParameters.m_dRMSE = dRMSE;
		cRespirationParameters.m_dCoefficientCorrelation = dCoefficientCorrelation;
		cRespirationParameters.m_iDataNum = iDataSize;

		m_aryRespirationParameters_bootstrap.push_back(cRespirationParameters);
	}

	return TRUE;
}

void CMeanTerm::DetermineRespirationCurve(std::vector<double>* aryTemperatureP, std::vector<double>* aryRadiationP, std::vector<double>* aryRespirationP, std::vector<double>* aryUstarP, 
	double& dTmax, double& dTmin, double& dTave, BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dMaximumQ10, const double& dTref, const double& dUpplerNighttimeRadiation, const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn, int iRespirationColumn, int iUstarColumn, BOOL bUseFixedData, const CRespirationParameters& FixedPrm, BOOL bAnnual,
	double& dQ10, double& dR0, double& dReferenceTemperature, double& dRMSE, double& dCoefficientCorrelation, int& iDataSize, int& iCount, int& iDataNum)
{
	BOOL bUseLogTransformation = FALSE;
	vector<double> aryTemperature;
	vector<double> aryRespiration;

	double dTemperature = 0.0;
	double dRespiration = 0.0;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();
	const double const_dUpperQ10 = 5.0;
	double dUpperQ10 = dMaximumQ10, dStartQ10 = 1.0, dSclaeQ10 = 0.0;
	double dUpperR0 = 0.0,  dStartR0 = 0.0,  dSclaeR0 = 0.0;
	double dOldQ10 = -9999, dOldR0 = -9999.;
	double dNewStartQ10 = 0.0;
	double dReferenceTemperature_LT = 10.0;
	double dTk = 273.15, dT0 = 227.13;
	int iNumDivideQ10 = pow(2, 9);
	int iNumDivideR0 = 50;
	
	double dMinimumRMSE = 99999.9;
	int iMinimumRMSE_R0, iMinimumRMSE_Q10;
	double dOldRMSE = 99999.9, dOldRMSE2 = 99999.9;
	const int iMaximumLoopCount = 20;


	if(bUseLloyd_Taylor){
		dReferenceTemperature = dReferenceTemperature_LT;
		dReferenceTemperature = dTref;						// add 2012.02.27
		// dUpperQ10 = 450 * s_dR;		// according to Reichsterin et al., (2005) [maximum E0 should be 450K]
		if(bAnnual) dUpperQ10 *= 2.0;
		dStartQ10 = 0.0;
	}

	// ̃f[^݂̂𒊏o
	double dTemperatureAve = 0.0, dRespirationAve = 0.0;
	dTmax = dErrorValue, dTmin = -dErrorValue;
	for(int i = 0; i < aryRadiationP->size(); i++){
		if(aryRadiationP->operator[](i) <= dUpplerNighttimeRadiation && aryRadiationP->operator[](i) != dErrorValue &&
			aryUstarP->operator[](i) >= dUstarThreshold && aryUstarP->operator[](i) != dErrorValue){
			if(aryTemperatureP->operator[](i) != dErrorValue && aryRespirationP->operator[](i) != dErrorValue){
				aryTemperature.push_back(aryTemperatureP->operator[](i));
				if(bUseNegativeValues){
					aryRespiration.push_back(aryRespirationP->operator[](i));
				}
				else{
					aryRespiration.push_back((-1) * aryRespirationP->operator[](i));
				}
				dTemperatureAve += aryTemperatureP->operator[](i);
				dRespirationAve += aryRespirationP->operator[](i);

				if(dTmax < aryTemperatureP->operator[](i)) dTmax = aryTemperatureP->operator[](i);
				if(dTmin > aryTemperatureP->operator[](i)) dTmin = aryTemperatureP->operator[](i);
			}
		}
	}
	if(aryTemperature.size() != 0){
		dTemperatureAve /= aryTemperature.size();
	}
	else{
		dTemperatureAve = 0.0;
	}
	if(aryRespiration.size() != 0){
		dRespirationAve /= aryRespiration.size();
	}
	else{
		dRespirationAve = 0.0;
	}
	if(dRespirationAve <= 0) dRespirationAve = 0.01;

	if(aryTemperature.size() != 0){
		dTave = dTemperatureAve;
	}
	else{
		dTave = dErrorValue;
	}
	if(dTmin == -dErrorValue)dTmin = dErrorValue;

	if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Tref == TRUE){
		dReferenceTemperature = FixedPrm.m_dTref;
	}

	if(bUseFixedData == FALSE || (FixedPrm.m_iFixed_Rref == FALSE || FixedPrm.m_iFixed_Q10 == FALSE)){
		if(aryTemperature.size() == 0){
			// SĂ̏ꍇ
			dQ10 = dErrorValue;
			dR0 = dErrorValue;
			dRMSE = dErrorValue;
			dCoefficientCorrelation = dErrorValue;
			iCount = dErrorValue;
			iDataNum = 0;				// dErrorValue; changed at 2010.01.27
			return;
		}

		// Determine the Upper Limit of R0
		// Q10 5.0 ̎肵čőR0 ߂B (2{̃}[W)
		// (ċz̕ϒl * (1./5.)^((C̕ϒl - 0) / 10) ) * 2
		dUpperR0 = dRespirationAve / (exp( log(const_dUpperQ10) / 10.0 * dTemperatureAve)) * 2.0;
		if(bUseLloyd_Taylor) dUpperR0 *= const_dUpperQ10;
		dSclaeQ10 = (dUpperQ10 - dStartQ10) / iNumDivideQ10;
		dSclaeR0 = (dUpperR0 - dStartR0) / iNumDivideR0;

		// Determine Q10 and R0
		int iCount = 0;
		int iLoopCount = 0;

		int iMutiQ10 = iNumDivideQ10 / 2;
		for(int iData = 0; iData < iNumDivideR0; iData++){
			dR0 = dStartR0 + iData * dSclaeR0;
			if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Rref == TRUE){
				dR0 = FixedPrm.m_dR0;
			}
			dOldRMSE = -1. * dErrorValue;
			for(int jData = 0; jData < iNumDivideQ10; jData+=iMutiQ10){	
				dRMSE = 0.0;
				dQ10 = dStartQ10 + jData * dSclaeQ10;
				if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Q10 == TRUE) dQ10 = FixedPrm.m_dQ10;
				while(jData + iMutiQ10 > iNumDivideQ10 - 1 && iMutiQ10 != 1){
					iMutiQ10 /= 2;
				}
				for(i = 0; i < aryTemperature.size(); i++){
					dTemperature = aryTemperature[i];
					dRespiration = aryRespiration[i];		

					if(bUseLogTransformation == FALSE){
						dRMSE += CalculateRespirationCurve(dTemperature, dRespiration, dR0, dQ10, dTk, dT0, dReferenceTemperature, bUseLloyd_Taylor);
					}
					else{
						dRMSE += CalculateRespirationCurve_log_transform(dTemperature, dRespiration, dR0, dQ10, dTk, dT0, dReferenceTemperature, bUseLloyd_Taylor);
					}
				}

				if((iData == 0 && jData == 0) || (dMinimumRMSE > dRMSE)){
					iMinimumRMSE_R0 = iData;
					iMinimumRMSE_Q10 = jData;
					dMinimumRMSE = dRMSE;
				}
				if(jData == 0) dOldRMSE = dRMSE;
				if(dOldRMSE < dRMSE){
					// ̂߂̏@iQ10 RMSE ɏl߂烋[v𔲂j
					if(iMutiQ10 == 1){
						break;
					}
					else{
						jData -= (iMutiQ10 * 2);
						if(jData < 0) jData = 0;
						iMutiQ10 = iMutiQ10 / 2;
						dOldRMSE =  -1. * dErrorValue;
						continue;
					}
				}
				if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Q10 == TRUE) break;
				dOldRMSE = dRMSE;
			}
			if(iData == 0){
				dOldRMSE2 = dRMSE;
			}
			else if(dOldRMSE2 < dRMSE){
				// ̂߂̏@    iR0 RMSE ɏl߂烋[v𔲂j
				break;
			}
			dOldRMSE2 = dRMSE;
			if(bUseFixedData == TRUE && FixedPrm.m_iFixed_Rref == TRUE) break;
		}
		if(bUseFixedData == FALSE){
			dR0 = dStartR0 + iMinimumRMSE_R0 * dSclaeR0;
			dQ10 = dStartQ10 + iMinimumRMSE_Q10 * dSclaeQ10;
		}
		else{
			if(FixedPrm.m_iFixed_Rref != TRUE) dR0 = dStartR0 + iMinimumRMSE_R0 * dSclaeR0;
			if(FixedPrm.m_iFixed_Q10 != TRUE) dQ10 = dStartQ10 + iMinimumRMSE_Q10 * dSclaeQ10;
		}

		if(dQ10 >= dUpperQ10){
			dQ10 = dUpperQ10;			// Add at 2008.10.10
		}
		if(dQ10 <= 0){
			double dTest = 5.0;
		}
		
		if(aryTemperature.size() == 0){
			dRMSE = dErrorValue;
			dCoefficientCorrelation = dErrorValue;
			iCount = dErrorValue;
			iDataNum = 0;				// dErrorValue; changed at 2010.01.27
			return;
		}
	}
	else{
		dR0 = FixedPrm.m_dR0;
		dQ10 = FixedPrm.m_dQ10;
	}

	// RMSE and ֌W̌vZ
	dRMSE = 0.;
	iCount = 0;
	vector<double> aryRespiration_Model;
	double dRespiration_model;
	for(i = 0; i < aryTemperature.size(); i++){
		dTemperature = aryTemperature[i];
		dRespiration = aryRespiration[i];			

		dRMSE += CalculateRespirationCurve(dTemperature, dRespiration, dR0, dQ10, dTk, dT0, dReferenceTemperature, bUseLloyd_Taylor);
		if(bUseLloyd_Taylor == 0){
			dRespiration_model = dR0 * exp( log(dQ10) / 10.0 * dTemperature);
		}
		else{
			dRespiration_model = dR0 * exp( dQ10 / s_dR * (1.0 / (dTk + dReferenceTemperature - dT0) - 1.0 / (dTk + dTemperature - dT0)));
		}
		aryRespiration_Model.push_back(dRespiration_model);

	}
	dCoefficientCorrelation = coefficient_correlation(aryRespiration, aryRespiration_Model);
	dRMSE = sqrt(dRMSE / aryTemperature.size());

	iDataSize = aryTemperature.size();
}

CString CMeanTerm::GetOutputLine_RespirationCurve(const double& dTmax, const double&dTmin, const double&dTave)
{
	CString strOutLine;

	strOutLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %d\n", 
		m_strCurrentDate,
		m_RespirationParameters.m_dR0,
		m_RespirationParameters.m_dQ10,
		m_RespirationParameters.m_dTref,
		m_RespirationParameters.m_dRMSE,
		m_RespirationParameters.m_dCoefficientCorrelation,
		dTmax, dTmin, dTave,
		m_RespirationParameters.m_iDataNum);

	return strOutLine;
}

CString CMeanTerm::GetOutputLine_RespirationCurve_bootstrap(const CRespirationParameters& cResp)
{
	CString strOutLine;

	strOutLine.Format("%s, %lf, %lf, %lf, %lf, %lf, %lf\n", 
		m_strCurrentDate,
		cResp.m_dR0,
		cResp.m_dQ10,
		cResp.m_dTref,
		cResp.m_dR0_stdev,
		cResp.m_dQ10_stdev,
		cResp.m_dTref_stdev);

	return strOutLine;
}

double CMeanTerm::CalculateRespirationCurve(double dTemperature, double dRespiration, double dR0, double dQ10, double dTk, double dT0, double dTref, BOOL bUseLloyd_Taylor)
{
	double dRMSE = 0.0;

	if(bUseLloyd_Taylor == 0){
		dRMSE = pow(dRespiration - dR0 * exp( log(dQ10) / 10.0 * dTemperature), 2);
	}
	else{
		dRMSE = pow(dRespiration - dR0 * exp( dQ10 / s_dR * (1.0 / (dTk + dTref - dT0) - 1.0 / (dTk + dTemperature - dT0)) ), 2);;
	}

	return dRMSE;
}

double CMeanTerm::CalculateRespirationCurve_log_transform(double dTemperature, double dRespiration, double dR0, double dQ10, double dTk, double dT0, double dTref, BOOL bUseLloyd_Taylor)
{
	double dRMSE = 0.0;

	if(bUseLloyd_Taylor == 0){
		if(dRMSE > 0.0){
			dRMSE = pow(log(dRespiration) - (log(dR0) + dTemperature / 10.0 * log(dQ10) ), 2);
		}
		else{
			dRMSE = pow(0.0 - (log(dR0) + dTemperature / 10.0 * log(dQ10) ), 2);
			// dRMSE = 0.0;
		}
	}
	else{
		if(dRMSE > 0.0){
			dRMSE = pow(log(dRespiration) - (log(dR0) + ( dQ10 / s_dR * (1.0 / (dTk + dTref - dT0) - 1.0 / (dTk + dTemperature - dT0)) )), 2);
		}
		else{
			dRMSE = pow(0.0 - (log(dR0) + ( dQ10 / s_dR * (1.0 / (dTk + dTref - dT0) - 1.0 / (dTk + dTemperature - dT0)) )), 2);
			// dRMSE = 0.0;
		}
	}

	return dRMSE;
}

int CMeanTerm::ApplyRespirationCurve(const int iTemperatureColumn)
{
	// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
	int iRE = -1;

	vector<double> aryRespirationRate;
	double dRespirationRate = 0.0;
	double dTemperature = 0.0;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();
	double dTk = 273.15, dT0 = 227.13;
	double dReferenceTemperature_LT = 10.0;

	int iTest = GetSizeOfDataset();
	for(int i = 0; i < (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->size(); i++){
		dTemperature = (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i);
		if(dTemperature != dErrorValue && m_RespirationParameters.m_dR0 != dErrorValue){
			if(!s_bUseLT_Equation){
				dRespirationRate = m_RespirationParameters.m_dR0 * exp( log(m_RespirationParameters.m_dQ10) / 10.0 * dTemperature);
			}
			else{
				double dTerm = dTk + dTemperature - dT0;
				if(dTerm <= 1.0) dTerm = 1.0;
				// dRespirationRate = m_RespirationParameters.m_dR0 * exp( m_RespirationParameters.m_dQ10 / s_dR * (1.0 / (dTk + dReferenceTemperature_LT - dT0) - 1.0 / (dTerm)));
				dRespirationRate = m_RespirationParameters.m_dR0 * exp( m_RespirationParameters.m_dQ10 / s_dR * (1.0 / (dTk + m_RespirationParameters.m_dTref - dT0) - 1.0 / (dTerm)));
			}
		}
		else{
			// CG[
			dRespirationRate = dErrorValue;
		}
		aryRespirationRate.push_back(dRespirationRate);
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryRespirationRate);
	m_aryDataset.push_back(Dataset);
	iRE = GetSizeOfDataset();

	return iRE;
}

int CMeanTerm::ApplyRespirationCurve_bootstrap(const int iTemperatureColumn)
{
	// ԂƂɕf[^AꍀڂƂ̃f[^Zbgɐ؂蕪	
	int iRE = -1;

	double dRespirationRate = 0.0;
	double dTemperature = 0.0;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();
	const double dTk = 273.15, dT0 = 227.13;
	double dReferenceTemperature_LT = 10.0;

	vector< vector<double> > aryRespirationRateBootstrap;

	for(int iBootstrap = 0; iBootstrap < m_aryRespirationParameters_bootstrap.size(); iBootstrap++){
		vector<double> aryRespirationRate;
		for(int i = 0; i < (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->size(); i++){
			dTemperature = (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i);
			if(dTemperature != dErrorValue && m_aryRespirationParameters_bootstrap[iBootstrap].m_dR0 >= 0.0 && m_aryRespirationParameters_bootstrap[iBootstrap].m_dQ10 >= 0.0){
				if(!s_bUseLT_Equation){
					dRespirationRate = m_aryRespirationParameters_bootstrap[iBootstrap].m_dR0 * exp( log(m_aryRespirationParameters_bootstrap[iBootstrap].m_dQ10) / 10.0 * dTemperature);
				}
				else{
					double dTerm = dTk + dTemperature - dT0;
					if(dTerm <= 1.0) dTerm = 1.0;
					// dRespirationRate = m_RespirationParameters.m_dR0 * exp( m_RespirationParameters.m_dQ10 / s_dR * (1.0 / (dTk + dReferenceTemperature_LT - dT0) - 1.0 / (dTerm)));
					dRespirationRate = m_aryRespirationParameters_bootstrap[iBootstrap].m_dR0 * exp( m_aryRespirationParameters_bootstrap[iBootstrap].m_dQ10 / s_dR * (1.0 / (dTk + m_aryRespirationParameters_bootstrap[iBootstrap].m_dTref - dT0) - 1.0 / (dTerm)));
				}
			}
			else{
				// CG[
				dRespirationRate = dErrorValue;
			}
			aryRespirationRate.push_back(dRespirationRate);
		}
		aryRespirationRateBootstrap.push_back(aryRespirationRate);
		aryRespirationRate.clear();
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryRespirationRateBootstrap);
	m_aryDataset.push_back(Dataset);
	iRE = GetSizeOfDataset();

	return iRE;
}

int CMeanTerm::QC_RespirationData(double dThresholdSigma,BOOL bUseNegativeValues, BOOL bUseLloyd_Taylor, const double& dUpplerNighttimeRadiation,  const double& dUstarThreshold, int iTemperatureColumn, int iRadiationColumn,  int iRespirationColumn, int iUstarColumn) 
{
	// Ԃ̌ċzf[^ɊւāA莮ƊϑlrA
	// ̍Aw肵W΍̔{ (dThresholdSigma) ȏ̃f[^B
 	vector<double>* aryTemperatureP = m_aryDataset[iTemperatureColumn]->GetContinuousDataset();
	vector<double>* aryRadiationP = m_aryDataset[iRadiationColumn]->GetContinuousDataset();
	vector<double>* aryRespirationP = m_aryDataset[iRespirationColumn]->GetContinuousDataset();
	vector<double>* aryUstarP = m_aryDataset[iUstarColumn]->GetContinuousDataset();
	vector<double> aryDifference;
	vector<int> aryIndex;

	double dErrorValue = m_aryDataset[0]->GetErrorValue();
	double dTk = 273.15, dT0 = 227.13;
	double dReferenceTemperature = 0.0, dReferenceTemperature_LT = 10.0, dTref;
	double dREmodel, dREobs;
	double dTx = 0.0, dTxx = 0.0, dStandardDev;
	int iCount = 0;
	int iOutlinerCount = 0;

	if(m_RespirationParameters.m_dR0 == dErrorValue || (m_RespirationParameters.m_iFixed_Rref == TRUE && m_RespirationParameters.m_iFixed_Q10 == TRUE)){
		return iOutlinerCount;
	}

	// ̃f[^݂̂𒊏o
	for(int i = 0; i < aryRadiationP->size(); i++){
		if(aryRadiationP->operator[](i) <= dUpplerNighttimeRadiation && aryRadiationP->operator[](i) != dErrorValue &&
			aryUstarP->operator[](i) >= dUstarThreshold && aryUstarP->operator[](i) != dErrorValue){
			if(aryTemperatureP->operator[](i) != dErrorValue && aryRespirationP->operator[](i) != dErrorValue){
				if(bUseNegativeValues){
					dREobs = aryRespirationP->operator[](i);
				}
				else{
					dREobs = -aryRespirationP->operator[](i);
				}

				if(bUseLloyd_Taylor == 0){
					dTref = dReferenceTemperature;
					dREmodel = m_RespirationParameters.m_dR0 * exp( log(m_RespirationParameters.m_dQ10) / 10.0 * aryTemperatureP->operator[](i));
				}
				else{
					// dTref = dReferenceTemperature_LT;
					dTref = m_RespirationParameters.m_dTref;
					dREmodel = m_RespirationParameters.m_dR0 * exp( m_RespirationParameters.m_dQ10 / s_dR * (1.0 / (dTk + dTref - dT0) - 1.0 / (dTk + aryTemperatureP->operator[](i) - dT0)) );
				}

				dTx = fabs(dREobs - dREmodel);
				dTxx = fabs(dREobs - dREmodel) * fabs(aryRespirationP->operator[](i) - dREmodel);
				iCount ++;

				aryDifference.push_back(fabs(aryRespirationP->operator[](i) - dREmodel));
				aryIndex.push_back(i);
			}
		}
	}
	dStandardDev = sqrt( (dTxx - dTx * dTx / iCount) / iCount );

	for(i = 0; i < aryDifference.size(); i++){
		if(aryDifference[i] > dStandardDev * dThresholdSigma){
			aryRespirationP->operator[](aryIndex[i]) = dErrorValue;
			iOutlinerCount++;
		}
	}
	return iOutlinerCount;
	
}

int CMeanTerm::GapFill_NEE_NonLinearRegression(const int iNEEraw, const int iUstar, const int iRadiation, const int iNEE_model_nlr)
{
	int iResult = -1;
	vector<double> aryResult;
	double dResult;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();

	for(int i = 0; i < (m_aryDataset[iNEEraw]->GetContinuousDataset())->size(); i++){
		dResult = (m_aryDataset[iNEEraw]->GetContinuousDataset())->operator[](i);
		if(dResult == dErrorValue){
			aryResult.push_back((m_aryDataset[iNEE_model_nlr]->GetContinuousDataset())->operator[](i));
		}
		else{
			// Ԃu* 臒l̏ꍇ
			if( (m_aryDataset[iRadiation]->GetContinuousDataset())->operator[](i) <= s_dNighttimeRadiation &&
				((m_aryDataset[iUstar]->GetContinuousDataset())->operator[](i) == dErrorValue || 
				(m_aryDataset[iUstar]->GetContinuousDataset())->operator[](i) < s_dUstar_threshold ) ){
				aryResult.push_back((m_aryDataset[iNEE_model_nlr]->GetContinuousDataset())->operator[](i) );
			}
			else{
				aryResult.push_back(dResult);
			}
		}
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryResult);
	m_aryDataset.push_back(Dataset);
	iResult = GetSizeOfDataset();

	return iResult;
}

int CMeanTerm::GapFill_NEE_NonLinearRegression(const int iNEEraw, const int iUstar, const int iRadiation, const int iNEE_model_nlr, const int iRE)
{
	int iResult = -1;
	vector<double> aryResult;
	double dResult;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();

	for(int i = 0; i < (m_aryDataset[iNEEraw]->GetContinuousDataset())->size(); i++){
		dResult = (m_aryDataset[iNEEraw]->GetContinuousDataset())->operator[](i);
		if(dResult == dErrorValue){
			// ̏ꍇ
			if(s_dNighttimeRadiation < (m_aryDataset[iRadiation]->GetContinuousDataset())->operator[](i)){
				// 
				aryResult.push_back((m_aryDataset[iNEE_model_nlr]->GetContinuousDataset())->operator[](i));
			}
			else{
				// 
				aryResult.push_back((m_aryDataset[iRE]->GetContinuousDataset())->operator[](i));
			}
		}
		else{
			// Ԃu* 臒l̏ꍇ
			if( s_dNighttimeRadiation >= (m_aryDataset[iRadiation]->GetContinuousDataset())->operator[](i) &&
				((m_aryDataset[iUstar]->GetContinuousDataset())->operator[](i) == dErrorValue || 
				(m_aryDataset[iUstar]->GetContinuousDataset())->operator[](i) < s_dUstar_threshold) ){
				aryResult.push_back((m_aryDataset[iRE]->GetContinuousDataset())->operator[](i));
			}
			else{
				aryResult.push_back(dResult);
			}
		}
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryResult);
	m_aryDataset.push_back(Dataset);
	iResult = GetSizeOfDataset();

	return iResult;
}

int CMeanTerm::GapFill_NEE_NonLinearRegression_bootstrap(const int iNEEraw, const int iUstar, const int iRadiation, const int iNEE_model_nlr, const int iRE, int iBootstrapNum)
{
	int iResult = -1;
	vector< vector<double> > aryBootstrapData;
	double dRE, dNEE_model_nlr, dRadiation, dNEEraw, dUstar;
	double dErrorValue = m_aryDataset[0]->GetErrorValue();

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		vector<double> aryResult;
		for(int i = 0; i < (m_aryDataset[iNEEraw]->GetContinuousDataset())->size(); i++){
			dRadiation = (m_aryDataset[iRadiation]->GetContinuousDataset())->operator[](i);
			dNEEraw =  (m_aryDataset[iNEEraw]->GetContinuousDataset())->operator[](i);
			dRE = m_aryDataset[iRE]->m_aryDataset_bs[iBootstrap][i];
			dNEE_model_nlr = m_aryDataset[iNEE_model_nlr]->m_aryDataset_bs[iBootstrap][i];
			dUstar = (m_aryDataset[iUstar]->GetContinuousDataset())->operator[](i);

			if(dNEEraw == dErrorValue){
				// ̏ꍇ
				if(s_dNighttimeRadiation < dRadiation){
					// 
					if(dNEE_model_nlr != dErrorValue){
						aryResult.push_back(dNEE_model_nlr);
					}
					else{
						aryResult.push_back(dErrorValue);
					}
				}
				else{
					// 
					if(dRE != dErrorValue){
						aryResult.push_back(dRE);
					}
					else{
						aryResult.push_back(dErrorValue);
					}
				}
			}
			else{
				// Ԃu* 臒l̏ꍇ
				if( s_dNighttimeRadiation >= dRadiation && dRE != dErrorValue && (dUstar == dErrorValue || dUstar < s_dUstar_threshold) ){
					aryResult.push_back(dRE);
				}
				else{
					aryResult.push_back(dNEEraw);
				}
			}
		}
		aryBootstrapData.push_back(aryResult);
		aryResult.clear();
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryBootstrapData);
	m_aryDataset.push_back(Dataset);
	iResult = GetSizeOfDataset();

	return iResult;
}

int CMeanTerm::Estimate_NEE_NonLinearRegression(const int iRadiation, const int iNEE_model_nlr, const int iRE)
{
	int iResult = -1;
	vector<double> aryResult;

	for(int i = 0; i < (m_aryDataset[iRadiation]->GetContinuousDataset())->size(); i++){
		if(s_dNighttimeRadiation < (m_aryDataset[iRadiation]->GetContinuousDataset())->operator[](i)){
			// 
			aryResult.push_back((m_aryDataset[iNEE_model_nlr]->GetContinuousDataset())->operator[](i));
		}
		else{
			// 
			aryResult.push_back((m_aryDataset[iRE]->GetContinuousDataset())->operator[](i));
		}
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryResult);
	m_aryDataset.push_back(Dataset);
	iResult = GetSizeOfDataset();

	return iResult;
}

int CMeanTerm::Estimate_NEE_NonLinearRegression_bootstrap(const int iRadiation, const int iNEE_model_nlr, const int iRE, int iBootstrapNum)
{
	int iResult = -1;
	vector< vector<double> > aryBootstrapData;
	vector<double> aryResult;

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		for(int i = 0; i < (m_aryDataset[iRadiation]->GetContinuousDataset())->size(); i++){
			if(s_dNighttimeRadiation < (m_aryDataset[iRadiation]->GetContinuousDataset())->operator[](i)){
				// 
				aryResult.push_back(m_aryDataset[iNEE_model_nlr]->m_aryDataset_bs[iBootstrap][i]);
			}
			else{
				// 
				aryResult.push_back(m_aryDataset[iRE]->m_aryDataset_bs[iBootstrap][i]);
			}
		}
		aryBootstrapData.push_back(aryResult);
		aryResult.clear();
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryBootstrapData);
	m_aryDataset.push_back(Dataset);
	iResult = GetSizeOfDataset();

	return iResult;
}

int CMeanTerm::Adjust_GPP_RE(const int iGPP,  const int iRE, int& iGPP2, int& iRE2)
{
	int iResult = -1;
	vector<double> aryGPP2, aryRE2;

	for(int i = 0; i < (m_aryDataset[iGPP]->GetContinuousDataset())->size(); i++){
		if((m_aryDataset[iGPP]->GetContinuousDataset())->operator[](i) < 0.0){
			// 
			aryGPP2.push_back(0.0);
			aryRE2.push_back((m_aryDataset[iRE]->GetContinuousDataset())->operator[](i) - (m_aryDataset[iGPP]->GetContinuousDataset())->operator[](i));
		}
		else{
			// 
			aryGPP2.push_back((m_aryDataset[iGPP]->GetContinuousDataset())->operator[](i));
			aryRE2.push_back((m_aryDataset[iRE]->GetContinuousDataset())->operator[](i));
		}
	}

	// Dataset NXɓo^
	CDataset* DatasetGPP = new CDataset(aryGPP2);
	m_aryDataset.push_back(DatasetGPP);
	iGPP2 = GetSizeOfDataset();

	CDataset* DatasetRE = new CDataset(aryRE2);
	m_aryDataset.push_back(DatasetRE);
	iRE2 = GetSizeOfDataset();

	return iGPP2;
}

int CMeanTerm::Adjust_GPP_RE_bootstrap(const int iGPP,  const int iRE, int& iGPP2, int& iRE2, int iBootstrapNum)
{
	int iResult = -1;
	vector< vector<double> > aryBootstrapGPP2;
	vector< vector<double> > aryBootstrapRE2;
	vector<double> aryGPP2, aryRE2;
	double dGPP = 0.0, dGPP2 = 0.0, dRE = 0.0, dRE2 = 0.0;

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){	
		for(int i = 0; i < m_aryDataset[iRE]->m_aryDataset_bs[iBootstrap].size(); i++){
			dGPP = m_aryDataset[iGPP]->m_aryDataset_bs[iBootstrap][i];
			dRE = m_aryDataset[iRE]->m_aryDataset_bs[iBootstrap][i];

			dGPP2 = dGPP;
			dRE2 = dRE;
			if(dGPP < 0.0 && dGPP != s_dErrorValue){
				// 
				dGPP2 = 0.0;
				dRE2 = dRE - dGPP;
			}
			if(dGPP == s_dErrorValue) dGPP2 = s_dErrorValue;
			if(dRE == s_dErrorValue) dRE2 = s_dErrorValue;

			aryGPP2.push_back(dGPP2);
			aryRE2.push_back(dRE2);
		}
		aryBootstrapGPP2.push_back(aryGPP2);
		aryGPP2.clear();
		aryBootstrapRE2.push_back(aryRE2);
		aryRE2.clear();
	}

	// Dataset NXɓo^
	CDataset* DatasetGPP = new CDataset(aryBootstrapGPP2);
	m_aryDataset.push_back(DatasetGPP);
	iGPP2 = GetSizeOfDataset();

	CDataset* DatasetRE = new CDataset(aryBootstrapRE2);
	m_aryDataset.push_back(DatasetRE);
	iRE2 = GetSizeOfDataset();

	return iGPP2;
}

int CMeanTerm::SetObservedGPP(const int iNEEraw, const int iGPP)
{
	int iResult = -1;
	vector<double> aryGPPobs;

	for(int i = 0; i < (m_aryDataset[iGPP]->GetContinuousDataset())->size(); i++){
		if((m_aryDataset[iNEEraw]->GetContinuousDataset())->operator[](i) ==  s_dErrorValue){
			aryGPPobs.push_back(s_dErrorValue);
		}
		else{
			aryGPPobs.push_back((m_aryDataset[iGPP]->GetContinuousDataset())->operator[](i));
		}
	}

	// Dataset NXɓo^
	CDataset* DatasetGPP = new CDataset(aryGPPobs);
	m_aryDataset.push_back(DatasetGPP);
	iResult = GetSizeOfDataset();

	return iResult;
}

int CMeanTerm::Estimate_GPP(const int iNEE_nlr2, const int iRE)
{
	int iGPP = -1;
	vector<double> aryResult;
	double dGPP;

	for(int i = 0; i < (m_aryDataset[iNEE_nlr2]->GetContinuousDataset())->size(); i++){
		dGPP = (m_aryDataset[iRE]->GetContinuousDataset())->operator[](i) - (m_aryDataset[iNEE_nlr2]->GetContinuousDataset())->operator[](i);
		aryResult.push_back(dGPP);
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryResult);
	m_aryDataset.push_back(Dataset);
	iGPP = GetSizeOfDataset();

	return iGPP;
}

int CMeanTerm::Estimate_GPP_bootstrap(const int iNEE_nlr2, const int iRE, int iBootstrapNum)
{
	int iGPP = -1;
	vector<double> aryResult;
	vector< vector<double> > aryBootstrapData;
	double dGPP, dNEE_nlr2, dRE;

	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		for(int i = 0; i < m_aryDataset[iRE]->m_aryDataset_bs[iBootstrap].size(); i++){
			dNEE_nlr2 = m_aryDataset[iNEE_nlr2]->m_aryDataset_bs[iBootstrap][i];
			dRE = m_aryDataset[iRE]->m_aryDataset_bs[iBootstrap][i];

			if(dRE != s_dErrorValue && dNEE_nlr2 != s_dErrorValue){
				dGPP = dRE - dNEE_nlr2;
			}
			else{
				dGPP = s_dErrorValue;
			}
			aryResult.push_back(dGPP);
		}
		aryBootstrapData.push_back(aryResult);
		aryResult.clear();
	}

	// Dataset NXɓo^
	CDataset* Dataset = new CDataset(aryBootstrapData);
	m_aryDataset.push_back(Dataset);
	iGPP = GetSizeOfDataset();

	return iGPP;
}

void CMeanTerm::Set_Final_Gap_Filled_Data(CMeanTerm& cMeanTermNLR, std::vector<CString>& aryDate,
	    std::vector<double>& aryFinalH, std::vector<double>& aryFinallE, std::vector<double>& aryFinalNEE,
	    std::vector<int>& aryFlagH, std::vector<int>& aryFlaglE, std::vector<int>& aryFlagNEE, 
		std::vector<double>& aryFinalGPP, std::vector<double>& aryFinalRE)
{
	// Look up table output file colums
	int iH_raw_mdv   = 0;
	int ilE_raw_mdv  = 1;
	int iNEE_raw_mdv = 2;
	int iH_mdv_mdv   = 3;
	int ilE_mdv_mdv  = 4;
	int iNEE_mdv_mdv = 5;
	int iH_lut_mdv   = 6;
	int ilE_lut_mdv  = 7;
	int iNEE_lut_mdv = 8;
	int iH_table_mdv   = 12;
	int ilE_table_mdv  = 13;
	int iNEE_table_mdv = 14;

	double dH;
	double dlE;
	double dNEE;
	double dGPP;
	double dRE;
	int iFlagH;
	int iFlaglE;
	int iFlagNEE;
	BOOL bUseNLR = TRUE;

	int iNEE_nlr2 = 4; // CFluxPartitioningDlg::Determine_GPP_Parameters Q
	int iRE2 = 9;

	for(int i= 0; i < (m_aryDataset[iH_raw_mdv]->GetContinuousDataset())->size(); i++){
		dH = (m_aryDataset[iH_raw_mdv]->GetContinuousDataset())->operator[](i);
		dlE = (m_aryDataset[ilE_raw_mdv]->GetContinuousDataset())->operator[](i);
		dNEE = (m_aryDataset[iNEE_raw_mdv]->GetContinuousDataset())->operator[](i);
		dRE = (cMeanTermNLR.m_aryDataset[iRE2]->GetContinuousDataset())->operator[](i);
		iFlagH =   m_aryDataset[iH_raw_mdv]->NONE_COMPLEMENT;
		iFlaglE =  m_aryDataset[ilE_raw_mdv]->NONE_COMPLEMENT;
		iFlagNEE = m_aryDataset[iNEE_raw_mdv]->NONE_COMPLEMENT;

		// sensible heat flux
		set_gap_fill_priority(cMeanTermNLR, this, dH, iFlagH,
				iH_raw_mdv, iH_lut_mdv, -1, iH_mdv_mdv, iH_table_mdv, i, FALSE);
		// latent heat flux
		set_gap_fill_priority(cMeanTermNLR, this, dlE, iFlaglE,
				ilE_raw_mdv, ilE_lut_mdv, -1, ilE_mdv_mdv, ilE_table_mdv, i, FALSE);
		// net ecosystem exchange
		set_gap_fill_priority(cMeanTermNLR, this, dNEE, iFlagNEE,
				iNEE_raw_mdv, iNEE_lut_mdv, iNEE_nlr2, iNEE_mdv_mdv, iNEE_table_mdv, i, TRUE);

		if(dNEE == s_dErrorValue || dRE == s_dErrorValue){
			dGPP = s_dErrorValue;
		}
		else{
			dGPP = dRE - dNEE;
			if(dGPP < 0.0){
				dRE -= dGPP;
				dGPP = 0.0;				
			}
		}

		aryDate.push_back(m_aryDataset[iH_raw_mdv]->GetDate(i));
		aryFinalH.push_back(dH);
		aryFinallE.push_back(dlE);
		aryFinalNEE.push_back(dNEE);
		aryFlagH.push_back(iFlagH);
		aryFlaglE.push_back(iFlaglE);
		aryFlagNEE.push_back(iFlagNEE);
		aryFinalGPP.push_back(dGPP);
		aryFinalRE.push_back(dRE);
	}
}

void CMeanTerm::Final_Priority_bootstrap(int iColumnNum, int iBootstrapNum, int iLimtSeqLoss,  BOOL bMovingAverage, BOOL bIsNEE, CDataset* pDataset_nlr)
{
	CDataset* pDataset = m_aryDataset[iColumnNum];
	vector<double> aryFilledData;

	int iCurrentDate = m_aryDataset[iColumnNum]->get_current_date(m_strCurrentDate);
	int iStart = 0, iEnd = m_iRunPerDay;
	if(bMovingAverage == FALSE){
		iCurrentDate = 0;
		iEnd = pDataset->m_aryContinuousDate.size();
	}

	// D揇ʂtfinal dataset 쐬
	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){		
		for(int i = iStart; i < iEnd; i++){
			if(pDataset->GetData(iCurrentDate + i) == pDataset->GetErrorValue()){
				// linear regression p\ȏꍇ   (Data number = Sf[^)
				if(pDataset->m_aryInterporateDataset[iCurrentDate + i] != pDataset->GetErrorValue() && pDataset->m_aryIsComplement[iCurrentDate + i] == 1 && (iCurrentDate + i) < pDataset->m_aryInterporateDataset.size()){
					aryFilledData.push_back(pDataset->m_aryInterporateDataset[iCurrentDate + i]);
					continue;
				}

				// look up table p\ȏꍇ   @@(Data number = Pf[^)
				if(pDataset->m_aryTable_Dataset_bs[iBootstrap][i] != pDataset->GetErrorValue() && i < pDataset->m_aryTable_Dataset_bs[iBootstrap].size()){
					aryFilledData.push_back(pDataset->m_aryTable_Dataset_bs[iBootstrap][i]);
					continue;
				}

				// non-linear regression p\ȏꍇ   (Data number = Sf[^)
				if(bIsNEE == TRUE && pDataset_nlr->m_aryDataset_bs[iBootstrap][iCurrentDate + i] != pDataset->GetErrorValue() && (iCurrentDate + i) < pDataset_nlr->m_aryDataset_bs[iBootstrap].size()){
					aryFilledData.push_back(pDataset_nlr->m_aryDataset_bs[iBootstrap][iCurrentDate + i]);
					continue;
				}

				// mean diurnal variation p\ȏꍇ   @@(Data number = Pf[^)
				if(pDataset->m_aryBootstrapDiurnalVariation[i % m_iRunPerDay][iBootstrap] != pDataset->GetErrorValue() && (i % m_iRunPerDay) < pDataset->m_aryBootstrapDiurnalVariation.size()){
					aryFilledData.push_back(pDataset->m_aryBootstrapDiurnalVariation[i % m_iRunPerDay][iBootstrap]);
					continue;
				}

				aryFilledData.push_back(pDataset->GetErrorValue());
			}
			else{
				// Ȃꍇ
				aryFilledData.push_back(pDataset->GetData(iCurrentDate + i));
			}
		}
		pDataset->m_aryDataset_final_bs.push_back(aryFilledData);
		aryFilledData.clear();
	}

	// ρEW΍̌vZFinal dataset gap-filling
	pDataset->m_aryAverage_Final_Dataset.clear();
	pDataset->m_aryStdev_Final_Dataset.clear();
	double dTx = 0.0, dTxx = 0.0;
	int iNum = 0;
	for(int i = iStart; i < iEnd; i++){
		dTx = 0.0;
		dTxx = 0.0;
		iNum = 0;
		for(iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
			if(pDataset->m_aryDataset_final_bs[iBootstrap][i] != pDataset->GetErrorValue()){
				dTx += pDataset->m_aryDataset_final_bs[iBootstrap][i];
				dTxx += pDataset->m_aryDataset_final_bs[iBootstrap][i] * pDataset->m_aryDataset_final_bs[iBootstrap][i];
				iNum++;
			}
		}
		if(iNum != 0){
			if((dTxx - dTx * dTx / iNum) > 0.0){
				pDataset->m_aryStdev_Final_Dataset.push_back( sqrt( (dTxx - dTx * dTx / iNum) / iNum ) );
			}
			else{
				pDataset->m_aryStdev_Final_Dataset.push_back(0.0);
			}
			pDataset->m_aryAverage_Final_Dataset.push_back(dTx / iNum);
		}
		else{
			pDataset->m_aryStdev_Final_Dataset.push_back( pDataset->GetErrorValue() );
			pDataset->m_aryAverage_Final_Dataset.push_back(pDataset->GetErrorValue());
		}
	}

	// Final dataset ̌𕽋ϒlgĂ߂
	for(i = iStart; i < iEnd; i++){
		for(iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
			if(pDataset->m_aryDataset_final_bs[iBootstrap][i] == pDataset->GetErrorValue() && pDataset->m_aryAverage_Final_Dataset[i] != pDataset->GetErrorValue()){
				pDataset->m_aryDataset_final_bs[iBootstrap][i] = pDataset->m_aryAverage_Final_Dataset[i];
			}
		}
	}
}

void CMeanTerm::Calculate_GPP_bootstrap(CDataset* pDataset_nee, CDataset* pDataset_re, CDataset* pDataset_gpp, int iBootstrapNum, BOOL bMovingAverage)
{
	double dGPP = 0.0, dRE = 0.0, dNEE = 0.0;
	int iCurrentDate = pDataset_nee->get_current_date(m_strCurrentDate);
	int iStart = 0;
	int iEnd = m_iRunPerDay;

	if(bMovingAverage == FALSE){
		iCurrentDate = 0;
		iEnd = pDataset_nee->m_aryDataset_final_bs[0].size();
	}

	if(pDataset_gpp != NULL) pDataset_gpp->m_aryDataset_final_bs.clear();
	if(pDataset_re != NULL) pDataset_re->m_aryDataset_final_bs.clear();

	vector<double> aryGPP, aryRE;	
	for(int iBootstrap = 0; iBootstrap < iBootstrapNum; iBootstrap++){
		for(int i = iStart; i < iEnd; i++){
			if((iCurrentDate + i) < pDataset_re->m_aryDataset_bs[iBootstrap].size()){
				dRE =  pDataset_re->m_aryDataset_bs[iBootstrap][iCurrentDate + i];
			}
			else{
				dRE = s_dErrorValue;
				pDataset_re->m_aryDataset_bs[iBootstrap].push_back(s_dErrorValue);
			}
			if(i < pDataset_nee->m_aryDataset_final_bs[iBootstrap].size()){
				dNEE = pDataset_nee->m_aryDataset_final_bs[iBootstrap][i];
			}
			else{
				dNEE = s_dErrorValue;
				pDataset_nee->m_aryDataset_final_bs[iBootstrap].push_back(s_dErrorValue);
			}
	
			if(dRE == s_dErrorValue || dNEE == s_dErrorValue){
				dGPP = s_dErrorValue;
			}
			else{
				dGPP = dRE - dNEE;				
				if(dGPP < 0.0){	
					dRE =  dRE - dGPP;
					dGPP = 0.0;
				}								
			}
			aryRE.push_back(dRE);
			aryGPP.push_back(dGPP);
		}
		pDataset_gpp->m_aryDataset_final_bs.push_back(aryGPP);
		aryGPP.clear();
		pDataset_re->m_aryDataset_final_bs.push_back(aryRE);
		aryRE.clear();
	}

	// ρEW΍̌vZFinal dataset gap-filling
	pDataset_gpp->m_aryAverage_Final_Dataset.clear();
	pDataset_gpp->m_aryStdev_Final_Dataset.clear();
	pDataset_re->m_aryAverage_Final_Dataset.clear();
	pDataset_re->m_aryStdev_Final_Dataset.clear();
	double dTx = 0.0, dTxx = 0.0;
	double dTx_re = 0.0, dTxx_re = 0.0;
	int iNum = 0, iNum_re = 0;
	for(int i = iStart; i < (iEnd - iStart); i++){
		dTx = 0.0;
		dTxx = 0.0;
		iNum = 0;
		dTx_re = 0.0;
		dTxx_re = 0.0;
		iNum_re = 0;
		for(iBootstrap = 0; iBootstrap <  iBootstrapNum; iBootstrap++){
			if(pDataset_gpp->m_aryDataset_final_bs[iBootstrap][i] != s_dErrorValue){
				dTx += pDataset_gpp->m_aryDataset_final_bs[iBootstrap][i];
				dTxx += pDataset_gpp->m_aryDataset_final_bs[iBootstrap][i] * pDataset_gpp->m_aryDataset_final_bs[iBootstrap][i];
				iNum++;
			}
			if(pDataset_re->m_aryDataset_final_bs[iBootstrap][i] != s_dErrorValue){
				dTx_re += pDataset_re->m_aryDataset_final_bs[iBootstrap][i];
				dTxx_re += pDataset_re->m_aryDataset_final_bs[iBootstrap][i] * pDataset_re->m_aryDataset_final_bs[iBootstrap][i];
				iNum_re++;
			}
		}

		if(iNum != 0){
			if((dTxx - dTx * dTx / iNum) > 0){
				pDataset_gpp->m_aryStdev_Final_Dataset.push_back( sqrt( (dTxx - dTx * dTx / iNum) / iNum ) );
			}
			else{
				pDataset_gpp->m_aryStdev_Final_Dataset.push_back( 0.0 );
			}
			pDataset_gpp->m_aryAverage_Final_Dataset.push_back(dTx / iNum);
		}
		else{
			pDataset_gpp->m_aryAverage_Final_Dataset.push_back(s_dErrorValue);
			pDataset_gpp->m_aryStdev_Final_Dataset.push_back( s_dErrorValue );
		}

		if(iNum_re != 0){
			if( (dTxx_re - dTx_re * dTx_re / iNum_re) > 0){
				pDataset_re->m_aryStdev_Final_Dataset.push_back( sqrt( (dTxx_re - dTx_re * dTx_re / iNum_re) / iNum_re ) );
			}
			else{
				pDataset_re->m_aryStdev_Final_Dataset.push_back( 0.0 );
			}
			pDataset_re->m_aryAverage_Final_Dataset.push_back(dTx_re / iNum_re);
		}
		else{
			pDataset_re->m_aryAverage_Final_Dataset.push_back(s_dErrorValue);
			pDataset_re->m_aryStdev_Final_Dataset.push_back( s_dErrorValue );
		}

	}

	// Final dataset ̌𕽋ϒlgĂ߂
	for(i = iStart; i < (iEnd - iStart); i++){
		for(iBootstrap = 0; iBootstrap <  iBootstrapNum; iBootstrap++){
			if(pDataset_gpp->m_aryDataset_final_bs[iBootstrap][i] == pDataset_gpp->GetErrorValue() && pDataset_gpp->m_aryAverage_Final_Dataset[i] != pDataset_gpp->GetErrorValue()){
				pDataset_gpp->m_aryDataset_final_bs[iBootstrap][i] = pDataset_gpp->m_aryAverage_Final_Dataset[i];
			}
			if(pDataset_re->m_aryDataset_final_bs[iBootstrap][i] == pDataset_re->GetErrorValue() && pDataset_re->m_aryAverage_Final_Dataset[i] != pDataset_re->GetErrorValue()){
				pDataset_re->m_aryDataset_final_bs[iBootstrap][i] = pDataset_re->m_aryAverage_Final_Dataset[i];
			}
		}
	}
}

void CMeanTerm::set_gap_fill_priority(CMeanTerm& cMeanTermNLR, const CMeanTerm* cMeanTermMDV, double& dData, int& iFlag,
				int raw_mdv, int lut_mdv, int nlr2, int mdv_mdv, int table_mdv, int i, BOOL bUseNLR)
{
	if(dData == s_dErrorValue){
		if((cMeanTermMDV->m_aryDataset[lut_mdv]->GetContinuousDataset())->operator[](i) == s_dErrorValue){
			if(bUseNLR == TRUE && (cMeanTermNLR.m_aryDataset[nlr2]->GetContinuousDataset())->operator[](i) != s_dErrorValue){
				// none-linear regression p\ȏꍇ
				dData = (cMeanTermNLR.m_aryDataset[nlr2]->GetContinuousDataset())->operator[](i);
				iFlag = cMeanTermMDV->m_aryDataset[raw_mdv]->NLRM_COMPLEMENT;
			}
			else{
				// look up table error ̏ꍇ
				if((cMeanTermMDV->m_aryDataset[mdv_mdv]->GetContinuousDataset())->operator[](i) != s_dErrorValue){
					// mean diurnal variation p\ȏꍇ
					dData = (cMeanTermMDV->m_aryDataset[mdv_mdv]->GetContinuousDataset())->operator[](i);
					iFlag = cMeanTermMDV->m_aryDataset[raw_mdv]->MDVM_COMPLEMENT;
				}
				else{
					iFlag = static_cast<int>(s_dErrorValue);
				}
			}
		}
		else{
			// look up table p\ȏꍇ
			dData = (cMeanTermMDV->m_aryDataset[lut_mdv]->GetContinuousDataset())->operator[](i);
			if((cMeanTermMDV->m_aryDataset[lut_mdv]->GetContinuousDataset())->operator[](i) == 
				(cMeanTermMDV->m_aryDataset[table_mdv]->GetContinuousDataset())->operator[](i)){
				iFlag = cMeanTermMDV->m_aryDataset[raw_mdv]->LUTM_COMPLEMENT;
			}
			else{
				iFlag = cMeanTermMDV->m_aryDataset[raw_mdv]->INTERPOLATE_COMPLEMENT;
			}
		}
	}
}

// ***************************************************************************************************
//  u* 臒ľ
// ***************************************************************************************************
// struct SUstarDataset { double dT; double dUstar; double dNEE;};
struct SUstarDataset { double dT; double dUstar; double dNEE; double dStdev_Us; int iNumSapmle;};
bool copmare_temperature_high_to_low(const SUstarDataset* high, const SUstarDataset* low){return high->dT > low->dT;};
bool copmare_ustar_high_to_low(const SUstarDataset* high, const SUstarDataset* low){return high->dUstar > low->dUstar;};

BOOL CMeanTerm::determin_u_star_threshold(int iUstarColumn, int iNEEColumn, int iRadiationColumn, int iTemperatureColumn, double dNighttimeRadiation,
	std::vector<std::string>& aryCurrentDate, std::vector<double>& aryMaximumT, std::vector<double>& aryMinimumT, std::vector<double>& aryCorrelationCoefficient, 
	std::vector<double>& aryUpperClassUstar, std::vector<double>& aryUstarThreshold, std::vector<int>& aryUstarThretholdClass, std::vector<int>& aryDataSize, double& dUstarThreshold) 
{
	//***************************************************************************
	//   M. Reichsterin et al., (2005) Global Change Biology 11, 1-16
	//***************************************************************************
	// o͗pf[^
	//vector<std::string> aryCurrentDate;			// Ώۂ̓ti[
	//vector<double> aryMaximumT;					// exW̍ōC
	//vector<double> aryMinimumT;					// exW̍ŒC
	//vector<double> aryCorrelationCoefficient;	// exWu* ƋC̑֌W
	//vector<double> aryUpperClassUstar;			// 5NXu* ̕ϒl
	//vector<double> aryUstarThreshold;			// exWu* 臒l
	//vector<double>    aryUstarClass;					// u* 臒l݂NX
	//vector<int>    aryDataSize;					// u* 臒lɎgpf[^
	//double dUstarThreshold = 0.0;				// exWu*臒l̒l
	vector<double> aryNEE;
	vector<double> aryUstar;
	vector<double> aryT;
	double dConfidentLevel = 0.95;
	vector<SUstarDataset*> aryData;
	vector<SUstarDataset*> aryData_bs;

	// Ԃ̃f[^̎擾
	for(int i = 0; i< (m_aryDataset[iUstarColumn]->GetContinuousDataset())->size(); i++){
		if((m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue || 
			(m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue || 
			(m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue || 
			(m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i) > dNighttimeRadiation){
			continue;
		}

		SUstarDataset* data = new SUstarDataset;
		data->dUstar = (m_aryDataset[iUstarColumn]->GetContinuousDataset())->operator[](i);
		data->dT = (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i);
		data->dNEE = (m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i);
		// aryData.push_back(data);
		aryData_bs.push_back(data);
	}

	// boot strap @
	int iSizeArrya = aryData_bs.size();
	for(i = 0; i < iSizeArrya; i++){
		aryData.push_back(aryData_bs[rand() % iSizeArrya]);
	}

	// C ̏ɕёւ
	sort(aryData.begin(), aryData.end(), copmare_temperature_high_to_low);

	// C̏6NXɕ
	int iSubClassSizeT = 6;
	int iCount = 0;
	int iTemperatureClass = aryData.size() / iSubClassSizeT;
	while(iTemperatureClass == 0) {		// 6NXmۂłȂقǃf[^Ȃꍇ̏
		iSubClassSizeT--;
		iTemperatureClass = aryData.size() / iSubClassSizeT;
		if(aryData.size() == 0 || iSubClassSizeT == 0){		// xNX1Ƃ̓G[lԂ
			dUstarThreshold = s_dErrorValue;
			aryCurrentDate.push_back((LPCTSTR)m_strCurrentDate);
			aryMaximumT.push_back(s_dErrorValue);
			aryMinimumT.push_back(s_dErrorValue);
			aryCorrelationCoefficient.push_back(s_dErrorValue);
			aryUpperClassUstar.push_back(s_dErrorValue);
			aryUstarThreshold.push_back(s_dErrorValue);
			aryDataSize.push_back((int)s_dErrorValue);
			return FALSE;
		}
	}
	vector< vector<SUstarDataset*> > arySubClassData;
	arySubClassData.resize(iSubClassSizeT);
	for(i = 0; i < aryData.size(); i++){
		if(i % iTemperatureClass == 0 && iCount != iSubClassSizeT){
			iCount++;
		}
		arySubClassData[iCount-1].push_back(aryData[i]);
	}

	// eC̃TuNXu* ̏ɕёւ
	for(i = 0; i < arySubClassData.size(); i++){
		sort(arySubClassData[i].begin(), arySubClassData[i].end(), copmare_ustar_high_to_low);
	}

	// eC̃TuNXu* ɂ20̃NXɕNEE, u* ̕ϒlZo
	int iSubClassSizeUstar = 20;
	vector<int> aryUstarClass;
	vector< vector<SUstarDataset*> > aryFinalDataMatrix;
	for(i = 0; i < arySubClassData.size(); i++){
		iSubClassSizeUstar = 20;
		int iUstarClass = arySubClassData[i].size() / iSubClassSizeUstar;
		while(iUstarClass == 0){
			iSubClassSizeUstar--;		// 20NXmۂłȂقǃf[^Ȃꍇ̏
			iUstarClass = arySubClassData[i].size() / iSubClassSizeUstar;
			if(iSubClassSizeUstar == 0){
				// ̕ɃG[ǉ
			}
		}

		vector<SUstarDataset*> aryFinalData;
		// 1̉xW̃NXu* ̐
		iCount = 0;		// ߂̃NX𒲂ׂ (20͂Ȃ͂)
		int iNum = 0;	// ς̌i[
		for(int j = 0; j < arySubClassData[i].size(); j++){
			if( j % iUstarClass == 0 && iCount != iSubClassSizeUstar){
				// O̗vf̕ϒlZo
				if(j != 0){
					aryFinalData.back()->dUstar /= iNum;
					aryFinalData.back()->dT     /= iNum;
					aryFinalData.back()->dNEE   /= iNum;
					iNum = 0;
				}

				// Vu* W̃NX쐬
				SUstarDataset* data = new SUstarDataset;
				aryFinalData.push_back(data);
				data->dUstar = arySubClassData[i][j]->dUstar;
				data->dT     = arySubClassData[i][j]->dT;
				data->dNEE   = arySubClassData[i][j]->dNEE;
				iNum++;
				iCount++;
			}
			else{
				aryFinalData.back()->dUstar += arySubClassData[i][j]->dUstar;
				aryFinalData.back()->dT     += arySubClassData[i][j]->dT;
				aryFinalData.back()->dNEE   += arySubClassData[i][j]->dNEE;
				iNum++;
			}
		}
		if(iNum != 0){
			aryFinalData.back()->dUstar /= iNum;
			aryFinalData.back()->dT     /= iNum;
			aryFinalData.back()->dNEE   /= iNum;
			iNum = 0;
		}
		aryDataSize.push_back(arySubClassData[i].size());
		aryFinalDataMatrix.push_back(aryFinalData);
	}


	// aryFinalDataMatrix ɂ́AexWƁAeu*Ẃ@u*, T, NEE ̕ϒlĂB
	// O[vCA[vu* @(Sč~ɕł)

	// ex[vu* NXɂu* ƋCɑւ
	// ̌Au* 臒l߂
	// aryFinalDataMatrix[xNX][u*NX]
	for(i = 0; i < aryFinalDataMatrix.size(); i++){
		vector <double> aryT;
		vector <double> aryUstar;
		vector <double> aryNEE;
		double dMaxT = - fabs(s_dErrorValue);
		double dMinT = fabs(s_dErrorValue);
		for(int j = 0; j < aryFinalDataMatrix[i].size(); j++){
			aryT.push_back(aryFinalDataMatrix[i][j]->dT);
			aryUstar.push_back(aryFinalDataMatrix[i][j]->dUstar);
			aryNEE.push_back(aryFinalDataMatrix[i][j]->dNEE);
			if(aryFinalDataMatrix[i][j]->dT > dMaxT) dMaxT = aryFinalDataMatrix[i][j]->dT;
			if(aryFinalDataMatrix[i][j]->dT < dMinT) dMinT = aryFinalDataMatrix[i][j]->dT;
		}
		aryCurrentDate.push_back((LPCTSTR)m_strCurrentDate);
		aryMaximumT.push_back(dMaxT);
		aryMinimumT.push_back(dMinT);

		// ex[vu* NXɂu* ƋCɑւ
		double dR = coefficient_correlation(aryT, aryUstar);
		aryCorrelationCoefficient.push_back(dR);

		// Upper class u* ɂNEE ̕ϒlvZ
		// Upper class ́A5NXƂ
		double dUpperClassUstar = 0.0, dUpperClassNEE = 0.0;
		int iUpperSize = 5;
		// if(iUpperSize > aryFinalDataMatrix.size()){ // changed at 2009.12.21
		if(iUpperSize > aryFinalDataMatrix[i].size()){
			dUpperClassUstar = s_dErrorValue;
			dUpperClassNEE = s_dErrorValue;
			aryUstarThreshold.push_back(s_dErrorValue);
			continue;
		}
		else{
			for(int j = 0; j < iUpperSize; j++){
				int iTest = aryFinalDataMatrix[i].size();
				int iTest2 = aryFinalDataMatrix.size();
				dUpperClassUstar += aryFinalDataMatrix[i][j]->dUstar;
				dUpperClassNEE   += aryFinalDataMatrix[i][j]->dNEE;
			}
			dUpperClassUstar /= iUpperSize;
			dUpperClassNEE   /= iUpperSize;
		}
		aryUpperClassUstar.push_back(dUpperClassUstar);

		// u* 臒l߂
		// u* 5NXɂNEE ̕ϒlƉʃNXNEE ̔r
		double dUstarThreshold = 0.0;
		BOOL bOneMoreLoop = FALSE;		// 񂾂̔肾ƌ̂œNXAŒႩIԂ悤ɂ
		for(j = iUpperSize; j < aryFinalDataMatrix[i].size(); j++){
			if(aryFinalDataMatrix[i][j]->dNEE < dUpperClassNEE * dConfidentLevel && bOneMoreLoop == TRUE){
				dUstarThreshold = aryFinalDataMatrix[i][j-1]->dUstar;
				aryUstarThretholdClass.push_back(j-1);
				break;
			}
			if(aryFinalDataMatrix[i][j]->dNEE < dUpperClassNEE * dConfidentLevel && bOneMoreLoop == FALSE){
				// 񂾂̔肾ƌ̂œNXAŒႩIԂ悤ɂׂ̏
				bOneMoreLoop = TRUE;
			}
			if(aryFinalDataMatrix[i][j]->dNEE >= dUpperClassNEE * dConfidentLevel && bOneMoreLoop == TRUE){
				// 񂾂̔肾ƌ̂œNXAŒႩIԂ悤ɂׂ̏
				bOneMoreLoop = FALSE;
			}
		}
		aryUstarThreshold.push_back(dUstarThreshold);
		if(aryUstarThreshold.size() > aryUstarThretholdClass.size()) aryUstarThretholdClass.push_back(j-1);
	}

	// ex[vœꂽu* ̒lu*臒lƂ
	vector<double> aryToFinalUstarThreshold;
	for(i = 0; i < aryUstarThreshold.size(); i++){
		if(aryUstarThreshold[i] != s_dErrorValue && fabs(aryCorrelationCoefficient[i]) < 0.4){
			aryToFinalUstarThreshold.push_back(aryUstarThreshold[i]);
		}
	}
	sort(aryToFinalUstarThreshold.begin(), aryToFinalUstarThreshold.end());
	int iMid = aryToFinalUstarThreshold.size() / 2;
	if(iMid == 0){
		dUstarThreshold = s_dErrorValue;
	}
	else{
		if(aryToFinalUstarThreshold.size() % 2 == 0){
			dUstarThreshold = (aryToFinalUstarThreshold[iMid] + aryToFinalUstarThreshold[iMid - 1]) / 2;
		}
		else{
			dUstarThreshold = aryToFinalUstarThreshold[iMid];
		}
	}

	// mۂq[v̊J
	for(i = 0; i < aryData.size(); i++){
		// delete aryData[i];
		delete aryData_bs[i];
	}
	for(i = 0; i < aryFinalDataMatrix.size(); i++){
		for(int j = 0; j < aryFinalDataMatrix[i].size(); j++){
			delete aryFinalDataMatrix[i][j];
		}
	}

	return TRUE;
}

double CalcPValue_F(int m,int n,double F)
{
	//FɑΉ鎩Rxm,n̂ez\̊mvZB
	//oTFp\Rv̓nhubN(bv) p.287B
	// oTFhttp://www.vector.co.jp/soft/win95/prog/se153377.html

	double x,Ix,U,f1,f2;
	int ma,na;

	if(F<0){
		F=0;
	}

	x=n/(n+m*F);

	ma=m%2;
	na=n%2;

	if((na==1)&&(ma==1)){
		Ix=1-2/3.141592*atan(sqrt(1/x-1));
		U=sqrt(x*(1-x))/3.141592;
	}
	else if((na==1)&&(ma==0)){
		Ix=sqrt(x);
		U=sqrt(x)*(1-x)/2;
	}
	else if((na==0)&&(ma==1)){
		Ix=1-sqrt(1-x);
		U=x*sqrt(1-x)/2;
	}
	else if((na==0)&&(ma==0)){
		Ix=x;
		U=x*(1-x);
	}

	if(ma==0){
		ma=2;
	}

	if(na==0){
		na=2;
	}

	for(f2=na;f2<n;f2+=2){
		f1=ma;
		Ix=Ix-2*U/f2;
		U=(f1+f2)*x*U/f2;
	}
	for(f1=ma;f1<m;f1+=2){
		Ix=Ix+2*U/f1;
		U=(f1+f2)*(1-x)*U/f1;
	}

	return Ix;
}
double CalcPValue_t(int f,double t)
{
	//tɑΉ鎩Rxf̂z\̊mvZB
	//oTFp\Rv̓nhubN(bv) p.289B
	// oTFhttp://www.vector.co.jp/soft/win95/prog/se153377.html

	if(t>0){
		return 0.5*CalcPValue_F(1,f,t*t);
	}
	else{
		return 1-0.5*CalcPValue_F(1,f,t*t);
	}
}

// Lu* 臒l̎쒆vO
BOOL CMeanTerm::determin_u_star_threshold2(int iUstarColumn, int iNEEColumn, int iRadiationColumn, int iTemperatureColumn, double dNighttimeRadiation,
	std::vector<std::string>& aryCurrentDate, std::vector<double>& aryMaximumT, std::vector<double>& aryMinimumT, std::vector<double>& aryCorrelationCoefficient, 
	std::vector<double>& aryUpperClassUstar, std::vector<double>& aryUstarThreshold, std::vector<int>& aryUstarThretholdClass, std::vector<int>& aryDataSize, double& dUstarThreshold, const double& dPvalue) 
{
	//***************************************************************************
	//   M. Reichsterin et al., (2005) Global Change Biology 11, 1-16
	//***************************************************************************
	// o͗pf[^
	//vector<std::string> aryCurrentDate;			// Ώۂ̓ti[
	//vector<double> aryMaximumT;					// exW̍ōC
	//vector<double> aryMinimumT;					// exW̍ŒC
	//vector<double> aryCorrelationCoefficient;	// exWu* ƋC̑֌W
	//vector<double> aryUpperClassUstar;			// 5NXu* ̕ϒl
	//vector<double> aryUstarThreshold;			// exWu* 臒l
	//vector<double>    aryUstarClass;					// u* 臒l݂NX
	//vector<int>    aryDataSize;					// u* 臒lɎgpf[^
	//double dUstarThreshold = 0.0;				// exWu*臒l̒l
	vector<double> aryNEE;
	vector<double> aryUstar;
	vector<double> aryT;
	double dConfidentLevel = 0.95;
	vector<SUstarDataset*> aryData;
	vector<SUstarDataset*> aryData_bs;

	// Ԃ̃f[^̎擾
	for(int i = 0; i< (m_aryDataset[iUstarColumn]->GetContinuousDataset())->size(); i++){
		if((m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue || 
			(m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue || 
			(m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i) == s_dErrorValue || 
			(m_aryDataset[iRadiationColumn]->GetContinuousDataset())->operator[](i) > dNighttimeRadiation){
			continue;
		}

		SUstarDataset* data = new SUstarDataset;
		data->dUstar = (m_aryDataset[iUstarColumn]->GetContinuousDataset())->operator[](i);
		data->dT = (m_aryDataset[iTemperatureColumn]->GetContinuousDataset())->operator[](i);
		data->dNEE = (m_aryDataset[iNEEColumn]->GetContinuousDataset())->operator[](i);
		// aryData.push_back(data);
		aryData_bs.push_back(data);
	}

	// boot strap @
	int iSizeArrya = aryData_bs.size();
	for(i = 0; i < iSizeArrya; i++){
		aryData.push_back(aryData_bs[rand() % iSizeArrya]);
	}

	// C ̏ɕёւ
	sort(aryData.begin(), aryData.end(), copmare_temperature_high_to_low);

	// C̏6NXɕ
	int iSubClassSizeT = 6;
	int iCount = 0;
	int iTemperatureClass = aryData.size() / iSubClassSizeT;
	while(iTemperatureClass == 0) {		// 6NXmۂłȂقǃf[^Ȃꍇ̏
		iSubClassSizeT--;
		iTemperatureClass = aryData.size() / iSubClassSizeT;
		if(aryData.size() == 0 || iSubClassSizeT == 0){		// xNX1Ƃ̓G[lԂ
			dUstarThreshold = s_dErrorValue;
			aryCurrentDate.push_back((LPCTSTR)m_strCurrentDate);
			aryMaximumT.push_back(s_dErrorValue);
			aryMinimumT.push_back(s_dErrorValue);
			aryCorrelationCoefficient.push_back(s_dErrorValue);
			aryUpperClassUstar.push_back(s_dErrorValue);
			aryUstarThreshold.push_back(s_dErrorValue);
			aryDataSize.push_back((int)s_dErrorValue);
			return FALSE;
		}
	}
	vector< vector<SUstarDataset*> > arySubClassData;
	arySubClassData.resize(iSubClassSizeT);
	for(i = 0; i < aryData.size(); i++){
		if(i % iTemperatureClass == 0 && iCount != iSubClassSizeT){
			iCount++;
		}
		arySubClassData[iCount-1].push_back(aryData[i]);
	}

	// eC̃TuNXu* ̏ɕёւ
	for(i = 0; i < arySubClassData.size(); i++){
		sort(arySubClassData[i].begin(), arySubClassData[i].end(), copmare_ustar_high_to_low);
	}

	// eC̃TuNXu* ɂ20̃NXɕNEE, u* ̕ϒlZo
	int iSubClassSizeUstar = 20;
	vector<int> aryUstarClass;
	vector< vector<SUstarDataset*> > aryFinalDataMatrix;
	for(i = 0; i < arySubClassData.size(); i++){
		iSubClassSizeUstar = 20;
		int iUstarClass = arySubClassData[i].size() / iSubClassSizeUstar;
		while(iUstarClass == 0){
			iSubClassSizeUstar--;		// 20NXmۂłȂقǃf[^Ȃꍇ̏
			iUstarClass = arySubClassData[i].size() / iSubClassSizeUstar;
			if(iSubClassSizeUstar == 0){
				// ̕ɃG[ǉ
			}
		}

		vector<SUstarDataset*> aryFinalData;
		double dTxx_us = 0.0;
		// 1̉xW̃NXu* ̐
		iCount = 0;		// ߂̃NX𒲂ׂ (20͂Ȃ͂)
		int iNum = 0;	// ς̌i[
		for(int j = 0; j < arySubClassData[i].size(); j++){
			if( j % iUstarClass == 0 && iCount != iSubClassSizeUstar){
				// O̗vf̕ϒlZo
				if(j != 0){
					aryFinalData.back()->iNumSapmle = iNum;
					aryFinalData.back()->dStdev_Us = sqrt( (dTxx_us - aryFinalData.back()->dUstar * aryFinalData.back()->dUstar / iNum) / iNum );
					aryFinalData.back()->dUstar /= iNum;
					aryFinalData.back()->dT     /= iNum;
					aryFinalData.back()->dNEE   /= iNum;
					iNum = 0;
					dTxx_us = 0.0;
				}

				// Vu* W̃NX쐬
				SUstarDataset* data = new SUstarDataset;
				aryFinalData.push_back(data);
				dTxx_us = arySubClassData[i][j]->dUstar * arySubClassData[i][j]->dUstar;
				data->dUstar = arySubClassData[i][j]->dUstar;
				data->dT     = arySubClassData[i][j]->dT;
				data->dNEE   = arySubClassData[i][j]->dNEE;
				iNum++;
				iCount++;
			}
			else{
				dTxx_us += arySubClassData[i][j]->dUstar * arySubClassData[i][j]->dUstar;
				aryFinalData.back()->dUstar += arySubClassData[i][j]->dUstar;
				aryFinalData.back()->dT     += arySubClassData[i][j]->dT;
				aryFinalData.back()->dNEE   += arySubClassData[i][j]->dNEE;
				iNum++;
			}
		}
		if(iNum != 0){
			aryFinalData.back()->iNumSapmle = iNum;
			aryFinalData.back()->dStdev_Us = sqrt( (dTxx_us - aryFinalData.back()->dUstar * aryFinalData.back()->dUstar / iNum) / iNum );
			aryFinalData.back()->dUstar /= iNum;
			aryFinalData.back()->dT     /= iNum;
			aryFinalData.back()->dNEE   /= iNum;
			iNum = 0;
		}
		aryDataSize.push_back(arySubClassData[i].size());
		aryFinalDataMatrix.push_back(aryFinalData);
	}


	// aryFinalDataMatrix ɂ́AexWƁAeu*Ẃ@u*, T, NEE ̕ϒlĂB
	// O[vCA[vu* @(Sč~ɕł)

	// ex[vu* NXɂu* ƋCɑւ
	// ̌Au* 臒l߂
	// aryFinalDataMatrix[xNX][u*NX]
	for(i = 0; i < aryFinalDataMatrix.size(); i++){
		vector <double> aryT;
		vector <double> aryUstar;
		vector <double> aryNEE;
		double dMaxT = - fabs(s_dErrorValue);
		double dMinT = fabs(s_dErrorValue);
		for(int j = 0; j < aryFinalDataMatrix[i].size(); j++){
			aryT.push_back(aryFinalDataMatrix[i][j]->dT);
			aryUstar.push_back(aryFinalDataMatrix[i][j]->dUstar);
			aryNEE.push_back(aryFinalDataMatrix[i][j]->dNEE);
			if(aryFinalDataMatrix[i][j]->dT > dMaxT) dMaxT = aryFinalDataMatrix[i][j]->dT;
			if(aryFinalDataMatrix[i][j]->dT < dMinT) dMinT = aryFinalDataMatrix[i][j]->dT;
		}
		aryCurrentDate.push_back((LPCTSTR)m_strCurrentDate);
		aryMaximumT.push_back(dMaxT);
		aryMinimumT.push_back(dMinT);

		// ex[vu* NXɂu* ƋCɑւ
		double dR = coefficient_correlation(aryT, aryUstar);
		aryCorrelationCoefficient.push_back(dR);

		// Upper class u* ɂNEE ̕ϒlvZ
		// Upper class ́A5NXƂ
		double dUpperClassUstar = 0.0, dUpperClassNEE = 0.0;
		double dUpperClassUstar_stdev = 0.0;
		int iUpperClassUstar_num = 0;
		int iUpperSize = 5;
		// if(iUpperSize > aryFinalDataMatrix.size()){ // changed at 2009.12.21
		if(iUpperSize > aryFinalDataMatrix[i].size()){
			dUpperClassUstar = s_dErrorValue;
			dUpperClassNEE = s_dErrorValue;
			aryUstarThreshold.push_back(s_dErrorValue);
			continue;
		}
		else{
			for(int j = 0; j < iUpperSize; j++){
				dUpperClassUstar += aryFinalDataMatrix[i][j]->dUstar;
				dUpperClassNEE   += aryFinalDataMatrix[i][j]->dNEE;
				dUpperClassUstar_stdev += aryFinalDataMatrix[i][j]->dStdev_Us * aryFinalDataMatrix[i][j]->dStdev_Us;
			}
			//	int iTest = aryFinalDataMatrix[i].size();
			//	int iTest2 = aryFinalDataMatrix.size();
			dUpperClassUstar /= iUpperSize;
			dUpperClassNEE   /= iUpperSize;
			dUpperClassUstar_stdev = sqrt(dUpperClassUstar_stdev / iUpperSize);
			// iUpperClassUstar_num = aryFinalDataMatrix[i][j]->iNumSapmle * iUpperSize;
			iUpperClassUstar_num = aryFinalDataMatrix[i][iUpperSize-1]->iNumSapmle * iUpperSize;
		}
		aryUpperClassUstar.push_back(dUpperClassUstar);

		// u* 臒l߂
		// u* 5NXɂNEE ̕ϒlƉʃNXNEE ̔r
		double dUstarThreshold = 0.0;
		double t = 0.0;
		double p_confidential = dPvalue;
		BOOL bOneMoreLoop = FALSE;		// 񂾂̔肾ƌ̂œNXAŒႩIԂ悤ɂ
		for(j = iUpperSize; j < aryFinalDataMatrix[i].size(); j++){
			if(aryFinalDataMatrix[i][j]->dNEE < dUpperClassNEE * dConfidentLevel && bOneMoreLoop == TRUE){
				// LӍ t
				double t_a = (dUpperClassNEE * dConfidentLevel - aryFinalDataMatrix[i][j]->dNEE);
				double t_b = (iUpperClassUstar_num - 1) * dUpperClassUstar_stdev * dUpperClassUstar_stdev + (aryFinalDataMatrix[i][j]->iNumSapmle - 1) * aryFinalDataMatrix[i][j]->dStdev_Us * aryFinalDataMatrix[i][j]->dStdev_Us;
				t_b /= (iUpperClassUstar_num + aryFinalDataMatrix[i][j]->iNumSapmle - 2);
				t_b *= (1.0 / iUpperClassUstar_num + 1.0 + aryFinalDataMatrix[i][j]->iNumSapmle);
				t_b = sqrt(t_b);
				t = t_a / t_b;
				double p = CalcPValue_t(iUpperClassUstar_num + aryFinalDataMatrix[i][j]->iNumSapmle - 2, t);

				if(p > p_confidential) continue;

				dUstarThreshold = aryFinalDataMatrix[i][j-1]->dUstar;
				aryUstarThretholdClass.push_back(j-1);
				bOneMoreLoop = FALSE;
				
				break;
			}
			if(aryFinalDataMatrix[i][j]->dNEE < dUpperClassNEE * dConfidentLevel && bOneMoreLoop == FALSE){
				// LӍ t
				double t_a = (dUpperClassNEE * dConfidentLevel - aryFinalDataMatrix[i][j]->dNEE);
				double t_b = (iUpperClassUstar_num - 1) * dUpperClassUstar_stdev * dUpperClassUstar_stdev + (aryFinalDataMatrix[i][j]->iNumSapmle - 1) * aryFinalDataMatrix[i][j]->dStdev_Us * aryFinalDataMatrix[i][j]->dStdev_Us;
				t_b /= (iUpperClassUstar_num + aryFinalDataMatrix[i][j]->iNumSapmle - 2);
				t_b *= (1.0 / iUpperClassUstar_num + 1.0 + aryFinalDataMatrix[i][j]->iNumSapmle);
				t_b = sqrt(t_b);
				t = t_a / t_b;
				double p = CalcPValue_t(iUpperClassUstar_num + aryFinalDataMatrix[i][j]->iNumSapmle - 2, t);

				if(p > p_confidential) continue;
				
				// 񂾂̔肾ƌ̂œNXAŒႩIԂ悤ɂׂ̏
				bOneMoreLoop = TRUE;
			}
		}
		aryUstarThreshold.push_back(dUstarThreshold);
		if(aryUstarThreshold.size() > aryUstarThretholdClass.size()) aryUstarThretholdClass.push_back(j-1);
	}

	// ex[vœꂽu* ̒lu*臒lƂ
	vector<double> aryToFinalUstarThreshold;
	for(i = 0; i < aryUstarThreshold.size(); i++){
		if(aryUstarThreshold[i] != s_dErrorValue && fabs(aryCorrelationCoefficient[i]) < 0.4){
			aryToFinalUstarThreshold.push_back(aryUstarThreshold[i]);
		}
	}
	sort(aryToFinalUstarThreshold.begin(), aryToFinalUstarThreshold.end());
	int iMid = aryToFinalUstarThreshold.size() / 2;
	if(iMid == 0){
		dUstarThreshold = s_dErrorValue;
	}
	else{
		if(aryToFinalUstarThreshold.size() % 2 == 0){
			dUstarThreshold = (aryToFinalUstarThreshold[iMid] + aryToFinalUstarThreshold[iMid - 1]) / 2;
		}
		else{
			dUstarThreshold = aryToFinalUstarThreshold[iMid];
		}
	}

	// mۂq[v̊J
	for(i = 0; i < aryData.size(); i++){
		// delete aryData[i];
		delete aryData_bs[i];
	}
	for(i = 0; i < aryFinalDataMatrix.size(); i++){
		for(int j = 0; j < aryFinalDataMatrix[i].size(); j++){
			delete aryFinalDataMatrix[i][j];
		}
	}

	return TRUE;
}

double CMeanTerm::coefficient_correlation(const std::vector<double>& x, const std::vector<double>& y)
{
	double Tx = 0.0;
	double Txx = 0.0;
	double Tyy = 0.0;
	double Txy = 0.0;
	double Ty = 0.0;
	const int iSize = x.size();
	double stdev1, stdev2, covariance;
	double dR = CDataset::s_dErrorValue;

    for(int i = 0; i < iSize; i++)
    {
    	Tx += x[i];
		Ty += y[i];
        Txx += x[i] * x[i];
		Tyy += y[i] * y[i];		
        Txy += x[i] * y[i];    
    }
    stdev1 = sqrt((Txx - Tx * Tx / iSize) / iSize);
	stdev2 = sqrt((Tyy - Ty * Ty / iSize) / iSize);
	covariance = (Txy - Tx * Ty / iSize) / iSize;

	if(Txx - Tx * Tx / iSize < 0){
		stdev1 = s_dErrorValue;
	}
	if(Tyy - Ty * Ty / iSize < 0){
		stdev2 = s_dErrorValue;
	}

	if(stdev1 != s_dErrorValue && stdev2 != s_dErrorValue){
		dR = covariance / stdev1 / stdev2;
	}

	return dR;
}

BOOL CMeanTerm::QualityControl_MAD(const double& dZvalue, BOOL bIsDayNightDiv, const double& dNighttimeRadiation, const int& iRadiationColumn)
{
	vector<int> aryNighttimeFlag;

	if(bIsDayNightDiv && m_aryDataset.size() <= iRadiationColumn - 1){
		AfxMessageBox("Radiation column should be less than column size.");
		return FALSE;
	}

	if(bIsDayNightDiv){
		double dRadiation;
		for(int i = 0; i < m_aryDataset[iRadiationColumn]->size(); i++){
			dRadiation = m_aryDataset[iRadiationColumn]->GetData(i);
			if(dRadiation < dNighttimeRadiation){
				aryNighttimeFlag.push_back(1);
			}
			else{
				aryNighttimeFlag.push_back(0);
			}
		}
	}

	for(int i = 0; i < m_aryDataset.size(); i++){
		m_aryDataset[i]->QualityControl_MAD(dZvalue, bIsDayNightDiv, dNighttimeRadiation, aryNighttimeFlag);
	}
	
	return TRUE;
}

BOOL CMeanTerm::ApplyQualityControl(int bIsDayNightDiv, const int& iRadiationColumn)
{
	for(int i = 0; i < m_aryDataset.size(); i++){
		if(bIsDayNightDiv && i == iRadiationColumn){
			continue;
		}
		m_aryDataset[i]->ApplyQualityControl();
	}
	return TRUE;
}

CPhotosynthesisParameters CMeanTerm::Average_stdev_bootstrap_parameters_photosynthesis()
{
	CPhotosynthesisParameters cParameter;
	int iNumAmax = 0, iNumB = 0, iNumR0 = 0;
	double dTx_Amax = 0.0, dTxx_Amax = 0.0;
	double dTx_B = 0.0, dTxx_B = 0.0;
	double dTx_R0 = 0.0, dTxx_R0 = 0.0;
	
	for(int i = 0; i < m_aryPhotosynthesisParameters_bootstrap.size(); i++){
		if(m_aryPhotosynthesisParameters_bootstrap[i].m_dMaximumPhotosynthesis > 0.0){
			dTx_Amax += m_aryPhotosynthesisParameters_bootstrap[i].m_dMaximumPhotosynthesis;
			dTxx_Amax += m_aryPhotosynthesisParameters_bootstrap[i].m_dMaximumPhotosynthesis * m_aryPhotosynthesisParameters_bootstrap[i].m_dMaximumPhotosynthesis;
			iNumAmax++;
		}
		if(m_aryPhotosynthesisParameters_bootstrap[i].m_dB > 0.0){
			dTx_B += m_aryPhotosynthesisParameters_bootstrap[i].m_dB;
			dTxx_B += m_aryPhotosynthesisParameters_bootstrap[i].m_dB * m_aryPhotosynthesisParameters_bootstrap[i].m_dB;
			iNumB++;
		}
		if(m_aryPhotosynthesisParameters_bootstrap[i].m_dR0 != s_dErrorValue){
			dTx_R0 += m_aryPhotosynthesisParameters_bootstrap[i].m_dR0;
			dTxx_R0 += m_aryPhotosynthesisParameters_bootstrap[i].m_dR0 * m_aryPhotosynthesisParameters_bootstrap[i].m_dR0;
			iNumR0++;
		}
	}

	if(iNumAmax != 0){
		cParameter.m_dMaximumPhotosynthesis_stdev = sqrt( (dTxx_Amax - dTx_Amax * dTx_Amax / iNumAmax) / iNumAmax );
		cParameter.m_dMaximumPhotosynthesis = dTx_Amax / iNumAmax;
	}
	else{
		cParameter.m_dMaximumPhotosynthesis_stdev = s_dErrorValue;
		cParameter.m_dMaximumPhotosynthesis = s_dErrorValue;
	}
	if(iNumB != 0){
		cParameter.m_dB_stdev = sqrt( (dTxx_B - dTx_B * dTx_B / iNumB) / iNumB );
		cParameter.m_dB = dTx_B / iNumB;
	}
	else{
		cParameter.m_dB_stdev = s_dErrorValue;
		cParameter.m_dB = s_dErrorValue;
	}
	if(iNumR0 != 0){
		cParameter.m_dR0_stdev = sqrt( (dTxx_R0 - dTx_R0 * dTx_R0 / iNumR0) / iNumR0 );
		cParameter.m_dR0 = dTx_R0 / iNumR0;	
	}
	else{
		cParameter.m_dR0_stdev = s_dErrorValue;
		cParameter.m_dR0 = s_dErrorValue;	
	}

	return cParameter;
}

void CMeanTerm::GetBootstrapPhotsynthesisParameters(std::vector<CPhotosynthesisParameters>& cPhoto)
{
	cPhoto.clear();

	for(int i = 0; i < m_aryPhotosynthesisParameters_bootstrap.size(); i++){
		cPhoto.push_back(m_aryPhotosynthesisParameters_bootstrap[i]);
	}
}

void CMeanTerm::SetBootstrapPhosynthesisParameters(std::vector<CPhotosynthesisParameters>& aryPhotosynthesisParametersBootstrap, const CPhotosynthesisParameters& cAveragePhotoParameters)
{
	for(int i = 0; i < m_aryPhotosynthesisParameters_bootstrap.size(); i++){
		CPhotosynthesisParameters cPhoto;

		if(m_aryPhotosynthesisParameters_bootstrap[i].m_dMaximumPhotosynthesis != s_dErrorValue){
			cPhoto.m_dMaximumPhotosynthesis = m_aryPhotosynthesisParameters_bootstrap[i].m_dMaximumPhotosynthesis;
		}
		else{
			cPhoto.m_dMaximumPhotosynthesis = cAveragePhotoParameters.m_dMaximumPhotosynthesis;
		}

		if(m_aryPhotosynthesisParameters_bootstrap[i].m_dB > 0.0){
			cPhoto.m_dB = m_aryPhotosynthesisParameters_bootstrap[i].m_dB;
		}
		else{
			cPhoto.m_dB = cAveragePhotoParameters.m_dB;
		}

		if(m_aryPhotosynthesisParameters_bootstrap[i].m_dR0 != s_dErrorValue){
			cPhoto.m_dR0 = m_aryPhotosynthesisParameters_bootstrap[i].m_dR0;
		}
		else{
			cPhoto.m_dR0 = cAveragePhotoParameters.m_dR0;
		}

		aryPhotosynthesisParametersBootstrap.push_back(cPhoto);
	}
}

CRespirationParameters CMeanTerm::Average_stdev_bootstrap_parameters_respiration()
{
	CRespirationParameters cParameter;
	int iNumQ10 = 0, iNumR0 = 0, iNumTref = 0;
	double dTx_Q10 = 0.0, dTxx_Q10 = 0.0;
	double dTx_R0 = 0.0, dTxx_R0 = 0.0;
	double dTx_Tref = 0.0, dTxx_Tref = 0.0;
	
	for(int i = 0; i < m_aryRespirationParameters_bootstrap.size(); i++){
		double aaa = m_aryRespirationParameters_bootstrap[i].m_dQ10;
		if(m_aryRespirationParameters_bootstrap[i].m_dQ10 != s_dErrorValue){
			dTx_Q10 += m_aryRespirationParameters_bootstrap[i].m_dQ10;
			dTxx_Q10 += m_aryRespirationParameters_bootstrap[i].m_dQ10 * m_aryRespirationParameters_bootstrap[i].m_dQ10;
			iNumQ10++;
		}
		if(m_aryRespirationParameters_bootstrap[i].m_dR0 != s_dErrorValue){
			dTx_R0 += m_aryRespirationParameters_bootstrap[i].m_dR0;
			dTxx_R0 += m_aryRespirationParameters_bootstrap[i].m_dR0 * m_aryRespirationParameters_bootstrap[i].m_dR0;
			iNumR0++;
		}
		if(m_aryRespirationParameters_bootstrap[i].m_dTref != s_dErrorValue){
			dTx_Tref += m_aryRespirationParameters_bootstrap[i].m_dTref;
			dTxx_Tref += m_aryRespirationParameters_bootstrap[i].m_dTref * m_aryRespirationParameters_bootstrap[i].m_dTref;
			iNumTref++;
		}
	}

	if(iNumQ10 != 0){
		cParameter.m_dQ10_stdev = sqrt( (dTxx_Q10 - dTx_Q10 * dTx_Q10 / iNumQ10) / iNumQ10 );
		cParameter.m_dQ10 = dTx_Q10 / iNumQ10;
	}
	else{
		cParameter.m_dQ10_stdev = s_dErrorValue;
		cParameter.m_dQ10 = s_dErrorValue;
	}
	if(iNumR0 != 0){
		cParameter.m_dR0_stdev = sqrt( (dTxx_R0 - dTx_R0 * dTx_R0 / iNumR0) / iNumR0 );
		cParameter.m_dR0 = dTx_R0 / iNumR0;
	}
	else{
		cParameter.m_dR0_stdev = s_dErrorValue;
		cParameter.m_dR0 = s_dErrorValue;
	}
	if(iNumTref != 0){
		cParameter.m_dTref_stdev = sqrt( (dTxx_Tref - dTx_Tref * dTx_Tref / iNumTref) / iNumTref );
		cParameter.m_dTref = dTx_Tref / iNumTref;	
	}
	else{
		cParameter.m_dTref_stdev = s_dErrorValue;
		cParameter.m_dTref = s_dErrorValue;	
	}

	return cParameter;
}

void CMeanTerm::SetBootstrapRespirationParameters(std::vector<CRespirationParameters>& aryRespirationParametersBootstrap, const CRespirationParameters& cAverageRespirationParameters, const double& dMaximumQ10)
{
	for(int i = 0; i < m_aryRespirationParameters_bootstrap.size(); i++){
		CRespirationParameters cRespiration;

		if(m_aryRespirationParameters_bootstrap[i].m_dQ10 != s_dErrorValue && m_aryRespirationParameters_bootstrap[i].m_dQ10 < dMaximumQ10 * 0.90){
			cRespiration.m_dQ10 = m_aryRespirationParameters_bootstrap[i].m_dQ10;
		}
		else{
			cRespiration.m_dQ10 = cAverageRespirationParameters.m_dQ10;
		}

		if(m_aryRespirationParameters_bootstrap[i].m_dR0 != s_dErrorValue){
			cRespiration.m_dR0 = m_aryRespirationParameters_bootstrap[i].m_dR0;
		}
		else{
			cRespiration.m_dR0 = cAverageRespirationParameters.m_dR0;
		}

		if(m_aryRespirationParameters_bootstrap[i].m_dTref != s_dErrorValue){
			cRespiration.m_dTref = m_aryRespirationParameters_bootstrap[i].m_dTref;
		}
		else{
			cRespiration.m_dTref = cAverageRespirationParameters.m_dTref;
		}

		aryRespirationParametersBootstrap.push_back(cRespiration);
	}
}

void CMeanTerm::GetBootstrapRespirationParameters(std::vector<CRespirationParameters>& cResp)
{
	cResp.clear();

	for(int i = 0; i < m_aryRespirationParameters_bootstrap.size(); i++){
		cResp.push_back(m_aryRespirationParameters_bootstrap[i]);
	}
}

BOOL CMeanTerm::SetBootstrapNonLinearParameters(const std::vector<CPhotosynthesisParameters>& aryBootstrapPhoto, const std::vector<CRespirationParameters>& aryBootstrapResp)
{
	m_aryPhotosynthesisParameters_bootstrap.clear();
	m_aryRespirationParameters_bootstrap.clear();

	for(int i = 0; i < aryBootstrapPhoto.size(); i++){
		m_aryPhotosynthesisParameters_bootstrap.push_back(aryBootstrapPhoto[i]);
		m_aryRespirationParameters_bootstrap.push_back(aryBootstrapResp[i]);
	}

	return TRUE;
}